SPL_File_Load_List_Operations_1 macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push string_length	;ebp+12
;push string_address	;ebp+8
;call Get_Dec_Value 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Dec_Value proc
;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
GDV_address_increment	dd 0
.CODE
mov GDV_address_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start escape separators
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]	;string address
mov ebx,dword ptr [ebp+12]	;string length

;;;SV_Escape_Separators SPL_048, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edi
mov esi,dword ptr [ebp+8]
mov eax,5			;String end reached [Error code]
cmp edi,1
jne end_get_dec_value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End escape separators
mov eax,5			;String end reached [Error code]
mov ecx,GDV_address_increment
add ecx,ebx
inc ecx
cmp ecx,dword ptr [ebp+12]	;string length
ja end_get_dec_value

add GDV_address_increment,ebx

mov eax,dword ptr [ebp+8]	;string address
add eax,GDV_address_increment

mov ebx,dword ptr [ebp+12]	;string length
sub ebx,GDV_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax
push eax
push ebx	;dword ptr scan_string_length ;ebx
push eax	;dword ptr scan_string ;eax
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov eax,offset e_file_names
;mov string_start_address,eax

;.DATA
;string_start_address	dd 0	;ebp+4
;string_length		dd 5	;ebp+8
;address_increment	dd 0	;ebp+12
;string_end_flag		dd 0	;ebp+16	;1-normal word found	;0-word found but string end reached
;.CODE

mov dword ptr [ebp+12],0	;mov address_increment,0

start_get_value_GDV:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]

Check_Location_Within_Boundaries 48, ebx, 57  ;[EAX] - 1 True	[EAX] - 0 False
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;48	0	Value range -->  [48 - 57]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 0 - IF byte is not in range 
;[EAX] - 1 - IF byte is in range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor edx,edx
mov ebx,eax
add ebx,dword ptr [ebp+12]	;add ebx,address_increment

cmp ebx,dword ptr [ebp+8]	;cmp ebx,string_length	;If [ebx]>[string_length] [ebx] = 0  Else [ebx] cannot be changed
setb dl
mov eax,edx
mov dword ptr [ebp+16],edx	;mov string_end_flag,eax

ror eax,1
cdq

pop eax

mov esi,0
mov edi,eax
and edi,edx
not edx
and esi,edx
add esi,edi
mov eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp+12],eax	;add address_increment,eax

cmp eax,0
jne start_get_value_GDV
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+16]	;mov eax,string_end_flag
mov ecx,dword ptr [ebp+12]	;mov ecx,address_increment
mov esi,dword ptr [ebp+4]	;string_start_address

;;;;;;;;;;;IF [EAX] = 0 then increment ecx
xor ebx,ebx
cmp eax,0
sete bl
add ecx,ebx
;;;;;;;;;;;IF [EAX] = 0 then increment ecx

;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
	xchg eax,ebx
xor eax,eax
cmp ecx,0
setne al
ror eax,1
cdq 
	xchg eax,ebx
and eax,edx
;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Value found  
;[EAX] - 0 Value found, but string end reached
	;[ESI] - Value start address
	;[ECX] - Value length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
pop edx
pop edx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Value
end_get_dec_value:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - string end reached but value get
;[eax] - 1 - Dec value normal Get
;[eax] - 5 - string end reached when Escape_Separators
	;[esi] - Dec value start address
	;[ecx] - Dec value length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Dec_Value endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




endm






