coordinate_check	macro
;;;;;Using example
;push offset check_point	;ebp+12
;push offset line_coordinates	;ebp+8
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Point_Location	proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;      X     Y     X      Y
;line_coordinates		dd  0,    0,   100,   100
;check_point			dd  12,   12

mov eax,dword ptr [ebp+8]
mov ebx,dword ptr [eax]
mov line_start_x_xoordinate,ebx
mov ecx,dword ptr [eax]+4
mov line_start_y_xoordinate,ecx
mov edx,dword ptr [eax]+8
mov line_end_x_xoordinate,edx
mov esi,dword ptr [eax]+12
mov line_end_y_xoordinate,esi

mov eax,dword ptr [ebp+12]
mov ebx,dword ptr [eax]
mov check_point_x_coordinate,ebx
mov ecx,dword ptr [eax]+4
mov check_point_y_coordinate,ecx

.DATA
present_in_region_status	dd 0; 0 - not present ; 1 - present
line_start_x_xoordinate		dd 0
line_start_y_xoordinate		dd 0
line_end_x_xoordinate		dd 0
line_end_y_xoordinate		dd 0

check_point_x_coordinate	dd 0
check_point_y_coordinate	dd 0
.CODE
;;Region is a rectangle which contains specified line.  

;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
;Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check x coordinate for region present
Sort_Values  line_start_x_xoordinate, line_end_x_xoordinate	;[EAX] - Max ;[EBX] - Min
mov ecx,eax	;Max
mov edx,ebx	;Min
Check_Location_Within_Boundaries edx, check_point_x_coordinate, ecx ;[EAX] - 1 True	[EAX] - 0 False 
mov present_in_region_status,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check x coordinate for region present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check y coordinate for region present
Sort_Values  line_start_y_xoordinate, line_end_y_xoordinate	;[EAX] - Max ;[EBX] - Min
mov ecx,eax	;Max
mov edx,ebx	;Min
Check_Location_Within_Boundaries edx, check_point_y_coordinate, ecx ;[EAX] - 1 True	[EAX] - 0 False 
and present_in_region_status,eax

xor eax,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check y coordinate for region present
cmp present_in_region_status,1
jne end_process_line

;Sort_Values  line_start_y_xoordinate, line_end_y_xoordinate	;[EAX] - Max ;[EBX] - Min
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process First line type
;First type parameters
; Xs < Xe	and  Ys < Ye
;or
; Xs > Xe	and  Ys > Ye

xor eax,eax
mov ebx,line_start_x_xoordinate	;Xs
cmp ebx,line_end_x_xoordinate	;Xe
setb al

xchg eax,ebx

xor eax,eax
mov ecx,line_start_y_xoordinate	;Ys
cmp ecx,line_end_y_xoordinate	;Ye
setb al
and eax,ebx

xor edx,eax
mov esi,line_start_x_xoordinate	;Xs
cmp esi,line_end_x_xoordinate	;Xe
seta dl

xchg edx,ebx

xor edx,edx
mov edi,line_start_y_xoordinate	;Ys
cmp edi,line_end_y_xoordinate	;Ye
seta dl
and edx,ebx
or eax,edx

cmp eax,1
jne no_first_type

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get X min
;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values line_start_x_xoordinate, line_end_x_xoordinate	;[EAX] - Max ;[EBX] - Min
mov line_minimum_x_coordinate,ebx
;line_start_x_xoordinate	dd 0
;line_end_x_xoordinate		dd 0
;line_minimum_x_coordinate	dd 0	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get X min
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get Y min
;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values line_start_y_xoordinate, line_end_y_xoordinate	;[EAX] - Max ;[EBX] - Min
mov line_minimum_y_coordinate,ebx
;line_start_y_xoordinate	dd 0
;line_end_y_xoordinate		dd 0
;line_minimum_y_coordinate	dd 0	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get Y min
mov eax,line_end_y_xoordinate
sub eax,line_start_y_xoordinate		;Y2 - Y1
F_T_start_neg_y_sub:
neg eax
cmp eax,0
jl F_T_start_neg_y_sub

mov ebx,line_end_y_xoordinate
sub ebx,line_start_y_xoordinate		;X2 - X1
F_T_start_neg_x_sub:
neg ebx
cmp ebx,0
jl F_T_start_neg_x_sub

;[eax] - [Y2 - Y1]
;[ebx] - [X2 - X1]


mov ecx,check_point_y_coordinate
sub ecx,line_minimum_y_coordinate	;Y3 - Ymin
F_T_start_neg_Y_Y_min_sub:
neg ecx
cmp ecx,0
jl F_T_start_neg_Y_Y_min_sub
;[ecx] - [Y3 - Ymin]

mov edx,check_point_x_coordinate
sub edx,line_minimum_x_coordinate	;X3 - Xmin
F_T_start_neg_X_X_min_sub:
neg edx
cmp edx,0
jl F_T_start_neg_X_X_min_sub
;;;[edx] - [X3 - Xmin]

xchg eax,esi
xchg edx,edi

;[esi] - [Y2 - Y1]
;[ebx] - [X2 - X1]
;[ecx] - [Y3 - Ymin]
;[edi] - [X3 - Xmin]
;[Y2 - Y1] x [X3 - Xmin]               [X2 - X1] x [Y3 - Ymin]
;  [esi]   x   [edi]                     [ebx]   x    [ecx]

mov eax,esi
mul edi
mov edi,eax  ;[edi] - [Y2 - Y1] x [X3 - Xmin]

;[edi] - 3000

mov eax,ebx
mul ecx
mov edx,eax  ;[eax] - [X2 - X1] x [Y3 - Ymin]

;[edx] - 1000

xor ebx,ebx
xor ecx,ecx
xor eax,eax
cmp edi,edx
sete bl		;IF point is on line
setb al		;IF point is below line
seta cl		;IF point is above line

mov edx,ebx
rol ecx,1
or edx,ecx
rol eax,2
or edx,eax

mov eax,edx

;[eax] - 1 - point is on line
;[eax] - 2 - point is below
;[eax] - 4 - point is above

;   0 0 0 1  -  1 - bit 0 - point is on line
;   0 0 1 0  -  2 - bit 1 - is below
;   0 1 0 0  -  4 - bit 2 - point is above

jmp end_process_line
no_first_type:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process First line type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process Second line type
;First type parameters
; Xs < Xe	and  Ys > Ye
;or
; Xs > Xe	and  Ys < Ye

xor eax,eax
mov ebx,line_start_x_xoordinate	;Xs
cmp ebx,line_end_x_xoordinate	;Xe
setb al

xchg eax,ebx

xor eax,eax
mov ecx,line_start_y_xoordinate	;Ys
cmp ecx,line_end_y_xoordinate	;Ye
seta al
and eax,ebx

xor edx,eax
mov esi,line_start_x_xoordinate	;Xs
cmp esi,line_end_x_xoordinate	;Xe
seta dl

xchg edx,ebx

xor edx,edx
mov edi,line_start_y_xoordinate	;Ys
cmp edi,line_end_y_xoordinate	;Ye
setb dl
and edx,ebx
or eax,edx

cmp eax,1
jne no_second_type

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check second line type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get X max
;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values line_start_x_xoordinate, line_end_x_xoordinate	;[EAX] - Max ;[EBX] - Min
mov line_minimum_x_coordinate,eax	;Get [eax] - Maximum
;line_start_x_xoordinate	dd 0
;line_end_x_xoordinate		dd 0
;line_minimum_x_coordinate	dd 0	;Used as Maximum coordinate	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get X min
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get Y min
;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values line_start_y_xoordinate, line_end_y_xoordinate	;[EAX] - Max ;[EBX] - Min
mov line_minimum_y_coordinate,ebx
;line_start_y_xoordinate	dd 0
;line_end_y_xoordinate		dd 0
;line_minimum_y_coordinate	dd 0	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get Y min
mov eax,line_end_y_xoordinate
sub eax,line_start_y_xoordinate		;Y2 - Y1
S_T_start_neg_y_sub:
neg eax
cmp eax,0
jl S_T_start_neg_y_sub

mov ebx,line_end_y_xoordinate
sub ebx,line_start_y_xoordinate		;X2 - X1
S_T_start_neg_x_sub:
neg ebx
cmp ebx,0
jl S_T_start_neg_x_sub

;[eax] - [Y2 - Y1]
;[ebx] - [X2 - X1]

mov ecx,check_point_y_coordinate
sub ecx,line_minimum_y_coordinate	;Y3 - Ymin
S_T_start_neg_Y_Y_min_sub:
neg ecx
cmp ecx,0
jl S_T_start_neg_Y_Y_min_sub
;[ecx] - [Y3 - Ymin]


mov edx,check_point_x_coordinate
sub edx,line_minimum_x_coordinate	;X3 - Xmax
S_T_start_neg_X_X_min_sub:
neg edx
cmp edx,0
jl S_T_start_neg_X_X_min_sub
;;;[edx] - [X3 - Xmin]


xchg eax,esi
xchg edx,edi

;[esi] - [Y2 - Y1]
;[ebx] - [X2 - X1]
;[ecx] - [Y3 - Ymin]
;[edi] - [X3 - Xmin]

;[Y2 - Y1] x [X3 - Xmax]               [X2 - X1] x [Y3 - Ymin]
;  [esi]   x   [edi]                     [ebx]   x    [ecx]

mov eax,esi
mul edi
mov edi,eax  ;[edi] - [Y2 - Y1] x [X3 - Xmin]

;[edi] - 6300

mov eax,ebx
mul ecx
mov edx,eax  ;[eax] - [X2 - X1] x [Y3 - Ymin]

;[edx] - 1800

xor ebx,ebx
xor ecx,ecx
xor eax,eax
cmp edi,edx
sete bl		;IF point is on line
seta cl		;IF point is below line
setb al		;IF point is above line

mov edx,ebx
rol ecx,1
or edx,ecx
rol eax,2
or edx,eax

mov eax,edx

;[eax] - 1 - point is on line
;[eax] - 2 - point is below
;[eax] - 4 - point is above

;   0 0 0 1  -  1 - bit 0 - point is on line
;   0 0 1 0  -  2 - bit 1 - is below
;   0 1 0 0  -  4 - bit 2 - point is above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check second line type 
no_second_type:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process Second line type
end_process_line:
.DATA
line_minimum_y_coordinate	dd 0	
line_minimum_x_coordinate	dd 0	;Also in second type used as maximum X coordinate
.CODE

mov ebx,present_in_region_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
	;[ebx] - 0 - point out of region
	;[ebx] - 1 - point in region
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Get_Point_Location	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push offset active_element_coordinates	;ebp+12
;push offset mouse_cursor_coordinates	;ebp+8
;call Check_Cursor_For_Active_Element 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_Cursor_For_Active_Element proc				;;FULL ACTIVE ELEMENT
push ebp
mov ebp,esp

.DATA
cursor_status_on_center_rect	dd 0	; 0 - on rectangle  ; 1 - not on rectangle
cursor_status_on_left_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
cursor_status_on_right_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    Xs  Ys   Xe           Ye        
;active_element_coordinates	dd 20, 60, 40, 40, 120, 40, 140, 60 	;ebp+12
;mouse_cursor_coordinates	dd 0, 0					;ebp+8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on left  triangle
;push offset check_point
;push offset line_coordinates
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
	;[ebx] - 0 - point out of region
	;[ebx] - 1 - point in region
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]

mov cursor_status_on_left_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_left_triangle

xor ecx,ecx
cmp eax,4	;Check if above [Must be above]
sete cl
cmp eax,1	;Check if on line above [Can be on line]
sete dl
or cl,dl
cmp ecx,0
je end_check_left_triangle

mov cursor_status_on_left_triangle,ecx	

end_check_left_triangle:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on left triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on right triangle
;push offset check_point
;push offset line_coordinates
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
	;[ebx] - 0 - point out of region
	;[ebx] - 1 - point in region
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]
add eax,16

mov cursor_status_on_right_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_right_triangle

xor ecx,ecx
cmp eax,4	;Check if above [Must be above]
sete cl
cmp eax,1	;Check if on line above [Can be on line]
sete dl
or cl,dl
cmp ecx,0
je end_check_right_triangle

mov cursor_status_on_right_triangle,ecx	

end_check_right_triangle:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on right triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on center rectangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    Xs  Ys   Xe           Ye        
;active_element_coordinates	dd 20, 60, 40, 40, 120, 40, 140, 60 	;ebp+12
;mouse_cursor_coordinates	dd 0, 0					;ebp+8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+8	;Xs1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setae bl
mov cursor_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+16	;Xs2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setbe bl
and cursor_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+12	;Ys1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setae bl
and cursor_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+28	;Ys2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setbe bl
and cursor_status_on_center_rect,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on center rectangle

mov eax,cursor_status_on_center_rect
or eax,cursor_status_on_left_triangle
or eax,cursor_status_on_right_triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the active element
;[eax] - 1 - cursor is on the active element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Check_Cursor_For_Active_Element endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push offset passive_element_coordinates	;ebp+12
;push offset mouse_cursor_coordinates	;ebp+8
;call Check_C_For_Passive_Element_Left  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_C_For_Passive_Element_Left  proc				;LEFT_TRUNCATED_ELEMENT
push ebp
mov ebp,esp

.DATA
c_status_on_center_rect		dd 0	; 0 - on rectangle  ; 1 - not on rectangle
c_status_on_left_above_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
c_status_on_left_below_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
c_status_on_right_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    Xs  Ys   Xe           Ye        
;active_element_coordinates	dd 20, 60, 40, 40, 120, 40, 140, 60 	;ebp+12
;passive_element_coordinates	dd 40, 60, 30, 50, 40, 40, 120, 40, 140, 60
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on left below triangle
;push offset check_point
;push offset line_coordinates
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]

mov c_status_on_left_below_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_left_below_triangle

xor ecx,ecx
cmp eax,2	;Check if below [Must be below]
sete cl
;;cmp eax,1	;Check if on line above [Can be on line]
;;sete dl
;;or cl,dl
cmp ecx,0
je end_check_left_below_triangle

mov c_status_on_left_below_triangle,ecx	

end_check_left_below_triangle:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on left above triangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on left below triangle
;push offset check_point
;push offset line_coordinates
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]
add eax,8

mov c_status_on_left_above_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_left_above_triangle

xor ecx,ecx
cmp eax,4	;Check if above [Must be above]
sete cl		;Cannot be 

cmp ecx,0
je end_check_left_above_triangle

mov c_status_on_left_above_triangle,ecx	

end_check_left_above_triangle:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on left below  triangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on right triangle
;push offset check_point
;push offset line_coordinates
;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - point is out of specified region
;[eax] - 1 - on line 
;[eax] - 2 - point is below
;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]
add eax,24

mov c_status_on_right_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je p_end_check_right_triangle

xor ecx,ecx
cmp eax,4	;Check if above [Must be above]
sete cl
cmp eax,1	;Check if on line above [Can be on line]
sete dl
or cl,dl
cmp ecx,0
je p_end_check_right_triangle

mov c_status_on_right_triangle,ecx	

p_end_check_right_triangle:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on right triangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on center rectangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;            Xs  Ys  Xe            Ye        
;passive_element_coordinates	dd 40, 60, 30, 50, 40, 40, 120, 40, 140, 60
;mouse_cursor_coordinates	dd 0, 0					;ebp+8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+16	;Xs1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setae bl
mov c_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+24	;Xs2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setbe bl
and c_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+20	;Ys1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setae bl
and c_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+36	;Ys2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setbe bl
and c_status_on_center_rect,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on center rectangle
mov eax,c_status_on_center_rect
or eax,c_status_on_left_below_triangle
or eax,c_status_on_left_above_triangle
or eax,c_status_on_right_triangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the active element
;[eax] - 1 - cursor is on the active element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Check_C_For_Passive_Element_Left endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push offset passive_element_coordinates	;ebp+12
;push offset mouse_cursor_coordinates	;ebp+8
;call Check_C_For_Passive_Element_Right
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_C_For_Passive_Element_Right  proc				;RIGHT_TUNCATED_ELEMENT
push ebp
mov ebp,esp

.DATA
cr_status_on_center_rect		dd 0	; 0 - on rectangle  ; 1 - not on rectangle
cr_status_on_left_triangle		dd 0	; 0 - on triangle   ; 1 - not on triangle
cr_status_on_right_above_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
cr_status_on_right_below_triangle	dd 0	; 0 - on triangle   ; 1 - not on triangle
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;    Xs  Ys   Xe           Ye        
;;passive_element_coordinates_r	dd  20, 60, 40, 40, 120, 40, 130, 50, 120, 60
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on left triangle
;;push offset check_point
;;push offset line_coordinates
;;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 0 - point is out of specified region
;;[eax] - 1 - on line 
;;[eax] - 2 - point is below
;;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]

mov cr_status_on_left_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_left_triangle_r

xor ecx,ecx
cmp eax,4	;Check if below [Must be below]
sete cl
cmp eax,1	;Check if on line above [Can be on line]
sete dl
or cl,dl
cmp ecx,0
je end_check_left_triangle_r

mov cr_status_on_left_triangle,ecx	

end_check_left_triangle_r:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on left triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on right above triangle
;;push offset check_point
;;push offset line_coordinates
;;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 0 - point is out of specified region
;;[eax] - 1 - on line 
;;[eax] - 2 - point is below
;;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]
add eax,16

mov cr_status_on_right_above_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je end_check_right_above_triangle_r

xor ecx,ecx
cmp eax,4	;Check if above [Must be above]
sete cl		;Cannot be 
;;cmp eax,1	;Check if on line above [Can be on line]
;;sete dl
;;or cl,dl

cmp ecx,0
je end_check_right_above_triangle_r

mov cr_status_on_right_above_triangle,ecx	

end_check_right_above_triangle_r:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on right above  triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on right below triangle
;;push offset check_point
;;push offset line_coordinates
;;call Get_Point_Location
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 0 - point is out of specified region
;;[eax] - 1 - on line 
;;[eax] - 2 - point is below
;;[eax] - 4 - above
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+12]
add eax,24

mov cr_status_on_right_below_triangle,0
push dword ptr [ebp+8]		;Cursor coordinates	;offset check_point
push eax			;offset line_coordinates	;
call Get_Point_Location
cmp eax,0
je p_end_check_right_triangle_r

xor ecx,ecx
cmp eax,2	;Check if above [Must be above]
sete cl
;;cmp eax,1	;Check if on line above [Can be on line]
;;sete dl
;;or cl,dl
cmp ecx,0
je p_end_check_right_triangle_r

mov cr_status_on_right_below_triangle,ecx	

p_end_check_right_triangle_r:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on right below triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check cursor location on center rectangle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   Xs  Ys   Xe                    Ye        
;;passive_element_coordinates_r	dd 20, 60, 40, 40, 120, 40, 130, 50, 120, 60
;;mouse_cursor_coordinates	dd 0, 0					;ebp+8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+8	;Xs1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setae bl
mov cr_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+16	;Xs2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]		;Cursor X
cmp eax,edx
setbe bl
and cr_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+12	;Ys1
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setae bl
and cr_status_on_center_rect,ebx

mov ebx,dword ptr [ebp+12]
mov edx,dword ptr [ebx]+36	;Ys2
xor ebx,ebx
mov ecx,dword ptr [ebp+8]
mov eax,dword ptr [ecx]+4	;Cursor Y
cmp eax,edx
setbe bl
and cr_status_on_center_rect,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check cursor location on center rectangle
mov eax,cr_status_on_center_rect
or eax,cr_status_on_left_triangle
or eax,cr_status_on_right_above_triangle
or eax,cr_status_on_right_below_triangle

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the active element
;[eax] - 1 - cursor is on the active element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Check_C_For_Passive_Element_Right endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



endm



 