find_dialog_external_control macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Key_Control_Header_Buttons proc

mov message_dispatch_allow,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 74h	;VK_F5		;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je not_find_replace_header_pressed

cmp header_selection_number,1
je not_find_replace_header_pressed
mov header_selection_number,1

push 1;header_control_state	;header_control_state
push 0				;operation_type
call SCL_Control_Find_Dialog_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
not_find_replace_header_pressed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 75h	;VK_F6		;ebp+8
call GetSingleKeyAccel
;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je not_find_options_header_pressed

cmp header_selection_number,2
je not_find_options_header_pressed
mov header_selection_number,2

push 1;header_control_state	;header_control_state
push 0				;operation_type
call SCL_Control_Find_Dialog_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
not_find_options_header_pressed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 76h	;VK_F7		;ebp+8
call GetSingleKeyAccel
;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je not_goto_header_pressed

cmp header_selection_number,3
je not_goto_header_pressed
mov header_selection_number,3

push 1;header_control_state	;header_control_state
push 0				;operation_type
call SCL_Control_Find_Dialog_Contents
mov message_dispatch_allow,1
jmp end_of_key_control
not_goto_header_pressed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp header_selection_number,1
jne no_process_keys_for_find

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 28h	;VK_DOWN	;ebp+8
call GetSingleKeyAccel
;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_down_for_find
cmp find_replace_words_selection,3
jae no_down_for_find

inc find_replace_words_selection

;push 0;header_control_state	;header_control_state
;push 0				;operation_type
;call SCL_Control_Find_Dialog_Contents

;IF [find_replace_words_selection] = 2  Then [find_second_window_handle] Else [replace_window_handle]

cmp find_replace_words_selection,2
sete al
ror eax,1
cdq
mov esi,find_second_window_handle
mov edi,replace_window_handle
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
call SetFocus

push hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

mov message_dispatch_allow,1
jmp end_of_key_control
no_down_for_find:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 26h	;VK_UP		;ebp+8
call GetSingleKeyAccel
;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_up_for_find
cmp find_replace_words_selection,1
jbe no_up_for_find

dec find_replace_words_selection

;push 0;header_control_state	;header_control_state
;push 0				;operation_type
;call SCL_Control_Find_Dialog_Contents

;IF [find_replace_words_selection] = 1  Then [find_first_window_handle] Else [find_second_window_handle]

cmp find_replace_words_selection,1
sete al
ror eax,1
cdq
mov esi,find_first_window_handle
mov edi,find_second_window_handle
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
call SetFocus

push hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values
mov message_dispatch_allow,1
jmp end_of_key_control
no_up_for_find:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_process_keys_for_find:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp header_selection_number,2
jne no_process_keys_for_find_options

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset message		;ebp+12
push 7Bh	;VK_CONTROL	;ebp+8
call GetSingleKeyAccel
;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_control_for_find_options

mov eax,current_active_item_address
mov ebx,dword ptr [eax]+20		;Item local state address	;20
btc dword ptr [ebx],0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
no_control_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset message		;ebp+16
;push 28h	;VK_DOWN	;ebp+12
;push 11h	;VK_CONTROL		;ebp+8
;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed

push offset message		;ebp+12
push 28h	;VK_DOWN	;ebp+8
call GetSingleKeyAccel

cmp eax,0
je no_down_for_find_options

mov eax,current_active_item_address
mov ecx,dword ptr [eax]+4		;Direction for DOWN
mov current_active_item_address,ecx

mov edx,dword ptr [eax]+16	;search_common_selection
mov dword ptr [edx],0		;Deactivate current_common_selection

mov esi,dword ptr [ecx]+16	;Item common state address
mov dword ptr [esi],1

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
no_down_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset message		;ebp+16
;push 26h	;VK_UP		;ebp+12
;push 11h	;VK_CONTROL	;ebp+8
;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
push offset message		;ebp+12
push 26h	;VK_UP	;ebp+8
call GetSingleKeyAccel
cmp eax,0
je no_up_for_find_options

mov eax,current_active_item_address
mov ecx,dword ptr [eax]			;Direction for UP
mov current_active_item_address,ecx

mov edi,dword ptr [eax]+16	;search_common_selection
mov dword ptr [edi],0		;Deactivate current_common_selection

mov esi,dword ptr [ecx]+16	;Item common state address
mov dword ptr [esi],1		;Activate new common selection

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
no_up_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset message		;ebp+16
;push 25h	;VK_LEFT 	;ebp+12
;push 11h	;VK_CONTROL	;ebp+8
;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
push offset message		;ebp+12
push 25h	;VK_LEFT	;ebp+8
call GetSingleKeyAccel

cmp eax,0
je no_left_for_find_options

mov eax,current_active_item_address
mov ecx,dword ptr [eax]+12		;Direction for LEFT
mov current_active_item_address,ecx

mov edi,dword ptr [eax]+16	;search_common_selection
mov dword ptr [edi],0		;Deactivate current_common_selection

mov esi,dword ptr [ecx]+16	;Item common state address
mov dword ptr [esi],1		;Activate new common selection

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
no_left_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset message		;ebp+16
;push 27h	;VK_RIGHT  	;ebp+12
;push 11h	;VK_CONTROL	;ebp+8
;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
push offset message		;ebp+12
push 27h	;VK_RIGHT	;ebp+8
call GetSingleKeyAccel

;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_right_for_find_options

mov eax,current_active_item_address
mov ecx,dword ptr [eax]+8		;Direction for RIGHT
mov current_active_item_address,ecx

mov edi,dword ptr [eax]+16	;search_common_selection
mov dword ptr [edi],0		;Deactivate current_common_selection

mov esi,dword ptr [ecx]+16	;Item common state address
mov dword ptr [esi],1		;Activate new common selection

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

mov message_dispatch_allow,1
jmp end_of_key_control
no_right_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_process_keys_for_find_options:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;  find_options_key_redirector_map

.DATA
current_active_item_address	dd offset map_item_6

map_item_1 label dword		;[SEARCH UP/DOWN]
				dd offset map_item_1 ;FF		;Direction for UP		;0
				dd offset map_item_1 ;FF		;Direction for DOWN		;4
				dd offset map_item_2			;Direction for RIGHT		;8
				dd offset map_item_1 ;FF		;Direction for LEFT		;12
				dd offset search_common_selection	;Item common state address	;16
				dd offset search_flag			;Item local state address	;20

map_item_2 label dword		;[CASE SENSITIVE]
				dd offset map_item_2 ;FF		;Direction for UP		;0
				dd offset map_item_3			;Direction for DOWN		;4
				dd offset map_item_4			;Direction for RIGHT		;8
				dd offset map_item_1			;Direction for LEFT		;12
				dd offset case_common_selection		;Item common state address	;16
				dd offset case_flag			;Item local state address	;20

map_item_3 label dword		;[WHOLE WORD]
				dd offset map_item_2			;Direction for UP		;0
				dd offset map_item_3 ;FF		;Direction for DOWN		;4
				dd offset map_item_6			;Direction for RIGHT		;8
				dd offset map_item_1			;Direction for LEFT		;12
				dd offset whole_common_selection	;Item common state address	;16
				dd offset whole_word_flag		;Item local state address	;20

map_item_4 label dword		;[COMBINATION]
				dd offset map_item_4 ;FF		;Direction for UP		;0
				dd offset map_item_6			;Direction for DOWN		;4
				dd offset map_item_5			;Direction for RIGHT		;8
				dd offset map_item_2			;Direction for LEFT		;12
				dd offset combination_common_selection	;Item common state address	;16
				dd offset combination_flag		;Item local state address	;20

map_item_5 label dword		;[NOT AS COMMENT]
				dd offset map_item_5 ;FF		;Direction for UP		;0
				dd offset map_item_5 ;FF		;Direction for DOWN		;4
				dd offset map_item_5 ;FF		;Direction for RIGHT		;8
				dd offset map_item_4			;Direction for LEFT		;12
				dd offset not_as_comment_common_selection	;Item common state address	;16
				dd offset not_as_comment_flag		;Item local state address	;20


map_item_6 label dword		;[ON ONE LINE/PAGE]
				dd offset map_item_4			;Direction for UP		;0
				dd offset map_item_6 ;FF		;Direction for DOWN		;4
				dd offset map_item_6 ;FF		;Direction for RIGHT		;8
				dd offset map_item_3 			;Direction for LEFT		;12
				dd offset combination_local_selection	;Item common state address	;16
				dd offset on_one_line_or_page_flag	;Item local state address	;20

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom keys
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process [ Find [ Ctrl + F ] ]

push offset message		;ebp+16
push 46h	;VK_F		;ebp+12
push 11h	;VK_CONTROL	;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_find_key
cmp header_selection_number,3
je no_find_key

push 0		;operation_type
call SCL_Find_Text

mov message_dispatch_allow,1
jmp end_of_key_control
no_find_key:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process [ Find [ Ctrl + F ] ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process [ Replace [ Ctrl + H ] ]
push offset message		;ebp+16
push 48h	;VK_H		;ebp+12
push 11h	;VK_CONTROL	;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_replace_key
cmp header_selection_number,3
je no_replace_key

mov message_dispatch_allow,1

push 0		;operation_type
call SCL_Replace

mov message_dispatch_allow,1
jmp end_of_key_control
no_replace_key:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process [ Replace [ Ctrl + H ] ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process [ Replace All [ Ctrl + E ] ]
push offset message		;ebp+16
push 45h	;VK_E		;ebp+12
push 11h	;VK_CONTROL	;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_replace_all_key
cmp header_selection_number,3
je no_replace_all_key

mov message_dispatch_allow,1

push 0		;operation_type
call SCL_Replace_All

jmp end_of_key_control
no_replace_all_key:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process [ Replace All [ Ctrl + E ] ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process [ Go to line [ Ctrl + G ] ]
push offset message		;ebp+16
push 47h	;VK_G		;ebp+12
push 11h	;VK_CONTROL	;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_goto_line_key
cmp header_selection_number,3
jne no_goto_line_key

;push 40
;push 440
;call Beep

mov message_dispatch_allow,1

push 0		;operation_type
call SCL_Go_To_Line

jmp end_of_key_control
no_goto_line_key:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process [ Go to line [ Ctrl + G ] ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;VK_UP                                equ 26h
;VK_DOWN                              equ 28h
;VK_LEFT                              equ 25h
;VK_RIGHT                             equ 27h
;VK_CONTROL                           equ 11h

;VK_F		46h
;VK_H		48h
;VK_E		45h
;VK_G		47h

;Ctrl + F		Find
;Ctrl + H		Replace
;Ctrl + E		Replace all
;Ctrl + G		Go to line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom keys
.DATA
message_dispatch_allow		dd 0	;0 - Allow dispatch message, 1 - Do no allow to dispatch message
.CODE

end_of_key_control:

mov eax,message_dispatch_allow

ret 
SC_Key_Control_Header_Buttons endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push dword ptr [ebp]+16			;ebp+12	;wparam
;push dword ptr [ebp]+20			;ebp+8	;lparam
;call SC_Buttom_Control_Header_Buttons

SC_Buttom_Control_Header_Buttons proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_BCHB_001, EP_BCHB_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom click for "Close" buttom
;BN_CLICKED		0

mov eax,dword ptr [ebp]+8	;lparam
cmp eax,cancel_button_handle
jne no_close_button_pushed

mov ebx,dword ptr [ebp]+12	;wparam
shr ebx,16
cmp ebx,0
jne no_close_button_pushed	;Jump if notification code is not "BN_CLICKED" [ 0 ]

push 0				;lparam
push 0				;wparam
push 10h			;WM_CLOSE
push hwnd
call SendMessageA

no_close_button_pushed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom click for "Close" buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom click for "Find" buttom
;BN_CLICKED		0

mov eax,dword ptr [ebp]+8	;lparam
cmp eax,find_button_handle
jne no_find_button_pushed

mov ebx,dword ptr [ebp]+12	;wparam
shr ebx,16
cmp ebx,0
jne no_find_button_pushed	;Jump if notification code is not "BN_CLICKED" [ 0 ]

cmp header_selection_number,3
je no_find_button_pushed	;Jump in case when Find buttom is used as Go to line buttom

push 0		;operation type
call SCL_Find_Text

no_find_button_pushed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom click for "Find" buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom click for "Goto" buttom
;BN_CLICKED		0

mov eax,dword ptr [ebp]+8	;lparam
cmp eax,find_button_handle
jne no_goto_button_pushed

mov ebx,dword ptr [ebp]+12	;wparam
shr ebx,16
cmp ebx,0
jne no_goto_button_pushed	;Jump if notification code is not "BN_CLICKED" [ 0 ]

cmp header_selection_number,3
jne no_goto_button_pushed	;Jump in case when Find buttom is not used as Go to line buttom

push 0		;operation type
call SCL_Go_To_Line

no_goto_button_pushed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom click for "Goto" buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom click for "Replace" buttom
;BN_CLICKED		0

mov eax,dword ptr [ebp]+8	;lparam
cmp eax,replace_button_handle
jne no_replace_button_pushed

mov ebx,dword ptr [ebp]+12	;wparam
shr ebx,16
cmp ebx,0
jne no_replace_button_pushed	;Jump if notification code is not "BN_CLICKED" [ 0 ]

cmp header_selection_number,3
je no_replace_button_pushed

push 0		;operation type
call SCL_Replace

no_replace_button_pushed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom click for "Replace" buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process buttom click for "Replace All" buttom
;BN_CLICKED		0

mov eax,dword ptr [ebp]+8	;lparam
cmp eax,replace_all_button_handle
jne no_replace_all_button_pushed

mov ebx,dword ptr [ebp]+12	;wparam
shr ebx,16
cmp ebx,0
jne no_replace_all_button_pushed	;Jump if notification code is not "BN_CLICKED" [ 0 ]

cmp header_selection_number,3
je no_replace_all_button_pushed

push 0		;operation type
call SCL_Replace_All

no_replace_all_button_pushed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process buttom click for "Replace All" buttom


;push 40
;push 440
;call Beep

;cancel_button_handle		dd 0
;find_button_handle		dd 0
;replace_button_handle		dd 0
;replace_all_button_handle	dd 0

;WM_COMMAND  
;wNotifyCode = HIWORD(wParam);notification code 
;wID = LOWORD(wParam)  ;item, control, or accelerator identifier 
;hwndCtl = (HWND) lParam     ;handle of control 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_BCHB_001, LP_BCHB_001, EP_BCHB_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Buttom_Control_Header_Buttons endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm
;;push offset message		;ebp+12
;;push vk_up			;ebp+8
;;call GetSingleKeyAccel
 
;;push offset message		;ebp+16
;;push vk_2			;ebp+12
;;push vk_1			;ebp+8
;;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed







