find_replace_dialog_windows macro

Create_Child_FR_Dialog proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
find_replace_cbSize			dd    48
find_replace_style			dd    3				;CS_HREDRAW+CS_VREDRAW
find_replace_lpfnWndProc		dd    offset find_replace_window_proc
find_replace_cbClsExtra			dd    0
find_replace_cbWndExtra			dd    0
find_replace_hInstance			dd    0
find_replace_hIcon			dd    0		;Values get from LoadIcon
find_replace_hCursor			dd    0		;Values get from LoadCursorA
find_replace_hbrBackground		dd    0
find_replace_find_lpszMenuName		dd    0
find_replace_lpszClassName		dd    offset  find_replace_class_name 	;Window name 
find_replace_hIconSm			dd    0
find_replace_class_name			db 'FIND_OPTIONS_CLASS',0
child_find_replace_handle		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov find_replace_hInstance,eax

	push	32649
	push	0
	call	LoadCursorA
	mov dword ptr find_replace_hCursor,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 3
	call GetStockObject
	mov   dword ptr find_replace_hbrBackground,eax
;mov   find_replace_lpszClassName,offset find_class_name

	push offset find_replace_cbSize
	call  RegisterClassExA
;	test  ax,ax
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	60			;Vertical size of window
	push	447			;Horizontal size of window 
	push	21			;Y coordinate relative to parent window
	push	4			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset find_replace_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_find_replace_handle,eax

	push	0
	push	child_find_replace_handle		;find options dialog
	call	ShowWindow		;Do not need to show window because it is already visible

mov esp,ebp
pop ebp
ret
Create_Child_FR_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
find_replace_window_proc proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	find_replace_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	find_replace_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	find_replace_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	find_replace_wm_mouse_right_button_up
cmp dword ptr ss:[ebp+0ch],WM_CREATE ;	201h
je	find_replace_wm_create
cmp dword ptr ss:[ebp+0ch],WM_COMMAND
je	find_replace_wm_command


jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Find Create
find_replace_wm_create:


jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Find Create
find_replace_wm_mouse_left_button_down:

push 0 ;operation_type
call SCL_Check_Find_Options_Dialog_Mouse


mov eax,0
jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process FIND WM_COMMAND
find_replace_wm_command:

;push 0 ;operation_type
;call SCL_Check_Find_Options_Dialog_Mouse

mov eax,0
jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process FIND WM_COMMAND

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process FR mouse right buttom
find_replace_wm_mouse_right_button_up:

mov eax,0
jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process FR mouse right buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
find_replace_wm_mouse_move:

mov eax,0
jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
find_replace_wmpaint:

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

;jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
find_replace_default:
      win_default
find_replace_window_exit:
pop edi
pop esi
pop ebx
pop ebp
ret 16
find_replace_window_proc	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm






























 
 