goto_dialog_windows macro

Create_Child_Goto_Dialog proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
goto_cbSize			dd    48
goto_style			dd    3				;CS_HREDRAW+CS_VREDRAW
goto_lpfnWndProc		dd    offset goto_window_proc
goto_cbClsExtra			dd    0
goto_cbWndExtra			dd    0
goto_hInstance			dd    0
goto_hIcon			dd    0		;Values get from LoadIcon
goto_hCursor			dd    0		;Values get from LoadCursorA
goto_hbrBackground		dd    0
goto_lpszMenuName		dd    0
goto_lpszClassName		dd    offset  goto_class_name 	;Window name 
goto_hIconSm			dd    0
goto_class_name			db 'GOTO_CLASS',0
child_goto_handle		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov goto_hInstance,eax

	push	32512	;32649
	push	0
	call	LoadCursorA
	mov dword ptr goto_hCursor,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 2
	call GetStockObject
	mov   dword ptr goto_hbrBackground,eax
;mov   find_replace_lpszClassName,offset find_class_name

	push offset goto_cbSize
	call  RegisterClassExA
;	test  ax,ax
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	60			;Vertical size of window
	push	447			;Horizontal size of window 
	push	21			;Y coordinate relative to parent window
	push	4			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset goto_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_goto_handle,eax

	push	0
	push	child_goto_handle
	call	ShowWindow		;Do not need to show window because it is already visible

mov esp,ebp
pop ebp
ret
Create_Child_Goto_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
goto_window_proc proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	goto_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	goto_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_SIZE	;5h
je	goto_wm_size
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	goto_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	goto_wm_mouse_right_button_up
cmp dword ptr ss:[ebp+0ch],WM_CREATE ;	201h
je	goto_wm_create
cmp dword ptr ss:[ebp+0ch],133h		;WM_CTLCOLOREDIT   133h
je	goto_wm_set_edit_window_colors
cmp dword ptr ss:[ebp+0ch],WM_COMMAND
je	goto_wm_command

jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Find Create
goto_wm_create:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start create goto window
push 0
push hInst
push 0
push dword ptr [ebp+08h]
push 14		;vertical size
push 378	;horizontal size
push 01		;Y
push 69   	;X
push 40000000h+1000h+40h+80h+2000h;+10000000h	  ;+4+100h+100000h+200000h  ;543041C4h
push 0	;offset cpedt
push offset edit_class
push 0
call CreateWindowExA ;;Create edit line
mov goto_window_handle,eax

push 1
push goto_window_handle
call ShowWindow

push 0   ;lparam  ;If this parameter is TRUE, the control redraws itself. 
push font_handle  ;wparam  ;Handle to the font 
push 30h; WM_SETFONT
push goto_window_handle
call SendMessageA

;;;EM_LIMITTEXT 0C5h
;;;wParam = (WPARAM) cchMax;   // text length, in characters 
;;;lParam = 0;                 // not used; must be zero 
push 0
push 10 ;wParam   
push 0C5h   ;EM_LIMITTEXT
push goto_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End create goto window

jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Find Create
goto_wm_mouse_left_button_down:

mov eax,0
jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process FIND WM_COMMAND
goto_wm_command:

;push 0 ;operation_type
;call SCL_Check_Find_Options_Dialog_Mouse

mov eax,0
jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process FIND WM_COMMAND
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process FR mouse right buttom
goto_wm_mouse_right_button_up:

mov eax,0
jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process FR mouse right buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Edit window colors
goto_wm_set_edit_window_colors:

start_control_edit_draw_sync:
call SC_Control_Edit_Window_Draw_Syncronization
cmp eax,(-1)
je start_control_edit_draw_sync

jmp goto_window_exit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Edit window colors
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redefine list size changes
goto_wm_size:

xor eax,eax
jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Redefine list size changes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
goto_wm_mouse_move:

mov eax,0
jmp goto_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
goto_wmpaint:

push child_goto_handle			;hwnd
push 0		;operation_type
call SCL_Show_Goto_Contents

;jmp find_replace_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
goto_default:
      win_default
goto_window_exit:
pop edi
pop esi
pop ebx
pop ebp
ret 16
goto_window_proc	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




endm
  