SPL_File_Load_List_Operations_1 macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push string_length	;ebp+12
;push string_address	;ebp+8
;call Get_Dec_Value 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Dec_Value proc
;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
GDV_address_increment	dd 0
.CODE
mov GDV_address_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start escape separators
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]	;string address
mov ebx,dword ptr [ebp+12]	;string length

;;;SV_Escape_Separators SPL_048, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edi
mov esi,dword ptr [ebp+8]
mov eax,5			;String end reached [Error code]
cmp edi,1
jne end_get_dec_value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End escape separators
mov eax,5			;String end reached [Error code]
mov ecx,GDV_address_increment
add ecx,ebx
inc ecx
cmp ecx,dword ptr [ebp+12]	;string length
ja end_get_dec_value

add GDV_address_increment,ebx

mov eax,dword ptr [ebp+8]	;string address
add eax,GDV_address_increment

mov ebx,dword ptr [ebp+12]	;string length
sub ebx,GDV_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax
push eax
push ebx	;dword ptr scan_string_length ;ebx
push eax	;dword ptr scan_string ;eax
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov eax,offset e_file_names
;mov string_start_address,eax

;.DATA
;string_start_address	dd 0	;ebp+4
;string_length		dd 5	;ebp+8
;address_increment	dd 0	;ebp+12
;string_end_flag		dd 0	;ebp+16	;1-normal word found	;0-word found but string end reached
;.CODE

mov dword ptr [ebp+12],0	;mov address_increment,0

start_get_value_GDV:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]

Check_Location_Within_Boundaries 48, ebx, 57  ;[EAX] - 1 True	[EAX] - 0 False
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;48	0	Value range -->  [48 - 57]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 0 - IF byte is not in range 
;[EAX] - 1 - IF byte is in range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor edx,edx
mov ebx,eax
add ebx,dword ptr [ebp+12]	;add ebx,address_increment

cmp ebx,dword ptr [ebp+8]	;cmp ebx,string_length	;If [ebx]>[string_length] [ebx] = 0  Else [ebx] cannot be changed
setb dl
mov eax,edx
mov dword ptr [ebp+16],edx	;mov string_end_flag,eax

ror eax,1
cdq

pop eax

mov esi,0
mov edi,eax
and edi,edx
not edx
and esi,edx
add esi,edi
mov eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp+12],eax	;add address_increment,eax

cmp eax,0
jne start_get_value_GDV
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+16]	;mov eax,string_end_flag
mov ecx,dword ptr [ebp+12]	;mov ecx,address_increment
mov esi,dword ptr [ebp+4]	;string_start_address

;;;;;;;;;;;IF [EAX] = 0 then increment ecx
xor ebx,ebx
cmp eax,0
sete bl
add ecx,ebx
;;;;;;;;;;;IF [EAX] = 0 then increment ecx

;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
	xchg eax,ebx
xor eax,eax
cmp ecx,0
setne al
ror eax,1
cdq 
	xchg eax,ebx
and eax,edx
;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Value found  
;[EAX] - 0 Value found, but string end reached
	;[ESI] - Value start address
	;[ECX] - Value length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
pop edx
pop edx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Value
end_get_dec_value:

;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - string end reached but value get
;[eax] - 1 - Dec value normal Get
;[eax] - 5 - string end reached when Escape_Separators
	;[esi] - Dec value start address
	;[ecx] - Dec value length
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Dec_Value endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push dec_value_length		;ebp+12
;push dec_value_address		;ebp+8
;call Convert_Dec_To_Bin
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Convert_Dec_To_Bin proc
push ebp
mov ebp,esp

.DATA
output_value	dd 0
value_status	dd 0	;0 - value is normal ;1 - Value is invalid
.CODE
mov output_value,0
mov value_status,0

cmp dword ptr [ebp+12],10
seta byte ptr value_status

cmp value_status,1
je end_convert_dec_value

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 1
mov eax,dword ptr [ebp+12]	;dec_value_length
dec eax
add eax,dword ptr [ebp+8]	;dec_value_address

xor ebx,ebx
mov bl,byte ptr [eax]
sub bl,30h			;convert to ASCII
mov output_value,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 2
cmp dword ptr [ebp+12],1	;dec_value_length
jbe end_convert_dec_value

dec eax
xor ebx,ebx
mov bl,byte ptr [eax]
sub bl,30h			;convert to ASCII

mov edx,ebx
rol ebx,3	;x 8
rol edx,1	;x 2 

add ebx,edx
add output_value,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 3
xchg eax,esi

cmp dword ptr [ebp+12],2	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 4
xchg eax,esi

cmp dword ptr [ebp+12],3	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 5
xchg eax,esi

cmp dword ptr [ebp+12],4	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,10000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 6
xchg eax,esi

cmp dword ptr [ebp+12],5	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 7
xchg eax,esi

cmp dword ptr [ebp+12],6	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 8
xchg eax,esi

cmp dword ptr [ebp+12],7	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,10000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 9
xchg eax,esi

cmp dword ptr [ebp+12],8	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 9

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 10
xchg eax,esi

cmp dword ptr [ebp+12],9	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000000000
mul ebx

cmp edx,0
setne byte ptr value_status ;;0 - value is normal ;1 - Value is invalid
;11101110 01101011 00101000 00000000  - 4000000000

add output_value,eax
setb cl

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 10
;4294967295	11111111 11111111 11111111 11111111
;1000000000	10 ^ 9
; 100000000	10 ^ 8
;  10000000	10 ^ 7
;   1000000	10 ^ 6
;    100000	10 ^ 5

end_convert_dec_value:

mov eax,value_status
mov ebx,output_value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - value is normal
;[eax] - 1 - Value is invalid	;[too large]
;[ebx] - Converted binary value 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Convert_Dec_To_Bin endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push load_file_length		;ebp+12
;push offset load_file		;ebp+8
;call Get_Load_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Load_File proc
;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]
mov load_file_address,eax
mov ebx,dword ptr [ebp+12]
mov load_file_length,ebx

.DATA
load_file_length		dd 0
load_file_address		dd 0
load_file_address_increment	dd 0
start_separator_increment	dd 0

found_file_name_start_address	dd 0
found_file_name_length		dd 0
found_line_number		dd 0

.CODE
mov load_file_address_increment,0
mov found_file_name_start_address,0
mov found_file_name_length,0
mov found_line_number,0

;	[FileName  =  '...................asm' Line = 42]

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
mov ebx,load_file_length

;;SV_Escape_Separators SPL_049, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

mov start_separator_increment,ebx

xchg eax,edx
mov esi,load_file_address
mov eax,147			;String end reached when try to get load file name [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,load_file_address
add esi,load_file_address_increment
mov eax,148		;Expected [  in File load object [Error code]
cmp byte ptr [esi],'['
jne end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inc load_file_address_increment


;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_051, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,149			;String end reached after symbol '['   [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_Get_Word SPL_033, eax, ebx
push ebx	;scan_string_length	;ebp+20
push eax	;scan_string		;ebp+16
call Get_Word

xchg eax,edx
	mov esi,load_file_address
	add esi,load_file_address_increment
mov eax,150		;String end reached when try to find "FileName" label [Error code]
cmp edx,1
jne end_get_load_file_name

mov eax,151		;Found word length is invalid [Error code]
cmp ecx,8
jne end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
file_name_label		db 'FileName'
.CODE

;SV_compare_string macro First_string, Second_string, ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_label
mov ebx,esi

;;SV_compare_string eax, ebx, ecx
push ecx	;compare_length		;ebp+24
push ebx	;Second_string		;ebp+20
push eax	;First_string		;ebp+16
call Compare_String


xchg eax,ebx
mov eax,152		;Specified word must be "FileName"
cmp ebx,1
jne end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add load_file_address_increment,8 ;jump over from word "FileName"

mov eax,153			;String end reached after word "FileName"  [Error code]
mov ebx,load_file_address_increment
cmp ebx,load_file_length
jae end_get_load_file_name

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_052, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,153			;String end reached after word "FileName"  [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
inc ecx
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,154			;Expected equal sign after word "FileName"
mov esi,load_file_address
add esi,load_file_address_increment
cmp byte ptr [esi],'='
jne end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inc load_file_address_increment

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_053, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,155			;String end reached after equal sign  [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
inc ecx
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Get_Object_In_Delimiters macro SPL_index, scan_string_address, scan_string_len
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 10	First symbol is not a delimiter
;;;[eax] = 1	Object in double delimiters is get
;;;[eax] = 0	String end reached, cannot retrieve delimiter object 
	;;;[esi] = start address of object in delimiters
	;;;[ecx] = length of string limited by delimiters
	;;;[edx] = address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;;Get_Object_In_Delimiters SPL_000, eax, ebx
push ebx	;scan_string_len			;ebp+12
push eax	;scan_string_address		;ebp+8
call Get_Object_In_Delimiters 

	mov found_file_name_start_address,esi
	mov found_file_name_length,ecx
xchg eax,ebx
xchg esi,edi
	mov esi,load_file_address
	add esi,load_file_address_increment
mov eax,156			;File load object: File name first symbol is not a delimiter [Error code]
cmp ebx,10
je end_get_load_file_name

mov eax,157			;String end reached when get object in delimiters [Error code]
cmp ebx,0
je end_get_load_file_name
xchg esi,edi

add load_file_address_increment,edx

mov eax,158			;String end reached after object in delimiters [Error code]
mov ebx,load_file_address_increment
add ebx,2
cmp ebx,load_file_length
jae end_get_load_file_name

inc load_file_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_054, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,158			;String end reached after object in delimiter [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
add ecx,4
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
line_word	db 'Line'
.CODE

;SV_compare_string macro First_string, Second_string, compare_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,offset line_word

;;;;SV_compare_string eax, ebx, 4
push 4	;compare_length		;ebp+24
push ebx	;Second_string		;ebp+20
push eax	;First_string		;ebp+16
call Compare_String

xchg eax,ebx
mov eax,159			;Specified word is not "Line" [Error code]
cmp ebx,0
je end_get_load_file_name

add load_file_address_increment,4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_055, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,158			;String end reached after object in delimiter [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
inc ecx
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,160			;Expected equal sign [Error code]
mov esi,load_file_address
add esi,load_file_address_increment
cmp byte ptr [esi],'='
jne end_get_load_file_name

inc load_file_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_056, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,161			;String end reached after object in delimiter [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
inc ecx
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

push ebx	;15			;string_length
push eax	;offset dec_number	;string_address
call Get_Dec_Value 
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - string end reached but value get
;[eax] - 1 - Dec value normal Get
;[eax] - 5 - string end reached when Escape_Separators
	;[esi] - Dec value start address
	;[ecx] - Dec value length
;;;;;;;;;;;;;;;;;;;;;;;;;;
xchg eax,edx
mov eax,162			;Cannot retrieve Line number
cmp edx,1
jne end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;

add load_file_address_increment,ecx

push ecx				;dec_value_length
push esi	;offset dec_number
call Convert_Dec_To_Bin
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - value is normal
;[eax] - 1 - Value is invalid	;[too large]
;[ebx] - Converted binary value 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xchg eax,ecx
mov eax,163
cmp ecx,1
je end_get_load_file_name
mov found_line_number,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,load_file_address
add eax,load_file_address_increment

mov ebx,load_file_length
sub ebx,load_file_address_increment

;;SV_Escape_Separators SPL_057, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx
mov esi,load_file_address
mov eax,164			;String end reached after line number [Error code]
cmp edx,1
jne end_get_load_file_name

add load_file_address_increment,ebx

mov ecx,load_file_address_increment
cmp ecx,load_file_length
jae end_get_load_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,165			;Expected ] symbol in file load object
mov esi,load_file_address
add esi,load_file_address_increment
cmp byte ptr [esi],']'
jne end_get_load_file_name

inc load_file_address_increment
mov eax,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	[FileName  =  '...................asm' Line = 42]


mov esi,found_file_name_start_address
mov ecx,found_file_name_length
mov edx,found_line_number
mov ebx,load_file_address_increment

mov edi,start_separator_increment
end_get_load_file_name:

;Get_Load_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - filename normal get
;[eax] - any other value is error code
	;[ebx] - address increment
	;[esi] - filename start address	;[or error address]
	;[ecx] - filename length
	;[edx] - specified line
	;[edi] - File Load object start separator increment
;[ebx] - [edi] only file load object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  [FileName  =  '1..................asm' Line = 42]
;  |<------ only file load object length---------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Get_Load_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;SPL_Add_File_To_Load_List
;SPL_Remove_File_To_Load_List






endm






