SPL_Standard_Functions_2 macro

SPL_Get_Object_From_Label proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;			[00176 = "....................." ]
;;			|<--------String length--------->|
;;Start address ------->| 				 |
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset object_from_label		;object_string_address	;ebp+36
;push 264				;object_string_length	;ebp+32
;push offset label		;ebp+28
;push 5 ;label_length		;ebp+244
;call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax		;ebp+16
push eax		;ebp+12
push eax		;ebp+8
push eax		;ebp+4

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;.DATA
;object_string_address	dd 0	;ebp+36		;Obtained from external way
;object_string_length	dd 0	;ebp+32		;Obtained from external way

;object_start_address	dd 0	;ebp+4
;object_length		dd 0	;ebp+8

;address_increment	dd 0	;ebp+12
;label_address		dd 0	;ebp+28		;Obtained from external way
;label_length		dd 0	;ebp+24		;Obtained from external way
;label_find_flag		dd 0	;ebp+16
;.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov dword ptr [ebp+12],0	;mov address_increment,0

start_find_object_from_label:

mov dword ptr [ebp+16],0	;mov label_find_flag,0
mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_Escape_Separators SPL_007, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

add dword ptr [ebp+12],ebx	;add address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,0			;String End reached [Unexpected end][Error code]
mov ecx,dword ptr [ebp+32]	;mov ecx,object_string_length
cmp ecx,dword ptr [ebp+12]	;cmp ecx,address_increment
jbe end_get_object_from_label

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,2			;[ Expected [Error code]
xor ebx,ebx
mov ecx,dword ptr [ebp+36]	;mov ecx,offset object_from_label
add ecx,dword ptr [ebp+12]	;add ecx,address_increment

mov bl,byte ptr [ecx]
cmp bl,'['			;[ --> 91
jne end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12] 	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
cmp dword ptr [ebp+32],2	;cmp object_string_length,2
jbe end_get_object_from_label

inc dword ptr [ebp+12]		;inc address_increment

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

;SV_Escape_Separators SPL_005, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,1
jne end_get_object_from_label

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment

mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length
jae end_get_object_from_label

xchg eax,edx
add dword ptr [ebp+12],ebx	;add address_increment,ebx

;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;SV_Get_Word SPL_006, eax, ebx

push ebx	;scan_string_length	;ebp+20
push eax	;scan_string		;ebp+16
call Get_Word

xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,0
je end_get_object_from_label
xchg eax,edx
xchg esi,edi

add dword ptr [ebp+12],ecx ;add address_increment,ecx

;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp dword ptr [ebp+24],ecx	;cmp label_length,ecx
sete byte ptr [ebp+16]		;sete byte ptr label_find_flag

mov edi,dword ptr [ebp+28]	;mov edi,label_address
mov ebx,dword ptr [ebp+24]	;mov ebx,label_length

;;;SV_compare_string esi, edi, ecx		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 5 --> ecx
push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xor ebx,ebx
cmp eax,1
sete bl
and dword ptr [ebp+16],ebx	;and label_find_flag,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
cmp ebx,dword ptr [ebp+12]	;cmp ebx,address_increment
jbe end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;SV_Escape_Separators SPL_008, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,1
jne end_get_object_from_label

mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length		;;;;;;;;;;;;;;;;;;;;;;;;;;;;;[ESI] --> [EDI]
jae end_get_object_from_label

xchg eax,edx
add dword ptr [ebp+12],ebx	;add address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
inc edi
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length
jae end_get_object_from_label;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,dword ptr [ebp+36]	;mov ecx,object_string_address
add ecx,dword ptr [ebp+12]	;add ecx,address_increment

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment

mov eax,9			; =  Expected [Error code]
cmp byte ptr [ecx],"="
jne end_get_object_from_label;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inc dword ptr [ebp+12]		;inc address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
cmp ebx,dword ptr [ebp+12]	;cmp ebx,address_increment
jbe end_get_object_from_label

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;;SV_Escape_Separators SPL_009, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,1
jne end_get_object_from_label
xchg esi,edi

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length
jae end_get_object_from_label

xchg eax,edx
add dword ptr [ebp+12],ebx	;add address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment
cmp byte ptr [eax],'"'
jne not_double_delimeter

;;;;;;;;;;;;;;;;;;;;;;;;;; 
;Get_Object_In_Double_Delimiters macro scan_string, string_len		;"........"
;;			"....................."
;;			|<---String length--->|
;;Start address-------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;Get_Object_In_Double_Delimiters eax, ebx		;"........"
push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Double_Delimiters


xchg esi,edi
xchg eax,ebx

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment

mov eax,8		;Cannot find second delimiter [Error code]
cmp ebx,1
jne end_get_object_from_label
xchg eax,ebx
xchg esi,edi

xchg esi,edi
xchg eax,ebx

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov ebx,dword ptr [ebp+12]	;mov ebx,address_increment
add ebx,edx
inc ebx
cmp ebx,dword ptr [ebp+32]	;cmp ebx,object_string_length
jae end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment
inc eax
mov dword ptr [ebp+4],eax	;mov object_start_address,eax
mov dword ptr [ebp+8],ecx	;mov object_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp+12],edx	;add address_increment,edx
inc dword ptr [ebp+12]		;inc address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;;;SV_Escape_Separators SPL_010, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,1
jne end_get_object_from_label
xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length
jae end_get_object_from_label

xchg eax,edx
add dword ptr [ebp+12],ebx	;add address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,5			;Unexpected end [Error code]
mov ecx,dword ptr [ebp+36]	;mov ecx,object_string_address
add ecx,dword ptr [ebp+12]	;add ecx,address_increment
cmp byte ptr [ecx],']'
jne end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
inc dword ptr [ebp+12]		;inc address_increment

mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;SV_Escape_Separators SPL_013, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xor edx,edx
xchg eax,ecx
mov eax,dword ptr [ebp+16]	;mov eax,label_find_flag

btc ecx,0
cmp ecx,1
je end_get_object_from_label
add dword ptr [ebp+12],ebx	;add address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
jmp delimiter_object_found
not_double_delimeter:

mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment
cmp byte ptr [eax],"'"
jne not_single_delimeter

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Get_Object_In_Single_Delimiters macro scan_string, string_len	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;;;Get_Object_In_Single_Delimiters eax, ebx		;"........"
push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Single_Delimiters


xchg esi,edi
xchg eax,ebx

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment

mov eax,8		;Cannot find second delimiter [Error code]
cmp ebx,1
jne end_get_object_from_label
xchg eax,ebx
xchg esi,edi

xchg esi,edi
xchg eax,ebx

	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment

mov eax,5			;Unexpected end [Error code]
mov ebx,dword ptr [ebp+12]	;mov ebx,address_increment
add ebx,edx
inc ebx
cmp ebx,dword ptr [ebp+32]	;cmp ebx,object_string_length
jae end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment
inc eax
mov dword ptr [ebp+4],eax	;mov object_start_address,eax
mov dword ptr [ebp+8],ecx	;mov object_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp+12],edx	;add address_increment,edx
inc dword ptr [ebp+12]		;inc address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;SV_Escape_Separators SPL_011, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
xchg eax,edx
mov eax,5			;Unexpected end [Error code]
cmp edx,1
jne end_get_object_from_label
xchg esi,edi
	mov esi,dword ptr [ebp+36]	;mov esi,object_string_address
	add esi,dword ptr [ebp+12]	;add esi,address_increment
mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+12]	;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+32]	;cmp edi,object_string_length
jae end_get_object_from_label

xchg eax,edx
add dword ptr [ebp+12],ebx	;add address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,5			;Unexpected end [Error code]
mov ecx,dword ptr [ebp+36]	;mov ecx,object_string_address
add ecx,dword ptr [ebp+12]	;add ecx,address_increment
cmp byte ptr [ecx],']'
jne end_get_object_from_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
inc dword ptr [ebp+12]		;inc address_increment

mov eax,dword ptr [ebp+36]	;mov eax,object_string_address
add eax,dword ptr [ebp+12]	;add eax,address_increment

mov ebx,dword ptr [ebp+32]	;mov ebx,object_string_length
sub ebx,dword ptr [ebp+12]	;sub ebx,address_increment

;;;SV_Escape_Separators SPL_012, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xor edx,edx
xchg eax,ecx
mov eax,dword ptr [ebp+16]	;mov eax,label_find_flag

btc ecx,0
cmp ecx,1
je end_get_object_from_label
add dword ptr [ebp+12],ebx	;add address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
jmp delimiter_object_found
not_single_delimeter:

mov eax,7
jmp end_get_object_from_label

delimiter_object_found:

cmp dword ptr [ebp+16],1	;cmp label_find_flag,1
jne start_find_object_from_label

mov eax,dword ptr [ebp+16]	;mov eax,label_find_flag

end_get_object_from_label:

mov esi,dword ptr [ebp+4]	;mov esi,object_start_address
mov ecx,dword ptr [ebp+8]	;mov ecx,object_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SPL_Get_Object_From_Label 
;;	 [00176 = "....................." ]
;;	 [00176 = '.....................' ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
pop edx
pop edx
pop edx
ret 16
;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Get_Object_From_Label endp
endm

