SPL_Standard_Functions_6 macro
;Using example 
;push offset op_s_scan_string		;ebp+12
;push op_s_scan_string_length		;ebp+8
;call SPL_Get_Operation_Object_Start

SPL_Get_Operation_Object_Start proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov op_s_scan_string_length,eax

mov ebx,dword ptr [ebp+12]
mov op_s_scan_string_address,ebx

mov op_s_address_increment,0

.DATA
op_s_scan_string_address	dd 0
op_s_scan_string_length		dd 0
op_s_address_increment		dd 0
op_s_operation_name_address	dd 0
op_s_operation_name_length	dd 0
.CODE

	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,65			;String end reached before any operation performed [Error code]
cmp op_s_scan_string_length,0
je end_get_operation_start

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;pushad
;mov eax,op_s_scan_string_address
;add eax,op_s_address_increment
;mov ebx,op_s_scan_string_length
;sub ebx,op_s_address_increment
;push ebx		;output_scan_string_length
;push eax ;spl_buffer_address	;output_scan_string_address
;push 380	
;push 30
;push hdc
;call TextOutA
;popad

;;SV_Escape_Separators SPL_036, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

;pushad
;show_decimal 430, 30, ebx

;push 60 ;ebx		;output_scan_string_length
;push ecx ;spl_buffer_address	;output_scan_string_address
;push 400	
;push 30
;push hdc
;call TextOutA
;popad

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,65				;Unexpected end in Operation start object [Error code]
cmp ecx,1
jne end_get_operation_start

mov eax,65				;Unexpected end in Operation start object [Error code]
add ebx,op_s_address_increment
inc ebx
cmp ebx,op_s_scan_string_length
ja end_get_operation_start

dec ebx
mov op_s_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,66				;[ Expected in Operation Start Object [Error code]
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
cmp byte ptr [esi],'['
jne end_get_operation_start

inc op_s_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;;SV_Escape_Separators SPL_037, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,67				;Unexpected end in Operation start object [Error code]
cmp ecx,1
jne end_get_operation_start

mov eax,67				;Unexpected end in Operation start object [Error code]
add ebx,op_s_address_increment
add ebx,9
inc ebx
cmp ebx,op_s_scan_string_length
ja end_get_operation_start

dec ebx
sub ebx,9			;9 - Because must contain word 'Operation'
mov op_s_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
operation_word	db 'Operation', 0, 0, 0
.CODE

;SV_compare_string macro First_string, Second_string, compare_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_s_scan_string_address
add esi,op_s_address_increment
mov edi,offset operation_word

;;;;SV_compare_string esi, edi,  9

push 9	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,68			;Word in Operation start is invalid. Must be 'Operation' [Error code]
cmp ecx,0
je end_get_operation_start
add op_s_address_increment,9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;;SV_Escape_Separators SPL_038, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,69				;Unexpected end after Operation word  [Error code]
cmp ecx,1
jne end_get_operation_start

mov eax,69				;Unexpected end after Operation word  [Error code]
add ebx,op_s_address_increment
cmp ebx,op_s_scan_string_length
ja end_get_operation_start

mov op_s_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Get_Object_In_Delimiters macro SPL_index, scan_string_address, scan_string_len
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 10	First symbol is not a delimiter
;;;[eax] = 1	Object in double delimiters is get
;;;[eax] = 0	String end reached, cannot retrieve delimiter object 
	;;;[esi] = start address of object in delimiters
	;;;[ecx] = length of string limited by delimiters
	;;;[edx] = address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;;;;Get_Object_In_Delimiters SPL_002, eax, ebx
push ebx	;scan_string_len			;ebp+12
push eax	;scan_string_address		;ebp+8
call Get_Object_In_Delimiters 


xchg eax,edx
xchg esi,edi
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,70			;Operation name defined not correct in Operation start [Error code]
cmp edx,1
jne end_get_operation_start
xchg esi,edi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov op_s_operation_name_address,esi
mov op_s_operation_name_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add ecx,2
add op_s_address_increment,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,71				;String end reached after Operation name [Error code]
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov ecx,op_s_address_increment
cmp ecx,op_s_scan_string_length
ja end_get_operation_start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;;SV_Escape_Separators SPL_039, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,71				;String end reached after Operation name [Error code]
cmp ecx,1
jne end_get_operation_start

mov eax,71				;String end reached after Operation name [Error code]
add ebx,op_s_address_increment
cmp ebx,op_s_scan_string_length
ja end_get_operation_start

mov op_s_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov edi,op_s_address_increment
add edi,5
cmp edi,op_s_scan_string_length
ja end_get_operation_start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
start_word	db 'Start', 0, 0, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_s_scan_string_address
add esi,op_s_address_increment
mov edi,offset start_word

;;;;SV_compare_string esi, edi,  5
push 5	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,72			;'Start' Word in Operation start is expected.[Error code]
cmp ecx,0
je end_get_operation_start

add op_s_address_increment,5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_s_scan_string_address
add eax,op_s_address_increment

mov ebx,op_s_scan_string_length
sub ebx,op_s_address_increment

;;SV_Escape_Separators SPL_040, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
mov eax,74				;String end reached after word 'Start'  [Error code]
cmp ecx,1
jne end_get_operation_start

mov eax,74				;String end reached after word 'Start' [Error code]
add ebx,op_s_address_increment
inc ebx
cmp ebx,op_s_scan_string_length
ja end_get_operation_start

dec ebx
mov op_s_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,73				;] Expected in Operation start [Error code]
	mov esi,op_s_scan_string_address
	add esi,op_s_address_increment
cmp byte ptr [esi],']'
jne end_get_operation_start

inc op_s_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_s_operation_name_address
mov ecx,op_s_operation_name_length
mov eax,1
mov ebx,op_s_address_increment
end_get_operation_start:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 Operation Object Start Normal get
;[eax] - any other value is error code
	;[esi] - Operation Name Address
	;[ecx] - Operation Name length
	;[ebx] - address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SPL_Get_Operation_Object_Start endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Using example 
;push offset op_s_scan_string		;ebp+12
;push op_s_scan_string_length		;ebp+8
;call SPL_Get_Operation_Object_End

SPL_Get_Operation_Object_End proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov op_e_scan_string_length,eax

mov ebx,dword ptr [ebp+12]
mov op_e_scan_string_address,ebx

mov op_e_address_increment,0

.DATA
op_e_scan_string_address	dd 0
op_e_scan_string_length		dd 0
op_e_address_increment		dd 0
op_e_operation_name_address	dd 0
op_e_operation_name_length	dd 0
.CODE

	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,75			;String end reached before any operation performed [Error code]
cmp op_e_scan_string_length,0
je end_get_operation_end

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;SV_Escape_Separators SPL_041, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,75				;Unexpected end in Operation start object [Error code]
cmp ecx,1
jne end_get_operation_end

mov eax,75				;Unexpected end in Operation start object [Error code]
add ebx,op_e_address_increment
inc ebx
cmp ebx,op_e_scan_string_length
ja end_get_operation_end

dec ebx
mov op_e_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,76				;[ Expected in Operation End Object [Error code]
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
cmp byte ptr [esi],'['
jne end_get_operation_end

inc op_e_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;SV_Escape_Separators SPL_042, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,77				;Unexpected end in Operation end object [Error code]
cmp ecx,1
jne end_get_operation_end

mov eax,77				;Unexpected end in Operation end object [Error code]
add ebx,op_e_address_increment
add ebx,9
inc ebx
cmp ebx,op_e_scan_string_length
ja end_get_operation_end

dec ebx
sub ebx,9			;9 - Because must contain word 'Operation'
mov op_e_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
e_operation_word	db 'Operation', 0, 0, 0
.CODE

;SV_compare_string macro First_string, Second_string, compare_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_e_scan_string_address
add esi,op_e_address_increment
mov edi,offset e_operation_word

;;SV_compare_string esi, edi,  9
push 9	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,78			;Word in Operation start is invalid. Must be 'Operation' [Error code]
cmp ecx,0
je end_get_operation_end
add op_e_address_increment,9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;SV_Escape_Separators SPL_043, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,79				;Unexpected end after Operation word  [Error code]
cmp ecx,1
jne end_get_operation_end

mov eax,79				;Unexpected end after Operation word  [Error code]
add ebx,op_e_address_increment
cmp ebx,op_e_scan_string_length
ja end_get_operation_end

mov op_e_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Get_Object_In_Delimiters macro SPL_index, scan_string_address, scan_string_len
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 10	First symbol is not a delimiter
;;;[eax] = 1	Object in double delimiters is get
;;;[eax] = 0	String end reached, cannot retrieve delimiter object 
	;;;[esi] = start address of object in delimiters
	;;;[ecx] = length of string limited by delimiters
	;;;[edx] = address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;;;;Get_Object_In_Delimiters SPL_003, eax, ebx
push ebx	;scan_string_len			;ebp+12
push eax	;scan_string_address		;ebp+8
call Get_Object_In_Delimiters 

xchg eax,edx
xchg esi,edi
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,80			;Operation name defined not correct in Operation end [Error code]
cmp edx,1
jne end_get_operation_end
xchg esi,edi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov op_e_operation_name_address,esi
mov op_e_operation_name_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add ecx,2
add op_e_address_increment,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,81				;String end reached after Operation name [Error code]
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov ecx,op_e_address_increment
cmp ecx,op_e_scan_string_length
ja end_get_operation_end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;SV_Escape_Separators SPL_044, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,81				;String end reached after Operation name [Error code]
cmp ecx,1
jne end_get_operation_end

mov eax,81				;String end reached after Operation name [Error code]
add ebx,op_e_address_increment
cmp ebx,op_e_scan_string_length
ja end_get_operation_end

mov op_e_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov edi,op_e_address_increment
add edi,5
cmp edi,op_e_scan_string_length
ja end_get_operation_end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
end_word	db 'End', 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_compare_string macro First_string, Second_string, compare_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_e_scan_string_address
add esi,op_e_address_increment
mov edi,offset end_word

;;;;SV_compare_string esi, edi,  3
push 3	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,82			;'End' Word in Operation start is expected.[Error code]
cmp ecx,0
je end_get_operation_end

add op_e_address_increment,3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,op_e_scan_string_address
add eax,op_e_address_increment

mov ebx,op_e_scan_string_length
sub ebx,op_e_address_increment

;;SV_Escape_Separators SPL_045, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
mov eax,84				;String end reached after word 'End'  [Error code]
cmp ecx,1
jne end_get_operation_end

mov eax,84				;String end reached after word 'End' [Error code]
add ebx,op_e_address_increment
inc ebx
cmp ebx,op_e_scan_string_length
ja end_get_operation_end

dec ebx
mov op_e_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,83				;] Expected in Operation end [Error code]
	mov esi,op_e_scan_string_address
	add esi,op_e_address_increment
cmp byte ptr [esi],']'
jne end_get_operation_end

inc op_e_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,op_e_operation_name_address
mov ecx,op_e_operation_name_length
mov eax,1
mov ebx,op_e_address_increment
end_get_operation_end:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 Operation Object Start Normal get
;[eax] - any other value is error code
	;[esi] - Operation Name Address
	;[ecx] - Operation Name length
	;[ebx] - address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SPL_Get_Operation_Object_End endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm

