;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
load_used_dynamic_libraries macro
;clsedit				db 'RICHEDIT20A',0      

.DATA
;;Used DLL list 
richedit_dll				db 'riched20.dll',0
richedit_dll_handle			dd 0
spl_v_10_dll				db 'SPLv10.dll',0
spl_v_10_dll_handle			dd 0
perform_spl_function_name		db 'SCL_Perform_SPL',0
perform_spl_function_address		dd 0

frd_v_10_dll				db 'FRDv10.dll',0
frd_v_10_dll_handle			dd 0

frd_v_10_activate_name			db '_SCL_Activate_Find_Replace_Dialog@0',0
frd_v_10_activate_address		dd 0

frd_v_10_deactivate_name		db '_SCL_Deactivate_Find_Replace_Dialog@0',0
frd_v_10_deactivate_address		dd 0

frd_v_10_hide_name			db '_SCL_Hide_Find_Replace_Dialog@0',0
frd_v_10_hide_address			dd 0

frd_v_10_refresh_name			db '_SCL_Refresh_Find_Replace_Info@0',0
frd_v_10_refresh_address		dd 0

frd_v_10_set_headers_name		db '_SCL_Set_Find_Replace_Header_Buttom@0',0
frd_v_10_set_headers_address		dd 0

frd_v_10_show_dialog_name		db '_SCL_Show_Find_Replace_Dialog@0',0
frd_v_10_show_dialog_address		dd 0

Window_Font_Parameters		db  15, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'Courier New',0, 0, 0 
Window_font_handle		dd 0

.CODE

push offset Window_Font_Parameters		 ;pointer to logical font structure  
call CreateFontIndirectA
mov Window_font_handle,eax

push offset richedit_dll	;address of filename of executable module 
call LoadLibrary
mov richedit_dll_handle,eax

push offset spl_v_10_dll	;address of filename of executable module 
call LoadLibrary
mov spl_v_10_dll_handle,eax

push offset frd_v_10_dll	;address of filename of executable module 
call LoadLibrary
mov frd_v_10_dll_handle,eax

push offset perform_spl_function_name
push spl_v_10_dll_handle
call GetProcAddress
mov perform_spl_function_address,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Enumerate FRDv10.dll exports
push offset frd_v_10_activate_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_activate_address,eax

push offset frd_v_10_deactivate_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_deactivate_address,eax

push offset frd_v_10_hide_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_hide_address,eax

push offset frd_v_10_refresh_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_refresh_address,eax

push offset frd_v_10_set_headers_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_set_headers_address,eax

push offset frd_v_10_show_dialog_name
push frd_v_10_dll_handle
call GetProcAddress
mov frd_v_10_show_dialog_address,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Enumerate FRDv10.dll exports




endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
unload_used_dynamic_libraries macro

push Window_font_handle
call DeleteObject

push richedit_dll_handle
call FreeLibrary

push spl_v_10_dll_handle
call FreeLibrary


push 0			;operation_type
call frd_v_10_deactivate_address


push frd_v_10_dll_handle
call FreeLibrary


endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
asm_ide_internal_file_controls macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push add_type					;ebp+16
;push offset file_name				;ebp+12
;push operation_type				;ebp+8
;call SCL_Add_Existing_File_To_Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Add_Existing_File_To_Project  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_AEFTP_01, EP_AEFTP_01

mov eax,dword ptr [ebp]+8
mov operation_type_AEFTP_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_AEFTP_01, LF_AEFTP_01, operation_type_AEFTP_01, LP_AEFTP_01, EP_AEFTP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;add_type - 0 - Use [ GetOpenFileNameA ] to get file name and open
;add_type - 1 - Use specified file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp dword ptr [ebp]+16,0			;Add_Type
je no_use_specified_file_name

mov eax,dword ptr [ebp]+12			;offset file_name
mov file_name_address,eax			;Set new file name address

jmp no_call_shell_file_name_open
no_use_specified_file_name:


;push 40
;push 440
;call Beep
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp dword ptr [ebp]+16,1			;Add_Type
je no_call_shell_file_name_open

.DATA
ADD_OPENFILENAMEA	db 76  dup (0)  ;;file name offset 56    file extension offset 58 
file_title		dd 100 dup (0)
extended_filter		db 'All files',0,'*.*',0, 'Asm files',0,'*.asm',0,'Inc files',0,'*.inc',0,'Def files',0,'*.def',0,'Rc files',0,'*.rc',0,'Map files',0,'*.map',0, 'Text files',0,'*.txt',0, 'Bat files',0,'*.bat',0,0
file_name_buffer	dd  100 dup (0)
add_existing_file_title	db 'Add existing file to project',0
file_name_address	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset file name buffer
xor eax,eax
mov edi,offset file_name_buffer
mov ecx,100
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset file name buffer
mov dword ptr ADD_OPENFILENAMEA+28,offset file_name_buffer
mov dword ptr ADD_OPENFILENAMEA+36,offset file_title
mov dword ptr ADD_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr ADD_OPENFILENAMEA+48,offset add_existing_file_title
mov dword ptr ADD_OPENFILENAMEA,76
mov dword ptr ADD_OPENFILENAMEA+24,2
mov dword ptr ADD_OPENFILENAMEA+32,398
mov dword ptr ADD_OPENFILENAMEA+40,398
mov dword ptr ADD_OPENFILENAMEA+52,80000h+1000h+200000h+02000000h 
mov dword ptr ADD_OPENFILENAMEA+12,offset extended_filter
mov eax,hwnd 
mov dword ptr ADD_OPENFILENAMEA+4,eax
push offset ADD_OPENFILENAMEA
call GetOpenFileNameA
cmp eax,0
je end_add_existing_file_to_project

mov eax,offset file_name_buffer
mov file_name_address,eax

no_call_shell_file_name_open:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_get_first_free_FNL:
push File_Name_List_address
push 0 ;operation_type
call SCL_Get_First_Free_FNL
cmp eax,(-1)
je start_get_first_free_FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ebx] - 0 - No free FNL
;[ebx] - any other value is FNL number
;[ecx] - First free FNL address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov AEF_first_free_FNL_item_number,ebx
mov AEF_first_free_FNL_item_address,ecx
.DATA
AEF_first_free_FNL_item_number	dd 0
AEF_first_free_FNL_item_address	dd 0
AEF_list_full_error_title_text	db 'List add error.',0
AEF_list_full_error_text	db 'Cannot add existing file to list becaues list is full.', 0dh, 0ah
				db 0dh, 0ah
				db 'Maximum allowed list items count is 36.',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp ebx,0
jne no_list_full_BY_FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text
add_report_line 		;[eax] - contains line address

mov eax,offset AEF_list_full_error_title_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset AEF_list_full_error_text
add_report_line 		;[eax] - contains line address

mov eax,offset line_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_add_existing_file_to_project
no_list_full_BY_FNL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check specified file name length
xor ecx,ecx

push 398		;string_length	;ebp+20
push ecx		;find_byte		;ebp+16
push file_name_address	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,1
je no_error_with_GFL_file_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text
add_report_line 		;[eax] - contains line address

mov eax,offset file_type_and_name_size_error_title
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_type_and_name_size_error_text
add_report_line 		;[eax] - contains line address

mov eax,offset line_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_add_existing_file_to_project
no_error_with_GFL_file_name:
mov file_name_length,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check specified file name length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer File name to FNL
;file_name_length
;file_name_address

mov edi,AEF_first_free_FNL_item_address
add edi,8
mov esi,file_name_address
mov ecx,file_name_length
cld
rep movsb

;AEF_first_free_FNL_item_number
;AEF_first_free_FNL_item_address

mov edi,AEF_first_free_FNL_item_address
add edi,8
mov file_name_address,edi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer File name to FNL
;AEF_first_free_FNL_item_number
;AEF_first_free_FNL_item_address

push AEF_first_free_FNL_item_address		;ebp+12
push 0;operation_type				;ebp+8
call SCL_Create_Corresponding_Richedit_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set Found FNL item as "BUSY"
mov eax,AEF_first_free_FNL_item_address
mov dword ptr [eax],1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set Found FNL item as "BUSY"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check File for Binary Executable 
push offset file_type
push file_name_address
call GetBinaryType		;If the file is executable, the return value is nonzero.
cmp eax,0
je no_file_executable

binary_type_error_message_show		;Send Error Messaged To Error Window 

mov esi,AEF_first_free_FNL_item_address
mov eax,dword ptr [esi]+448			;mov eax,richedit_window_handle

push 0
push eax
call ShowWindow			;Hide richedit window 

mov eax,AEF_first_free_FNL_item_address
push dword ptr [eax]+448		;richedit_window_handle
call DestroyWindow			;Destroy richedit window

push AEF_first_free_FNL_item_address
push 0 ;operation_type
call SCL_Invalidate_FNL_Item

jmp end_add_existing_file_to_project
no_file_executable:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check File for Binary Executable 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer File to Richedit Window
start_transfer_file_contents_into_window:

mov esi,AEF_first_free_FNL_item_address
mov eax,dword ptr [esi]+448			;mov eax,richedit_window_handle

;STREAMIN_type  ; 0 - All ;1 - File

push 0  ;STREAMIN_type					;ebp+24
push 160000		;file_size_limit in bytes	;ebp+20
push eax		;richedit_window_handle		;ebp+16
push file_name_address	;offset file_name		;ebp+12
push 0		 	;operation_type			;ebp+8
call SCL_Transfer_File_Contents_Into_Richedit_Window
cmp eax,(-1)
je start_transfer_file_contents_into_window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je file_processed_normal

mov input_transfer_error_code,eax
mov input_transfer_system_error_code,ebx

.DATA
input_transfer_system_error_code	dd 0
input_transfer_error_code		dd 0
input_transfer_system_error_text	dd 0

file_input_access_error			db 'File access system error occured',0dh, 0ah, 0
file_input_error_title			db 'System error description:		',0

file_size_error_title_text		db 'File size error.',0dh, 0ah, 0
file_size_error_text			db 'File size is too large',0dh, 0ah
					db 'Specified file size is above than 160kb.',0dh, 0ah, 0
file_add_description			db 'Process type: [Try to add file into project]',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp input_transfer_error_code,3		;File size is out of allowed limit
jne no_file_size_input_error

mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text
add_report_line 		;[eax] - contains line address

mov eax,offset file_size_error_title_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text
add_report_line 		;[eax] - contains line address

mov eax,file_name_address
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
mov eax,offset file_size_error_text
add_report_line 		;[eax] - contains line address

mov eax,offset line_text
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_file_size_input_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp input_transfer_error_code,3		;File size is out of allowed limit
je no_file_system_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset file_add_description
push file_name_address				;ebp+16
push input_transfer_system_error_code		;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_file_system_error:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,AEF_first_free_FNL_item_address
mov eax,dword ptr [esi]+448			;mov eax,richedit_window_handle

push 0
push eax
call ShowWindow			;Hide richedit window 

mov eax,AEF_first_free_FNL_item_address
push dword ptr [eax]+448		;richedit_window_handle
call DestroyWindow			;Destroy richedit window

push AEF_first_free_FNL_item_address
push 0 ;operation_type
call SCL_Invalidate_FNL_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
jmp end_add_existing_file_to_project
file_processed_normal:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer File to Richedit Window
push file_name_address			;ebp+16
push AEF_first_free_FNL_item_number	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Connect_File_Name_With_List

mov eax,AEF_first_free_FNL_item_address
mov ebx,dword ptr [eax]+448		;richedit_window_handle

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push ebx			;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,1
push 6  ;function_number		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Concentrated_Switch_Control

push 0 ;operation_type				;ebp+8
call SCL_Set_Workspace_Lists_View

end_add_existing_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_AEFTP_01, LP_AEFTP_01, EP_AEFTP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Add_Existing_File_To_Project  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Add_New_File_To_Project  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_ANFTP_01, EP_ANFTP_01

mov eax,dword ptr [ebp]+8
mov operation_type_ANFTP_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_ANFTP_01, LF_ANFTP_01, operation_type_ANFTP_01, LP_ANFTP_01, EP_ANFTP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
default_extension		db '.inc',0
add_new_file_title		db 'Add new file to project. [Extension is not obligatory] ',0
new_file_name_buffer		db 400 dup (0)
new_file_title			db 400 dup (0)
file_create_internal_handle	dd 0
create_new_file_error_text	dd 0
create_new_file_error_title	db 'System error occured with new file',0dh, 0ah, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset file name buffer
xor eax,eax
mov edi,offset new_file_name_buffer
mov ecx,100
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset file name buffer
mov dword ptr ADD_OPENFILENAMEA+28,offset new_file_name_buffer
mov dword ptr ADD_OPENFILENAMEA+36,offset new_file_title
mov dword ptr ADD_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr ADD_OPENFILENAMEA+48,offset add_new_file_title
mov dword ptr ADD_OPENFILENAMEA,76
mov dword ptr ADD_OPENFILENAMEA+24,2
mov dword ptr ADD_OPENFILENAMEA+60,offset default_extension
mov dword ptr ADD_OPENFILENAMEA+32,398
mov dword ptr ADD_OPENFILENAMEA+40,398
mov dword ptr ADD_OPENFILENAMEA+52,80000h+4h+200000h+20000h+2000000h+400h
mov dword ptr ADD_OPENFILENAMEA+12,offset extended_filter
mov eax,hwnd 
mov dword ptr ADD_OPENFILENAMEA+4,eax
push offset ADD_OPENFILENAMEA
call GetSaveFileNameA
cmp eax,0
je end_add_new_file_to_project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create New File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
push 0         
push 80h			;FILE_ATTRIBUTE_NORMAL)
push 1				;CREATE_NEW  1
push 0         
push 0  
push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
push offset new_file_name_buffer
call CreateFileA
mov file_create_internal_handle,eax
cmp eax,(-1)
jne no_error_in_new_file			;INVALID_HANDLE_VALUE -1
call GetLastError
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset new_file_name_buffer		;ebp+16
push eax 					;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Generate_File_IO_Error_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
jmp end_add_new_file_to_project
no_error_in_new_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 
push file_create_internal_handle	;current_file_handle;  ;Returned by CreateFileA
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create New File

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 1  ;add_type				;ebp+16
push offset new_file_name_buffer		;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Add_Existing_File_To_Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;add_type - 0 - Use [ GetOpenFileNameA ] to get file name and open
;add_type - 1 - Use specified file name

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_add_new_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_ANFTP_01, LP_ANFTP_01, EP_ANFTP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Add_New_File_To_Project  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start SPL transfer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push operation_type				;ebp+8
;call SCL_Set_Workspace_Lists_View
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Set_Workspace_Lists_View  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SWLW_01, EP_SWLW_01

mov eax,dword ptr [ebp]+8
mov operation_type_SWLW_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SWLW_01, LF_SWLW_01, operation_type_SWLW_01, LP_SWLW_01, EP_SWLW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;IF [header_selection_number] = 0 Then Set [header_selection_number] = 1
cmp header_selection_number,0
sete al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;IF [header_selection_number] > 4 Then Set [header_selection_number] = 1
cmp header_selection_number,4
seta al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;List_Item_Selection_Number

;IF [List_Item_Selection_Number] = 0 and [List_Items_Count] = 0 Then Do Nothing


;IF [List_Item_Selection_Number] = 0 and [List_Items_Count] <> 0 Then SET [List_Item_Selection_Number] = 1
xor eax,eax
xor ebx,ebx
cmp List_Item_Selection_Number,0
sete al
cmp List_Items_Count,0
setne bl
and ebx,eax
cmp ebx,1
sete al
ror eax,1
cdq
mov esi,1
mov edi,List_Item_Selection_Number
and esi,edx
not edx
and edi,edx
add esi,edi
mov List_Item_Selection_Number,esi

;IF [List_Item_Selection_Number] > [List_Items_Count] Then SET [List_Item_Selection_Number] = [List_Items_Count]
mov ecx,List_Items_Count
xor eax,eax
cmp List_Item_Selection_Number,ecx
seta al
ror eax,1
cdq
mov esi,List_Items_Count
mov edi,List_Item_Selection_Number
and esi,edx
not edx
and edi,edx
add esi,edi
mov List_Item_Selection_Number,esi


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set File List Item Visibility
cmp List_Items_Count,0
je no_set_list_item_visibility

push offset vertical_current_pos	;ebp+24
push List_Item_Selection_Number		;List_Item number		;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

no_set_list_item_visibility:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set File List Item Visibility

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set File Results List Item Visibility
cmp P_List_Items_Count,0
je no_set_R_item_visibility

push offset P_vertical_current_pos	;ebp+24
push P_List_Item_Selection_Number	;List_Item number		;ebp+20
push offset PROJECT_LIST_CONTENTS	;ebp+16
push child_project_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

no_set_R_item_visibility:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set File Results List Item Visibility

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redefine list scroll bars
push list_font_handle			;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle			;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Redefine_List_Scroll_Bars

push list_font_handle			;ebp+20
push offset PROJECT_LIST_CONTENTS	;ebp+16
push child_project_list_handle		;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Redefine_List_Scroll_Bars
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Redefine list scroll bars
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List Parameters
push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset PROJECT_LIST_CONTENTS	;ebp+12
push 0;operation_type			;ebp+8
call SCL_Set_List_Parameters 

push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Set_List_Parameters 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List Parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set List Selection Color
push offset COLOR_HANDLES_ARRAY	;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0;  operation_type			;ebp+8
call SCL_Set_List_Selection_Color

push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset PROJECT_LIST_CONTENTS	;ebp+12
push 0;  operation_type			;ebp+8
call SCL_Set_List_Selection_Color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set List Selection Color
push offset COLOR_HANDLES_ARRAY	;ebp+28
push memory_dc				;ebp+24
push list_font_handle			;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6 

push offset COLOR_HANDLES_ARRAY	;ebp+28
push memory_dc				;ebp+24
push list_font_handle			;ebp+20
push offset PROJECT_LIST_CONTENTS	;ebp+16
push child_project_list_handle		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show File List Item
cmp header_selection_number,1
jne no_show_file_list_item

cmp List_Item_Selection_Number,0
je no_show_file_list_item

cmp List_Items_Count,0
je no_show_file_list_item

mov eax,List_Item_Selection_Number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov ebx,dword ptr [eax]+448

push	1				;SW_RESTORE
push	ebx				;FNL_richedit_window_handle
call	ShowWindow			;Hide Window 

no_show_file_list_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show File List Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SWLW_01, LP_SWLW_01, EP_SWLW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Set_Workspace_Lists_View endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push open_type					;ebp+16
;push file_list_item_number			;ebp+12
;push operation_type				;ebp+8
;call SCL_Save_File_List
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Save_File_List  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_OFFP_01, EP_OFFP_01

mov eax,dword ptr [ebp]+8
mov operation_type_OFFP_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_OFFP_01, LF_OFFP_01, operation_type_OFFP_01, LP_OFFP_01, EP_OFFP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save Specified File List Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16

mov ecx,dword ptr [ebp]+16			;open_type
bt ecx,0
jnc do_not_save_or_close_specified_file		;Jump if CF = 0 [ecx.0 = 0]

mov eax,List_Items_Count
cmp dword ptr [ebp]+12,eax
ja end_save_file_list				;Jump if specified file list item is above than [List_Item_Count]

.DATA
specified_file_window_handle	dd 0
specified_file_FNL_address	dd 0
all_files_save_counter		dd 0
.CODE

mov eax,dword ptr [ebp]+12		;List_Item_Selection_Number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov specified_file_FNL_address,eax

mov ebx,dword ptr [eax]+448		;FNL_richedit_window_handle  448
mov specified_file_window_handle,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push specified_file_window_handle
call SendMessageA
cmp eax,0
je no_specified_text_modified			;Jump if specified text is not modified
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16

mov eax,dword ptr [ebp]+16		;save_type
bt eax,1
jnc do_not_show_save_confirmation	;Jump if bit is zero [eax.1 = 0]

push 30h+3				;MB_YESNOCANCEL   3h
push offset close_confirmation_title	;"Save confirmation"
push offset close_confirmation_text	;"The contents of specified window has been changed"
push hwnd
call MessageBoxA
;IDYES                                equ 6
;IDNO                                 equ 7
;IDCANCEL                             equ 2

cmp eax,2				;IDCANCEL	2
je end_save_file_list
cmp eax,7				;IDNO		7
je no_specified_text_modified

do_not_show_save_confirmation:

mov eax,specified_file_FNL_address
add eax,8				;FNL_file_full_name

push eax				;offset project_spl_file_name	;ebp+16
push specified_file_window_handle	;window_handle			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Save_Specified_File

push 0				;lParam   
push 0				;wParam		Modification new value   
push 0B9h			;EM_SETMODIFY 0B8h
push specified_file_window_handle
call SendMessageA

no_specified_text_modified:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16

mov eax,dword ptr [ebp]+16
bt eax,2
jnc do_not_close_specified_file			;Jump if no need to close file [eax.2 = 0]

push 0
push specified_file_window_handle
call ShowWindow					;Hide Specified window

push specified_file_window_handle
call DestroyWindow				;Hide Specified window

start_remove_specified_item_for_close:

mov eax,dword ptr [ebp]+12			;;push file_list_item_number	 ebp+12

push offset COLOR_HANDLES_ARRAY	;ebp+20
push eax					;remove_position				;ebp+16
push offset LIST_CONTENTS			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Remove_File_List_Item
cmp eax,(-1)
je start_remove_specified_item_for_close

mov eax,specified_file_FNL_address

push eax				;File_List_Item_Address		;ebp+12
push 0 					;operation_type			;ebp+8
call SCL_Invalidate_FNL_Item

do_not_close_specified_file:

jmp end_save_file_list
do_not_save_or_close_specified_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save Specified File List Item


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16

mov eax,dword ptr [ebp]+16
bt eax,0
jc no_save_all_files				;Jump if no need to save all files. [eax.0 = 1]

.DATA
all_close_save_NO_TO_ALL	dd 0
all_close_save_YES_TO_ALL	dd 0
file_list_save_description	db 'Try to save file list. [Save all files]',0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All Windows contents
mov all_files_save_counter,0

cmp List_Items_Count,0
je end_save_file_list

start_save_all_files:
inc all_files_save_counter

mov eax,all_files_save_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov specified_file_FNL_address,eax
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle
mov specified_file_window_handle,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp all_close_save_NO_TO_ALL,1
je no_save_specified_file_for_all	;Jump if no need to save files to disk
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp all_close_save_YES_TO_ALL,1
je no_show_all_save_confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 0				;wParam   
push 0B8h			;EM_GETMODIFY 0B8h
push specified_file_window_handle
call SendMessageA
cmp eax,0
je no_show_all_save_confirmation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16

mov eax,dword ptr [ebp]+16			;open_type
bt eax,1
jnc no_show_all_save_confirmation		;Jump id CF = 0 [eax.1 = 0]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,specified_file_FNL_address
add eax,8
mov dialog_file_name_show_address,eax		;Set File Name

push 0
push offset Project_Save_Dialog
push hwnd   ;handle to the owner window
push offset dialog_name
push hInst
call DialogBoxParamA
;;;Return values
;[eax] - 0 - Only close without button push
;[eax] - 1000 - Pressed [ Yes ] button
;[eax] - 1001 - Pressed [ Yes to all ] button
;[eax] - 1002 - Pressed [ No ] button
;[eax] - 1003 - Pressed [ No to all ] button
;[eax] - 1004 - Pressed [ Cancel ] button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,1004				;[eax] - 1004 - Pressed [ Cancel ] button
je end_save_file_list
cmp eax,0				;[eax] - 0 - Only close without button push
je end_save_file_list
cmp eax,1002				;[eax] - 1002 - Pressed [ No ] button
je no_save_specified_file_for_all
;;[eax] - 1000 - Pressed [ Yes ] button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check "No to all"
cmp eax,1003				;[eax] - 1003 - Pressed [ No to all ] button
jne no_no_to_all

mov project_close_save_NO_TO_ALL,1

jmp do_not_save_files
no_no_to_all:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check "No to all"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check "Yes to all"
cmp eax,1001				;[eax] - 1001 - Pressed [ Yes to all ] button
jne no_yes_to_all

mov project_close_save_YES_TO_ALL,1

no_yes_to_all:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check "Yes to all"
no_show_all_save_confirmation:

mov eax,offset file_list_save_description
mov specified_file_description,eax

mov eax,specified_file_FNL_address
add eax,8

push eax				;offset file_name			;ebp+16
push specified_file_window_handle	;window_handle			;ebp+12
push 0;operation_type			;ebp+8
call SCL_Save_Specified_File

no_save_specified_file_for_all:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files				;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push open_type					;ebp+16


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Close Saved File
mov eax,dword ptr [ebp]+16		;open_type
bt eax,2
jnc no_close_all_files			;Jump if no need to close all files [eax.2 = 0]

;specified_file_FNL_address
;specified_file_window_handle

push 0
push specified_file_window_handle
call ShowWindow

push specified_file_window_handle
call DestroyWindow

push specified_file_FNL_address		;ebp+12
push 0					;operation_type			;ebp+8
call SCL_Invalidate_FNL_Item

push offset COLOR_HANDLES_ARRAY	;ebp+20
push all_files_save_counter		;remove_position			;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0					;operation_type			;ebp+8
call SCL_Remove_File_List_Item

no_close_all_files:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Close Saved File
mov edx,List_Items_Count
cmp all_files_save_counter,edx
jb start_save_all_files

do_not_save_files:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save All Windows contents

no_save_all_files:


end_save_file_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_OFFP_01, LP_OFFP_01, EP_OFFP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


mov esp,ebp
pop ebp
ret 12
SCL_Save_File_List  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End SPL transfer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


endm


;;Project Definition

;; asm_name.APF		--> Project file which contains
;;			Project SPL file name
;;			Project Load Files List


