asm_ide_popup_menu_operations  macro

SCL_Activate_Edit_Popup_Menu proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_AEPM_01, EP_AEPM_01

mov eax,dword ptr [ebp]+8
mov operation_type_AEPM_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_AEPM_01, LF_AEPM_01, operation_type_AEPM_01, LP_AEPM_01, EP_AEPM_01

push 0		;operation_type
call SCL_Build_Edit_Popup_Contents

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_AEPM_01, LP_AEPM_01, EP_AEPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Activate_Edit_Popup_Menu endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Activate_Files_Popup_Menu proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_AFPM_01, EP_AFPM_01

mov eax,dword ptr [ebp]+8
mov operation_type_AFPM_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_AFPM_01, LF_AFPM_01, operation_type_AFPM_01, LP_AFPM_01, EP_AFPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_AFPM_01, LP_AFPM_01, EP_AFPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Activate_Files_Popup_Menu endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Activate_Results_Popup_Menu proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_ARPM_01, EP_ARPM_01

mov eax,dword ptr [ebp]+8
mov operation_type_ARPM_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_ARPM_01, LF_ARPM_01, operation_type_ARPM_01, LP_ARPM_01, EP_ARPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_ARPM_01, LP_ARPM_01, EP_ARPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Activate_Results_Popup_Menu endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Build_Edit_Popup_Contents proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_BEPC_01, EP_BEPC_01

mov eax,dword ptr [ebp]+8
mov operation_type_BEPC_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_BEPC_01, LF_BEPC_01, operation_type_BEPC_01, LP_BEPC_01, EP_BEPC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


start_get_active_window_for_edit_popup:

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_get_active_window_for_edit_popup
mov active_window_for_popup,ebx
cmp ebx,0
je end_build_contents_for_edit

.DATA
active_window_for_popup		dd 0
edit_popup_returned_item_number	dd 0
menu_cursor_pos			dd 0, 0
edit_popup_menu_error_title	db 'Main edit window popup menu causes an error.',0

;PML_LIST_CONTENTS	label dword

;PML_List_Items_Count			dd   1						;0
;PML_List_Item_Selection_Number		dd   0  ;1 - Based ;Current list selection	;4
;PML_List_Internal_X_offset			dd   0						;8
;PML_List_Internal_Y_offset			dd   0					;12
;PML_List_Empty_Region_Fill_Color_Handle	dd   0						;16

;PML_List_Item_1				dd   4						;0
;					dd   offset text_1				;4
;					dd   0			;Text color		;8
;					dd   00E9E9E9h		;Text background color	;12
;					dd   0	;Background color handle		;16
;					dd   28	;Text X coordinate			;20
;					dd   0	;Text Y coordinate			;24
;					dd  000000000000001100000000b	;Arrow show status			;28
;

current_window_selection		dd 0, 0
selected_text_present_flag		dd 0    ;0 - Text Not selected ;1 - Text Selected
can_paste_flag				dd 0	;0 - Cannot paste ;NonZero - Can Paste
can_undo_flag				dd 0	;0 - Cannot undo  ;NonZero - Can undo 
can_redo_flag				dd 0	;0 - Cannot redo  ;NonZero - Can redo
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine Popup Menu contents valid state
push offset current_window_selection	;lParam   
push 0					;wParam   
push 400h+52				;EM_EXGETSEL WM_USER + 52
push active_window_for_popup 
call SendMessageA
mov ebx,current_window_selection
mov ecx,current_window_selection+4
cmp ebx,ecx
sete al
ror eax,1
cdq
mov esi,0
mov edi,1
and esi,edx
not edx
and edi,edx
add esi,edi
mov selected_text_present_flag,esi		;0 - Text Not selected ;1 - Text Selected
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;lParam   
push 1	;CF_TEXT			;wParam   
push 400h+50			;EM_CANPASTE  WM_USER + 50
push active_window_for_popup 
call SendMessageA
mov can_paste_flag,eax

push 0				;lParam   
push 0				;wParam   
push 0C6h			;EM_CANUNDO  0C6h
push active_window_for_popup 
call SendMessageA
mov can_undo_flag,eax

push 0				;lParam   
push 0				;wParam   
push 400h+85			;EM_CANREDO  (WM_USER + 85)  ;400h + 85
push active_window_for_popup 
call SendMessageA
mov can_redo_flag,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;selected_text_present_flag		dd 0    ;0 - Text Not selected ;1 - Text Selected
;can_paste_flag				dd 0	;0 - Cannot paste ;NonZero - Can Paste
;can_undo_flag				dd 0	;0 - Cannot undo  ;NonZero - Can undo 
;can_redo_flag				dd 0	;0 - Cannot redo  ;NonZero - Can redo

push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1000
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Undo" item
cmp can_undo_flag,0
je no_transfer_undo_item

push 0			;MF_GRAYED 1	;MF_DISABLED
push 1000
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_undo_item:

;MF_BYCOMMAND 	0h
;MF_ENABLED 0h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Undo" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1001
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Redo" item
cmp can_redo_flag,0
je no_transfer_redo_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1001
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2


no_transfer_redo_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Redo" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1002
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Delete" item
cmp selected_text_present_flag,0
je no_transfer_delete_item

push 0			;MF_GRAYED 1	;MF_DISABLED
push 1002
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_delete_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Delete" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1003
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Copy" item
cmp selected_text_present_flag,0
je no_transfer_copy_item

push 0			;MF_GRAYED 1	;MF_DISABLED
push 1003
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2


no_transfer_copy_item:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Copy" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1004
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Paste" item
cmp can_paste_flag,0
je no_transfer_paste_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1004
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_paste_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Paste" item

;;;;;;;"Select All" is never been disabled

push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1006
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Save as..." item
cmp selected_text_present_flag,0
je no_transfer_save_as_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1006
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2


no_transfer_save_as_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Save as" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1007
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Convert To Uppercase" item
cmp selected_text_present_flag,0
je no_transfer_convert_uppercase_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1007
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_convert_uppercase_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Convert To Uppercase" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1008
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Convert To Lowercase" item
cmp selected_text_present_flag,0
je no_transfer_convert_lowercase_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1008
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2


no_transfer_convert_lowercase_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Convert To Lowercase" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1009
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Comment Selection" item
cmp selected_text_present_flag,0
je no_transfer_comment_selection_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1009
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_comment_selection_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Comment Selection" item
push 2h+2+1			;MF_GRAYED 1	;MF_DISABLED
push 1010
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Transfer "Uncomment Selection" item
cmp selected_text_present_flag,0
je no_transfer_uncomment_selection_item

push 0				;MF_GRAYED 1	;MF_DISABLED
push 1010
push edit_popup_menu_handle
call EnableMenuItem

;MF_ENABLED		0
;MF_GRAYED		1
;MF_DISABLED		2

no_transfer_uncomment_selection_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Transfer "Uncomment Selection" item

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine Popup Menu contents valid state
;active_window_for_popup		dd 0

;undo_item				0	;ITEM_NUMBER FOR ID
;redo_item				1	;ITEM_NUMBER FOR ID
;;;;Selection operations
;delete_item				2	;ITEM_NUMBER FOR ID
;copy_item				3	;ITEM_NUMBER FOR ID
;paste_item 				4	;ITEM_NUMBER FOR ID
;select_all_item			5	;ITEM_NUMBER FOR ID		;Always
;save_as_item				6	;ITEM_NUMBER FOR ID
;convert_uppercase_item			7	;ITEM_NUMBER FOR ID
;convert_lowercase_item			8	;ITEM_NUMBER FOR ID
;comment_selection_item			9	;ITEM_NUMBER FOR ID
;uncomment_selection_item		10	;ITEM_NUMBER FOR ID

;EM_UNDO                              equ 0C7h

show_edit_popup_menu:

push offset menu_cursor_pos
call GetCursorPos

push 0
push hwnd
push menu_cursor_pos+4		;150				;Y
push menu_cursor_pos		;100				;X
push 40h  ;+100h+80h		;flags
push edit_popup_menu_handle
call TrackPopupMenuEx
cmp eax,0
jne no_edit_popup_show_fails

call GetLastError

push eax
call Get_System_Error_Text 

push 30h
push offset edit_popup_menu_error_title
push eax
push hwnd
call MessageBoxA

no_edit_popup_show_fails:

;TPM_RETURNCMD		100h
;TPM_NONOTIFY		080h
;TPM_VERTICAL		040h 

;;;Return value is a pressed menu item identifier  or null if cancel
mov edit_popup_returned_item_number,eax

;TPM_LEFTBUTTON			equ 0h
;TPM_RIGHTBUTTON		equ 2h
;TPM_LEFTALIGN			equ 0h
;TPM_CENTERALIGN		equ 4h
;TPM_RIGHTALIGN			equ 8h
;TPM_TOPALIGN			equ 0
;TPM_VCENTERALIGN		equ 10h
;TPM_BOTTOMALIGN		equ 20h
;TPM_HORIZONTAL			equ 0
;TPM_VERTICAL			equ 40h
;TPM_NONOTIFY			equ 80h
;TPM_RETURNCMD			equ 100h
;TPM_RECURSE			equ 1


end_build_contents_for_edit:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_BEPC_01, LP_BEPC_01, EP_BEPC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Build_Edit_Popup_Contents endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Force_Close_Popup_Menu proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_FCPM_01, EP_FCPM_01

mov eax,dword ptr [ebp]+8
mov operation_type_FCPM_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_FCPM_01, LF_FCPM_01, operation_type_FCPM_01, LP_FCPM_01, EP_FCPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;push 40
;push 2100
;call Beep

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_FCPM_01, LP_FCPM_01, EP_FCPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Force_Close_Popup_Menu endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push dword ptr [ebp]+20	;lparam - second message parameter
;push dword ptr [ebp]+16	;wparam - first message parameter
;push dword ptr [ebp]+12	;mes    - message identifier
;push dword ptr [ebp]+8
;push 0 ;operation_type
;call SCL_Process_Edit_Popup_Messages
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Process_Edit_Popup_Messages proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PEPM_01, EP_PEPM_01

mov eax,dword ptr [ebp]+8
mov operation_type_PEPM_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_PEPM_01, LF_PEPM_01, operation_type_PEPM_01, LP_PEPM_01, EP_PEPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Undo"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1000
jne no_popup_menu_undo

push 0				;lParam   
push 0				;wParam   
push 0C7h			;EM_UNDO 0C7h 
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_undo:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Undo"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Redo"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1001
jne no_popup_menu_redo

push 0				;lParam   
push 0				;wParam   
push 400h+84			;EM_REDO     (WM_USER + 84)  ;400h + 84
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_redo:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Redo"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Delete"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1002
jne no_popup_menu_delete

push 0				;lParam   
push 1				;wParam   
push 0C2h			;EM_REPLACESEL
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_delete:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Delete"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Copy"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1003
jne no_popup_menu_copy

push 0				;lParam   
push 0				;wParam   
push 301h			;WM_COPY 301h
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_copy:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Copy"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Paste"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1004
jne no_popup_menu_paste

push 0				;lParam   
push 0				;wParam   
push 302h			;WM_PASTE 302h
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_paste:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Paste"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Select all"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1005
jne no_popup_menu_select_all
.DATA
select_all_start	dd 0
select_all_end		dd (-1)
.CODE

push offset select_all_start	;lParam   
push 0				;wParam   
push 400h+55			;EM_EXSETSEL WM_USER + 55
push active_window_for_popup
call SendMessageA

jmp end_process_popup_menu_commands
no_popup_menu_select_all:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Select all"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Save as"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1006
jne no_popup_menu_save_as

push 1 ;save_type						;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Save_Selection_As
;;save_type ;0 -  Save all ;1 - Save selection

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_popup_menu_commands
no_popup_menu_save_as:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Save as"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Convert to Uppercase"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1007
jne no_popup_menu_convert_to_uppercase

push active_window_for_popup	;window_handle
call SC_Convert_Richedit_Selection_To_Uppercase

jmp end_process_popup_menu_commands
no_popup_menu_convert_to_uppercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Convert to Uppercase"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Convert to Lowercase"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1008
jne no_popup_menu_convert_to_lowercase

push active_window_for_popup	;window_handle
call SC_Convert_Richedit_Selection_To_Lowercase

jmp end_process_popup_menu_commands
no_popup_menu_convert_to_lowercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Convert to Lowercase"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Comment Selection"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1009
jne no_popup_menu_comment

push active_window_for_popup	;window_handle
call SC_Comment_Richedit_Selection

jmp end_process_popup_menu_commands
no_popup_menu_comment:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Comment Selection"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Uncomment Selection"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1010
jne no_popup_menu_uncomment

push active_window_for_popup	;window_handle
call SC_Uncomment_Richedit_Selection

;push 40
;push 2100
;call Beep

jmp end_process_popup_menu_commands
no_popup_menu_uncomment:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Uncomment Selection"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start popup menu "Insert FileName"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1011
jne no_popup_menu_insert_filename

;push 40
;push 2100
;call Beep

push 0		;operation_type
call SCL_Insert_File_Name_To_Window

jmp end_process_popup_menu_commands
no_popup_menu_insert_filename:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End popup menu "Insert FileName"


end_process_popup_menu_commands:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PEPM_01, LP_PEPM_01, EP_PEPM_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 20
SCL_Process_Edit_Popup_Messages endp		;FPC_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push 0		;operation_type
;call SCL_Insert_File_Name_To_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Insert_File_Name_To_Window proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_IFNTW_01, EP_IFNTW_01

mov eax,dword ptr [ebp]+8
mov operation_type_IFNTW_01,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_IFNTW_01, LF_IFNTW_01, operation_type_IFNTW_01, LP_IFNTW_01, EP_IFNTW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start_get_active_window_for_insert_filename:
push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_get_active_window_for_insert_filename
mov active_window_for_edit_insert_filename,ebx
cmp ebx,0
je no_active_window_for_insert_file_name

.DATA
active_window_for_edit_insert_filename	dd 0

INSERT_OPENFILENAMEA		db 76  dup (0)  ;;file name offset 56    file extension offset 58 
INSERT_file_title			dd 100 dup (0)
INSERT_extended_filter		db 'All files',0, '*.*',0,   'Exe files',0, '*.exe',0,  'Asm files',0, '*.asm',0,  'Inc files',0,'*.inc',0,'Def files',0,'*.def',0,'Rc files',0,'*.rc',0,'Map files',0,'*.map',0, 'Text files',0,'*.txt',0, 'Bat files',0,'*.bat',0,  'DLL files',0,'*.dll',0,  'LIB files',0 ,'*.lib',0, 0
INSERT_file_name_buffer		dd  100 dup (0)
INSERT_add_existing_file_title	db 'Add existing file to project',0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset file name buffer
xor eax,eax
mov edi,offset INSERT_file_name_buffer
mov ecx,100
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset file name buffer
mov dword ptr INSERT_OPENFILENAMEA+28,offset INSERT_file_name_buffer
mov dword ptr INSERT_OPENFILENAMEA+36,offset INSERT_file_title
mov dword ptr INSERT_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr INSERT_OPENFILENAMEA+48,offset INSERT_add_existing_file_title
mov dword ptr INSERT_OPENFILENAMEA,76
mov dword ptr INSERT_OPENFILENAMEA+24,2
mov dword ptr INSERT_OPENFILENAMEA+32,398
mov dword ptr INSERT_OPENFILENAMEA+40,398
mov dword ptr INSERT_OPENFILENAMEA+52,80000h+1000h+200000h+02000000h 
mov dword ptr INSERT_OPENFILENAMEA+12,offset INSERT_extended_filter
mov eax,hwnd 
mov dword ptr INSERT_OPENFILENAMEA+4,eax
push offset INSERT_OPENFILENAMEA
call GetOpenFileNameA
cmp eax,0
je end_insert_file_name_to_window

push offset INSERT_file_name_buffer		;lparam 
push 0					;wparam 
push 0C2h				;EM_REPLACESEL
push active_window_for_edit_insert_filename
call SendMessageA

push offset eol_code			;lparam 
push 0					;wparam 
push 0C2h				;EM_REPLACESEL
push active_window_for_edit_insert_filename
call SendMessageA

end_insert_file_name_to_window:


no_active_window_for_insert_file_name:

;push 40
;push 2100
;call Beep
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_IFNTW_01, LP_IFNTW_01, EP_IFNTW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Insert_File_Name_To_Window  endp		;FPC_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Draw_Main_Window_Interface proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_DMWI_01, EP_DMWI_01

mov eax,dword ptr [ebp]+8
mov operation_type_DMWI_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_DMWI_01, LF_DMWI_01, operation_type_DMWI_01, LP_DMWI_01, EP_DMWI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push hwnd
call GetDC
mov draw_main_interface_hdc,eax
.DATA
draw_main_interface_hdc			dd 0
files_window_header_coordinates		dd 0, 16, 16, 0,  133, 0, 149, 16
results_window_header_coordinates	dd 0, 16, 16, 0,  133, 0, 149, 16

files_text				db 'Files',0, 0, 0
results_text				db 'Results',0
.CODE

push List_Color_2_Handle
push draw_main_interface_hdc
call SelectObject

push 4				;point count
push offset files_window_header_coordinates
push draw_main_interface_hdc
call Polygon

mov results_window_header_coordinates,0
mov results_window_header_coordinates+4,16
mov results_window_header_coordinates+8,16
mov results_window_header_coordinates+12,0
mov results_window_header_coordinates+16,133
mov results_window_header_coordinates+20,0
mov results_window_header_coordinates+24,149
mov results_window_header_coordinates+28,16

;project_list_rect		dd 0, 0, 150, 0

;0
;8
;16
;24

mov ebx,[main_asm_ide_window_client_rect]+8
sub ebx,151

add dword ptr [results_window_header_coordinates],ebx
add dword ptr [results_window_header_coordinates]+8,ebx
add dword ptr [results_window_header_coordinates]+16,ebx
add dword ptr [results_window_header_coordinates]+24,ebx

push 4				;point count
push offset results_window_header_coordinates
push draw_main_interface_hdc
call Polygon

push list_font_handle
push draw_main_interface_hdc
call SelectObject

push 0000FF00h
push draw_main_interface_hdc
call SetTextColor

push 0
push draw_main_interface_hdc
call SetBkMode

push 4	
push offset files_text
push 2
push 60
push draw_main_interface_hdc
call TextOutA

mov ebx,[main_asm_ide_window_client_rect]+8
sub ebx,151
add ebx,60

push 7
push offset results_text
push 2
push ebx;60
push draw_main_interface_hdc
call TextOutA

push draw_main_interface_hdc
push hwnd
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_DMWI_01, LP_DMWI_01, EP_DMWI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Draw_Main_Window_Interface endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Load_Asm_Ide_New_Instance proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_LAINI_01, EP_LAINI_01

mov eax,dword ptr [ebp]+8
mov operation_type_LAINI_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_LAINI_01, LF_LAINI_01, operation_type_LAINI_01, LP_LAINI_01, EP_LAINI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
current_module_file_name		db 400 dup (0)
.CODE

mov edi,offset current_module_file_name
mov ecx,100
xor eax,eax
cld
rep stosd

push 400
push offset current_module_file_name
push hInst
call GetModuleFileName
;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
mov edi,offset CP_STARTUPINFO
mov ecx,17
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
mov edi,offset CP_PROCESS_INFORMATION
mov ecx,4
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
CP_STARTUPINFO 		dd 68 dup (0)
CP_PROCESS_INFORMATION	db 16 dup (0)
.CODE

push offset CP_PROCESS_INFORMATION		;pointer to PROCESS_INFORMATION           
push offset CP_STARTUPINFO			;pointer to STARTUPINFO
push 0							;offset lpCurrentDirectory   ;pointer to current directory
push 0							;offset lpEnvironment    ;pointer to new environment block 
push 0							;dwCreationFlags      ;creation flags 
push 0							;bInheritHandles      ;handle inheritance flag 
push 0							;offset lpThreadAttributes   ;thread security attributes 
push 0							;offset lpProcessAttributes  ;process security attributes 
push 0							;offset lpCommandLine     ;pointer to command line string
push offset current_module_file_name		;offset lpApplicationName    ;name of executable module 
call CreateProcessA  
	;If the function fails, the return value is zero. To get extended error information, call GetLastError. 

push dword ptr CP_PROCESS_INFORMATION+4
call CloseHandle

push dword ptr CP_PROCESS_INFORMATION
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_LAINI_01, LP_LAINI_01, EP_LAINI_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Load_Asm_Ide_New_Instance endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Load_Mouse_Coordinates_Tool  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_LMCT_01, EP_LMCT_01

mov eax,dword ptr [ebp]+8
mov operation_type_LMCT_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_LMCT_01, LF_LMCT_01, operation_type_LMCT_01, LP_LMCT_01, EP_LMCT_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0			;operation_type
call SCL_Get_Current_Module_Path

mov edi,GCMFNP_only_file_name_address
mov esi,offset mouse_coordinates_process
mov ecx,8
cld
rep movsb

;mouse_coordinates_process		db 'WPI.exe',0		;7

push 1					;Method of show	;1 -  for *.exe files	;0 - for  *.htm ... ;;; 
push 0					;Work catalog
push 0					;Command line 
push GCMFNP_file_name_address	;Offset of file name        
push 0					;For open  - 0    ;for print - 1
push 0					;Parent window handle who get message 
call ShellExecuteA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_LMCT_01, LP_LMCT_01, EP_LMCT_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Load_Mouse_Coordinates_Tool endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Get_Current_Module_Path  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GCMP_08, EP_GCMP_08

mov eax,dword ptr [ebp]+8
mov operation_type_GCMP_08,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_GCMP_08, LF_GCMP_08, operation_type_GCMP_08, LP_GCMP_08, EP_GCMP_08
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
;;current_module_file_name		db 400 dup (0)
current_module_path			db 400 dup (0)
mouse_coordinates_process		db 'WPI.exe',0		;7
insert_color_tool				db 'CPICKER.EXE',0		;11

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
GET_CM_FILE_NAME_PARAMETERS label dword
		GCMFNP_file_name_length			dd 43					;0
		GCMFNP_file_name_address			dd 0;offset file_name_string_for_check		;4
		GCMFNP_full_file_name_length		dd 0					;8
		GCMFNP_specified_file_type		dd 0	;0 - Full file name	;1 - Only File name	;12
		GCMFNP_file_name_end_type		dd 0	;0 - End Found	;1 - End Not Found	;16
		GCMFNP_only_file_name_length		dd 0					;20
		GCMFNP_only_file_name_address		dd 0					;24
		GCMFNP_extension_specified_flag	dd 0					;28
		GCMFNP_only_extension_length		dd 0					;32
		GCMFNP_only_extension_address		dd 0					;36
		GCMFNP_extension_type			dd 0					;40
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Current Module File Name
mov edi,offset current_module_path
mov ecx,100
xor eax,eax
cld
rep stosd

push 400
push offset current_module_path
push hInst
call GetModuleFileName
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Current Module File Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine Current Module Path
mov dword ptr GET_CM_FILE_NAME_PARAMETERS,400
mov dword ptr GET_CM_FILE_NAME_PARAMETERS+4,offset current_module_path

push offset GET_CM_FILE_NAME_PARAMETERS		;ebp+8
call SC_Get_File_Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine Current Module Path
	mov eax,GCMFNP_only_file_name_address
mov edi,eax
	mov ebx,GCMFNP_only_file_name_length
mov ecx,ebx
xor eax,eax
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GCMP_08, LP_GCMP_08, EP_GCMP_08
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Get_Current_Module_Path endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;push 1					;Method of show	;1 -  for *.exe files	;0 - for  *.htm ... ;;; 
;push 0					;Work catalog
;push 0					;Command line 
;push GCMFNP_file_name_address	;Offset of file name        
;push 0					;For open  - 0    ;for print - 1
;push 0					;Parent window handle who get message 
;call ShellExecuteA

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Load_ASM_IDE_About_Html  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_LAIAH_01, EP_LAIAH_01

mov eax,dword ptr [ebp]+8
mov operation_type_LAIAH_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_LAIAH_01, LF_LAIAH_01, operation_type_LAIAH_01, LP_LAIAH_01, EP_LAIAH_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
about_htm_name	db 'about.htm',0
.CODE

push 0			;operation_type
call SCL_Get_Current_Module_Path

mov edi,GCMFNP_only_file_name_address
mov esi,offset about_htm_name
mov ecx,9
cld
rep movsb

;mouse_coordinates_process		db 'WPI.exe',0		;7

push 1					;Method of show	;1 -  for *.exe files	;0 - for  *.htm ... ;;; 
push 0					;Work catalog
push 0					;Command line 
push GCMFNP_file_name_address	;Offset of file name        
push 0					;For open  - 0    ;for print - 1
push 0					;Parent window handle who get message 
call ShellExecuteA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_LAIAH_01, LP_LAIAH_01, EP_LAIAH_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Load_ASM_IDE_About_Html endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;












;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm












