asm_ide_all_size_control macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push file_list_hide_status				;ebp+16
;push project_list_hide_status				;ebp+12
;push operation_type					;ebp+8
;call SCL_Control_File_And_Project_List_Location

SCL_Control_File_And_Project_List_Location proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CFAPLL_01, EP_CFAPLL_01

mov eax,dword ptr [ebp]+8
mov operation_type_CFAPLL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CFAPLL_01, LF_CFAPLL_01, operation_type_CFAPLL_01, LP_CFAPLL_01, EP_CFAPLL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
main_asm_ide_window_client_rect	dd 0, 0, 0, 0
file_list_rect			dd 0, 0, 150, 0
project_list_rect		dd 0, 0, 150, 0
status_bar_rect			dd 0, 0, 0, 0
.CODE

push offset main_asm_ide_window_client_rect
push hwnd
call GetClientRect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start adjust main window rect
;;Keep_Within_Boundaries macro min, value, max 	;result in [EAX]
Keep_Within_Boundaries 320, main_asm_ide_window_client_rect+8, 10000 	;result in [EAX]
mov main_asm_ide_window_client_rect + 8,eax	;width of client rect

;;Keep_Within_Boundaries macro min, value, max 	;result in [EAX]
Keep_Within_Boundaries 60, main_asm_ide_window_client_rect+12, 10000 	;result in [EAX]
mov main_asm_ide_window_client_rect + 12,eax	;height of client rect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End adjust main window rect

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start move file list
mov eax,main_asm_ide_window_client_rect + 12	;height of client rect
sub eax,32
mov file_list_rect+12,eax

push 1
push file_list_rect+12
push file_list_rect+8		;width
push 16				;Y
push 0				;X
push child_file_list_handle
call MoveWindow

;main_asm_ide_window_client_rect + 8	--> width of client rect
;main_asm_ide_window_client_rect + 12	--> height of client rect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End move file list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start move project list
mov eax,main_asm_ide_window_client_rect + 12	;height of client rect
sub eax,32
mov project_list_rect+12,eax

;project_list_rect		X
;project_list_rect+4		Y

mov eax,main_asm_ide_window_client_rect + 8	;width of client rect
sub eax,151

push 1
push project_list_rect+12
push project_list_rect+8	;width
push 16				;Y
push eax			;X
push child_project_list_handle
call MoveWindow

;main_asm_ide_window_client_rect + 8	--> width of client rect
;main_asm_ide_window_client_rect + 12	--> height of client rect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start move project list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start move statusbar
;mov eax,main_asm_ide_window_client_rect + 12	;height of client rect
;sub eax,32
;mov project_list_rect+12,eax

;main_asm_ide_window_client_rect	dd 0, 0, 0, 0
;status_bar_rect			dd 0, 0, 0, 0

mov eax,main_asm_ide_window_client_rect+12	;Height of main window
sub eax,16
mov ebx,main_asm_ide_window_client_rect+8	;Width of main window

mov status_bar_rect,0				;X
mov status_bar_rect+4,eax			;Y
mov status_bar_rect+8,ebx			;Width
mov status_bar_rect+12,16			;Height

push 1
push 16						;Height
push ebx					;Width
push eax					;Y
push 0						;X
push child_status_bar_handle
call MoveWindow


;main_asm_ide_window_client_rect + 8	--> width of client rect
;main_asm_ide_window_client_rect + 12	--> height of client rect
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End move statusbar



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start control richedit window 
.DATA
Left_List_Window_Width			dd 0
Right_List_Window_Width			dd 0
Left_Zone				dd 5
Right_Zone				dd 5
Richedit_Window_Width			dd 0
Richedit_Window_Height			dd 0
Richedit_Window_Start_X			dd 0
Richedit_Window_Start_Y			dd 0
main_richedit_window_resize_counter	dd 0
.CODE

cmp file_list_hide_status,0			;0 - Hide 1 - show
sete al
ror eax,1
cdq
mov esi,0
mov edi,dword ptr [file_list_rect]+8		;File list width
and esi,edx
not edx
and edi,edx
add esi,edi
mov Left_List_Window_Width,esi

cmp project_list_hide_status,0			;0 - Hide 1 - show
sete al
ror eax,1
cdq
mov esi,0
mov edi,dword ptr [file_list_rect]+8		;File list width
and esi,edx
not edx
and edi,edx
add esi,edi
mov Right_List_Window_Width,esi

mov ecx,main_asm_ide_window_client_rect + 8	;width of client rect
sub ecx,Left_List_Window_Width
sub ecx,Right_List_Window_Width
sub ecx,Left_Zone
sub ecx,Right_Zone
mov Richedit_Window_Width,ecx

mov ecx,main_asm_ide_window_client_rect + 12	;height of client rect
sub ecx,32
mov Richedit_Window_Height,ecx

mov eax,Left_Zone
add eax,Left_List_Window_Width
mov Richedit_Window_Start_X,eax

mov Richedit_Window_Start_Y,16
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Resize all richedit windows
mov main_richedit_window_resize_counter,36
start_resize_main_richedit_windows:
mov eax,main_richedit_window_resize_counter
dec eax
mov ebx,476					;FNL item size in bytes
mul ebx
add eax,File_Name_List_address

cmp dword ptr [eax],0
je FNL_item_Free				;Jump if FNL item is free

mov ecx,dword ptr [eax]+448			;Richedit_Window_Handle

push 1
push Richedit_Window_Height			;Height
push Richedit_Window_Width			;width
push Richedit_Window_Start_Y			;Y
push Richedit_Window_Start_X			;X
push ecx					;child_project_list_handle
call MoveWindow


FNL_item_Free:

dec main_richedit_window_resize_counter
cmp main_richedit_window_resize_counter,0
jne start_resize_main_richedit_windows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Resize all richedit windows
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Resize optional richedit windows
push 1
push Richedit_Window_Height			;Height
push Richedit_Window_Width			;width
push Richedit_Window_Start_Y			;Y
push Richedit_Window_Start_X			;X
push spl_window_handle				;child_project_list_handle
call MoveWindow

push 1
push Richedit_Window_Height			;Height
push Richedit_Window_Width			;width
push Richedit_Window_Start_Y			;Y
push Richedit_Window_Start_X			;X
push output_window_handle			;child_project_list_handle
call MoveWindow

push 1
push Richedit_Window_Height			;Height
push Richedit_Window_Width			;width
push Richedit_Window_Start_Y			;Y
push Richedit_Window_Start_X			;X
push report_window_handle			;child_project_list_handle
call MoveWindow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Resize optional richedit windows




;file_list_rect			dd 0, 0, 150, 0
;project_list_rect		dd 0, 0, 150, 0


;mov main_asm_ide_window_client_rect + 8,eax	;width of client rect
;mov main_asm_ide_window_client_rect + 12,eax	;height of client rect




;main_asm_ide_window_client_rect	dd 0, 0, 0, 0




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End control richedit window 
;push 40
;push 440
;call Beep

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CFAPLL_01, LP_CFAPLL_01, EP_CFAPLL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Control_File_And_Project_List_Location endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push save_type						;ebp+12
;push operation_type					;ebp+8
;call SCL_Save_Selection_As

;save_type ;0 -  Save all ;1 - Save selection

SCL_Save_Selection_As proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SSA_01, EP_SSA_01

mov eax,dword ptr [ebp]+8
mov operation_type_SSA_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SSA_01, LF_SSA_01, operation_type_SSA_01, LP_SSA_01, EP_SSA_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
save_as_active_richedit_window		dd 0
s_save_as_dialog_title			db 'Save selection as',0
s_save_as_file_name_buffer		db 400 dup (0)
s_save_as_file_title			db 400 dup (0)
s_save_file_internal_handle		dd 0
selection_save_as_error_code		dd 0
.CODE


start_get_active_window_for_save_as:
push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_get_active_window_for_save_as
mov save_as_active_richedit_window,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get File Name For Save As
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset file name buffer
xor eax,eax
mov edi,offset new_file_name_buffer
mov ecx,100
cld 
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset file name buffer
mov dword ptr ADD_OPENFILENAMEA+28,offset s_save_as_file_name_buffer
mov dword ptr ADD_OPENFILENAMEA+36,offset s_save_as_file_title
mov dword ptr ADD_OPENFILENAMEA+44,0					;offset current_dir
mov dword ptr ADD_OPENFILENAMEA+48,offset s_save_as_dialog_title
mov dword ptr ADD_OPENFILENAMEA,76
mov dword ptr ADD_OPENFILENAMEA+24,2
mov dword ptr ADD_OPENFILENAMEA+60,offset default_extension
mov dword ptr ADD_OPENFILENAMEA+32,398
mov dword ptr ADD_OPENFILENAMEA+40,398
mov dword ptr ADD_OPENFILENAMEA+52,80000h+4h+200000h+20000h+2000000h+400h+2
mov dword ptr ADD_OPENFILENAMEA+12,offset extended_filter
mov eax,hwnd 
mov dword ptr ADD_OPENFILENAMEA+4,eax
push offset ADD_OPENFILENAMEA
call GetSaveFileNameA
cmp eax,0
je end_save_as_selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create New File
start_save_selection_in_richedit:

push dword ptr [ebp]+12		;STREAMOUT_type		;ebp+20
push save_as_active_richedit_window			;ebp+16
push offset s_save_as_file_name_buffer			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Transfer_Richedit_Window_Contents_Into_File
;;;;STREAMOUT_type	 ;0 - Save All Richedit window ;1 - Save only selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - Error owner
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - WriteFile generates error
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_save_selection_in_richedit
cmp eax,0
je end_report_selection_save_as

mov selection_save_as_error_code,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset line_text	;"_______________________________"
add_report_line 		;[eax] - contains line address

mov eax,offset create_new_file_error_title		;"System error occured with new file"
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset file_name_text	;"File name"
add_report_line 		;[eax] - contains line address

mov eax,offset s_save_as_file_name_buffer   ; "..........asm/inc/txt/bat" ;File name which obtained from GetSaveFileNameA
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code		;eol_code db 0dh, 0ah,0
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
mov eax,offset file_input_error_title	;"System error description"
add_report_line 		;[eax] - contains line address

push selection_save_as_error_code	;system_error code		;ebp+8
call Get_System_Error_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;mov eax,create_new_file_error_text	;[eax] - contains error text address
add_report_line 		;[eax] - contains line address

mov eax,offset eol_code		;eol_code db 0dh, 0ah,0
add_report_line 		;[eax] - contains line address

mov eax,offset line_text	;"___________________________________________",0dh, 0ah
add_report_line 		;[eax] - contains line address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_report_selection_save_as:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get File Name For Save As
end_save_as_selection:

;push 40
;push 440
;call Beep
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SSA_01, LP_SSA_01, EP_SSA_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Save_Selection_As endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push dword ptr [ebp]+20				;ebp+16
;push dword ptr [ebp]+16				;ebp+12
;push 0 ;operation_type					;ebp+8
;call SCL_Set_Active_Window_Focus

;dword ptr [ebp]+20	;lparam - second message parameter
;dword ptr [ebp]+16	;wparam - first message parameter
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SCL_Set_Active_Window_Focus proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SCLSAWF_01, EP_SCLSAWF_01

mov eax,dword ptr [ebp]+8
mov operation_type_SCLSAWF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SCLSAWF_01, LF_SCLSAWF_01, operation_type_SCLSAWF_01, LP_SCLSAWF_01, EP_SCLSAWF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je no_window_active
cmp ebx,0
je no_window_active

push ebx		;ebx
call SetFocus

no_window_active:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_SCLSAWF_01, LP_SCLSAWF_01, EP_SCLSAWF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Set_Active_Window_Focus endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Timer_Function proc
push ebp
mov ebp,esp
push ebx
push esi
push edi


call GetForegroundWindow
cmp eax,hwnd
jne no_current_window_active

;push 40
;push 440
;call Beep

push 0 ;operation_type					;ebp+8
call SCL_Set_Active_Window_Focus

push 0  ;operation_type
call SCL_Draw_Status_Bar
no_current_window_active:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_get_active_window_for_find:
push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_get_active_window_for_find
mov active_window_for_find,ebx
.DATA
active_window_for_find		dd 0
autosave_enable_flag		dd 0		;0 - Autosave disabled	;1 - Autosave Enabled
current_save_count_start_point	dd 0
current_tick_count		dd 0
autosave_time_period_in_MS	dd 600000 ;2000		;600000
.CODE

mov ebx,active_window_for_find
cmp ebx,0
je no_active_window_for_find

push ebx				;richedit_window_handle		;ebp+12
push 0					;operation_type			;ebp+8
call frd_v_10_refresh_address		;SCL_Refresh_Find_Replace_Info

no_active_window_for_find:

mov ebx,active_window_for_find
cmp ebx,0
jne no_hide_find_dialog

push 0				;operation_type
call frd_v_10_hide_address	;SCL_Hide_Find_Replace_Dialog

no_hide_find_dialog:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp autosave_enable_flag,0
je no_autosave_by_timer			;0 - Autosave disabled	;1 - Autosave Enabled

call GetTickCount		;The return value is the number of milliseconds that have elapsed since the system was started.
mov current_tick_count,eax

mov eax,current_tick_count
sub eax,current_save_count_start_point
cmp eax,autosave_time_period_in_MS
jb no_autosave_period_expired
;;;IF [[current_tick_count] - [current_save_count_start_point]] > = [autosave_time_period_in_MS]
;;;;	 Then call [SCL_Autosave] and set [current_tick_count] - [current_save_count_start_point]
;10 min = 600000 ms

push 0	;operation_type
call SCL_Auto_Save_Project

mov eax,current_tick_count
mov current_save_count_start_point,eax

no_autosave_period_expired:

no_autosave_by_timer:


pop edi
pop esi
pop ebx
mov esp,ebp
pop ebp
ret 16
Timer_Function endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push operation_type					;ebp+8
;call SCL_Perform_Main_Window_Close

SCL_Perform_Main_Window_Close proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PMWC_01, EP_PMWC_01

mov eax,dword ptr [ebp]+8
mov operation_type_PMWC_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_PMWC_01, LF_PMWC_01, operation_type_PMWC_01, LP_PMWC_01, EP_PMWC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;IF [APF_load_flag] = 1 then [Close Project]		;0 - APF absent ;1 - APF present 

cmp APF_load_flag,0
je no_close_existing_project
push 1	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

no_close_existing_project:


;IF [SPL_load_flag] = 1 then [Save and Close SPL]	;0 - Spl file not loaded ;1 - SPl file loaded
cmp SPL_load_flag,0
je no_close_existing_SPL

push 011b			;save_type		;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type
;;Bits
;0	;0 - Do not display save confirmation	;1 - Display save confirmation
;1	;0 - Do not close SPL			;1 - Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
no_close_existing_SPL:


;push 40
;push 440
;call Beep
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PMWC_01, LP_PMWC_01, EP_PMWC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Perform_Main_Window_Close endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push operation_type					;ebp+8
;call SCL_Perform_Main_Window_Close

SCL_Auto_Save_Project proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_ASP_01, EP_ASP_01

mov eax,dword ptr [ebp]+8
mov operation_type_ASP_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_ASP_01, LF_ASP_01, operation_type_ASP_01, LP_ASP_01, EP_ASP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;popup_text_2_1_1	db 'Autosave...	Ctrl+D',0			;211

;;; IF [APF_load_flag] = 1 Save Project	;;APF_load_flag  ;0 - APF absent ;1 - APF present 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Autosave All Project
cmp APF_load_flag,1
jne no_autosave_project

jmp end_perform_autosave
no_autosave_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Autosave All Project


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Autosave SPL
;;; IF [SPL_load_flag] = 1 Save SPL	;;;SPL_load_flag ;0 - Spl file not loaded ;1 - SPl file loaded



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Autosave SPL



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Autosave Files List
cmp List_Item_Selection_Number,0
je no_autosave_files_list

push 000b  ;open_type					;ebp+16
push 0	;file_list_item_number			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Save_File_List
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Save All files					;1 - Save Specified file list item
;1	;0 - Do not show save confirmation dialog 	;1 - Show save confirmation dialog
;2	;0 - Do not close saved files			;1 - Close saved files
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 

no_autosave_files_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Autosave Files List

;push 20
;push 2050
;call Beep

end_perform_autosave:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_ASP_01, LP_ASP_01, EP_ASP_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Auto_Save_Project endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Asm_Ide_About_Dialog	proc 
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr [ebp+0ch],WM_CLOSE
je	about_dialog_close
cmp dword ptr [ebp+0ch],WM_COMMAND
je	about_dialog_close 
cmp dword ptr [ebp+0ch],WM_PAINT
je	about_wm_dialog_paint 
cmp dword ptr [ebp+0ch],WM_ACTIVATE 
je	about_wm_dialog_paint 
cmp dword ptr [ebp+0ch],WM_ACTIVATEAPP
je	about_wm_dialog_paint 

jmp about_dialog_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process About WM_PAINT
about_wm_dialog_paint:
.DATA
about_dialog_window_hdc		dd 0
asm_main_description_1		db 'Asm IDE version 1.6.0.0'	;23
asm_main_description_2		db 'For Assembler Project'	;21
asm_main_description_3		db 'Development'			;11
.CODE

push dword ptr [ebp]+8
call GetDC
mov about_dialog_window_hdc,eax

push 0
push about_dialog_window_hdc
call SetBkMode

push 00FFFFFFh
push about_dialog_window_hdc
call SetTextColor

push list_font_handle
push about_dialog_window_hdc
call SelectObject

push 23
push offset asm_main_description_1
push 10		;Y
push 50		;X
push about_dialog_window_hdc
call TextOutA

push 21
push offset asm_main_description_2
push 24		;Y
push 56		;X
push about_dialog_window_hdc
call TextOutA

push 11
push offset asm_main_description_3
push 38		;Y
push 76		;X
push about_dialog_window_hdc
call TextOutA


push info_icon_handle
push 10  	;Y
push 10	;X
push about_dialog_window_hdc
call DrawIcon

push about_dialog_window_hdc
push dword ptr [ebp]+8
call ReleaseDC

jmp about_dialog_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process About WM_PAINT

about_dialog_close:

push 0
push dword ptr [ebp+8]  ;;hwnd
call EndDialog

;jmp about_dialog_default
about_dialog_default:
mov eax,0
pop edi
pop esi
pop ebx
pop ebp
ret 16
Asm_Ide_About_Dialog	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push operation_type					;ebp+8
;call SCL_Perform_Input_From_Command_Line

SCL_Perform_Input_From_Command_Line proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PIFCL_01, EP_PIFCL_01

mov eax,dword ptr [ebp]+8
mov operation_type_PIFCL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_PIFCL_01, LF_PIFCL_01, operation_type_PIFCL_01, LP_PIFCL_01, EP_PIFCL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
command_line_file		db 400 dup (0)
command_line_result	dd 0
.CODE

start_scan_main_module_command_line:

push offset command_line_file	;ebp+12
push 0	;operation_type		;ebp+8
call SCL_Scan_Command_Line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Return 
;[eax] - (-1) - Function busy
	;[ebx] -  0  - No command Line Specified 
	;[ebx] -  1 -  Specified .APF file	
	;[ebx] -  2  -  File Which must be load as single file in project
	;[ebx] -  3  - Specified .spl file
	;[ebx] -  4  - Absent first delimiter [Error code]
	;[ebx] -  5  - Absent Second delimiter [Error code]
	;[ebx]  - 6  - Specified filename has incorrect format
	;[ebx]  - 7  - Specified file name has no extension
	;[ebx] -  8  - Specified file name has unsupported extension
;[esi]  - File full name address
;[ecx] - File full name length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_scan_main_module_command_line
cmp ebx,0
je no_command_line_file_specified
mov command_line_result,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check IF APF file specified 
;IF [command_line_result] = 1 - Load as APF file
cmp command_line_result,1
jne no_APF_in_command_line

push 1 ;open_type				;ebp+16
push offset  command_line_file	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Open_Project_APF_File
;open_type ;0 - Use GetOpenFileNameA ;1 - Use specified file

no_APF_in_command_line:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check IF APF file specified 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check IF standard file specified 
;IF [command_line_result] = 2 - Load as file to project

cmp command_line_result,2
jne no_STD_file_in_command_line

push 1 ;add_type					;ebp+16
push offset  command_line_file		;ebp+12
push 0;operation_type				;ebp+8
call SCL_Add_Existing_File_To_Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;add_type - 0 - Use [ GetOpenFileNameA ] to get file name and open
;add_type - 1 - Use specified file name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_STD_file_in_command_line:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check IF standard file specified 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check IF SPL file specified 
;IF [command_line_result] = 3 - Load as SPL
cmp command_line_result,3
jne no_SPL_file_in_command_line

push 0110b  ;open_type			;ebp+16
push offset  command_line_file	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Open_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_SPL_file_in_command_line:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check IF SPL file specified 

no_command_line_file_specified:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PIFCL_01, LP_PIFCL_01, EP_PIFCL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Perform_Input_From_Command_Line endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
















endm










 