create_child_file_list macro

Create_Child_File_List proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
cbSize_2                dd    48
style_2                 dd    3				;CS_HREDRAW+CS_VREDRAW
lpfnWndProc_2           dd    offset Child_List_Window_Proc_1
cbClsExtra_2            dd    0
cbWndExtra_2            dd    0
hInstance_2             dd    0
hIcon_2                 dd    0				;Values get from LoadIcon
hCursor_2               dd    0				;Values get from LoadCursorA
hbrBackground_2         dd    0
lpszMenuName_2          dd    0
lpszClassName_2         dd    offset  new_class_name 	;Window name 
hIconSm_2               dd    0

new_class_name		db 'NEW_LIST_CLASS',0
child_file_list_handle	dd 0
child_hdc		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov hInstance_2,eax

	push	32649
	push	0
	call	LoadCursorA
	mov dword ptr hCursor_2,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 5
	call GetStockObject
	mov   dword ptr hbrBackground_2,eax

mov   lpszClassName_2,offset new_class_name	

	push offset cbSize_2
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	520			;Vertical size of window
	push	150			;Horizontal size of window 
	push	16			;Y coordinate relative to parent window
	push	1			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset new_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_file_list_handle,eax

push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Set_List_Parameters

push    0				;bRedraw
push	0				;nMaxPos
push    0				;nMinPos
push    0 				;nBar
push  child_file_list_handle
call   SetScrollRange			;Set New Scroll Range

push    1				;bRedraw
push	0				;nMaxPos
push    0				;nMinPos
push    1				;nBar
push  child_file_list_handle
call   SetScrollRange			;Set New Scroll Range

;	push	1
;	push	child_file_list_handle
;	call	ShowWindow		;Do not need to show window because it is already visible
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create Child Class and Window
mov esp,ebp
pop ebp
ret
Create_Child_File_List endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Child_List_Window_Proc_1 proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	wmpaint_2
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_SIZE	;5h
je	wm_size
cmp dword ptr ss:[ebp+0ch],115h	;WM_VSCROLL 115h
je	wm_vscroll_2
cmp dword ptr ss:[ebp+0ch],114h	;WM_HSCROLL 115h
je	wm_hscroll_2

cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	wm_mouse_right_button_up


jmp default_2

wm_mouse_left_button_down:

push 0	;operation_type
call SCL_Force_Close_Popup_Menu

push 0 ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control

.DATA
text_to_add		db 'Text to add ',0
.CODE


jmp wmpaint_2

mov eax,0
jmp default_2


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
wm_mouse_right_button_up:

push 8 ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;SCL_Activate_Files_Popup_Menu 

mov eax,0
jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process vertical scroll
wm_vscroll_2:
scroll_vertical_scroll_bar
jmp wmpaint_2
;jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process vertical scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process horizontal scroll
wm_hscroll_2:
scroll_horizontal_scroll_bar

jmp wmpaint_2
;jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process horizontal scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redefine list size changes
wm_size:

push list_font_handle			;ebp+20
push offset LIST_CONTENTS		;ebp+16
push dword ptr [ebp]+8	;child_file_list_handle			;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Redefine_List_Scroll_Bars

;jmp wmpaint_2
xor eax,eax
jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Redefine list size changes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
wm_mouse_move:

;push 1;draw_operation			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push child_file_list_handle		;ebp+12
;push 0;operation_type			;ebp+8
;call SCL_Perform_List_Effect		;FPC_5


;push offset COLOR_HANDLES_ARRAY	;ebp+32
;push memory_dc				;ebp+28
;push List_Item_Number			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call SCL_Repaint_List_Item		;FPC_7


mov eax,0
jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
wmpaint_2:

push offset COLOR_HANDLES_ARRAY		;ebp+28
push memory_dc				;ebp+24
push list_font_handle			;ebp+20
push offset LIST_CONTENTS		;ebp+16
push dword ptr [ebp]+8		;child_file_list_handle				;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6

;push dword ptr [ebp]+8	;child_file_list_handle
;call GetDC
;mov child_hdc,eax

.DATA
too_long_text		db 'Too long text which is shown in child window and always shows partial',0
mouse_status		dd 0
.CODE

;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push child_hdc				;ebp+12
;push 0;operation_type			;ebp+8
;call SCL_Get_List_Content_Dimensions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ecx] - List contents width
;[ebx] - List contents height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;show_decimal 80, 30, ebx

;;;	show_decimal 160, 30, mouse_status

;push child_hdc
;push dword ptr [ebp]+8	;child_file_list_handle
;call ReleaseDC

;jmp default_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
default_2:
      win_default

pop edi
pop esi
pop ebx
pop ebp
ret 16
Child_List_Window_Proc_1	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Delete Window ALL classes
Delete_Window_Classes proc
push ebp
mov ebp,esp

push hInst
push offset new_class_name
call UnregisterClass			;Unregister Child File CLASS

push hInst
push offset project_class_name
call UnregisterClass			;Unregister Child Project CLASS

push hInst
push offset header_class_name
call UnregisterClass			;Unregister Child Header Class

push hInst
push offset SB_class_name
call UnregisterClass			;Unregister Child Status Bar Class

push hInst
push offset szClassName
call UnregisterClass			;Unregister Main Class


mov esp,ebp
pop ebp
ret 
Delete_Window_Classes endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Delete Window ALL classes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push operation_type
;call SCL_Compile_Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Compile_Project proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_CP, EP_CP 

mov eax,dword ptr [ebp]+8
mov operation_type_CP,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_CP, LF_CP, operation_type_CP, LP_CP, EP_CP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp SPL_load_flag,0			;dd 0 ;0 - Spl file not loaded ;1 - SPl file loaded
je end_of_project_compile


.DATA
SPL_buffer_length	dd 0
SPL_buffer		db 16384 dup (0)
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset SPL buffer
xor eax,eax
mov edi,offset SPL_buffer
mov ecx,4096
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset SPL buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer SPL contents into buffer
push 0				;lParam 
push 0				;wParam
push 0eh			;WM_GETTEXTLENGTH
push spl_window_handle
call SendMessageA
mov SPL_buffer_length,eax
inc eax

push offset SPL_buffer
push eax			;wParam
push 0dh			;WM_GETTEXT
push spl_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer SPL contents into buffer
mov eax,perform_spl_function_address

push output_window_handle		;ebp+20	;Output edit window handle
push SPL_buffer_length			;ebp+16
push offset SPL_buffer			;ebp+12
push 0 ;operation_type			;ebp+8
call eax				;SCL_Perform_SPL

end_of_project_compile:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CP, LP_CP, EP_CP
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Compile_Project endp		;FPC_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push operation_type
;call SCL_Generate_Results_Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Generate_Results_Report proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_GRP_02, EP_GRP_02

mov eax,dword ptr [ebp]+8
mov operation_type_GRP_02,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_GRP_02, LF_GRP_02, operation_type_GRP_02, LP_GRP_02, EP_GRP_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov result_list_create_report_internal_counter,0

start_get_active_window_for_RR:
push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je start_get_active_window_for_RR
cmp ebx,0
je no_active_window_for_results_report
mov current_active_window_for_RR,ebx

.DATA
current_active_window_for_RR	dd 0
result_list_create_report_internal_counter	dd 0
current_result_report_file_name_address		dd 0
;comment_line					db ';;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;',0dh, 0ah, 0
;comment_symbol					db ';',0
;files_count_text				db ';		Loaded files report',0dh, 0ah
;						db ';Loaded files count		',0

results_files_count_text			db ';		Result files report',0dh, 0ah
						db ';Loaded files count		',0

result_tab					db '			',0
result_files_count				db '0000000000',0dh, 0ah, 0
file_valid_text					db 'File Valid',0
file_invalid_text				db 'File Invalid',0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset comment_line	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA

push offset results_files_count_text	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA

push P_List_Items_Count
push offset result_files_count
call SC_Convert_Bin_To_Dec_10 

push offset result_files_count	;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Report Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Report Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate report
cmp P_List_Items_Count,0
je end_create_result_list_report

mov file_list_create_report_internal_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_create_result_list_report:
inc result_list_create_report_internal_counter

mov eax,result_list_create_report_internal_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset PROJECT_LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset RESULT_FILE_NAME_LIST
mov ecx,eax				;FNL_file_full_name
add ecx,8 
mov current_report_file_name_address,ecx

mov eax,P_List_Items_Count
cmp result_list_create_report_internal_counter,eax
ja end_create_result_list_report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start insert file name
push offset comment_symbol	;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA

push current_report_file_name_address	;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA

push offset result_tab		;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA

mov eax,current_report_file_name_address
sub eax,8
add eax,464			;;RFNL_file_present_flag			dd 0		;464
cmp dword ptr [eax],0		;0 - File not found ;1 - File found
sete al
ror eax,1
cdq
mov esi,offset file_invalid_text
mov edi,offset file_valid_text
and esi,edx
not edx
and edi,edx
add esi,edi

push esi			;offset file_valid_text		;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA


push offset eol_code		;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End insert file name
mov eax,P_List_Items_Count
cmp file_list_create_report_internal_counter,eax
jbe start_create_result_list_report


end_create_result_list_report:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset comment_line	;lparam 
push 0				;wparam 
push 0C2h			;EM_REPLACESEL
push current_active_window_for_RR
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;RESULT_FILE_NAME_LIST label dword		;RRFNL items list is 1 - Based

;RFNL_Item_1	label dword 
;	RFNL_busy_flag				dd 0		;0	;0 - Free ;1 - Busy
;	RFNL_file_full_name_length		dd 0		;4
;	RFNL_file_full_name			db 400 dup (0)	;8
;	RFNL_only_file_path_length		dd 0		;408
;	RFNL_only_file_name_length		dd 0		;412
;	RFNL_file_size				dd 0		;416
;	RFNL_only_file_name_address		dd 0		;420
;	RFNL_only_file_extension_address	dd 0		;424
;	RFNL_file_extension_length		dd 0		;428
;	RFNL_CFL_ftCreationTime_Low		dd 0		;432
;	RFNL_CFL_ftCreationTime_High		dd 0		;436
;	RFNL_CFL_ftLastAccessTime_Low		dd 0		;440
;	RFNL_CFL_ftLastAccessTime_High		dd 0		;444
;	RFNL_CFL_ftLastWriteTime_Low		dd 0		;448
;	RFNL_CFL_ftLastWriteTime_High		dd 0		;452
;	RFNL_CFL_nFileSizeHigh			dd 0		;456
;	RFNL_CFL_nFileSizeLow			dd 0		;460
;	RFNL_file_present_flag			dd 0		;464
;	RFNL_RS2				dd 0		;468
;	RFNL_RS3
;
;

;
;PROJECT_LIST_CONTENTS	label dword

;P_List_Items_Count			dd   0						;0
;P_List_Item_Selection_Number		dd   0  ;1 - Based ;Current list selection	;4
;P_List_Internal_X_offset		dd   0						;8
;P_List_Internal_Y_offset		dd   0					;12
;P_List_Empty_Region_Fill_Color_Handle	dd   0;








;push 40
;push 440
;call Beep

no_active_window_for_results_report:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GRP_02, LP_GRP_02, EP_GRP_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Generate_Results_Report endp		;FPC_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





endm


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
show_decimal macro s_x_c, s_y_c, show_value
pushad
mov eax,show_value  ;show;start_address
mov dword ptr string_bin_qword,eax
push offset result_data       ;       ebp+20;
push offset string_pack210    ;       ebp+16
push offset output            ;       ebp+12 
push offset string_bin_qword  ;input  ebp+8
call ConvertBinToDec
push 10
push offset result_data
push s_x_c ;100
push s_y_c ;100
push child_hdc
call TextOutA

popad
endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

