string_functions_1  macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;Using example
;push string_length		;ebp+28
;push offset string		;ebp+24
;call Escape_Separators

Escape_Separators proc
;;;;;;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;ebp+16
push 0a0dh			;ebp+12
push 0				;ebp+8
push 0				;ebp+4

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;		
;push 0					;ebp+24 --> ebp+16
;push 0a0dh				;ebp+20 --> ebp+12
;push 0					;ebp+16 --> ebp+8
;push 0					;ebp+12 --> ebp+4
;push dword ptr string_length		;ebp+8	--> ebp+28
;push dword ptr string_address		;ebp+4	--> ebp+24
;push ebp
;mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;

;.DATA
;string_start_address	dd 0		;ebp+4
;escape_string_length	dd 0		;ebp+8
;address_increment	dd 0		;ebp+12
;increment_count		dd 0		;ebp+16
;eol			dw 0a0dh, 0	;ebp+20
;escape_result		db 0, 0, 0, 0	;ebp+24
;.CODE

start_escape_SPL_F:

mov dword ptr [ebp+8],0	;mov increment_count,0
mov dword ptr [ebp+16],0	;mov escape_result,0
mov edx,dword ptr [ebp+24]	;mov edx,string_start_address
add edx,dword ptr [ebp+4]	;add edx,address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp byte ptr [edx],09h	;Tab
sete al
mov dword ptr [ebp+8],eax	;mov increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp byte ptr [edx],20h	;Space
sete al
add dword ptr [ebp+8],eax	;add increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp word ptr [edx],0a0dh ;EOL
sete al
mov ebx,2
mul ebx		;after this edx --> 0
add dword ptr [ebp+8],eax	;add increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ecx,1
	mov eax,dword ptr [ebp+8]	;mov eax,increment_count
	add eax,dword ptr [ebp+4]	;add eax,address_increment
	cmp eax,dword ptr [ebp+28]	;cmp eax,escape_string_length
	setna al
	mov byte ptr [ebp+16],al	;mov escape_result,al
	ror eax,1
	cdq
	and dword ptr [ebp+8],edx	;and increment_count,edx
	not edx
	and ecx,edx

mov eax,dword ptr [ebp+8]	;mov eax,increment_count
add dword ptr [ebp+4],eax	;add address_increment,eax	;string start address is changed parrallel with escape[increment] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Escape Comments Start
mov edx,dword ptr [ebp+24]	;mov edx,string_start_address
add edx,dword ptr [ebp+4]	;add edx,address_increment
cmp byte ptr [edx],59	;Comment
jne no_find_comment_SPL_F

;;SV_find_string  macro label_index, scan_string_address, all_string_size, find_string_address, find_str_size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;[eax] = 1 string find
;;;;[eax] = 0 string not find
	;;;[ebx] address_increment while find string = [esi] -  scan_string_offset
	;;;[esi] address of first byte of found string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov edi,dword ptr [ebp+24]	;mov edi,string_start_address
add edi,dword ptr [ebp+4]	;add edi,address_increment

mov ebx,dword ptr [ebp+28]	;mov ebx,escape_string_length
sub ebx,dword ptr [ebp+4]	;sub ebx,address_increment
mov ecx,ebp	;mov ecx,offset eol ;0a0dh	;ebp+12
add ecx,12

SV_find_string  SPL_F, edx, ebx, ecx, 2

mov dword ptr [ebp+8],ebx	;mov increment_count,ebx

	mov ecx,1
	mov eax,dword ptr [ebp+8]	;mov eax,increment_count
	add eax,dword ptr [ebp+4]	;add eax,address_increment
	cmp eax,dword ptr [ebp+28]	;cmp eax,escape_string_length
	setna al
add byte ptr [ebp+16],al	;add escape_result,al
	ror eax,1
	cdq
	and dword ptr [ebp+8],edx	;and increment_count,edx
	not edx
	and ecx,edx

mov eax,dword ptr [ebp+8]	;mov eax,increment_count
add dword ptr [ebp+4],eax	;add address_increment,eax	;string start address is changed parrallel with escape[increment] 

no_find_comment_SPL_F:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Escape Comments End
cmp dword ptr [ebp+8],0	;cmp increment_count,0
jne start_escape_SPL_F

mov ecx,dword ptr [ebp+24]	;mov ecx,string_start_address
add ecx,dword ptr [ebp+4]	;add ecx,address_increment

mov ebx,dword ptr [ebp+4]	;mov ebx,address_increment
mov eax,dword ptr [ebp+16]	;mov eax,dword ptr escape_result
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp

pop edx
pop edx
pop edx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 8
Escape_Separators endp

endm
