win_register1 macro

cbSize1                dd    48 
style1                 dd    3                   ;CS_HREDRAW+CS_VREDRAW
lpfnWndProc1           dd    offset WindowProc  
cbClsExtra1            dd    0
cbWndExtra1            dd    0
hInstance1             dd    0  
hIcon1                 dd    ?                   ;Values get from LoadIcon
hCursor1               dd    ?                   ;Values get from LoadCursorA
hbrBackground1         dd    ?
lpszMenuName1          dd    0                   ;   
lpszClassName1         dd    offset  szClassName ;Window name 
hIconSm1               dd    0

endm

win_extern1 macro

extrn SetMenu:PROC
extrn SetWindowLong:PROC     
extrn SendMessageA:PROC
extrn SetFocus:PROC
extrn ShowWindow:PROC
extrn SelectObject:PROC
extrn SetWindowsHookExA:PROC
extrn SetTextColor:PROC
extrn SetBkColor:PROC
extrn SetPixel:PROC
extrn SetPixelFormat:PROC
extrn SetCursorPos:PROC
extrn SetActiveWindow:PROC
extrn LoadMenuA:PROC
extrn LoadCursorA:PROC
extrn LineTo:PROC
extrn GetMenuItemInfoA:PROC
extrn GetCommandLineA:PROC
extrn GetSystemMetrics:PROC
extrn GetProcAddress:PROC
extrn GetSystemMetrics:PROC
extrn GetStockObject:PROC
extrn GetModuleHandleA:PROC
extrn GetMessageA:PROC
extrn GetDC:PROC
extrn GetVersionExA:PROC
extrn GetCurrentProcess:PROC
extrn GetTextExtentPoint32:PROC
extrn GetWindowRect:PROC
extrn UpdateWindow:PROC
extrn TranslateMessage:PROC
extrn DispatchMessageA:PROC
extrn DeleteDC:PROC
extrn DefWindowProcA:PROC
extrn DestroyMenu:PROC
extrn DrawTextA:PROC
extrn DeleteObject:PROC
extrn DrawMenuBar:PROC
extrn DestroyWindow:PROC
extrn ExitProcess:PROC
extrn EndPaint:PROC
extrn EndPath:PROC
extrn PatBlt:PROC
extrn PostQuitMessage:PROC
extrn ReleaseDC:PROC
extrn RegisterClassExA:PROC
extrn Rectangle:PROC
extrn TextOutA:PROC
extrn BitBlt:PROC
extrn BeginPaint:PROC
extrn BeginPath:PROC
extrn MessageBoxA:PROC
extrn CreateCompatibleDC:PROC
extrn CreateCompatibleBitmap:PROC
extrn CreateWindowExA:PROC
extrn CreateSolidBrush:PROC
extrn CreateProcess:PROC
extrn CreatePen:PROC
extrn CreateMenu:PROC
extrn CreateDialog:PROC
extrn InvalidateRect:PROC
extrn TerminateProcess:PROC
extrn UnhookWindowHookEx:PROC
extrn LoadMenuA:PROC
extrn LoadAcceleratorsA:PROC
extrn EndPaint:PROC
extrn TranslateAcceleratorA:PROC 
extrn MoveToEx:PROC
extrn LineTo:PROC
extrn Pie:PROC;

endm

win_default  macro
push	dword ptr  ss:[ebp+14h];@@lparam -- second message parameter
push	dword ptr  ss:[ebp+10h];@@wparam -- first message parameter
push	dword ptr  ss:[ebp+0ch];@@mes    -- message identifier
push	dword ptr  ss:[ebp+08h];@@hwnd   -- handle to window
call	DefWindowProcA
endm

;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; string_bin_qword   dq          (0)
; output             dt  2   dup (0)
; string_pack210     dt  2   dup (0) ;For internal use
; result_data        db '0000000000.',0 
  
;mov eax,1234567891
;mov dword ptr string_bin_qword,eax
;push offset result_data       ;       ebp+20;
;push offset string_pack210    ;       ebp+16
;push offset output            ;       ebp+12 
;push offset string_bin_qword  ;input  ebp+8
;call ComvertBinToDec

convert macro
ConvertBinToDec proc
;;;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||
.586
push ebp
mov ebp,esp
xor eax,eax

fwait
finit
mov eax,dword ptr ss:[ebp+8]  ;offset string_bin_qword
fild dword ptr [eax]   ;string_bin_qword

mov eax,dword ptr ss:[ebp+16]
fbstp [eax] ;string_pack210      ;; result in packed BCD    

finit
fwait
wait
push edx
push ebx
;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||||
;;; Packed BCD unpacking operation
;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||||
mov ebx,dword ptr ss:[ebp+12]
mov edx,dword ptr ss:[ebp+16]
;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||||
xor eax,eax
mov al,byte ptr [edx]        
rol ax,4
mov byte ptr [ebx]+1,ah; ;output+1,ah ;;;;;;;;;;;1
mov ah,0
ror ax,4
mov byte ptr [ebx],al ;;;;;;;;;;;0
;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||
mov al,byte ptr [edx]+1
rol ax,4
mov byte ptr [ebx]+3,ah
mov ah,0
ror ax,4
mov byte ptr [ebx]+2,al
;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||
mov al,byte ptr [edx]+2  
rol ax,4
mov byte ptr [ebx]+5,ah
mov ah,0
ror ax,4
mov byte ptr [ebx]+4,al
;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||
mov al,byte ptr [edx]+3
rol ax,4
mov byte ptr [ebx]+7,ah
mov ah,0
ror ax,4
mov byte ptr [ebx]+6,al
;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||
mov al,byte ptr [edx]+4
rol ax,4
mov byte ptr [ebx]+9,ah
mov ah,0
ror ax,4
mov byte ptr [ebx]+8,al
;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||
push esi
mov esi,dword ptr ss:[ebp+20]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;__________________________________
mov al,byte ptr [ebx]
add al,30h
mov byte ptr [esi]+9,al;

mov al,byte ptr [ebx]+1
add al,30h
mov byte ptr [esi]+8,al;

mov al,byte ptr [ebx]+2
add al,30h
mov byte ptr [esi]+7,al;

mov al,byte ptr [ebx]+3
add al,30h
mov byte ptr [esi]+6,al;

mov al,byte ptr [ebx]+4
add al,30h
mov byte ptr [esi]+5,al;

mov al,byte ptr [ebx]+5
add al,30h
mov byte ptr [esi]+4,al;

mov al,byte ptr [ebx]+6
add al,30h
mov byte ptr [esi]+3,al;

mov al,byte ptr [ebx]+7
add al,30h
mov byte ptr [esi]+2,al;

mov al,byte ptr [ebx]+8
add al,30h
mov byte ptr [esi]+1,al;

mov al,byte ptr [ebx]+9
add al,30h
mov byte ptr [esi],al;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;__________________________________
pop esi
pop ebx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;______________________
pop ebp
ret 16
ConvertBinToDec endp
endm



;;Using example
;push eax          ;;ebp+12;
;push offset text  ;;ebp+8
;call ShowBinary


show_binary macro
ShowBinary proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;||||||||||||||||||||||||||||||||||||||||||||||||||||
.586
push ebp
mov ebp,esp

mov edi,31   ;  
mov ebx,0    ;  
mov esi,0
mov eax,dword ptr [ebp+12]
mov edx,dword ptr [ebp+8]

c123:
bt eax,edi
jnc i1_0

mov edx,dword ptr [ebp+8]
add edx,esi
mov byte ptr [edx],31h  
jmp no_i1

i1_0:
mov edx,dword ptr [ebp+8]
add edx,esi
mov byte ptr [edx],30h  
no_i1:
dec edi
inc esi
cmp esi,32
je ncx
jmp c123
ncx:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;
pop ebp
ret 8
ShowBinary endp
endm


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;

;push eax                  ;ebp+12
;push offset hex_convert   ;ebp+8
;call HexConvert

convert_to_hex macro
HexConvert proc
.586
push ebp
mov ebp,esp

mov edx,000001111b
mov esi,0

mov ecx,8
start_hex_convert:
push ecx

mov ebx,dword ptr [ebp+12]
and ebx,edx 
mov ecx,esi
shr ebx,cl
add esi,4
shl edx,4
add bl,30h
cmp bl,39h
jna n_c_v_1
mov cl,bl
sub cl,39h
mov bl,40h
add bl,cl
n_c_v_1:

pop ecx
dec ecx

mov edi,dword ptr [ebp+8]
mov byte ptr [edi][ecx],bl
cmp ecx,0
jne start_hex_convert

pop ebp
ret 8
endp

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;|||||||||||||||||||||||||||||||||||||||||||||||||||||;
;;escape_close closes the window when ESC is pressed
;;
escape_close  macro handle_to_window

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 1bh		;;VK_ESCAPE 1Bh
call GetAsyncKeyState
	extrn GetAsyncKeyState:PROC
mov dword ptr vk_escape,eax        ;;15 - th bit  (0-15) signaled about key state (1-pressed, 0-not pressed)

assd

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
vk_escape		dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push 40
;push 440
;call Beep
;	extrn Beep:PROC

;MSG STRUCT
;  hwnd      DWORD      ?
;  message   DWORD      ?
;  wParam    DWORD      ?
;  lParam    DWORD      ?
;  time      DWORD      ?
;  pt        POINT      <>
;MSG ENDS 

;cmp dword ptr message+4,100h ;WM_KEYDOWN
;jne escape_not_press

bt vk_escape,15
jnc escape_not_press

push 0    ;lParam   
push 0    ;wParam   
push 10h
push handle_to_window ;hwnd 
call SendMessageA

escape_not_press:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm

escape_close_masm  macro handle_to_window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 1bh		;;VK_ESCAPE 1Bh
call GetAsyncKeyState@4
	extrn GetAsyncKeyState@4:NEAR
mov dword ptr vk_escape,eax        ;;15 - th bit  (0-15) signaled about key state (1-pressed, 0-not pressed)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
vk_escape		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	extrn Beep:PROC

;MSG STRUCT
;  hwnd      DWORD      ?
;  message   DWORD      ?
;  wParam    DWORD      ?
;  lParam    DWORD      ?
;  time      DWORD      ?
;  pt        POINT      <>
;MSG ENDS 

;cmp dword ptr message+4,100h ;WM_KEYDOWN
;jne escape_not_press

;push 40
;push 440
;call Beep

bt vk_escape,15
jnc escape_not_press

push 0    ;lParam   
push 0    ;wParam   
push 10h
push handle_to_window ;hwnd 
call SendMessageA

escape_not_press:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm
