;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
bcd_one_item_add  macro  bcd_address_offset
mov ecx,dword ptr [ebp]+16
mov edx,dword ptr [ebp]+12
xor eax,eax
mov al,byte ptr [ecx]+bcd_address_offset
add al,byte ptr [edx]+bcd_address_offset
add al,bl
aam
mov ecx,dword ptr [ebp]+8
mov byte ptr [ecx]+bcd_address_offset,al 		;;add byte ptr bcd_result+bcd_address_offset,30h  ;;convert 
shr eax,8 
mov ebx,eax

endm

BCD_operations macro
;;;;;;;;;Using example
;push offset BCD_1			;ebp+16
;push offset BCD_2			;ebp+12
;push offset RESULT			;ebp+8
;call SC_Add_BCD_Data_10

SC_Add_BCD_Data_10 proc
push ebp
mov ebp,esp
.DATA
add_bcd_10_busy_flag	dd 0
.CODE
mov eax,(-1)
cmp add_bcd_10_busy_flag,1
je end_add_bcd_data_10
mov add_bcd_10_busy_flag,1

xor ebx,ebx
bcd_one_item_add 9
bcd_one_item_add 8
bcd_one_item_add 7
bcd_one_item_add 6
bcd_one_item_add 5
bcd_one_item_add 4
bcd_one_item_add 3
bcd_one_item_add 2
bcd_one_item_add 1
bcd_one_item_add 0

mov add_bcd_10_busy_flag,0
xor eax,eax
end_add_bcd_data_10:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] -  0   - function processed 
	;[ebx] - remainder
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SC_Add_BCD_Data_10 endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset RESULT		;ebp+12
;push offset BCD_VIEW		;ebp+8
;call SC_Recover_BCD_View

SC_Recover_BCD_View proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer
mov esi,dword ptr [ebp]+12
mov edi,dword ptr [ebp]+8
mov ecx,10
cld
rep movsb			;Transfer from [RESULT] to [BCD_VIEW]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start add for convert to ASCII view
mov edi,dword ptr [ebp]+8
add byte ptr [edi],30h
add byte ptr [edi]+1,30h
add byte ptr [edi]+2,30h
add byte ptr [edi]+3,30h
add byte ptr [edi]+4,30h
add byte ptr [edi]+5,30h
add byte ptr [edi]+6,30h
add byte ptr [edi]+7,30h
add byte ptr [edi]+8,30h
add byte ptr [edi]+9,30h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End add for convert to ASCII view
mov esp,ebp
pop ebp
ret 8
SC_Recover_BCD_View endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push eax
;push offset result_text
;call SC_Convert_Bin_To_Dec_10

SC_Convert_Bin_To_Dec_10 proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header bcd_convert_10_busy_flag, bcd_convert_10_end_point

xor eax,eax
mov edi,offset convert_10_intermediate
mov ecx,4
cld
rep stosd

.DATA

convert_10_bit_0	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 1
convert_10_bit_1	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 2
convert_10_bit_2	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 4
convert_10_bit_3	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 8
convert_10_bit_4	db 0, 0, 0, 0, 0, 0, 0, 0, 1, 6
convert_10_bit_5	db 0, 0, 0, 0, 0, 0, 0, 0, 3, 2
convert_10_bit_6	db 0, 0, 0, 0, 0, 0, 0, 0, 6, 4
convert_10_bit_7	db 0, 0, 0, 0, 0, 0, 0, 1, 2, 8
convert_10_bit_8	db 0, 0, 0, 0, 0, 0, 0, 2, 5, 6
convert_10_bit_9	db 0, 0, 0, 0, 0, 0, 0, 5, 1, 2
convert_10_bit_10	db 0, 0, 0, 0, 0, 0, 1, 0, 2, 4
convert_10_bit_11	db 0, 0, 0, 0, 0, 0, 2, 0, 4, 8
convert_10_bit_12	db 0, 0, 0, 0, 0, 0, 4, 0, 9, 6
convert_10_bit_13	db 0, 0, 0, 0, 0, 0, 8, 1, 9, 2
convert_10_bit_14	db 0, 0, 0, 0, 0, 1, 6, 3, 8, 4
convert_10_bit_15	db 0, 0, 0, 0, 0, 3, 2, 7, 6, 8
convert_10_bit_16	db 0, 0, 0, 0, 0, 6, 5, 5, 3, 6
convert_10_bit_17	db 0, 0, 0, 0, 1, 3, 1, 0, 7 ,2
convert_10_bit_18	db 0, 0, 0, 0, 2, 6, 2, 1, 4, 4
convert_10_bit_19	db 0, 0, 0, 0, 5, 2, 4, 2, 8, 8
convert_10_bit_20	db 0, 0, 0, 1, 0, 4, 8, 5, 7, 6
convert_10_bit_21	db 0, 0, 0, 2, 0, 9, 7, 1, 5, 2
convert_10_bit_22	db 0, 0, 0, 4, 1, 9, 4, 3, 0, 4
convert_10_bit_23	db 0, 0, 0, 8, 3, 8, 8, 6, 0, 8
convert_10_bit_24	db 0, 0, 1, 6, 7, 7, 7, 2, 1, 6
convert_10_bit_25	db 0, 0, 3, 3, 5, 5, 4, 4, 3, 2
convert_10_bit_26	db 0, 0, 6, 7, 1, 0, 8, 8, 6, 4
convert_10_bit_27	db 0, 1, 3, 4, 2, 1, 7, 7, 2, 8
convert_10_bit_28	db 0, 2, 6, 8, 4, 3, 5, 4, 5, 6
convert_10_bit_29	db 0, 5, 3, 6, 8, 7, 0, 9, 1, 2
convert_10_bit_30	db 1, 0, 7, 3, 7, 4, 1, 8, 2, 4
convert_10_bit_31	db 2, 1, 4, 7, 4, 8, 3, 6, 4, 8
convert_10_intermediate	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
convert_10_result	db 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
.CODE

ADD_from_Bit_Test 0,  convert_10_bit_0,  no_bit_0
ADD_from_Bit_Test 1,  convert_10_bit_1,  no_bit_1
ADD_from_Bit_Test 2,  convert_10_bit_2,  no_bit_2
ADD_from_Bit_Test 3,  convert_10_bit_3,  no_bit_3
ADD_from_Bit_Test 4,  convert_10_bit_4,  no_bit_4
ADD_from_Bit_Test 5,  convert_10_bit_5,  no_bit_5
ADD_from_Bit_Test 6,  convert_10_bit_6,  no_bit_6
ADD_from_Bit_Test 7,  convert_10_bit_7,  no_bit_7
ADD_from_Bit_Test 8,  convert_10_bit_8,  no_bit_8
ADD_from_Bit_Test 9,  convert_10_bit_9,  no_bit_9
ADD_from_Bit_Test 10, convert_10_bit_10, no_bit_10
ADD_from_Bit_Test 11, convert_10_bit_11, no_bit_11
ADD_from_Bit_Test 12, convert_10_bit_12,  no_bit_12
ADD_from_Bit_Test 13, convert_10_bit_13,  no_bit_13
ADD_from_Bit_Test 14, convert_10_bit_14,  no_bit_14
ADD_from_Bit_Test 15, convert_10_bit_15,  no_bit_15
ADD_from_Bit_Test 16, convert_10_bit_16,  no_bit_16
ADD_from_Bit_Test 17, convert_10_bit_17, no_bit_17
ADD_from_Bit_Test 18, convert_10_bit_18, no_bit_18
ADD_from_Bit_Test 19, convert_10_bit_19, no_bit_19
ADD_from_Bit_Test 20, convert_10_bit_20, no_bit_20
ADD_from_Bit_Test 21, convert_10_bit_21, no_bit_21
ADD_from_Bit_Test 22, convert_10_bit_22, no_bit_22
ADD_from_Bit_Test 23, convert_10_bit_23, no_bit_23
ADD_from_Bit_Test 24, convert_10_bit_24, no_bit_24
ADD_from_Bit_Test 25, convert_10_bit_25, no_bit_25
ADD_from_Bit_Test 26, convert_10_bit_26, no_bit_26
ADD_from_Bit_Test 27, convert_10_bit_27, no_bit_27
ADD_from_Bit_Test 28, convert_10_bit_28, no_bit_28
ADD_from_Bit_Test 29, convert_10_bit_29, no_bit_29
ADD_from_Bit_Test 30, convert_10_bit_30, no_bit_30
ADD_from_Bit_Test 31, convert_10_bit_31, no_bit_31

start_recover_bcd_10_view:

push offset convert_10_intermediate
push dword ptr [ebp]+8			;offset BCD_VIEW
call SC_Recover_BCD_View
cmp eax,(-1)
je start_recover_bcd_10_view

mov eax,0
mov bcd_convert_10_busy_flag,0
bcd_convert_10_end_point:


mov esp,ebp
pop ebp
ret 8
SC_Convert_Bin_To_Dec_10 endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push dec_value_length		;ebp+12
;push dec_value_address		;ebp+8
;call SC_Convert_Dec_To_Bin_10
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Convert_Dec_To_Bin_10 proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header convert_dec_to_bin_10_busy_flag, no_convert_dec_to_bin_10

;mov eax,(-1)
;cmp convert_dec_to_bin_10_busy_flag,1
;je no_convert_dec_to_bin_10
;mov convert_dec_to_bin_10_busy_flag,1

.DATA
;;;;;;convert_dec_to_bin_10_busy_flag		dd 0

output_value	dd 0
value_status	dd 0	;0 - value is normal ;1 - Value is invalid
.CODE
mov output_value,0
mov value_status,0

cmp dword ptr [ebp+12],10
seta byte ptr value_status

cmp value_status,1
je end_convert_dec_value

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 1
mov eax,dword ptr [ebp+12]	;dec_value_length
dec eax
add eax,dword ptr [ebp+8]	;dec_value_address

xor ebx,ebx
mov bl,byte ptr [eax]
sub bl,30h			;convert to ASCII
mov output_value,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 2
cmp dword ptr [ebp+12],1	;dec_value_length
jbe end_convert_dec_value

dec eax
xor ebx,ebx
mov bl,byte ptr [eax]
sub bl,30h			;convert to ASCII

mov edx,ebx
rol ebx,3	;x 8
rol edx,1	;x 2 

add ebx,edx
add output_value,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 3
xchg eax,esi

cmp dword ptr [ebp+12],2	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 4
xchg eax,esi

cmp dword ptr [ebp+12],3	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 5
xchg eax,esi

cmp dword ptr [ebp+12],4	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,10000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 6
xchg eax,esi

cmp dword ptr [ebp+12],5	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100000		
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 7
xchg eax,esi

cmp dword ptr [ebp+12],6	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 8
xchg eax,esi

cmp dword ptr [ebp+12],7	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,10000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 9
xchg eax,esi

cmp dword ptr [ebp+12],8	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,100000000
mul ebx

add output_value,eax

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert 10
xchg eax,esi

cmp dword ptr [ebp+12],9	;dec_value_length
jbe end_convert_dec_value

dec esi
xor ebx,ebx
mov bl,byte ptr [esi]
sub bl,30h			;convert to ASCII
mov eax,1000000000
mul ebx

cmp edx,0
setne byte ptr value_status ;;0 - value is normal ;1 - Value is invalid
;11101110 01101011 00101000 00000000  - 4000000000

add output_value,eax
setb cl

xchg eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert 10
;4294967295	11111111 11111111 11111111 11111111
;1000000000	10 ^ 9
; 100000000	10 ^ 8
;  10000000	10 ^ 7
;   1000000	10 ^ 6
;    100000	10 ^ 5


end_convert_dec_value:

xor eax,eax
mov convert_dec_to_bin_10_busy_flag,0
no_convert_dec_to_bin_10:


mov ebx,value_status
mov ecx,output_value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ebx] - 0 - value is normal
;[ebx] - 1 - Value is invalid	;[too large]
;[ecx] - Converted binary value 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Convert_Dec_To_Bin_10 endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm

ADD_from_Bit_Test macro bit_number, bit_value_dec, bit_label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start For Bit 2
mov eax,dword ptr [ebp]+12
btc eax,bit_number
jnc bit_label

push offset bit_value_dec		;ebp+16
push offset convert_10_intermediate	;ebp+12
push offset convert_10_result		;ebp+8
call SC_Add_BCD_Data_10

mov esi,offset convert_10_result
mov edi,offset convert_10_intermediate
mov ecx,10
cld
rep movsb

xor eax,eax
mov edi,offset convert_10_result
mov ecx,10
cld
rep stosb

bit_label:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End For Bit 2

endm











