external_DLL_control macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push parent_window_handle		;ebp+12
;push operation_flag			;ebp+8
;call SCL_Activate_Find_Replace_Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Activate_Find_Replace_Dialog proc	export
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_AD_001, EP_AD_001

mov eax,dword ptr [ebp]+8
mov operation_type_AD_001,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_AD_001, LF_AD_001, operation_type_AD_001, LP_AD_001, EP_AD_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,2					;Thread already activated [Error code]
cmp find_replace_dialog_activation_flag,1	;dd 0	;0 - Not active ; 1 -  active
je LP_AD_001

mov eax,dword ptr [ebp]+12
mov find_replace_parent_window_handle,eax

push offset find_replace_dialog_main_thread_id  ;pointer to returned thread identifier 
push 0				;creation flags (or 04h if thread suspended) 
push 0				;argument for new thread(0 no arguments) 
push offset start		;pointer to thread function 
push 0				;initial thread stack size in bytes 
push 0				;offset lpThreadAttributes 
call CreateThread

start_wait_for_activation_init:

push 10
call Sleep

cmp find_replace_dialog_activation_flag,0	;dd 0	;0 - Not active ; 1 -  active
je start_wait_for_activation_init
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
;;;standard_sync_lock_footer BF_AD_001, LP_AD_001, EP_AD_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov deactivate_allow_flag,1			;Deactivation not allowed

mov eax,1
LP_AD_001:
mov BF_AD_001,0
EP_AD_001:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Thread normal activated
;[eax] - 2 - Thread already activated
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
mov esp,ebp
pop ebp
ret 8
SCL_Activate_Find_Replace_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push operation_type
;call SCL_Deactivate_Find_Replace_Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Deactivate_Find_Replace_Dialog proc		export
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_DA_001, EP_DA_001

mov eax,dword ptr [ebp]+8
mov operation_type_DA_001,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_DA_001, LF_DA_001, operation_type_DA_001, LP_DA_001, EP_DA_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,2					;Thread already deactivated [Error code]
cmp find_replace_dialog_activation_flag,0	;dd 0	;0 - Not active ; 1 -  active
je LP_DA_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
deactivate_allow_flag		dd 0	;0 - Deactivation allowed; 1 - Deactivation not allowed
.CODE

mov deactivate_allow_flag,0

;WM_CLOSE                             equ 10h

push 0			;lParam   
push 0			;wParam   
push 10h		;WM_CLOSE	;message    
push hwnd 
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
LP_DA_001:
mov BF_DA_001,0
EP_DA_001:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Thread successfully deactivated
;[eax] - 2 - Thread already deactivated
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
mov esp,ebp
pop ebp
ret 4
SCL_Deactivate_Find_Replace_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push richedit_window_handle		;ebp+12
;push operation_type			;ebp+8
;call SCL_Show_Find_Replace_Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Show_Find_Replace_Dialog proc  export
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SFRD_001, EP_SFRD_001

mov eax,dword ptr [ebp]+8
mov operation_type_SFRD_001,eax

;;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SFRD_001, LF_SFRD_001, operation_type_SFRD_001, LP_SFRD_001, EP_SFRD_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12		;richedit_window_handle
mov internal_richedit_window_handle,eax

push	1
push	hwnd
call	ShowWindow  

push hwnd				;ebp+16
push offset HEADER_DRAW_CONTENT		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Draw_Header_Buttons 

push 1			;header_state		;ebp+12;
push 0			;operation_type		;ebp+8
call SCL_Control_Find_Dialog_Contents

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
LP_SFRD_001:
mov BF_SFRD_001,0
EP_SFRD_001:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
mov esp,ebp
pop ebp
ret 8
SCL_Show_Find_Replace_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push operation_type
;call SCL_Hide_Find_Replace_Dialog
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Hide_Find_Replace_Dialog proc export
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_HFRD_001, EP_HFRD_001

mov eax,dword ptr [ebp]+8
mov operation_type_HFRD_001,eax

;;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_HFRD_001, LF_HFRD_001, operation_type_HFRD_001, LP_HFRD_001, EP_HFRD_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push	0
push	hwnd
call	ShowWindow  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
LP_HFRD_001:
mov BF_HFRD_001,0
EP_HFRD_001:

mov eax,1
mov esp,ebp
pop ebp
ret 4
SCL_Hide_Find_Replace_Dialog endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push richedit_window_handle		;ebp+12
;push operation_type			;ebp+8
;call SCL_Refresh_Find_Replace_Info
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Refresh_Find_Replace_Info proc export
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_RFDI_001, EP_RFDI_001

mov eax,dword ptr [ebp]+8
mov operation_type_RFDI_001,eax

;;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_RFDI_001, LF_RFDI_001, operation_type_RFDI_001, LP_RFDI_001, EP_RFDI_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get text modify status
;text_modify_status_flag			dd 0	;0 - Not modified ;1 - Modified
push 0				;lparam
push 0				;wparam
push 0B8h			;EM_GETMODIFY 0B8h
push dword ptr [ebp]+12		;push richedit_window_handle
call SendMessageA
;If the contents of edit control have been modified, the return value is nonzero.
;otherwise, it is zero.
mov text_modify_status_flag,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get text modify status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get lines count
;lines_count				dd 0
push 0				;lparam
push 0				;wparam
push 0BAh			;EM_GETLINECOUNT 0BAh
push dword ptr [ebp]+12		;push richedit_window_handle
call SendMessageA
mov lines_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get lines count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get current line number
;current_line				dd 0
push 0				;lparam
push (-1)			;wparam		;  (-1) - for current line number 
push 0C9h			;EM_LINEFROMCHAR 0C9h 
push dword ptr [ebp]+12		;push richedit_window_handle
call SendMessageA
mov current_line,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get current line number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get current line number
push 0				;lParam 
push 0				;wParam
push 0eh			;WM_GETTEXTLENGTH
push dword ptr [ebp]+12		;push richedit_window_handle
call SendMessageA
mov text_size,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get current line number

push hwnd
push 0		;operation_type
call SCL_Show_Goto_Contents

mov eax,dword ptr [ebp]+12		;richedit_window_handle		;ebp+12
mov internal_richedit_window_handle,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
LP_RFDI_001:
mov BF_RFDI_001,0
EP_RFDI_001:

mov eax,1
mov esp,ebp
pop ebp
ret 8
SCL_Refresh_Find_Replace_Info endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;;push header_number			;ebp+12
;;push operation_type			;ebp+8
;;call SCL_Set_Find_Replace_Header_Buttom
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Set_Find_Replace_Header_Buttom proc export
push ebp
mov ebp,esp
;;;;;;header_number is 1 - based
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SFDHB_001, EP_SFDHB_001

mov eax,dword ptr [ebp]+8
mov operation_type_SFDHB_001,eax

;;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_SFDHB_001, LF_SFDHB_001, operation_type_SFDHB_001, LP_SFDHB_001, EP_SFDHB_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12		;header buttom number
mov header_selection_number,eax

push hwnd				;ebp+16
push offset HEADER_DRAW_CONTENT		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Draw_Header_Buttons 

push 1			;header_state		;ebp+12;
push 0			;operation_type		;ebp+8
call SCL_Control_Find_Dialog_Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,1
LP_SFDHB_001:
mov BF_SFDHB_001,0
EP_SFDHB_001:

mov eax,1
mov esp,ebp
pop ebp
ret 8
SCL_Set_Find_Replace_Header_Buttom endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm







 