find_dialog_header_buttons_control macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push header_state			;ebp+12
;push 0		;operation_type		;ebp+8
;call SCL_Control_Find_Dialog_Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Control_Find_Dialog_Contents  proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CFDC_002, EP_CFDC_002

mov eax,dword ptr [ebp]+8
mov operation_type_CFDC_002,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CFDC_002, LF_CFDC_002, operation_type_CFDC_002, LP_CFDC_002, EP_CFDC_002
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Selection not changed
;[eax] - 1 - Selection changed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw "Find/Replace" contents
mov eax,dword ptr [ebp]+12
cmp eax,0
je no_readraw_headers

push hwnd				;ebp+16
push offset HEADER_DRAW_CONTENT		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Draw_Header_Buttons

;push offset HEADER_DRAW_CONTENT	;ebp+16
;push hwnd				;ebp+12
;push 0; operation_type			;ebp+8
;call Draw_Header_Buttons_Text

no_readraw_headers:


push 0
push child_find_handle
call ShowWindow

push 0
push child_find_replace_handle
call ShowWindow

push 0
push child_goto_handle
call ShowWindow

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for "Find" window
cmp header_selection_number,1
jne no_show_find_window

push 1
push child_find_handle
call ShowWindow

push 1
push replace_button_handle
call EnableWindow

push 1
push replace_all_button_handle
call EnableWindow

push offset find_button_text
push 0
push 0ch		;WM_SETTEXT
push find_button_handle
call SendMessageA 

push hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values


no_show_find_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for "Find" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for "Find / Replace" window
cmp header_selection_number,2
jne no_show_find_replace_window

push 1
push child_find_replace_handle
call ShowWindow

push 1
push replace_button_handle
call EnableWindow

push 1
push replace_all_button_handle
call EnableWindow

push offset find_button_text
push 0
push 0ch		;WM_SETTEXT
push find_button_handle
call SendMessageA 

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_show_find_replace_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for "Find / Replace" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check for "Goto" window
cmp header_selection_number,3
jne no_show_goto_window

push 1
push child_goto_handle
call ShowWindow

push 0
push replace_button_handle
call EnableWindow

push 0
push replace_all_button_handle
call EnableWindow

push offset goto_button_text
push 0
push 0ch		;WM_SETTEXT
push find_button_handle
call SendMessageA

push child_goto_handle			;hwnd
push 0		;operation_type
call SCL_Show_Goto_Contents

no_show_goto_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check for "Goto" window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw "Find/Replace" contents
push hwnd
push 0		;operation_type
call SCL_Draw_Common_Contents 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CFDC_002, LP_CFDC_002, EP_CFDC_002
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SCL_Control_Find_Dialog_Contents  endp		;FPC_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;call SC_Control_Edit_Window_Draw_Syncronization
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Control_Edit_Window_Draw_Syncronization  proc
;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_EDS_01, EP_EDS_01

push    00FF0000h			;Text color
push    dword ptr [ebp]+16		;edit draw hdc
call    SetTextColor

;push    321130	;12632256			;Background color
;push    dword ptr [ebp]+16		;hdc
;call    SetBkColor

push   	12632256			;Background color
push    dword ptr [ebp]+16		;hdc
call    SetBkMode

mov eax,edit_window_background_brush

mov BF_EDS_01,0
EP_EDS_01:

ret
SC_Control_Edit_Window_Draw_Syncronization  endp		;FPC_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push header_state			;ebp+12
;push 0		;operation_type		;ebp+8
;call SC_Draw_Edit_Contents_Size_Values
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Draw_Edit_Contents_Size_Values  proc
;push ebp
;mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_EDS_02, EP_EDS_02
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push child_find_handle			;hwnd
call GetDC
mov internal_draw_edit_size_hdc,eax
.DATA
internal_draw_edit_size_hdc	dd 0
size_word			db 'Size'
bytes_word			db 'bytes',0, 0, 0
result_text			db '0000000000',0
.CODE

cmp header_selection_number,1
jne no_show_find_replace_header_contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0 ;00C0C0C0h
push internal_draw_edit_size_hdc
call SetBkMode

push font_handle
push internal_draw_edit_size_hdc
call SelectObject

push 00FFFFFFh
push internal_draw_edit_size_hdc
call SetTextColor

push 4
push offset size_word
push 0 ;21		;Y
push 350		;X
push internal_draw_edit_size_hdc
call TextOutA

push 4
push offset size_word
push 16 ;37		;Y
push 350		;X
push internal_draw_edit_size_hdc
call TextOutA

push 4
push offset size_word
push 31 ;53		;Y
push 350		;X
push internal_draw_edit_size_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 8421504
push internal_draw_edit_size_hdc
call SetBkColor

push 00FFFFFFh
push internal_draw_edit_size_hdc
call SetTextColor

push 2
push internal_draw_edit_size_hdc
call SetBkMode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0			;lparam  ;If this parameter is TRUE, the control redraws itself. 
push 0			;wparam  ;Handle to the font 
push 0Eh		;;WM_GETTEXTLENGTH 0Eh wParam = 0; lParam = 0;
push find_first_window_handle
call SendMessage

push eax
push offset result_text
call SC_Convert_Bin_To_Dec_10

push 4
push offset result_text+6
push 0 ;21		;Y
push 375	;X
push internal_draw_edit_size_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0			;lparam  ;If this parameter is TRUE, the control redraws itself. 
push 0			;wparam  ;Handle to the font 
push 0Eh		;;WM_GETTEXTLENGTH 0Eh wParam = 0; lParam = 0;
push find_second_window_handle
call SendMessage

push eax
push offset result_text
call SC_Convert_Bin_To_Dec_10

push 4
push offset result_text+6
push 16 ;37		;Y
push 375	;X
push internal_draw_edit_size_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0			;lparam  ;If this parameter is TRUE, the control redraws itself. 
push 0			;wparam  ;Handle to the font 
push 0Eh		;;WM_GETTEXTLENGTH 0Eh wParam = 0; lParam = 0;
push replace_window_handle
call SendMessage

push eax
push offset result_text
call SC_Convert_Bin_To_Dec_10

push 4
push offset result_text+6
push 31 ;54		;Y
push 375	;X
push internal_draw_edit_size_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 5
push offset bytes_word
push 0 ;21		;Y
push 405	;X
push internal_draw_edit_size_hdc
call TextOutA

push 5
push offset bytes_word
push 16 ;37		;Y
push 405	;X
push internal_draw_edit_size_hdc
call TextOutA

push 5
push offset bytes_word
push 31;54		;Y
push 405	;X
push internal_draw_edit_size_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
no_show_find_replace_header_contents:

;push 40
;push 440
;call Beep

;find_first_window_handle	dd 0
;find_second_window_handle	dd 0
;replace_window_handle		dd 0
;goto_window_handle		dd 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push internal_draw_edit_size_hdc
push child_find_handle			;hwnd
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov BF_EDS_02,0
EP_EDS_02:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov esp,ebp
;pop ebp
;ret 12
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ret
SC_Draw_Edit_Contents_Size_Values  endp		;FPC_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm 