all_find_dialog_mouse_control macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push operation_type
;call SCL_Check_Find_Options_Dialog_Mouse
SCL_Check_Find_Options_Dialog_Mouse proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CFDO_001, EP_CFDO_001

mov eax,dword ptr [ebp]+8
mov operation_type_CFDO_001,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CDFO_001, LF_CFDO_001, operation_type_CFDO_001, LP_CFDO_001, EP_CFDO_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp header_selection_number,2
jne no_check_find_dialog_options_mouse
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Mouse Coordinates
.DATA
main_mouse_cursor_coordinates	dd 0, 0
.CODE

push offset main_mouse_cursor_coordinates
call GetCursorPos;

push offset main_mouse_cursor_coordinates
push child_find_replace_handle			;hwnd
call ScreenToClient
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Mouse Coordinates
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Search UP]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 0, main_mouse_cursor_coordinates, 114,  02, main_mouse_cursor_coordinates+4, 17
cmp eax,0
je no_radio_search_up
;cmp search_flag,1
;je no_radio_search_up

mov current_active_item_address,offset map_item_1

mov search_common_selection,1
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,0
mov not_as_comment_common_selection,0

mov search_flag,1

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_radio_search_up:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Search UP]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Search DOWN]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 0, main_mouse_cursor_coordinates, 112,  18, main_mouse_cursor_coordinates+4, 35
cmp eax,0
je no_radio_search_down
;cmp search_flag,0
;je no_radio_search_down

mov current_active_item_address,offset map_item_1

mov search_common_selection,1
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,0
mov not_as_comment_common_selection,0

mov search_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_radio_search_down:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Search DOWN]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Case sensitive]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 116, main_mouse_cursor_coordinates, 214,  02, main_mouse_cursor_coordinates+4, 17
cmp eax,0
je no_check_case_sensitive

mov current_active_item_address,offset map_item_2

mov search_common_selection,0
mov case_common_selection,1
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,0
mov not_as_comment_common_selection,0

btc case_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_check_case_sensitive:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Case sensitive]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Whole word]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 116, main_mouse_cursor_coordinates, 214,  19, main_mouse_cursor_coordinates+4, 35
cmp eax,0
je no_check_whole_word

mov current_active_item_address,offset map_item_3

mov search_common_selection,0
mov case_common_selection,0
mov whole_common_selection,1
mov combination_common_selection,0
mov combination_local_selection,0
mov not_as_comment_common_selection,0

;;search_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;case_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;whole_common_selection		dd 0
;;combination_common_selection	dd 0
;;combination_local_selection	dd 0
;;not_as_comment_common_selection	dd 0

btc whole_word_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_check_whole_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Whole word]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Combination]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 216, main_mouse_cursor_coordinates, 335,  02, main_mouse_cursor_coordinates+4, 17
cmp eax,0
je no_check_combination

mov current_active_item_address,offset map_item_4

mov search_common_selection,0
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,1
mov combination_local_selection,0
mov not_as_comment_common_selection,0

;;search_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;case_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;whole_common_selection		dd 0
;;combination_common_selection	dd 0
;;combination_local_selection	dd 0
;;not_as_comment_common_selection	dd 0

btc combination_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents


no_check_combination:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Combination]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [On one line]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 216, main_mouse_cursor_coordinates, 335,  19, main_mouse_cursor_coordinates+4, 34
cmp eax,0
je no_radio_on_one_line

mov current_active_item_address,offset map_item_6

mov search_common_selection,0
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,1
mov not_as_comment_common_selection,0

;;search_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;case_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;whole_common_selection		dd 0
;;combination_common_selection	dd 0
;;combination_local_selection	dd 0
;;not_as_comment_common_selection	dd 0

;on_one_line_or_page_flag	dd 0		;1 - On one page ;0 - On one line
mov on_one_line_or_page_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents


no_radio_on_one_line:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [On one line]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [On one page]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 216, main_mouse_cursor_coordinates, 335,  35, main_mouse_cursor_coordinates+4, 52
cmp eax,0
je no_radio_on_one_page

mov current_active_item_address,offset map_item_6

mov search_common_selection,0
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,1
mov not_as_comment_common_selection,0

;;search_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;case_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;whole_common_selection		dd 0
;;combination_common_selection	dd 0
;;combination_local_selection	dd 0
;;not_as_comment_common_selection	dd 0

;on_one_line_or_page_flag	dd 0		;1 - On one page ;0 - On one line
mov on_one_line_or_page_flag,1

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents

no_radio_on_one_page:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [On one page]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Not as comment]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 337, main_mouse_cursor_coordinates, 444,  02, main_mouse_cursor_coordinates+4, 17
cmp eax,0
je no_check_as_comment

mov current_active_item_address,offset map_item_5

mov search_common_selection,0
mov case_common_selection,0
mov whole_common_selection,0
mov combination_common_selection,0
mov combination_local_selection,0
mov not_as_comment_common_selection,1

;;search_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;case_common_selection		dd 0	;0 - Not selected ; 1 - Selected
;;whole_common_selection		dd 0
;;combination_common_selection	dd 0
;;combination_local_selection	dd 0
;;not_as_comment_common_selection	dd 0

btc not_as_comment_flag,0

push child_find_replace_handle
push 0		;operation_type
call SCL_Show_Find_Options_Contents


no_check_as_comment:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Not as comment]

;search_flag			dd 0		;0 - Down		;1 - Up
;case_flag			dd 0		;0 - Not checked	;1 - Checked
;whole_word_flag			dd 0		;0 - Partial		;1 - Whole word search 
;combination_flag		dd 0		;0 - Search one word	;1 - Search combination
;not_as_comment_flag		dd 0		;0 - Search all words	;1 - Search only uncommented


no_check_find_dialog_options_mouse:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CFDO_001, LP_CFDO_001, EP_CFDO_001

mov esp,ebp
pop ebp
ret 4
SCL_Check_Find_Options_Dialog_Mouse endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push operation_type
;call SCL_Check_Find_Dialog_Mouse
SCL_Check_Find_Dialog_Mouse proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CFD_001, EP_CFD_001

mov eax,dword ptr [ebp]+8
mov operation_type_CFD_001,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CDF_001, LF_CFD_001, operation_type_CFD_001, LP_CFD_001, EP_CFD_001

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp header_selection_number,1
jne no_check_find_dialog_mouse
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Mouse Coordinates
;.DATA
;main_mouse_cursor_coordinates	dd 0, 0
;.CODE

push offset main_mouse_cursor_coordinates
call GetCursorPos;

push offset main_mouse_cursor_coordinates
push hwnd
call ScreenToClient
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Mouse Coordinates
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [First word]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 4, main_mouse_cursor_coordinates, 72,  21, main_mouse_cursor_coordinates+4, 34
cmp eax,0
je no_first_word

mov find_replace_words_selection,1

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values


push find_first_window_handle
call SetFocus

;find_first_window_handle	dd 0
;find_second_window_handle	dd 0
;replace_window_handle		dd 0


no_first_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [First word]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Second word]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 4, main_mouse_cursor_coordinates, 72,  37, main_mouse_cursor_coordinates+4, 50
cmp eax,0
je no_second_word

mov find_replace_words_selection,2

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

push find_second_window_handle
call SetFocus

;find_first_window_handle	dd 0
;find_second_window_handle	dd 0
;replace_window_handle		dd 0

no_second_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Second word]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for [Replace with]
;;;;Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2  
;;;;;;[EAX] - 1 True ;;[EAX] - 0 False
Check_Location_Within_Rectangle 4, main_mouse_cursor_coordinates, 72,  53, main_mouse_cursor_coordinates+4, 66
cmp eax,0
je no_replace_with

mov find_replace_words_selection,3

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

push replace_window_handle
call SetFocus

;find_first_window_handle	dd 0
;find_second_window_handle	dd 0
;replace_window_handle		dd 0

no_replace_with:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for [Replace]

no_check_find_dialog_mouse:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CFD_001, LP_CFD_001, EP_CFD_001

mov esp,ebp
pop ebp
ret 4
SCL_Check_Find_Dialog_Mouse endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;call SC_Process_Edit_Window_Commands
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Process_Edit_Window_Commands proc

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_EWC_001, EP_EWC_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check if First window
mov eax,find_first_window_handle
cmp dword ptr [ebp]+20,eax
jne no_find_first_window

xor eax,eax
mov ebx,dword ptr [ebp]+16
ror ebx,16			;Notification code contains in high word of wparam [ebp]+16
mov ax,bx
cmp ax,100h		;EN_SETFOCUS  100h	;EN_KILLFOCUS 200h
jne no_find_first_window

mov find_replace_words_selection,1

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values


no_find_first_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check if First window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check if Second window
mov eax,find_second_window_handle
cmp dword ptr [ebp]+20,eax
jne no_find_second_window

xor eax,eax
mov ebx,dword ptr [ebp]+16
ror ebx,16			;Notification code contains in high word of wparam [ebp]+16
mov ax,bx
cmp ax,100h		;EN_SETFOCUS  100h	;EN_KILLFOCUS 200h
jne no_find_second_window

mov find_replace_words_selection,2

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

no_find_second_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check if Second window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check if Replace window
mov eax,replace_window_handle
cmp dword ptr [ebp]+20,eax
jne no_replace_window

xor eax,eax
mov ebx,dword ptr [ebp]+16
ror ebx,16			;Notification code contains in high word of wparam [ebp]+16
mov ax,bx
cmp ax,100h		;EN_SETFOCUS  100h	;EN_KILLFOCUS 200h
jne no_replace_window

mov find_replace_words_selection,3

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

no_replace_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check if Replace window

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_EWC_001, LP_EWC_001, EP_EWC_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ret 
SC_Process_Edit_Window_Commands endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm



