find_dialog_optional_windows macro

Create_Child_Find_Window proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
find_cbSize                dd    48
find_style                 dd    3				;CS_HREDRAW+CS_VREDRAW
find_lpfnWndProc           dd    offset find_window_proc
find_cbClsExtra            dd    0
find_cbWndExtra            dd    0
find_hInstance             dd    0
find_hIcon                 dd    0				;Values get from LoadIcon
find_hCursor               dd    0				;Values get from LoadCursorA
find_hbrBackground         dd    0
find_find_lpszMenuName          dd    0
find_lpszClassName        dd    offset  find_class_name 	;Window name 
find_hIconSm               dd    0

find_class_name		db 'FIND_CLASS',0
child_find_handle	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov find_hInstance,eax

	push	32649
	push	0
	call	LoadCursorA
	mov dword ptr find_hCursor,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 4
	call GetStockObject
	mov   dword ptr find_hbrBackground,eax

mov   find_lpszClassName,offset find_class_name

	push offset find_cbSize
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	60			;Vertical size of window
	push	447			;Horizontal size of window 
	push	21			;Y coordinate relative to parent window
	push	4			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset find_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_find_handle,eax

	push	0
	push	child_find_handle
	call	ShowWindow		;Do not need to show window because it is already visible

mov esp,ebp
pop ebp
ret
Create_Child_Find_Window endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Unregister_All_Classes proc

push hInst
push offset find_class_name
call UnregisterClass			;Unregister Find Class Name

push hInst
push offset find_replace_class_name
call UnregisterClass			;Unregister Find Options Class Name

push hInst
push offset goto_class_name
call UnregisterClass			;Unregister Goto Class Name

push hInst
push offset szClassName
call UnregisterClass			;Unregister Main Class

ret
Unregister_All_Classes endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
find_window_proc proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	find_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	find_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_SIZE	;5h
je	find_wm_size
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	find_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	find_wm_mouse_right_button_up
cmp dword ptr ss:[ebp+0ch],WM_CREATE ;	201h
je	find_wm_create
cmp dword ptr ss:[ebp+0ch],133h		;WM_CTLCOLOREDIT   133h
je	find_wm_set_edit_window_colors
cmp dword ptr ss:[ebp+0ch],WM_COMMAND
je	find_wm_command

jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Find Create
find_wm_create:
create_find_buttons
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Find Create
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Mouse Left Button
find_wm_mouse_left_button_down:

push 0 ;operation_type
call SCL_Check_Find_Dialog_Mouse

mov eax,0
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Mouse Left Button
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process FIND WM_COMMAND
find_wm_command:

call SC_Process_Edit_Window_Commands

mov eax,0
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process FIND WM_COMMAND

find_wm_mouse_right_button_up:

mov eax,0
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Edit window colors
find_wm_set_edit_window_colors:

call SC_Draw_Edit_Contents_Size_Values

start_control_edit_draw_sync:
call SC_Control_Edit_Window_Draw_Syncronization
cmp eax,(-1)
je start_control_edit_draw_sync
jmp find_window_exit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Edit window colors
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redefine list size changes
find_wm_size:


xor eax,eax
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Redefine list size changes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
find_wm_mouse_move:

mov eax,0
jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
find_wmpaint:

push child_find_handle ;hwnd
push 0		;operation_type
call SCL_Show_Find_Dialog_Contents

call SC_Draw_Edit_Contents_Size_Values

;jmp find_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
find_default:
      win_default
find_window_exit:
pop edi
pop esi
pop ebx
pop ebp
ret 16
find_window_proc	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;






endm






























 