richedit_file_standard_operations macro
;;;;;;Using example 
;push STREAMIN_type					;ebp+24
;push 128000		;file_size_limit in bytes	;ebp+20
;push richedit_window_handle				;ebp+16
;push offset file_name					;ebp+12
;push operation_type					;ebp+8
;call SCL_Transfer_File_Contents_Into_Richedit_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SCL_Transfer_File_Contents_Into_Richedit_Window proc export
;push ebp
;mov ebp,esp
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
;standard_sync_header BF_028, EP_028

;mov eax,dword ptr [ebp]+8
;mov operation_type_028,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
;standard_lock_header IND_028, LF_028, operation_type_028, LP_028, EP_028
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov STREAMIN_error_code_owner,0			;Set owner to "NONE"
;mov STREAMIN_system_error_code,0
;mov STREAMIN_type,0001h

;;SFF_SELECTION	--> 8000h

;cmp dword ptr [ebp]+24,1		;STREAMIN_type
;sete al
;ror eax,1
;cdq
;mov edi,0001h
;mov esi,0001h+8000h
;and esi,edx
;not edx
;and edi,edx
;add esi,edi
;mov STREAMIN_type,esi			;;SFF_SELECTION	--> 8000h

;.DATA
;STREAMIN_type					dd 0	;SF_TEXT + [SFF_SELECTION]
;STREAMIN_error_code_owner			dd 0
;STREAMIN_system_error_code			dd 0
;file_size_high_dword				dd 0
;file_load_internal_handle			dd 0
;file_open_for_input_transfer_error_code		dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;edit_input_stream LABEL DWORD
;    dd 0			;application defained value
;    dd 0			;DWORD dwError;
;    dd offset Stream_Input	;EDITSTREAMCALLBACK pfnCallback;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;.CODE;;;

;mov file_read_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
;push 0         
;push 80h			;FILE_ATTRIBUTE_NORMAL)
;push 3				;OPEN_EXISTING  3 
;push 0         
;push 0  
;push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
;push dword ptr  [ebp+12]	;offset file_name
;call CreateFileA
;mov file_load_internal_handle,eax
;cmp eax,(-1)
;jne no_error_in_file_for_stream_input		;INVALID_HANDLE_VALUE -1

;call GetLastError
;mov STREAMIN_error_code_owner,1			;[Error code]
;mov STREAMIN_system_error_code,eax

;jmp file_input_transfer_end
;no_error_in_file_for_stream_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check file size

;push offset file_size_high_dword
;push file_load_internal_handle
;call GetFileSize
;mov ebx,eax

;cmp eax,dword ptr [ebp]+20
;setae al
;ror eax,1
;cdq
;mov esi,3
;mov edi,0
;and esi,edx
;not edx
;and edi,edx
;add esi,edi

;mov STREAMIN_error_code_owner,esi		;File size is out of allowed limit [Error code]
;mov STREAMIN_system_error_code,0		

;cmp ebx,dword ptr [ebp]+20
;jae file_handle_close_STREAMIN_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check file size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer file contents 
;mov file_read_error_code,0		;Set error code to null

;mov ebx,file_load_internal_handle
;mov dword ptr edit_input_stream,ebx

;push offset  edit_input_stream	;lParam   
;push STREAMIN_type		;SF_TEXT ;wParam   +SFF_SELECTION
;push 400h+73			;EM_STREAMIN =WM_USER + 73 ;message    
;push dword ptr [ebp]+16		;richedit_window_handle
;call SendMessageA;

;cmp file_read_error_code,0
;je file_handle_close_STREAMIN_point

;mov eax,file_read_error_code
;mov STREAMIN_error_code_owner,2			;[Error code]
;mov STREAMIN_system_error_code,eax

;file_handle_close_STREAMIN_point:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 
;push file_load_internal_handle		; current_file_handle;  ;(offset)   ;Returned by CreateFileA
;call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
;file_input_transfer_end:

;mov eax,STREAMIN_error_code_owner
;mov ebx,STREAMIN_system_error_code

;LP_028:
;mov BF_028,0
;EP_028:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov esp,ebp
;pop ebp
;ret 20
;SCL_Transfer_File_Contents_Into_Richedit_Window endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push pcb		;ebp+20	;count of valid bytes in buffer.(must be filled)
;push cb		;ebp+16	;Buffer size in bytes
;push offset pbBuff	;ebp+12	;offset of RICHEDIT internal buffer 
;push dwCookie		;ebp+8 	;Value of the dwCookie member of the EDITSTREAM structure.[which passed to streamIn proc]
;call Stream_Input	;FPC_4

;Stream_Input  proc
;push ebp
;mov ebp,esp
;push esi
;push edi
;push ebx

;.DATA
;read_file_status_code			dd 0
;internal_status				dd 0
;number_of_read_bytes_for_stream_input	dd 0
;file_read_error_code			dd 0
;.CODE

;push 0				;must be offset in  other case
;push dword ptr [ebp]+20		;offset number_of_read_bytes_for_stream_input
;push dword ptr [ebp]+16		;Buffer size in bytes
;push dword ptr [ebp]+12		;offset of RICHEDIT internal buffer
;push file_load_internal_handle		;dword ptr [ebp]+8 		;file_load_internal_handle
;call ReadFile
;mov read_file_status_code,eax
;;;If the function fails, the return value is zero. 
;;;To get extended error information, call GetLastError.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get ReadFile system error code
;cmp eax,0
;jne no_read_error_for_stream_input
;call GetLastError
;mov file_read_error_code,eax
;mov number_of_read_bytes_for_stream_input,0

;no_read_error_for_stream_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get ReadFile system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate Stream_Input end code
;mov eax,read_file_status_code
;cmp eax,0
;sete al
;ror eax,1
;cdq
;mov esi,0		;For success
;mov edi,2		;For Read Error
;and edi,edx
;not edx
;and esi,edx
;add esi,edi
;mov eax,esi

;mov internal_status,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate Stream_Input end code
;mov eax,internal_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Operation result is depend on the [eax] - value
;; IF [eax] - 2 - than current operation discarded 
;; IF [eax] - 0 - than current operation continue 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;pop ebx
;pop edi
;pop esi
;mov esp,ebp
;pop ebp
;ret 16
;Stream_Input  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push STREAMOUT_type					;ebp+20
;push richedit_window_handle				;ebp+16
;push offset file_name					;ebp+12
;push operation_type					;ebp+8
;call SCL_Transfer_Richedit_Window_Contents_Into_File

;SCL_Transfer_Richedit_Window_Contents_Into_File proc	export
;push ebp
;mov ebp,esp

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
;standard_sync_header BF_029, EP_029

;mov eax,dword ptr [ebp]+8
;mov operation_type_029,eax

;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
;standard_lock_header IND_029, LF_029, operation_type_029, LP_029, EP_029
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov STREAMOUT_error_code_owner,0
;mov STREAMOUT_system_error_code,0
;mov STREAMOUT_type,0001h		;;SFF_SELECTION	--> 8000h

;add STREAMOUT_type,8000h		;IF process only selection
;;;add STREAMOUT_type,0010h		;IF process as UNICODE

;cmp dword ptr [ebp]+20,1
;sete al
;ror eax,1
;cdq
;mov edi,0001h
;mov esi,0001h+8000h
;and esi,edx
;not edx
;and edi,edx
;add esi,edi
;mov STREAMOUT_type,esi			;;SFF_SELECTION	--> 8000h

;;SF_TEXT	--> 0001h
;;SF_UNICODE	--> 0010h
;;SFF_SELECTION	--> 8000h

;.DATA
;STREAMOUT_type					dd 0	;SF_TEXT + [SFF_SELECTION]
;STREAMOUT_error_code_owner			dd 0
;STREAMOUT_system_error_code			dd 0

;file_save_internal_handle			dd 0
;file_save_for_output_transfer_error_code	dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;edit_output_stream LABEL DWORD
;    dd 0			;application defained value
;    dd 0			;DWORD dwError;
;    dd offset Stream_Output	;EDITSTREAMCALLBACK pfnCallback;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;.CODE

;;mov file_read_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
;push 0         
;push 80h			;FILE_ATTRIBUTE_NORMAL)
;push 4				;OPEN_ALWAYS  4
;push 0         
;push 0  
;push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
;push dword ptr  [ebp+12]	;offset file_name
;call CreateFileA
;mov file_save_internal_handle,eax
;cmp eax,(-1)
;jne no_error_in_file_for_stream_output		;INVALID_HANDLE_VALUE -1

;call GetLastError
;mov STREAMOUT_error_code_owner,1		;CreateFile generates error	[Error code]
;mov STREAMOUT_system_error_code,eax

;jmp file_output_transfer_end
;no_error_in_file_for_stream_output:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer file contents 
;mov file_save_error_code,0		;Set error code to null

;mov ebx,file_save_internal_handle
;mov dword ptr edit_output_stream,ebx

;push offset  edit_output_stream	;lParam   
;push STREAMOUT_type		;SF_TEXT ;wParam   
;push 400h+74			;EM_STREAMOUT    
;push dword ptr [ebp]+16		;richedit_window_handle
;call SendMessageA

;cmp file_save_error_code,0
;je no_error_on_file_save

;mov eax,file_save_error_code
;mov STREAMOUT_error_code_owner,2		;CreateFile generates error	[Error code]
;mov STREAMOUT_system_error_code,eax

;no_error_on_file_save:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start truncate file after file write
;push file_save_internal_handle
;call SetEndOfFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start truncate file after file write
;push file_save_internal_handle
;call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
;file_output_transfer_end:

;mov eax,STREAMOUT_error_code_owner
;mov ebx,STREAMOUT_system_error_code

;LP_029:
;mov BF_029,0
;EP_029:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - Error owner
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - WriteFile generates error
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov esp,ebp
;pop ebp
;ret 16
;SCL_Transfer_Richedit_Window_Contents_Into_File endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push pcb		;ebp+20	;count of valid bytes in buffer.(must be filled)
;push cb		;ebp+16	;Buffer size in bytes
;push offset pbBuff	;ebp+12	;offset of RICHEDIT internal buffer 
;push dwCookie		;ebp+8 	;Value of the dwCookie member of the EDITSTREAM structure.[which passed to streamIn proc]
;call Stream_Output	;
;
;Stream_Output  proc
;push ebp
;mov ebp,esp
;push esi
;push edi
;push ebx

;.DATA
;write_file_status_code			dd 0
;internal_write_status			dd 0
;number_of_save_bytes_for_stream_output	dd 0
;file_save_error_code			dd 0
;.CODE

;push 0				;must be offset in  other case
;push dword ptr [ebp]+20		;offset number_of_save_bytes_for_stream_output
;push dword ptr [ebp]+16		;Buffer size in bytes
;push dword ptr [ebp]+12		;offset of RICHEDIT internal buffer
;push file_save_internal_handle		;dword ptr [ebp]+8 		;file_load_internal_handle
;call WriteFile
;mov write_file_status_code,eax
;;;If the function fails, the return value is zero. 
;;;To get extended error information, call GetLastError.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get ReadFile system error code
;cmp eax,0
;jne no_save_error_for_stream_output
;call GetLastError
;mov file_save_error_code,eax
;mov number_of_save_bytes_for_stream_output,0

;no_save_error_for_stream_output:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get ReadFile system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate Stream_Input end code
;mov eax,write_file_status_code
;cmp eax,0
;sete al
;ror eax,1
;cdq
;mov esi,0		;For success
;mov edi,2		;For Read Error
;and edi,edx
;not edx
;and esi,edx
;add esi,edi
;mov eax,esi

;mov internal_write_status,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate Stream_Input end code
;mov eax,internal_write_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Operation result is depend on the [eax] - value
;; IF [eax] - 2 - than current operation discarded 
;; IF [eax] - 0 - than current operation continue 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;pop ebx
;pop edi
;pop esi
;mov esp,ebp
;pop ebp
;ret 16
;Stream_Output  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;New_richedit_window_proc proc
;push ebp
;mov ebp,esp
;push ebx
;push esi
;push edi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cmp dword ptr [ebp+0ch],100h		;WM_KEYDOWN  	100h
;jne no_insert

;;WM_KEYDOWN  	100h
;;nVirtKey = (int) wParam;    // virtual-key code 
;;lKeyData = lParam;          // key data 

;cmp dword ptr [ebp]+16,2Dh	;VK_INSERT 2Dh
;jne no_insert

;push 40
;push 880
;call Beep

;xor eax,eax
;no_insert:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cmp dword ptr [ebp+0ch],205h		;WM_RBUTTONUP  205h
;jne	richedit_left_button_up

;push 40
;push 880*2
;call Beep

;push 0
;push offset text
;push offset text
;push hwnd
;call MessageBoxA

;xor eax,eax
;richedit_left_button_up:

;push dword ptr [ebp]+20		;lparam
;push dword ptr [ebp]+16		;wparam
;push dword ptr [ebp]+12		;message
;push dword ptr [ebp]+8		;richedit_window_handle
;push richedit_previous_proc_address
;call CallWindowProcA

;;;;win_default

;;push 40
;;push 440
;;call Beep

;;mov eax,1

;pop edi
;pop esi
;pop ebx
;mov esp,ebp
;pop ebp
;ret 16
;New_richedit_window_proc endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset SIMPLE_SEARCH_PARAMETERS	;ebp+8
;call SC_Richedit_Simple_Text_Search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Richedit_Simple_Text_Search proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_STS_001, EP_STS_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start SIMPLE search text
.DATA
simple_search_flags				dd 0
FIND_TEXT_EX	LABEL DWORD
		search_start_position		dd 0
		search_end_position		dd 0
		find_text_address		dd 0		;offset TEXT_TO_FIND
		found_text_start_position	dd 0
		found_text_end_position		dd 0

;SIMPLE_SEARCH_PARAMETERS LABEL DWORD

;S_search_direction		dd 0			;0	;0 - UP 		;1 - DOWN
;S_case_sensitive		dd 1			;4	;0 - Not sensitive	;1 - Sensitive
;S_whole_word			dd 0			;8	;0 - Partial search	;1 - Whole word search
;search_richedit_window_handle	dd 0			;12
;search_text_address		dd 0			;16
;richedit_text_size		dd 0			;20
;S_selected_text_start_position	dd 0			;24	;Used to determine search position
;S_selected_text_end_position	dd 0			;28	;Used to determine search position

.CODE
mov eax,dword ptr [ebp]+8	;offset SIMPLE_SEARCH_PARAMETERS

mov ebx,dword ptr [eax]+16
mov find_text_address,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create search parameters
;IF [S_search_direction] = 0 [UP]  Then 
	;search_start_position = selected_text_start_position
	;search_end_position   = 0
;IF [S_search_direction] = 1 [Down]  Then 
	;search_start_position = selected_text_end_position
	;search_end_position   = richedit_text_size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine search start position
;IF [S_search_direction] = 0 [UP]	Then [search_start_position] = selected_text_start_position 
;IF [S_search_direction] = 1 [Down]	Then [search_start_position] = selected_text_end_position

mov ebx,dword ptr [ebp]+8		;offset SIMPLE_SEARCH_PARAMETERS
cmp dword ptr [ebx],0			;cmp S_search_direction,0
sete al
ror eax,1
cdq

mov esi,dword ptr [ebx]+24		;mov esi,S_selected_text_start_position
mov edi,dword ptr [ebx]+28		;mov edi,S_selected_text_end_position
and esi,edx
not edx
and edi,edx
add esi,edi
mov search_start_position,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine search start position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine search end position
;IF [S_search_direction] = 0 [UP]	Then [search_end_position] = 0
;IF [S_search_direction] = 1 [Down]	Then [search_end_position] = richedit_text_size

cmp dword ptr [ebx],0			;cmp S_search_direction,0
sete al
ror eax,1
cdq
mov esi,0
mov edi,dword ptr [ebx]+20		;mov edi,richedit_text_size
and esi,edx
not edx
and edi,edx
add esi,edi
mov search_end_position,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine search start position
mov simple_search_flags,0

mov ebx,dword ptr [ebp]+8		;offset SIMPLE_SEARCH_PARAMETERS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine [SEARCH_DIRECTION] flag
;IF [S_search_direction] = 1 then ADD [simple_search_flags] 01h
mov ecx,dword ptr [ebx]			;mov ecx,S_search_direction
add simple_search_flags,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine [SEARCH_DIRECTION] flag
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine [CASE_SENSITIVE] flag
;IF [S_case_sensitive]   = 1 then ADD [simple_search_flags] 04h

cmp dword ptr [ebx]+4,1			;cmp S_case_sensitive,1
sete al
ror eax,1
cdq
mov esi,simple_search_flags
add esi,04h
mov edi,simple_search_flags

and esi,edx
not edx
and edi,edx
add esi,edi
mov simple_search_flags,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine [CASE_SENSITIVE] flag
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Determine [WHOLE_WORD] flag
;IF [S_whole_word]       = 1 then ADD [simple_search_flags] 02h

;;;mov ebx,dword ptr [ebp]+8		;offset SIMPLE_SEARCH_PARAMETERS
cmp dword ptr [ebx]+8,1			;cmp S_whole_word,1
sete al
ror eax,1
cdq
mov esi,simple_search_flags
add esi,02h
mov edi,simple_search_flags
and esi,edx
not edx
and edi,edx
add esi,edi
mov simple_search_flags,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Determine [WHOLE_WORD] flag
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create search parameters
;wParam
	;FR_DOWN	00000001h 
	;FR_MATCHCASE	00000004h 
	;FR_WHOLEWORD	00000002h 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find text
;;mov ebx,dword ptr [ebp]+8		;offset SIMPLE_SEARCH_PARAMETERS
push offset FIND_TEXT_EX	;lparam
push simple_search_flags	;wparam
push 400h+79			;EM_FINDTEXTEX	400h + 79
push dword ptr [ebx]+12		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find text
cmp eax,(-1)			;;IF [eax] - (-1) then there are no matches
sete al
ror eax,1
cdq
mov esi,0
mov edi,1
and esi,edx
not edx
and edi,edx
add esi,edi
mov eax,esi

mov simple_search_flags,eax		;There is no need contensts of [simple_search_flags]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End SIMPLE search text
;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values found_text_start_position, found_text_end_position	;[EAX] - Max ;[EBX] - Min

mov ecx,eax
;;mov ebx,ebx
mov eax,simple_search_flags		;There is no need contensts of [simple_search_flags]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - matches not found
;[eax] - 1 - found matches
	;[ebx] - found word start position
	;[ecx] - found word end position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov BF_STS_001,0
EP_STS_001:

mov esp,ebp
pop ebp
ret 4
SC_Richedit_Simple_Text_Search endp	;FPC_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset RANGE				;ebp+12
;push richedit_window_handle			;ebp+8
;call SC_Determine_Range_Commented_State 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Determine_Range_Commented_State proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_DRCS_0001, EP_DRCS_0001 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
commented_range_start		dd 0
commented_range_end		dd 0
line_start_position		dd 0
line_end_position		dd 0
text_commented_state		dd 0	;0 - Not commented ;1 - Commented
.CODE
mov text_commented_state,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12		;offset RANGE
mov ebx,dword ptr [eax]
mov ecx,dword ptr [eax]+4

mov commented_range_start,ebx
mov commented_range_end,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values commented_range_start, commented_range_end	;[EAX] - Max ;[EBX] - Min

mov commented_range_start,ebx
mov commented_range_end,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;..........|<----------COMMENTED RANGE------------>|...........

;Use only  [commented_range_start]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE INDEX which contains RANGE_START
push commented_range_start		;lparam	;characted_position
push 0					;wparam
push 400h+54 				;;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;Returns the zero-based index of the line. [ or line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE INDEX which contains RANGE_START
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
push 0				;lparam
push eax			;wparam line index
push 0BBh 			;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;in [eax] - line start position
mov line_start_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE length 
push 0				;lparam
push commented_range_start	;wparam line index
push 0C1h 			;EM_LINELENGTH  0C1h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;The return value is the length, in characters, of the line

add eax,line_start_position
mov line_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find comment symbol in specified line
mov ebx,line_start_position
mov eax,line_end_position
mov comment_search_start_position,ebx
mov comment_search_end_position,eax

.DATA
CF_FIND_TEXT_EX LABEL DWORD
		comment_search_start_position		dd 0
		comment_search_end_position		dd 0
		comment_find_text_address		dd offset COMMENT_SYMBOL
		comment_found_text_start_position	dd 0
		comment_found_text_end_position		dd 0
COMMENT_SYMBOL						db ";",0
.CODE

push offset CF_FIND_TEXT_EX	;lparam
push 1				;wparam
push 400h+79			;EM_FINDTEXTEX	400h + 79
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find comment symbol in specified line
;IF [eax] - (-1) then Set range_commented_state as "NOT COMMENTED"
cmp eax,(-1)
je end_determine_commented_state

;IF [eax] - any other value then 
	;Check ;IF [comment_found_text_start_position] > commented_range_start Then set range_commented_state as "NOT COMMENTED"
	;Check ;IF [comment_found_text_start_position] = < commented_range_start Then set range_commented_state as "COMMENTED"
;text_commented_state		dd 0	;0 - Not commented ;1 - Commented

mov ebx,comment_found_text_start_position
cmp ebx,commented_range_start
seta al
ror eax,1
cdq
mov esi,0
mov edi,1
and esi,edx
not edx
and edi,edx
add esi,edi
mov text_commented_state,esi
end_determine_commented_state:

mov eax,text_commented_state
mov BF_DRCS_0001,0
EP_DRCS_0001:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Range not commented. [ checked only range start ]
;[eax] - 1 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Determine_Range_Commented_State endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset RESULT_ARRAY			;ebp+20
;push richedit_window_handle			;ebp+16
;push offset EXTENDED_SEARCH_PARAMETERS		;ebp+12
;push operation_type				;ebp+8
;call SCL_Extended_Text_Search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Extended_Text_Search proc
push ebp
mov ebp,esp

;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_ETS_001, EP_ETS_001

mov eax,dword ptr [ebp]+8
mov operation_type_ETS_001,eax

;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header  IND_ETS_001, LF_ETS_001, operation_type_ETS_001, LP_ETS_001, EP_ETS_001
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine Richedit window contents size
push 0
push 0				;wparam	;Selection start  
push 0Eh			;WM_GETTEXTLENGTH
push dword ptr [ebp]+16		;richedit_window_handle
call SendMessageA
mov richedit_text_size,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine Richedit window contents size
mov extended_search_result,0
xor eax,eax
cmp richedit_text_size,0
je end_of_extended_search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine SELECTION start
push offset S_selected_text_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+16		;richedit_window_handle
call SendMessageA

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values S_selected_text_start_position, S_selected_text_end_position	;[EAX] - Max ;[EBX] - Min

mov S_selected_text_end_position,eax
mov S_selected_text_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine SELECTION start

.DATA

SIMPLE_SEARCH_PARAMETERS LABEL DWORD

S_search_direction		dd 0			;0	;0 - UP 		;1 - DOWN
S_case_sensitive		dd 0			;4	;0 - Not sensitive	;1 - Sensitive
S_whole_word			dd 0			;8	;0 - Partial search	;1 - Whole word search
search_richedit_window_handle	dd 0			;12
search_text_address		dd 0;offset  first_word			;16
richedit_text_size		dd 0			;20
S_selected_text_start_position	dd 0			;24	;Used to determine search position
S_selected_text_end_position	dd 0				;28	;Used to determine search position

search_result_found_word_start_position		dd 0
search_result_found_word_end_position		dd 0
extended_search_result				dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start [ONE WORD] search 
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
cmp dword ptr [eax]+12,1	;
je no_only_one_word_search	;Jump if [search combination]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer parameters
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]		;search_direction
mov ecx,dword ptr [eax]+4	;case_sensitive
mov edx,dword ptr [eax]+8	;whole_word
mov esi,dword ptr [ebp]+16	;richedit_window_handle
mov edi,dword ptr [eax]+20	;first_word_address

mov S_search_direction,ebx
mov S_case_sensitive,ecx
mov S_whole_word,edx 
mov search_richedit_window_handle,esi
mov search_text_address,edi

start_S_for_single_search:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer parameters
push offset SIMPLE_SEARCH_PARAMETERS	;ebp+8
call SC_Richedit_Simple_Text_Search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - matches not found
;[eax] - 1 - found matches
	;[ebx] - found word start position
	;[ecx] - found word end position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_S_for_single_search

mov first_word_start_position,ebx
mov first_word_end_position,ecx

inc eax
mov extended_search_result,eax
	;[eax] - 1 - matches not found
	;[eax] - 2 - found matches

cmp eax,1
je end_of_extended_search

mov search_result_found_word_start_position,ebx
mov search_result_found_word_end_position,ecx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
;EXTENDED_SEARCH_PARAMETERS LABEL DWORD 
;		search_direction	dd 0	;0	;0 - UP 		;1 - DOWN
;		case_sensitive		dd 0	;4	;0 - Not sensitive	;1 - Sensitive
;		whole_word		dd 0	;8	;0 - Partial		;1 - Whole word
;		combination		dd 0	;12	;0 - only first word 	;1 - Search combination
;		not_as_comment		dd 0	;16	;0 - search all words	;1 - Search only uncommented words

start_check_R_C_state_for_single_search:

push offset search_result_found_word_start_position				;ebp+12
push dword ptr [ebp]+16			;richedit_window_handle		;ebp+8
call SC_Determine_Range_Commented_State 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Range not commented. [ checked only range start ]
;[eax] - 1 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_check_R_C_state_for_single_search

mov search_first_word_commented_state,eax

add eax,3
mov extended_search_result,eax
	;[eax] - 3 - Range not commented. [ checked only range start ]
	;[eax] - 4 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
jmp end_of_extended_search
no_only_one_word_search:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End [ONE WORD] search 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine SELECTED TEXT for COMBINATION search
push offset S_selected_text_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+16		;richedit_window_handle
call SendMessageA

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values S_selected_text_start_position, S_selected_text_end_position	;[EAX] - Max ;[EBX] - Min

mov S_selected_text_end_position,eax
mov S_selected_text_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine SELECTED TEXT for COMBINATION search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
cmp dword ptr [eax]+12,0	;combination
je no_combination_search	;Jump if [search one word]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start [COMBINATION] search 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start search [FIRST WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer parameters
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]		;search_direction
mov ecx,dword ptr [eax]+4	;case_sensitive
mov edx,dword ptr [eax]+8	;whole_word
mov esi,dword ptr [ebp]+16	;richedit_window_handle

mov S_search_direction,ebx
mov S_case_sensitive,ecx
mov S_whole_word,edx 
mov search_richedit_window_handle,esi

;IF [search_direction] = 0 [UP]   then [search_text_address] = [second_word_address]
;IF [search_direction] = 1 [DOWN] then [search_text_address] = [first_word_address]

cmp dword ptr [eax],0		;search_direction
sete al
ror eax,1
cdq
	mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov esi,dword ptr [eax]+24	;second_word_address
mov edi,dword ptr [eax]+20	;first_word_address
and esi,edx
not edx
and edi,edx
add esi,edi
mov search_text_address,esi		;edi

start_S_for_DUAL_search_1:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer parameters
push offset SIMPLE_SEARCH_PARAMETERS	;ebp+8
call SC_Richedit_Simple_Text_Search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - matches not found
;[eax] - 1 - found matches
	;[ebx] - found word start position
	;[ecx] - found word end position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_S_for_DUAL_search_1

;IF [eax] - 0 - Then no matches
	;IF search_direction - 0 [UP]   then [extended_search_result] = 5 
	;IF search_direction - 1 [DOWN] then [extended_search_result] = 6 
push ebx
push ecx

xchg eax,ecx
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]		;search_direction

cmp ebx,0
sete al
ror eax,1
cdq
mov esi,5
mov edi,6
and esi,edx
not edx
and edi,edx
add esi,edi
mov extended_search_result,esi

cmp ecx,0
je end_of_extended_search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End search [FIRST WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check [FIRST WORD] commented state
pop ecx
pop ebx

mov first_word_start_position,ebx
mov first_word_end_position,ecx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
;EXTENDED_SEARCH_PARAMETERS LABEL DWORD 
;		search_direction	dd 0	;0	;0 - UP 		;1 - DOWN
;		case_sensitive		dd 0	;4	;0 - Not sensitive	;1 - Sensitive
;		whole_word		dd 0	;8	;0 - Partial		;1 - Whole word
;		combination		dd 0	;12	;0 - only first word 	;1 - Search combination
;		not_as_comment		dd 0	;16	;0 - search all words	;1 - Search only uncommented words

start_check_R_C_state_for_DUAL_search_1:

push offset first_word_start_position					;ebp+12
push dword ptr [ebp]+16			;richedit_window_handle		;ebp+8
call SC_Determine_Range_Commented_State 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Range not commented. [ checked only range start ]
;[eax] - 1 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_check_R_C_state_for_DUAL_search_1

mov search_first_word_commented_state,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
.DATA
search_first_word_commented_state	dd 0
search_second_word_commented_state	dd 0

first_word_start_position		dd 0
first_word_end_position			dd 0

second_word_start_position		dd 0
second_word_end_position		dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check [FIRST WORD] commented state
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End search [FIRST WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx

mov eax,first_word_start_position
mov ebx,first_word_end_position

mov S_selected_text_start_position,eax
mov S_selected_text_end_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start search [SECOND WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer parameters
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]		;search_direction
mov ecx,dword ptr [eax]+4	;case_sensitive
mov edx,dword ptr [eax]+8	;whole_word
mov esi,dword ptr [ebp]+16	;richedit_window_handle

mov S_search_direction,ebx
mov S_case_sensitive,ecx
mov S_whole_word,edx 
mov search_richedit_window_handle,esi


;IF [search_direction] = 0 [UP]   then [search_text_address] = [first_word_address]
;IF [search_direction] = 1 [DOWN] then [search_text_address] = [second_word_address]

cmp dword ptr [eax],1		;search_direction
sete al
ror eax,1
cdq
	mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov esi,dword ptr [eax]+24	;second_word_address
mov edi,dword ptr [eax]+20	;first_word_address
and esi,edx
not edx
and edi,edx
add esi,edi
mov search_text_address,esi		;edi

start_S_for_DUAL_search_2:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer parameters
push offset SIMPLE_SEARCH_PARAMETERS	;ebp+8
call SC_Richedit_Simple_Text_Search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - matches not found
;[eax] - 1 - found matches
	;[ebx] - found word start position
	;[ecx] - found word end position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_S_for_DUAL_search_2

mov extended_search_result,eax

;IF [eax] - 0 - Then no matches
;	;IF search_direction - 0 [UP]   then [extended_search_result] = 7
;	;IF search_direction - 1 [DOWN] then [extended_search_result] = 8 
push ebx
push ecx

xchg eax,ecx
mov eax,dword ptr [ebp]+12	;offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]		;search_direction

cmp ebx,0			;[UP]
sete al
ror eax,1
cdq
mov esi,7
mov edi,8
and esi,edx
not edx
and edi,edx
add esi,edi
mov extended_search_result,esi

cmp ecx,0
je end_of_extended_search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End search [FIRST WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check [FIRST WORD] commented state
pop ecx
pop ebx

mov second_word_start_position,ebx
mov second_word_end_position,ecx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
;EXTENDED_SEARCH_PARAMETERS LABEL DWORD 
;		search_direction	dd 0	;0	;0 - UP 		;1 - DOWN
;		case_sensitive		dd 0	;4	;0 - Not sensitive	;1 - Sensitive
;		whole_word		dd 0	;8	;0 - Partial		;1 - Whole word
;		combination		dd 0	;12	;0 - only first word 	;1 - Search combination
;		not_as_comment		dd 0	;16	;0 - search all words	;1 - Search only uncommented words

start_check_R_C_state_for_DUAL_search_2:

push offset second_word_start_position					;ebp+12
push dword ptr [ebp]+16			;richedit_window_handle		;ebp+8
call SC_Determine_Range_Commented_State 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Range not commented. [ checked only range start ]
;[eax] - 1 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_check_R_C_state_for_DUAL_search_2

mov extended_search_result,9

mov search_second_word_commented_state,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check range commented state
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check [SECOND WORD] commented state
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End search [SECOND WORD]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
no_combination_search:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End [COMBINATION] search 
align 16
end_of_extended_search:

;RESULT_ARRAY	LABEL DWORD
;		ES_found_first_word_start_position		dd 0		;0
;		ES_found_first_word_end_position		dd 0		;4
;		ES_found_second_word_start_position		dd 0		;8
;		ES_found_second_word_end_position		dd 0		;12
;		ES_found_first_word_commented_state		dd 0		;16
;		ES_found_second_word_commented_state		dd 0		;20
;		ES_result_code					dd 0		;24
;

mov eax,dword ptr [ebp]+20		;offset RESULT_ARRAY

mov ebx,first_word_start_position
mov ecx,first_word_end_position
mov edx,second_word_start_position
mov esi,second_word_end_position

mov dword ptr [eax],ebx			;ES_found_first_word_start_position
mov dword ptr [eax]+4,ecx		;ES_found_first_word_end_position
mov dword ptr [eax]+8,edx		;ES_found_second_word_start_position
mov dword ptr [eax]+12,esi		;ES_found_second_word_end_position

mov ebx,search_first_word_commented_state
mov ecx,search_second_word_commented_state
mov edx,extended_search_result

mov dword ptr [eax]+16,ebx		;ES_found_first_word_commented_state
mov dword ptr [eax]+20,ecx		;ES_found_second_word_commented_state
mov dword ptr [eax]+24,edx		;ES_result_code

mov eax,extended_search_result
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - richedit window has no contents. Cannot perform any search operation. [Error code]
	;[eax] - 1 - [Single search][Search all] --> Text not found
	;[eax] - 2 - [Single search][Search all] --> Text found
	;[eax] - 3 - [Single search] --> Text found and specified text is not commented [ checked only range start ]
	;[eax] - 4 - [Single search] --> Text found, but specified text is commented.
	;[eax] - 5 - [Dual search]   --> Could not find [second word][search direction [UP]   ]
	;[eax] - 6 - [Dual search]   --> Could not find [first  word][search direction [DOWN] ]
	;[eax] - 7 - [Dual search]   --> Could not find [first word][but second word found][search direction [UP]   ]
	;[eax] - 8 - [Dual search]   --> Could not find [second word][but first word found][search direction [DOWN] ]
	;[eax] - 9 - [Dual search]   --> Found word combination
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_ETS_001, LP_ETS_001, EP_ETS_001

mov esp,ebp
pop ebp
ret 16
SCL_Extended_Text_Search endp		;FPC_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push line_number			;ebp+12
;push richedit_window_handle		;ebp+8
;call SC_Set_Richedit_Line_Visibility
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Set_Richedit_Line_Visibility proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_SRLV_1, EP_SRLV_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
richedit_line_visibility_set_error_code		dd 0
.CODE

mov richedit_line_visibility_set_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check error cases
push 0				;lparam
push 0				;wparam
push 0BAh			;EM_GETLINECOUNT
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA
mov richedit_line_visibility_set_error_code,1
cmp dword ptr [ebp]+12,eax
ja no_set_line_visibility
mov richedit_line_visibility_set_error_code,2
cmp eax,1
jbe no_set_line_visibility
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check error cases
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get first visible line in editor
;;EM_GETFIRSTVISIBLELINE 0CEh	 wParam = 0; lParam = 0;
push 0				;lparam
push 0				;wparam
push 0CEh			;EM_GETFIRSTVISIBLELINE
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA
mov first_visible_line_number,eax

.DATA
first_visible_line_number		dd 0
last_visible_line_number		dd 0
specified_line_character_index		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get first visible line in editor
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check specified line visibility
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check line visibility. IF line is below window client area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get specified line character index
push dword ptr [ebp]+12	;line_number		;lparam	;Selection end
push 0				;  
push 0BBh 			;EM_LINEINDEX
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA
mov specified_line_character_index,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get specified line character index
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get richedit window client coordinates
push offset richedit_client_window_rect
push dword ptr [ebp]+8		;richedit_window_handle
call GetClientRect
;richedit_client_window_rect + 8	Horizontal size [ X ]
;richedit_client_window_rect + 12	Vertical size [ Y ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get richedit window client coordinates
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get last visible line number
mov eax,richedit_client_window_rect + 12
mov char_y_coordinate,eax
mov char_x_coordinate,0

.DATA
richedit_client_window_rect		dd 0, 0, 0, 0
POSITION_COORDINATES label dword
		char_x_coordinate	dd 0	;Do not change this value because line visibility check is performing
		char_y_coordinate	dd 0			;in respect of Y coordinate 
.CODE

push offset POSITION_COORDINATES	;lparam	;Selection end
push 0					;Specifies the zero-based index of the character.
push 0D7h 				;EM_CHARFROMPOS 0D7h
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA			;Get charactes position

;Rich edit controls: The return value specifies the zero-based character index of 
;the character nearest the specified point. The return value indicates the last 
;character in the edit control if the specified point is beyond the last character in the control. 

push 0					;lparam	;Not used
push eax				;Specifies the zero-based index of the character.
push 0C9h 				;EM_LINEFROMCHAR 0C9h
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA			;Get line number from character position
mov last_visible_line_number,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get last visible line number

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check location of specified line  is visible range
mov eax,dword ptr [ebp]+12		;line_number

cmp eax,first_visible_line_number
jne no_specified_line_is_first_visible
cmp eax,last_visible_line_number
je no_specified_line_is_first_visible

push (-1)				;lparam ;Vertical scroll count
push 0				;Not used
push 0B6h 			;EM_LINESCROLL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

no_specified_line_is_first_visible:

mov eax,dword ptr [ebp]+12		;line_number

cmp eax,last_visible_line_number
jne no_specified_line_is_last_visible
cmp eax,first_visible_line_number
je no_specified_line_is_last_visible

push 1				;lparam ;Vertical scroll count
push 0				;Not used
push 0B6h 			;EM_LINESCROLL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

no_specified_line_is_last_visible:


mov eax,dword ptr [ebp]+12		;line_number

;IF [line_number] > = [first_visible_line_number] AND [line_number] < = [last_visible_line_number]
xor ebx,ebx
xor ecx,ecx
xor edx,edx
xor esi,esi
xor edi,edi

cmp eax,first_visible_line_number
setae bl
cmp eax,last_visible_line_number
setbe cl
and ebx,ecx

mov richedit_line_visibility_set_error_code,3		;Specified line is already visible
cmp ebx,1
je no_set_line_visibility				;Jump if Specified line contains within visible range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check location of specified line  is visible range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start scroll richedit window contents to set line visibility
mov eax,dword ptr [ebp]+12		;line_number
cmp eax,first_visible_line_number
ja specified_list_is_not_below

mov ebx,first_visible_line_number
sub ebx,eax				;line_number
inc ebx
neg ebx					;Convert into negative for [ SCROLL UP ]

push ebx				;lparam ;Vertical scroll count
push 0				;Not used
push 0B6h 			;EM_LINESCROLL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA		;Scroll UP

specified_list_is_not_below: 

mov eax,dword ptr [ebp]+12		;line_number
cmp eax,last_visible_line_number
jb specified_list_is_not_above

mov ebx,eax				;line_number
sub ebx,last_visible_line_number
inc ebx

push ebx				;lparam ;Vertical scroll count
push 0				;Not used
push 0B6h 			;EM_LINESCROLL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA		;Scroll Down

specified_list_is_not_above: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End scroll richedit window contents to set line visibility
mov richedit_line_visibility_set_error_code,4		;Specified line is successfully set as "VISIBLE"

no_set_line_visibility:
mov eax,richedit_line_visibility_set_error_code


mov BF_SRLV_1,0
EP_SRLV_1:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy.
;[eax] - 0 - Line visibility successfully set
;[eax] - 1 - Specified line number is above than line count of [richedit window]
;[eax] - 2 - Richedit window contains too small count of lines and all of them are visible.
;[eax] - 3 - Specified line is already visible
;[eax] - 4 - Specified Line visibility successfully set. [Line was invisible previous]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SC_Set_Richedit_Line_Visibility endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push 30				;line_number	;ebp+12
;push richedit_window_handle		;ebp+8
;call SC_Goto_Richedit_Line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Goto_Richedit_Line proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GRL_1, EP_GRL_1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine character from line
push 0				;lparam	;Selection end
push dword ptr [ebp]+12		;line_index  
push 0BBh 			;EM_LINEINDEX
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA
mov goto_start_position,eax
mov goto_end_position,eax
.DATA
goto_start_position		dd 0
goto_end_position		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine character from line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set new selection
push offset goto_start_position		;lparam	;Selection end
push 0					;wparam	;Selection start  
push 400h+55 				;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set new selection
start_set_visibility_for_goto:

push dword ptr [ebp]+12			;line_number	;ebp+12
push dword ptr [ebp]+8			;richedit_window_handle
call SC_Set_Richedit_Line_Visibility
cmp eax,(-1)
je start_set_visibility_for_goto
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Line visibility successfully set
;[eax] - 1 - Specified line number is above than line count of [richedit window]
;[eax] - 2 - Richedit window contains too small count of lines and all of them are visible.
;[eax] - 3 - Specified line is already visible
;[eax] - 4 - Specified Line visibility successfully set. [Line was invisible previous]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push dword ptr [ebp]+8			;richedit_window_handle
call SetFocus

mov eax,0
mov BF_GRL_1,0
EP_GRL_1:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Goto_Richedit_Line endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset RESULT_ARRAY			;ebp+16
;push richedit_window_handle			;ebp+12
;push offset EXTENDED_SEARCH_PARAMETERS		;ebp+8
;call SC_Process_Extended_Search_Results
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Process_Extended_Search_Results proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PESR_1, EP_PESR_1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov process_results_internal_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]+12			;combination
cmp ebx,1
jne no_combination_selected_for_search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start sort obtained search values
;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values ES_found_first_word_start_position, ES_found_first_word_end_position	;[EAX] - Max ;[EBX] - Min
mov found_max_1,eax
mov found_min_1,ebx

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values ES_found_second_word_start_position, ES_found_second_word_end_position	;[EAX] - Max ;[EBX] - Min
mov found_max_2,eax
mov found_min_2,ebx

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values found_max_1, found_max_2	;[EAX] - Max ;[EBX] - Min
mov internal_selection_end_position,eax

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values found_min_1, found_min_2	;[EAX] - Max ;[EBX] - Min
mov internal_selection_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End sort obtained search values

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check combination found parameters
;IF [ES_result_code] = 0  THEN  [process_results_internal_error_code] = 1 Richedit window has no contents. [Error code]

mov eax,ES_result_code
mov process_results_internal_error_code,eax

cmp ES_result_code,0
je end_process_extended_search_results		;Jump if richedit window has no contents. [Error case]

cmp ES_result_code,9
jne end_process_extended_search_results		;Jump if combination not found.		[Error case]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for commented combination search
mov eax,offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]+16			;not_as_comment
cmp ebx,0
je no_need_for_commented_check			;Jump if must search all word without cheking commented state

;IF [search_direction] = UP then set [internal_selection_start_position]
mov edi,dword ptr [ebp]+8		;offset EXTENDED_SEARCH_PARAMETERS
cmp dword ptr [edi],0
sete al
ror eax,1
cdq 
mov esi,internal_selection_start_position
mov edi,internal_selection_end_position
and esi,edx
not edx
and edi,edx
add esi,edi

mov eax,esi
mov internal_start_position,eax
mov internal_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection
push offset internal_start_position		;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+12				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection

mov process_results_internal_error_code,10	;Not found specified combination. [Because first word is commented]
mov edi,offset RESULT_ARRAY
cmp dword ptr [edi]+16,1			;ES_found_first_word_commented_state
je end_process_extended_search_results		;Jump if first word commented

mov process_results_internal_error_code,11	;Not found specified combination. [Because second word is commented]
cmp dword ptr [edi]+20,1
je end_process_extended_search_results		;Jump is second word is commented

no_need_for_commented_check:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for commented combination search

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for location on one line
mov eax,offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]+28			;on_one_line
cmp ebx,0
je no_need_for_one_line_check			;Jump if musty search all word without cheking commented state

.DATA
selection_start_line		dd 0
selection_end_line		dd 0
.CODE

mov process_results_internal_error_code,12	;Found specified combination but it is not on one line.

;IF [search_direction] = UP then set [internal_selection_start_position]
mov edi,dword ptr [ebp]+8		;offset EXTENDED_SEARCH_PARAMETERS
cmp dword ptr [edi],0
sete al
ror eax,1
cdq 
mov esi,internal_selection_start_position
mov edi,internal_selection_end_position
and esi,edx
not edx
and edi,edx
add esi,edi

mov eax,esi
mov internal_start_position,eax
mov internal_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection
push offset internal_start_position		;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+12				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push internal_selection_start_position	;lparam	;characted_position
push 0					;wparam
push 400h+54 				;;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+12			;push richedit_window_handle
call SendMessageA			;Returns the zero-based index of the line. [ or line number ]
mov selection_start_line,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push internal_selection_end_position	;lparam	;characted_position
push 0					;wparam
push 400h+54 				;;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+12			;push richedit_window_handle
call SendMessageA			;Returns the zero-based index of the line. [ or line number ]
mov selection_end_line,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,selection_start_line
jne end_process_extended_search_results
no_need_for_one_line_check:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for location on one line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check combination found parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Select found word for combination
.DATA
process_results_internal_error_code	dd 0
internal_selection_start_position	dd 0
internal_selection_end_position		dd 0
found_max_1				dd 0
found_min_1				dd 0
found_max_2				dd 0
found_min_2				dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection
push offset internal_selection_start_position		;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+12				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Select found word for combination
no_combination_selected_for_search:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process results for one word search
mov eax,offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]+12			;combination
cmp ebx,0
jne no_one_word_selected_for_search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check error cases for single search
mov eax,ES_result_code
mov process_results_internal_error_code,eax

cmp ES_result_code,0
je end_process_extended_search_results		;Jump if richedit window has no contents. [Error case]

cmp ES_result_code,1
je end_process_extended_search_results		;Jump if specified word not found.		[Error case]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check error cases for single search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Select found word for combination
;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values ES_found_first_word_start_position, ES_found_first_word_end_position	;[EAX] - Max ;[EBX] - Min
mov internal_selection_end_position,eax
mov internal_selection_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - richedit window has no contents. Cannot perform any search operation. [Error code]
	;[eax] - 1 - [Single search][Search all] --> Text not found
	;[eax] - 2 - [Single search][Search all] --> Text found
	;[eax] - 3 - [Single search] --> Text found and specified text is not commented [ checked only range start ]
	;[eax] - 4 - [Single search] --> Text found, but specified text is commented.
	;[eax] - 5 - [Dual search]   --> Could not find [second word][search direction [UP]  ]
	;[eax] - 6 - [Dual search]   --> Could not find [first  word][search direction [DOWN]]
	;[eax] - 7 - [Dual search]   --> Could not find [first  word][but second word found][search direction [UP]  ]
	;[eax] - 8 - [Dual search]   --> Could not find [second word][but first word found ][search direction [DOWN]]
	;[eax] - 9 - [Dual search]   --> Found word combination
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check for commented word search
mov eax,offset EXTENDED_SEARCH_PARAMETERS
mov ebx,dword ptr [eax]+16			;not_as_comment
cmp ebx,0
je no_need_for_commented_word_check		;Jump if musty search all word without cheking commented state
.DATA
internal_start_position		dd 0
internal_end_position		dd 0
.CODE


;IF [search_direction] = UP then set [internal_selection_start_position]
mov edi,dword ptr [ebp]+8		;offset EXTENDED_SEARCH_PARAMETERS
cmp dword ptr [edi],0
sete al
ror eax,1
cdq 
mov esi,internal_selection_start_position
mov edi,internal_selection_end_position
and esi,edx
not edx
and edi,edx
add esi,edi

mov eax,esi
mov internal_start_position,eax
mov internal_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection
push offset internal_start_position		;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+12				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection

mov process_results_internal_error_code,13	;Not found specified word. [Because first word is commented]
mov edi,offset RESULT_ARRAY
cmp dword ptr [edi]+16,1			;ES_found_first_word_commented_state
je end_process_extended_search_results		;Jump if first word commented

no_need_for_commented_word_check:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check for commented word search
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection
push offset internal_selection_start_position		;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+12				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Select found word for combination
no_one_word_selected_for_search:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process results for one word search


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[process_results_internal_error_code] - 10 - Not found specified combination. [Because first word is commented]
;[process_results_internal_error_code] - 11 - Not found specified combination. [Because second word is commented]
;[process_results_internal_error_code] - 12 - Found specified combination but it is no on one line.
;[process_results_internal_error_code] - 13 - Not found specified word. [Because first word is commented]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov process_results_internal_error_code,9
end_process_extended_search_results:
mov eax,process_results_internal_error_code

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - richedit window has no contents. Cannot perform any search operation. [Error code]
	;[eax] - 1 - [Single search][Search all] --> Text not found
	;[eax] - 2 - [Single search][Search all] --> Text found
	;[eax] - 3 - [Single search] --> Text found and specified text is not commented [ checked only range start ]
	;[eax] - 4 - [Single search] --> Text found, but specified text is commented.
	;[eax] - 5 - [Dual search]   --> Could not find [second word][search direction [UP]  ]
	;[eax] - 6 - [Dual search]   --> Could not find [first  word][search direction [DOWN]]
	;[eax] - 7 - [Dual search]   --> Could not find [first  word][but second word found][search direction [UP]  ]
	;[eax] - 8 - [Dual search]   --> Could not find [second word][but first word found ][search direction [DOWN]]
	;[eax] - 9 - [Dual search]   --> Found word combination
	;[eax] - 10 - Not found specified combination. [Because first word is commented]
	;[eax] - 11 - Not found specified combination. [Because second word is commented]
	;[eax] - 12 - Found specified combination but it is no on one line.
	;[eax] - 13 - Not found specified word. [Because first word is commented]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov BF_PESR_1,0
EP_PESR_1:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SC_Process_Extended_Search_Results endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm 





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
show_decimal macro s_x_c, s_y_c, show_value
pushad
mov eax,show_value  ;show;start_address
mov dword ptr string_bin_qword,eax
push offset result_data       ;       ebp+20;
push offset string_pack210    ;       ebp+16
push offset output            ;       ebp+12 
push offset string_bin_qword  ;input  ebp+8
call ConvertBinToDec
push 10
push offset result_data
push s_x_c ;100
push s_y_c ;100
push hdc
call TextOutA
;	extrn TextOutA:PROC
popad
endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;DRAW_ITEM_1		LABEL DWORD
;		address_in_case_of_up		dd  0
;		address_in_case_of_down		dd  0
;		address_in_case_of_right		dd  0
;		address_in_case_of_left		dd  0
;		draw_item_rect_start_X		dd  0
;		draw_item_rect_start_Y		dd  0
;		draw_item_rect_end_X		dd  0
;		draw_item_rect_end_Y		dd  0
;		draw_item_state			dd  0
;

