SPL_Edit_Operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push edit_increment		;ebp+16
;push scan_text_length		;ebp+12
;push offset scan_text		;ebp+8
;call Get_Edit_Coordinats_By_Increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Edit_Coordinats_By_Increment	proc
push ebp
mov ebp,esp
;Line starts 	at 0
;Column starts  at 0

.DATA
EC_edit_address_increment	dd 0
EC_eol_string			db 0dh, 0ah, 0, 0
EC_current_line_number		dd 0
EC_current_column_number	dd 0
.CODE

mov EC_edit_address_increment,0
mov EC_current_line_number,0
mov EC_current_column_number,0

mov eax,0			;Not Found
cmp dword ptr [ebp+12],0	;scan_text_length,0
je end_get_line_number

start_get_line_number:

mov eax,0			;Not Found
mov ebx,dword ptr [ebp+12]	;scan_text_length
cmp ebx,EC_edit_address_increment
jb end_get_line_number

;SV_find_string  macro label_index, scan_string_address, all_string_size, find_string_address, find_str_size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1 string find
;;;[eax] = 0 string not find
	;;;[ebx] address_increment while find string = [esi] -  scan_string_offset
	;;;[esi] address of first byte of found string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+8]	;offset scan_text
	add eax,EC_edit_address_increment 
mov ebx,dword ptr [ebp+12]	;scan_text_length
	sub ebx,EC_edit_address_increment
mov ecx,offset EC_eol_string

;SV_find_string EDIT_001, eax, ebx, ecx, 2

push 2		;find_str_size			;ebp+24
push ecx	;find_string_address		;ebp+20
push ebx	;all_string_size			;ebp+16
push eax	;scan_string_address		;ebp+12
call Find_String 

cmp eax,0
je end_get_line_number

mov eax,ebx
add ebx,EC_edit_address_increment

;;;Range [edit_address_increment]<--[edx]-->[eax]

mov edx,dword ptr [ebp]+16

mov ecx,edx
sub ecx,EC_edit_address_increment
mov EC_current_column_number,ecx

push eax
Check_Location_Within_Boundaries EC_edit_address_increment, edx, ebx ;[EAX] - 1 True	[EAX] - 0 False
pop esi
mov ebx,esi

mov ecx,ebx
cmp eax,1
je end_get_line_number

xor eax,eax

mov ecx,EC_edit_address_increment 
add ecx,ebx			;[ebx] - contains address increment when found line 
add ecx,2			;add [eax] - 2 byte  [ 0dh 0ah ]
cmp ecx,dword ptr [ebp+12]	;scan_text_length
jae end_get_line_number

inc EC_current_line_number
mov EC_edit_address_increment,ecx

jmp start_get_line_number
nop
nop
end_get_line_number:

mov ebx,EC_current_line_number
mov ecx,EC_current_column_number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - no line found
;[eax] - 1 - line found
;[ebx] - line number
;[ecx] - column number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	'................................' 0dh, 0ah
;	|<----- edit line length ------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
Get_Edit_Coordinats_By_Increment endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
















endm


 