SPL_Advanced_Operations_1 macro
;;;;;;;;Using example
;push output_window_handle		;ebp+16
;push spl_buffer_content_length		;ebp+12
;push offset spl_buffer			;ebp+8
;call Process_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Process_SPL proc
push ebp
mov ebp,esp

.DATA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
all_spl_program_descriptor_block	db 444 dup (0)
operation_fill_block			db 100 dup (0)
buffers_block				db 17184 dup (0)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
op_relative_address_increment		dd 0
current_processing_operation		dd 0
spl_empty_data				dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset edit window
;;WM_SETTEXT  0ch
;;wParam = 0;                     // not used; must be zero 
;;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
push offset spl_empty_data	;lparam 
push 0	;wparam 
push 0Ch		;WM_SETTEXT
push dword ptr [ebp+16]	;output_window_handle		;ebp+16
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset edit window
;;;;;;;;;;;;;;;;;;;;;;
SPL_init_buffers
mov op_relative_address_increment,0
mov current_processing_operation,0
;;;No Results
;;;;;;;;;;;;;;;;;;;;;;

mov eax,dword ptr [ebp+8]
mov dword ptr [all_spl_program_descriptor_block]+48,eax

mov ebx,offset operation_fill_block
mov dword ptr [ebx]+88,eax		;Set SPL error address 

push dword ptr [ebp+12]		;4096		;spl_buffer_length
push dword ptr [ebp+8]	;offset spl_buffer
push offset all_spl_program_descriptor_block
call SPL_Init_System
;;;No result 

push offset all_spl_program_descriptor_block	;ebp+8
call SPL_Check_System_Initialization
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - All SPL normal init
;;[eax] - any other value is error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block;
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block

	mov ecx,dword ptr [ebp+8]
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+88,ecx		;Set SPL error address 
cmp eax,1
jne end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Operations
start_perform_operation:

xor eax,eax
mov edi,offset buffers_block
mov ecx,4296
rep stosd

mov edx,offset all_spl_program_descriptor_block
mov ecx,dword ptr [edx]+28	;Operations list start
mov eax,dword ptr [edx]+32	;Operations list length
sub eax,op_relative_address_increment
add ecx,op_relative_address_increment

push offset all_spl_program_descriptor_block
push offset operation_fill_block
push ecx	;offset operation_object
push eax	;Operations list length
call SPL_Get_Operation_Object

add op_relative_address_increment,ebx
inc current_processing_operation

;;pushad
;;mov edx,offset all_spl_program_descriptor_block
;;mov ecx,dword ptr [edx]+28	;Operations list start
;;mov eax,dword ptr [edx]+32	;Operations list length
;;sub eax,op_relative_address_increment
;;add ecx,op_relative_address_increment
;;push eax ;ebx		;output_scan_string_length
;;push ecx ;spl_buffer_address	;output_scan_string_address
;;;push 380	
;;push 30
;;push hdc
;;call TextOutA
;;popad

cmp eax,145		;String end reached when get operation 
je no_spl_error
cmp eax,65		;Operation object start end reached before any operation performed
je no_spl_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+88,esi		;Set SPL error address 
cmp eax,1
jne end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - Normal get Operation Object
;;[eax] - any other value is error code
;;[ebx] - operation_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset operation_fill_block
push offset all_spl_program_descriptor_block
call SPL_Process_Operation_Object

;;mov ebx,operation_fill_block_address
;;mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]
;;show_decimal 430, 30, ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - Operation Object normal process
;;[eax] - 145 - String End Reached
;;[eax] - any other value is error code
;;[esi] - error address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block
	
	mov ebx,offset operation_fill_block;
	mov dword ptr [ebx]+88,esi		;Set SPL error address ;
cmp eax,1
jne end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push offset operation_fill_block
call SPL_Get_Operation_Type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - operation type normal get
;[eax] - 144 - cannot determine operation object type by name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block

	mov ecx,dword ptr [ebp+8]
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+88,ecx		;Set SPL error address 

cmp eax,1
jne end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

push offset all_spl_program_descriptor_block	;ebp+12
push offset operation_fill_block
call SPL_Perform_Operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1   - normal operation perform
;[eax] - 146 - Operation type is unknown. Specified Operation could not be performed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block
	
	mov ecx,dword ptr [ebp+8]
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+88,ecx		;Set SPL error address 
cmp eax,146
je end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push dword ptr [ebp+16]	;output_window_handle		;ebp+16
push offset all_spl_program_descriptor_block	;ebp+12
push offset operation_fill_block		;ebp+8
call SPL_Report_Operation_Results		;Report Operation perform results

mov eax,1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block
	mov ecx,dword ptr [ebp+8]
	mov ebx,offset operation_fill_block
	mov dword ptr [ebx]+88,ecx		;Set SPL error address 
;;cmp eax,1
;;jne end_process_spl
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp start_perform_operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Operations
mov eax,1
end_process_spl:

push dword ptr [ebp+12]	;push spl_buffer_content_length		;ebp+12
push dword ptr [ebp+16]		;;push output_window_handle		;ebp+16
push offset all_spl_program_descriptor_block	;ebp+12
push offset operation_fill_block		;ebp+8
call SPL_Report_Errors

no_spl_error:

mov esp,ebp
pop ebp
ret 12
Process_SPL endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push offset all_spl_program_descriptor_block	;ebp+12
;push offset operation_fill_block		;ebp+8
;call SPL_Perform_Operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Perform_Operation  proc
push ebp
mov ebp,esp

mov eax,146			;Operation type is unknown [Error code]
mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,0
je end_perform_operation

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,3
ja no_operation_type_console

;;;;mov ebx,operation_fill_block_address
;;;;mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]
;;;;cmp eax,0

;;mov ecx,dword ptr [ebp+8]
;;push 0
;;push dword ptr [ecx]+24
;;push dword ptr [ecx]+40
;;push 0
;;call MessageBoxA;

xor eax,eax
xor esi,esi
mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]+60	;STDERR
mov eax,ebx
mov ebx,dword ptr [ecx]+44	;STDOUT
rol ebx,1
or eax,ebx

push eax			;Output buffer type ;1 - STDERR;2 - STDOUT;3 - STDOUT/STDERR
push 0;show_flag		;0-show;1-not show
push dword ptr [ecx]+56		;offset STDOUT_buffer		;ebp+20
push 8192			;buffer_size			;ebp+16
push dword ptr [ecx]+40  	;offset console_command_line	;ebp+12	
push dword ptr [ecx]+24		;offset console_address		;ebp+8	
call ConsoleStart
;;;	extrn ConsoleStart:PROC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error code
;[ebx] - console exit code	;processed only if 103h [259] - STILL ACTIVE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov dword ptr [ecx]+80,eax	;Set system code

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov dword ptr [ecx]+76,ebx	;Set console exit code

jmp end_perform_operation
no_operation_type_console:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,4
jne no_operation_type_delete

mov eax,dword ptr [ebp+8]

push dword ptr [eax]+24		;input_1_buffer address
call DeleteFileA		;If the function fails, the return value is zero. To get extended error information, call GetLastError. 
;;	extrn DeleteFileA:PROC

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov dword ptr [ecx]+80,0	;eax	;Set system code

cmp eax,0
jne no_delete_file_error 

call GetLastError ;
;;;	extrn GetLastError:PROC

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
;;;;mov edx,dword ptr [ebp]+12	;all_spl_program_descriptor_block	;ebp+12
mov dword ptr [ecx]+80,eax	;Set system code

no_delete_file_error:

mov eax,1
jmp end_perform_operation
no_operation_type_delete:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,5
jne no_operation_type_execute
;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
mov edi,offset CP_STARTUPINFO
mov ecx,17
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
mov edi,offset CP_PROCESS_INFORMATION
mov ecx,4
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
CP_STARTUPINFO 		dd 68 dup (0)
CP_PROCESS_INFORMATION	db 16 dup (0)
.CODE

;;mov ecx,dword ptr [ebp+8]

;;;push 0
;;push dword ptr [ecx]+24
;;push dword ptr [ecx]+24
;;push 0
;;call MessageBoxA
;;;;	extrn MessageBoxA:PROC

mov ecx,dword ptr [ebp+8]

;;;.DATA
;;;psdf		db 'c:\TasmIDE\Tasmide2\Projects1\Scanner\MN.exe',0
;;;.CODE

push offset CP_PROCESS_INFORMATION ;pointer to PROCESS_INFORMATION           
push offset CP_STARTUPINFO        ;pointer to STARTUPINFO
push 0	 ;offset lpCurrentDirectory   ;pointer to current directory
push 0	 ;offset lpEnvironment    ;pointer to new environment block 
push 0	 ;dwCreationFlags      ;creation flags 
push 0	 ;bInheritHandles      ;handle inheritance flag 
push 0	 ;offset lpThreadAttributes   ;thread security attributes 
push 0	 ;offset lpProcessAttributes  ;process security attributes 
push dword ptr [ecx]+40		;offset lpCommandLine     ;pointer to command line string
push dword ptr [ecx]+24		;offset lpApplicationName    ;name of executable module 
call CreateProcessA  
;;;	extrn CreateProcessA:PROC
	;If the function fails, the return value is zero. To get extended error information, call GetLastError. 

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov dword ptr [ecx]+80,0	;eax	;Set system code

cmp eax,0
jne no_execute_file_error 

call GetLastError 
;;;	extrn GetLastError:PROC

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
;;;;mov edx,dword ptr [ebp]+12	;all_spl_program_descriptor_block	;ebp+12
mov dword ptr [ecx]+80,eax	;Set system code

push dword ptr CP_PROCESS_INFORMATION+4
call CloseHandle

push dword ptr CP_PROCESS_INFORMATION
call CloseHandle

mov eax,1
jmp end_perform_operation
no_execute_file_error:

push dword ptr CP_PROCESS_INFORMATION+4
call CloseHandle

push dword ptr CP_PROCESS_INFORMATION
call CloseHandle

mov eax,1
jmp end_perform_operation
no_operation_type_execute:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp ebx,6
jne no_operation_type_shell_execute

;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;push offset operation_fill_block		;ebp+8

mov ecx,dword ptr [ebp+8]

push 5	;SW_SHOW 5 ; INT nShowCmd 	      - whether file is shown when opened
push 0	;LPCTSTR lpDirectory  - pointer to string that specifies default directory
push dword ptr [ecx]+40   ;LPCTSTR lpParameters - pointer to string that specifies executable-file parameters 
push dword ptr [ecx]+24   ;LPCTSTR lpFile       - pointer to filename or folder name string
push 0	;LPCTSTR lpOperation  - pointer to string that specifies operation to perform
push 0	;    HWND hwnd,	// handle to parent window
call ShellExecuteA
;;;	extrn ShellExecuteA:PROC
;;;If the function fails, the return value is an error value that is less than or equal to 32. 

mov ecx,dword ptr [ebp]+12	;all_spl_program_descriptor_block	;ebp+12
mov dword ptr [ecx]+36,1024	;Shell Execute error codes

cmp eax,32
ja no_shell_execute_error

mov ecx,dword ptr [ebp]+12	;all_spl_program_descriptor_block	;ebp+12
mov dword ptr [ecx]+36,eax	;Shell Execute error codes

no_shell_execute_error:

mov eax,1
jmp end_perform_operation
no_operation_type_shell_execute:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,7
jne no_operation_type_copy

mov ecx,dword ptr [ebp+8]	;offset operation_fill_block		;ebp+8
mov eax,168			;Input 1 Contents are invalid	[Error code]
mov ebx,dword ptr [ecx]+20	;Input 1 content valid flag
cmp ebx,0
je no_copy_file_error
mov eax,169			;Input 2 Contents are invalid	[Error code]
mov ebx,dword ptr [ecx]+36	;Input 2 content valid flag
cmp ebx,0
je no_copy_file_error

mov eax,dword ptr [ecx]+24	;Input 1 buffer address
mov ebx,dword ptr [ecx]+40	;Input 2 buffer address

;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;push offset operation_fill_block		;ebp+8
;;;show_decimal 430, 30, esi
;;;.DATA
;;;source_file_name	db 'c:\check_file_io.txt',0
;;;destination_file_name	db 'c:\TasmIDE\Tasmide2\Projects1\Scanner\check_file_io.txt',0
;;;.CODE

push 0		;flag for operation if file exists 
push ebx ;offset destination_file_name	;pointer to filename to copy to 
push eax ;offset source_file_name	;pointer to name of an existing file 
call CopyFileA
;;;	extrn CopyFileA:PROC

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov dword ptr [ecx]+80,0	;eax	;Set system code

cmp eax,0
jne no_copy_file_error

call GetLastError 
;	extrn GetLastError:PROC

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
;;;;mov edx,dword ptr [ebp]+12	;all_spl_program_descriptor_block	;ebp+12
mov dword ptr [ecx]+80,eax	;Set system code

mov eax,1
jmp end_perform_operation
no_copy_file_error:

mov eax,1
jmp end_perform_operation
no_operation_type_copy:

mov eax,1
end_perform_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1   - normal operation perform
;[eax] - 146 - Operation type is unknown. Specified Operation could not be performed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SPL_Perform_Operation  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Using example
;push remove_file_length		;ebp+28
;push offset file_name_to_remove	;ebp+24
;push spl_window_handle			;ebp+20
;push output_window_handle		;ebp+16
;push spl_buffer_content_length		;ebp+12
;push offset spl_buffer			;ebp+8
;call SPL_Remove_File_Load_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPL_Remove_File_Load_Object proc
;push ebp
;mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset Results edit window
;;WM_SETTEXT  0ch
;;wParam = 0;                     // not used; must be zero 
;;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
;push offset spl_empty_data	;lparam 
;push 0	;wparam 
;push 0Ch		;WM_SETTEXT
;push dword ptr [ebp+16]	;output_window_handle		;ebp+16
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Results edit window

;SPL_init_buffers

;mov eax,dword ptr [ebp+8]
;mov dword ptr [all_spl_program_descriptor_block]+48,eax

;mov ebx,offset operation_fill_block
;mov dword ptr [ebx]+88,eax		;Set SPL error address 

;push dword ptr [ebp+12]		;4096		;spl_buffer_length
;push dword ptr [ebp+8]	;offset spl_buffer
;push offset all_spl_program_descriptor_block
;call SPL_Init_System
;;;;No result 

;push offset all_spl_program_descriptor_block	;ebp+8
;call SPL_Check_System_Initialization
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - All SPL normal init
;[eax] - any other value is error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov ebx,offset operation_fill_block;
;	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block

;	mov ecx,dword ptr [ebp+8]
;	mov ebx,offset operation_fill_block
;	mov dword ptr [ebx]+88,ecx		;Set SPL error address 
;cmp eax,1
;jne spl_end_remove_file_load_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Remove File Name
;push 22		;remove_file_name_length		;ebp+20
;push offset file_name_for_remove	;ebp+16
;push 54 ;343	;load_file_string_length		;ebp+12
;push offset load_file		;ebp+8
;call Remove_Load_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - file for remove was found
;[eax] - 147 - specified filename was not found [String end reached]
;[eax] - any other value is error code
	;[ebx] - filename object length
	;[esi] - filename object start address ;[or error address]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov eax,offset all_spl_program_descriptor_block
;mov ebx,dword ptr [eax]+12	;File load list start
;mov ecx,dword ptr [eax]+16	;File load list length
;
;push dword ptr [ebp+28]	;22 ;remove_file_name_length		;ebp+20
;push dword ptr [ebp+24]	;offset file_name_for_remove	;ebp+16
;push ecx 	;load_file_string_length		;ebp+12
;push ebx	;offset load_file		;ebp+8
;call Remove_Load_File
;	mov ecx,offset operation_fill_block;
;	mov dword ptr [ecx]+84,eax		;Set SPL error code to the Operation Fill Block
;
;	mov edx,offset operation_fill_block
;	mov dword ptr [edx]+88,esi		;Set SPL error address 
;cmp eax,1
;jne spl_end_remove_file_load_object

;cmp eax,147
;je no_report_spl_remove_error

;[esi] - start address
;[ebx] - object length to remove
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Remove File Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace text
;mov eax,esi
;sub eax,dword ptr [ebp+8]	;offset spl_buffer	[ebp+8]
;mov ecx,dword ptr [ebp+12]	;spl_buffer_content_length	[ebp+12]

;push esi
;push ebx

;sub ecx,eax
;mov edi,esi
;add esi,ebx
;cld 
;rep movsb

;pop ebx
;pop esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New Text
;mov eax,dword ptr [ebp+8]	;offset spl_buffer	[ebp+8]
;mov ecx,dword ptr [ebp+12]	;spl_buffer_content_length	[ebp+12]
;sub ecx,ebx
;add eax,ecx
;mov byte ptr [eax],0

;WM_SETTEXT 0Ch
;wParam = 0;                     // not used; must be zero 
;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
;push offset spl_buffer
;push 4096   ;wParam
;push 0ch ;WM_SETTEXT
;push hww  
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New Text
;mov eax,1
;spl_end_remove_file_load_object:

;cmp eax,1
;je no_report_spl_remove_error

;push dword ptr [ebp+12]	;push spl_buffer_content_length		;ebp+12
;push dword ptr [ebp+16]		;;push output_window_handle		;ebp+16
;push offset all_spl_program_descriptor_block	;ebp+12
;push offset operation_fill_block		;ebp+8
;call SPL_Report_Errors

;no_report_spl_remove_error:

;mov esp,ebp
;pop ebp
;ret 24
;SPL_Remove_File_Load_Object endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXx
;;;;;;;;Using example
;push SPL_buffer_Max_Limit		;ebp+36
;push Line Number			;ebp+32
;push Insert_file_length		;ebp+28
;push offset file_name_to_insert	;ebp+24
;push spl_window_handle			;ebp+20
;push output_window_handle		;ebp+16
;push spl_buffer_content_length		;ebp+12
;push offset spl_buffer			;ebp+8
;call SPL_Insert_File_Load_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SPL_Insert_File_Load_Object proc
;push ebp
;mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset Results edit window
;;WM_SETTEXT  0ch
;;wParam = 0;                     // not used; must be zero 
;;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
;push offset spl_empty_data	;lparam 
;push 0	;wparam 
;push 0Ch		;WM_SETTEXT
;push dword ptr [ebp+16]	;output_window_handle		;ebp+16
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Results edit window
;SPL_init_buffers

;mov eax,dword ptr [ebp+8]
;mov dword ptr [all_spl_program_descriptor_block]+48,eax

;mov ebx,offset operation_fill_block
;mov dword ptr [ebx]+88,eax		;Set SPL error address 

;push dword ptr [ebp+12]		;4096		;spl_buffer_length
;push dword ptr [ebp+8]	;offset spl_buffer
;push offset all_spl_program_descriptor_block
;call SPL_Init_System
;;;;;No result 

;push offset all_spl_program_descriptor_block	;ebp+8
;call SPL_Check_System_Initialization
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - All SPL normal init
;[eax] - any other value is error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov ebx,offset operation_fill_block;
;	mov dword ptr [ebx]+84,eax		;Set SPL error code to the Operation Fill Block

;	mov ecx,dword ptr [ebp+8]
;	mov ebx,offset operation_fill_block
;	mov dword ptr [ebx]+88,ecx		;Set SPL error address 
;cmp eax,1
;jne spl_end_add_file_load_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Insert New File Name
;.DATA
;generate_buffer		db 400 dup (0)
;.CODE

;push Insert_file_length		;ebp+28
;push offset file_name_to_insert	;ebp+24

;push dword ptr [ebp+28]		;generate_file_name_length		;ebp+20
;push dword ptr [ebp+24]		;offset file_name_for_generate	;ebp+16
;push offset generate_buffer		;ebp+12	;Buffer max length 400 byte
;push dword ptr [ebp+32]		;line_number			;ebp+8
;call Generate_Insert_Load_Filename
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - 166 - Filename for generate is too long
;[ebx] - generate filename load object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;	mov edx,offset operation_fill_block;
;	mov dword ptr [edx]+84,eax		;Set SPL error code to the Operation Fill Block
;
;	mov ecx,dword ptr [ebp+8]
;	mov edx,offset operation_fill_block
;	mov dword ptr [edx]+88,ecx		;Set SPL error address 
;cmp eax,1
;jne spl_end_add_file_load_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Insert New File Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Buffer Max Limit
;mov eax,167			;SPL Buffer limit reached. Cannot Insert FileName [Error code]
;	mov edx,offset operation_fill_block;
;	mov dword ptr [edx]+84,eax		;Set SPL error code to the Operation Fill Block
;mov ecx,dword ptr [ebp+12]	;spl_buffer_content_length
;add ecx,ebx
;cmp ecx,dword ptr [ebp+36]	;SPL_buffer_Max_Limit
;jae spl_end_add_file_load_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Buffer Max Limit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Insert New File Name
;mov esi,dword ptr [ebp+8]	;offset spl_buffer
;add esi,dword ptr [ebp+12]	;spl_buffer_content_length
;mov edi,esi
;add edi,ebx

;mov edx,dword ptr all_spl_program_descriptor_block+12	;File Load list Start
;add edx,dword ptr all_spl_program_descriptor_block+16	;File Load List Length
;	push edx
;sub edx,dword ptr [ebp+8]				;offset spl_buffer
;
;mov ecx,dword ptr [ebp+12]	;spl_buffer_content_length
;sub ecx,edx
;inc ecx

;std
;rep movsb		;Shift SPL Text For Insert FileName Load Object
;cld
;	pop edi
;
;mov esi,offset generate_buffer
;mov ecx,ebx
;cld
;rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Insert New File Name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New Text
;;WM_SETTEXT 0Ch
;;wParam = 0;                     // not used; must be zero 
;;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
;push offset spl_buffer
;push 4096   ;wParam
;push 0ch ;WM_SETTEXT
;push hww  
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New Text
;mov eax,1
;jmp no_report_spl_add_error
;spl_end_add_file_load_object:

;cmp eax,1
;je no_report_spl_add_error

;push dword ptr [ebp+12]	;push spl_buffer_content_length		;ebp+12
;push dword ptr [ebp+16]		;;push output_window_handle		;ebp+16
;push offset all_spl_program_descriptor_block	;ebp+12
;push offset operation_fill_block		;ebp+8
;call SPL_Report_Errors

;no_report_spl_add_error:

;mov esp,ebp
;pop ebp
;ret 32
;SPL_Insert_File_Load_Object endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm



