SPL_File_Load_List_Operations_2 macro

;;;Using example
;push remove_file_name_length		;ebp+20
;push offset file_name_for_remove	;ebp+16
;push load_file_string_length		;ebp+12
;push offset load_file_string		;ebp+8
;call Remove_Load_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Remove_Load_File proc
;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp+8]
mov eax,147			;String end reached [Error code]
cmp dword ptr [ebp+12],0
je end_remove_load_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA
r_l_f_address_increment		dd 0
file_load_object_start_address	dd 0
file_load_object_length		dd 0

.CODE
mov r_l_f_address_increment,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find remove filename
start_remove_load_file:
mov file_load_object_start_address,0
mov file_load_object_length,0

mov eax,147			;String end reached [Error code]
mov ebx,dword ptr [ebp+12]
cmp ebx,r_l_f_address_increment
jbe end_remove_load_file

mov eax,dword ptr [ebp+8]
add eax,r_l_f_address_increment

mov ebx,dword ptr [ebp+12]
sub ebx,r_l_f_address_increment

;push ebx	;53		;load_file_length		;ebp+12
;push eax	;offset load_file		;ebp+8
;call Get_Load_File
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - filename normal get
;[eax] - any other value is error code
	;[ebx] - address increment
	;[esi] - filename start address	;[or error address]
	;[ecx] - filename length
	;[edx] - specified line
	;[edi] - File Load object start separator increment
;[ebx] - [edi] only file load object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebx	;53		;load_file_length		;ebp+12
push eax	;offset load_file		;ebp+8
call Get_Load_File
cmp eax,147			;String end reached [Error code]
je end_remove_load_file

push eax
push ebx
mov eax,dword ptr [ebp+8]
add eax,r_l_f_address_increment
add eax,edi	;File load object start address
sub ebx,edi	;only file load object length
mov file_load_object_start_address,eax
mov file_load_object_length,ebx
pop ebx
pop eax

cmp eax,1
jne end_remove_load_file

add r_l_f_address_increment,ebx

;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+20]	;[eax] - remove_file_name_length
cmp ecx,eax
jne start_remove_load_file	;Jump if filename is invalid [Lengths are not similar]

push edi
push ebx
;;;;;;;;push edx	;line number in filename object [Not needs]
;[esi] - filename start address
;[ecx] - filename length

mov eax,dword ptr [ebp+16]	;offset file_name_for_remove

;;SV_compare_string esi, eax, ecx
push ecx	;compare_length		;ebp+24
push eax	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String

pop edi
pop ebx

cmp eax,1			;Jump if filename is invalid
jne start_remove_load_file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start remove file
mov esi,file_load_object_start_address
mov ebx,file_load_object_length

mov ecx,esi
add ecx,ebx
cmp word ptr [ecx],0a0dh
jne no_add_EOL
add ebx,2
no_add_EOL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End remove file

end_remove_load_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find remove filename
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - file for remove was found
;[eax] - 147 - specified filename was not found [String end reached]
;[eax] - any other value is error code
	;[ebx] - filename object length
	;[esi] - filename object start address ;[or error address]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
Remove_Load_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push generate_file_name_length		;ebp+20
;push offset file_name_for_generate	;ebp+16
;push offset generate_buffer		;ebp+12	;Buffer max length 400 byte
;push line_number			;ebp+8
;call Generate_Insert_Load_Filename
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Generate_Insert_Load_Filename proc
;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp

mov eax,166			;Filename for generate is too long [Error code]
mov ecx,dword ptr [ebp+20]	;generate_file_name_length
add ecx,38
cmp ecx,400
jae end_generate_file_name

mov edi,dword ptr [ebp+12]	;offset generate_buffer;Buffer max length 400 byte
xor eax,eax
mov ecx,100
rep stosd

.DATA
file_load_name_start	db "[ FileName = '", 0, 0		;14 byte
file_load_name_end	db "'  Line = 0000000000  ]", 0dh, 0ah	;24 byte
line_value		db '0000000000', 0, 0, 0, 0, 0, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer File Load object start
mov edi,dword ptr [ebp+12]	;offset generate_buffer;Buffer max length 400 byte
mov esi,offset file_load_name_start
mov ecx,4 ;16	;Additional 2 bytes for alignment
rep movsd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer File Load object start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer File Load object FileName
mov edi,dword ptr [ebp+12]	;offset generate_buffer;Buffer max length 400 byte
add edi,14
mov esi,dword ptr [ebp+16]	;offset file_name_for_generate
mov ecx,dword ptr [ebp+20]	;generate_file_name_length
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer File Load object FileName
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer File Load object end
mov edi,dword ptr [ebp+12]	;offset generate_buffer;Buffer max length 400 byte
add edi,14
add edi,dword ptr [ebp+20]	;generate_file_name_length
mov esi,offset file_load_name_end
mov ecx,6
rep movsd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer File Load object end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert line number
mov eax,dword ptr [ebp+8]		;Line number
mov dword ptr string_bin_qword,eax
push offset line_value       ;       ebp+20;
push offset string_pack210    ;       ebp+16
push offset output            ;       ebp+12 
push offset string_bin_qword  ;input  ebp+8
call ConvertBinToDec
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert line number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer File Load object Line number
mov edi,dword ptr [ebp+12]	;offset generate_buffer;Buffer max length 400 byte
add edi,14
add edi,dword ptr [ebp+20]	;generate_file_name_length
add edi,10
mov esi,offset line_value
mov ecx,10
rep movsb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer File Load object Line number
mov ebx,38
add ebx,dword ptr [ebp+20]	;generate_file_name_length

mov eax,1
end_generate_file_name:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal execution
;[eax] - any other value is error code
;[ebx] - generate filename load object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; |<-------------------- FileName load object ------------------>|
; [ FileName = "......................"  Line = 0000000042 ] 0a0dh
; |<---- 14 --->|<---- File name --->|<--------- 24 byte ------->|
;[File name + 14 + 24] < 400 byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
Generate_Insert_Load_Filename endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm