SPL_Standard_Functions_5 macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push offset all_spl_program_descriptor_block	;ebp+20
;push offset operation_fill_block		;ebp+16
;push offset operation_object			;ebp+12
;push 121	;operation_scan_text_length	;ebp+8
;call SPL_Get_Operation_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SPL_Get_Operation_Object proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov operation_object_length,eax
mov ebx,dword ptr [ebp+12]
mov operation_object_address,ebx
mov ecx,dword ptr [ebp+16]
mov operation_fill_block_address,ecx
mov edx,dword ptr [ebp+20]
mov spl_program_descriptor_block,edx
mov operation_address_increment,0

.DATA
operation_object_address	dd 0
operation_object_length		dd 0

operation_fill_block_address	dd 0
spl_program_descriptor_block	dd 0	;address

operation_address_increment	dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

;;SV_Escape_Separators SPL_050, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,operation_object_address
	add esi,operation_address_increment
mov eax,145			;String end reached while Get Operation Type [Error code]
cmp ecx,1
jne end_get_operation_object
add operation_address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset operation_object 		;ebp+12
;push 30					;ebp+8
;call SPL_Get_Operation_Object_Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 Operation Object Start Normal get
;[eax] - any other value is error code
	;[esi] - Operation Name Address
	;[ecx] - Operation Name length
	;[ebx] - address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment
mov ebx,operation_object_length
sub ebx,operation_address_increment


push eax	;offset operation_object 		;ebp+12
push ebx		;30					;ebp+8
call SPL_Get_Operation_Object_Start

cmp eax,1
jne end_get_operation_object		;Error case [with Error code and Error address]

mov eax,operation_fill_block_address
mov dword ptr [eax]+4,ecx
mov dword ptr [eax]+8,esi
add operation_address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset output_object
;push 19 ; offset output_scan_string_length	;[ebp+8]
;call Get_Output_Type					;;[Output:STDOUT/STDERR 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 output type normal get
;[eax] - any other value is error code
	;[ebx] - 1 - STDOUT	0 - No STDOUT
	;[ecx] - 1 - STDERR	0 - No STDERR
	;[esi] - error address
	;[edx] - address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

push eax		;offset output_object
push ebx		;19 ; offset output_scan_string_length	;[ebp+8]
call Get_Output_Type					;;[Output:STDOUT/STDERR 

cmp eax,1
jne end_get_operation_object		;Error case [with Error code and Error address]

add operation_address_increment,edx
mov eax,operation_fill_block_address
mov dword ptr [eax]+44,ebx
mov dword ptr [eax]+60,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

;;SV_Escape_Separators SPL_046, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,operation_object_address
	add esi,operation_address_increment
mov eax,85			;String end reached before first input object [Error code]
cmp ecx,1
jne end_get_operation_object
add operation_address_increment,ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get First Input
;push offset spl_object_string ;spl_object_address	;ebp + 24
;push 20  ;string_length					;ebp + 20
;call SPL_Get_Standard_Object 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

push eax		;offset spl_object_string ;spl_object_address	;ebp + 24
push ebx  ;string_length					;ebp + 20
call SPL_Get_Standard_Object 
cmp eax,1
jne end_get_operation_object		;Error case [with Error code and Error address]

mov eax,88				;First input is too large [Error code]
cmp ecx,400
jae end_get_operation_object		;Error case [with Error code and Error address]
;;;;;;;;;;;;;;;;;;;;;;;Start transfer First Input
push edi
push ecx
;[esi] ;[ecx]
mov edi,offset buffers_block
rep movsb
pop ecx
pop edi

inc ebx			;[1 - direct word  2 - Label]

mov eax,operation_fill_block_address
mov dword ptr [eax]+20,ebx		;Set Input_1_type [0-word 1-label]

mov eax,operation_fill_block_address
mov dword ptr [eax]+16,ecx		;Set Input_1 contents length
;;;;;;;;;;;;;;;;;;;;;;;End transfer First Input
mov eax,operation_object_address
add eax,operation_address_increment

	mov esi,operation_object_address
	add esi,operation_address_increment

sub edi,eax
inc edi
mov eax,86			;String end reached after first input object [Error code]
cmp edi,operation_object_length
ja end_get_operation_object
add operation_address_increment,edi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get First Input
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

;;SV_Escape_Separators SPL_047, eax, ebx
push ebx	;string_length		;ebp+28
push eax		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,ecx
	mov esi,operation_object_address
	add esi,operation_address_increment
mov eax,86			;String end reached after first input object [Error code]
cmp ecx,1
jne end_get_operation_object
add operation_address_increment,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Second Input
;push offset spl_object_string ;spl_object_address	;ebp + 24
;push 20  ;string_length					;ebp + 20
;call SPL_Get_Standard_Object 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

push eax		;offset spl_object_string ;spl_object_address	;ebp + 24
push ebx  ;string_length					;ebp + 20
call SPL_Get_Standard_Object 
cmp eax,1
jne no_second_input_object

mov eax,89				;Second input is too large [Error code]
cmp ecx,400
jae end_get_operation_object		;Error case [with Error code and Error address]
;;;;;;;;;;;;;;;;;;;;;;;Start transfer Second Input
push edi
push ecx
;[esi] ;[ecx]
mov edi,offset buffers_block+400
rep movsb
pop ecx
pop edi

inc ebx

mov eax,operation_fill_block_address
mov dword ptr [eax]+36,ebx		;Set Input_2_type [0-word 1-label]

mov eax,operation_fill_block_address
mov dword ptr [eax]+32,ecx		;Set Input_2 contents length
;;;;;;;;;;;;;;;;;;;;;;;End transfer Second Input

mov eax,operation_object_address
add eax,operation_address_increment
	mov esi,operation_object_address
	add esi,operation_address_increment
sub edi,eax
inc edi
mov eax,87			;String end reached after second input object [Error code]
cmp edi,operation_object_length
ja end_get_operation_object
add operation_address_increment,edi

no_second_input_object:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Second Input

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset operation_object 		;ebp+12
;push 30					;ebp+8
;call SPL_Get_Operation_Object_End
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 Operation Object Start Normal get
;[eax] - any other value is error code
	;[esi] - Operation Name Address
	;[ecx] - Operation Name length
	;[ebx] - address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_object_address
add eax,operation_address_increment

mov ebx,operation_object_length
sub ebx,operation_address_increment

push eax	;offset operation_object 		;ebp+12
push ebx		;30					;ebp+8
call SPL_Get_Operation_Object_End
cmp eax,1
jne end_get_operation_object		;Error case [with Error code and Error address]

add operation_address_increment,ebx

;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,operation_fill_block_address
mov edx,dword ptr [eax]+4
mov eax,92		;Operation start and end names are not similar [Error code]
cmp edx,ecx
jne end_get_operation_object

mov eax,operation_fill_block_address
mov edi,dword ptr [eax]+8
;;SV_compare_string edi, esi, ecx

push ecx	;compare_length		;ebp+24
push edi	;Second_string		;ebp+20
push edi	;First_string		;ebp+16
call Compare_String

xchg eax,ebx
mov eax,92
cmp ebx,1
jne end_get_operation_object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov eax,1
mov ebx,operation_address_increment
end_get_operation_object:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Normal get Operation Object
;[eax] - any other value is error code
;[ebx] - operation_address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 16
SPL_Get_Operation_Object endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Process_Operation_Object proc
;;Using example
;push offset operation_fill_block		;ebp+12
;push offset all_spl_program_descriptor_block	;ebp+8
;call SPL_Process_Operation_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push ebp
mov ebp,esp

mov eax,dword ptr [ebp+8]
mov poo_spl_program_descriptor_block,eax
mov ebx,dword ptr [ebp+12]
mov poo_operation_fill_block_address,ebx

.DATA
poo_operation_fill_block_address	dd 0
poo_spl_program_descriptor_block	dd 0	;address
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process First Input
mov eax,poo_operation_fill_block_address
cmp dword ptr [eax]+20,2
jne end_process_first_input		;jump if content is not label 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find filename in Files list
mov eax,poo_spl_program_descriptor_block
mov ebx,poo_operation_fill_block_address

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
push dword ptr [eax]+4	;		;object_string_address	;ebp+36
push dword ptr [eax]+8	;264		;object_string_length	;ebp+32
push dword ptr [ebx]+24		;offset label		;ebp+28
push dword ptr [ebx]+16	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,1
jne no_file_found_at_file_list

push esi
push ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Input Object
mov ebx,poo_operation_fill_block_address

mov ecx,dword ptr [ebx]+16	;input_1_buffer content length

mov edi,dword ptr [ebx]+24	;input_1 buffer address
xor eax,eax
cld
rep stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Input Object
pop ecx
pop esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
;[esi] - contains the filename Label address
mov eax,90		;Found File name is too large [Error code]
cmp ecx,400
jae end_process_operation_object

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+16,ecx		;Set Input_1_buffer contents length

mov ebx,poo_operation_fill_block_address
mov edi,dword ptr [ebx]+24		;Input 1 buffer address 
;[ecx]
;[esi]
cld
rep movsb

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+20,1		;Set Input_1_buffer content as direct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
mov eax,1

jmp end_process_first_input
no_file_found_at_file_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End try to find filename in Files list

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find filename in Programs list
mov eax,poo_spl_program_descriptor_block
mov ebx,poo_operation_fill_block_address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
push dword ptr [eax]+20	;		;object_string_address	;ebp+36
push dword ptr [eax]+24	;264		;object_string_length	;ebp+32
push dword ptr [ebx]+24		;offset label		;ebp+28
push dword ptr [ebx]+16	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,1
jne no_file_found_at_program_list

push esi
push ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Input Object
mov ebx,poo_operation_fill_block_address

mov ecx,dword ptr [ebx]+16	;input_1_buffer content length

mov edi,dword ptr [ebx]+24	;input_1 buffer address
xor eax,eax
cld
rep stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Input Object
pop ecx
pop esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
;[esi] - contains the filename Label address
mov eax,90		;Found File name is too large [Error code]
cmp ecx,400
jae end_process_operation_object

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+16,ecx		;Set Input_1_buffer contents length

mov ebx,poo_operation_fill_block_address
mov edi,dword ptr [ebx]+24		;Input 1 buffer address 
;[ecx]
;[esi]
cld
rep movsb

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+20,1		;Set Input_1_buffer content as direct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
mov eax,1


jmp end_process_first_input
no_file_found_at_program_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End try to find filename in Programs list
xor eax,eax
mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+20,0		;Set Input_1_buffer content as invalid

end_process_first_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process First Input

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Second Input
mov eax,poo_operation_fill_block_address
cmp dword ptr [eax]+36,2
jne end_process_second_input		;jump if content is not label 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find filename in Files list
mov eax,poo_spl_program_descriptor_block
mov ebx,poo_operation_fill_block_address

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
push dword ptr [eax]+4	;		;object_string_address	;ebp+36
push dword ptr [eax]+8	;264		;object_string_length	;ebp+32
push dword ptr [ebx]+40		;offset label		;ebp+28
push dword ptr [ebx]+32	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,1
jne no_file_found_at_file_list_si

push esi
push ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Input Object
mov ebx,poo_operation_fill_block_address

mov ecx,dword ptr [ebx]+32	;input_2_buffer content length

mov edi,dword ptr [ebx]+40	;input_2_buffer address
xor eax,eax
cld
rep stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Input Object
pop ecx
pop esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
;[esi] - contains the filename Label address
mov eax,91		;Found File name is too large [Error code]
cmp ecx,400
jae end_process_operation_object

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+32,ecx		;Set Input_2_buffer contents length

mov ebx,poo_operation_fill_block_address
mov edi,dword ptr [ebx]+40		;Input_2_buffer address 
;[ecx]
;[esi]
cld
rep movsb

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+36,1		;Set Input_2_buffer content as direct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
mov eax,1
jmp end_process_second_input
no_file_found_at_file_list_si:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End try to find filename in Files list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start try to find filename in Programs list
mov eax,poo_spl_program_descriptor_block
mov ebx,poo_operation_fill_block_address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
push dword ptr [eax]+20	;		;object_string_address	;ebp+36
push dword ptr [eax]+24	;264		;object_string_length	;ebp+32
push dword ptr [ebx]+40		;offset label		;ebp+28
push dword ptr [ebx]+32	;5 ;label_length		;ebp+244
call SPL_Get_Object_From_Label
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;[EAX] - 1 Object from label find [Success]
;[EAX] - 0 Object from label not find [Error]
;[EAX] - Any other value[False][Error code]
	;[ESI] - Object start address	;or error address
	;[ECX] - Object length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,1
jne no_file_found_at_program_list_si

push esi
push ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Input Object
mov ebx,poo_operation_fill_block_address

mov ecx,dword ptr [ebx]+32	;input_2_buffer content length

mov edi,dword ptr [ebx]+40	;input_2_buffer address
xor eax,eax
cld
rep stosb
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Input Object
pop ecx
pop esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Replace with file name
;[esi] - contains the filename Label address
mov eax,91		;Found File name is too large [Error code]
cmp ecx,400
jae end_process_operation_object

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+32,ecx		;Set Input_2_buffer contents length

mov ebx,poo_operation_fill_block_address
mov edi,dword ptr [ebx]+40		;Input_2_buffer address 
;[ecx]
;[esi]
cld
rep movsb

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+36,1		;Set Input_2_buffer content as direct string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Replace with file name
mov eax,1
jmp end_process_second_input
no_file_found_at_program_list_si:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End try to find filename in Programs list

mov ebx,poo_operation_fill_block_address
mov dword ptr [ebx]+36,0		;Set Input_2_buffer content as invalid

mov eax,0
end_process_second_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Second Input
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process First Input As Direct String
mov eax,poo_operation_fill_block_address
cmp dword ptr [eax]+20,0
je first_contents_are_invalid		;jump if contents are invalid

mov ebx,poo_operation_fill_block_address
mov eax,poo_spl_program_descriptor_block

push dword ptr [eax]+4	;file_names_start_address			;ebp+20
push dword ptr [eax]+8	;file_names_length				;ebp+16
push dword ptr [ebx]+24	;insert_object_string_address		;ebp+12
push dword ptr [ebx]+16	;insert_object_string_length		;ebp+8
call Process_Insert_Object 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Insert Object Not Found
;[eax] - 5 - Insert Object Not Found [string end reached while search Insert Object]
;[eax] - 1 - Insert Object Found and Replaced
;[eax] - any other value - error code
	;[esi] - error address
	;[ebx] - Insert Objects Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,5
ja end_process_operation_object	;Jump If error in found insert object

first_contents_are_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process First Input As Direct String

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Second Input As Direct String
mov eax,poo_operation_fill_block_address
cmp dword ptr [eax]+36,0
je second_contents_are_invalid		;jump if contents are invalid

mov ebx,poo_operation_fill_block_address
mov eax,poo_spl_program_descriptor_block

push dword ptr [eax]+4	;file_names_start_address			;ebp+20
push dword ptr [eax]+8	;file_names_length				;ebp+16
push dword ptr [ebx]+40	;insert_object_string_address		;ebp+12
push dword ptr [ebx]+32	;insert_object_string_length		;ebp+8
call Process_Insert_Object 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Insert Object Not Found
;[eax] - 5 - Insert Object Not Found [string end reached while search Insert Object]
;[eax] - 1 - Insert Object Found and Replaced
;[eax] - any other value - error code
	;[esi] - error address
	;[ebx] - Insert Objects Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,5
ja end_process_operation_object	;Jump If error in found insert object


second_contents_are_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Second Input As Direct String

mov eax,1			
end_process_operation_object:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 1 - Operation Object normal process
;[eax] - 145 - String End Reached
;[eax] - any other value is error code
;[esi] - error address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SPL_Process_Operation_Object endp

endm