SPL_Report_Results	macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push dword ptr [ebp+12]	;push spl_buffer_content_length		;ebp+20
;push hwnd					;ebp+16
;push offset all_spl_program_descriptor_block	;ebp+12
;push offset operation_fill_block		;ebp+8
;call SPL_Report_Operation_Results
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Report_Operation_Results proc
push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset operation name
xor eax,eax
mov ecx,100
mov edi,offset c_operation_name
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset operation name
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line

	mov MASM_TEMP_REGISTER,offset SPL_current_operation
add_edit_text MASM_TEMP_REGISTER	;SPL_current_operation
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER	;tab_1

;;;add_edit_text c_separator_line
;;;add_edit_text c_operation

;;;SPL_current_operation

CBTD_4:

mov eax,current_processing_operation
	;mov dword ptr string_bin_qword,eax
	;push offset SPL_Error_Code_Data      ;       ebp+20;
	;push offset string_pack210    ;       ebp+16	
	;push offset output            ;       ebp+12 
	;push offset string_bin_qword  ;input  ebp+8
	;call ConvertBinToDec

push eax
push offset SPL_Error_Code_Data
call SC_Convert_Bin_To_Dec_10
cmp eax,(-1)
je CBTD_4


;;;;;add_edit_text c_return_line
	mov MASM_TEMP_REGISTER,offset SPL_Error_Code_Data
add_edit_text MASM_TEMP_REGISTER  ;SPL_Error_Code_Data

	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER ;c_return_line

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,3
ja no_report_console_operation

.DATA
MASM_TEMP_REGISTER	dd 0
c_separator_line	db '_________________________________________________________________', 0
c_all_output		db 'STDOUT/STDERR',0, 0, 0
c_operation		db 'Operation name:',0
c_operation_name	dd 100 dup (0)
c_output_type		db 'Output type:',0, 0, 0, 0
c_output_stdout		db 'STDOUT', 0, 0
c_output_stderr		db 'STDERR', 0, 0 
c_output_none		db 'None',0, 0, 0, 0
c_program_name		db 'Program name:', 0, 0, 0
c_program_execution	db 'Program execution:',0, 0, 0, 0, 0, 0
c_command_line		db 'Command line:', 0, 0, 0 
c_result		db 'Result:',0
c_return_line		db 0dh, 0ah, 0,   0
tab_1			db 09h, 0,   0,   0
tab_2			db 09h, 09h, 0,   0
tab_3			db 09h, 09h, 09h, 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Word "Operation" to edit window
;;;EM_REPLACESEL  0c2h
;;;wParam = 0;                     // not used; must be zero 
;;;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
;;push offset c_operation	;lparam 
;;push 0	;wparam 
;;push 0C2h		;EM_REPLACESEL
;;push dword ptr [ebp+16]	;hwnd
;;call SendMessageA

	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER	;c_separator_line
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line
	mov MASM_TEMP_REGISTER,offset c_operation
add_edit_text MASM_TEMP_REGISTER	;c_operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Word "Operation" to edit window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name to edit window
mov eax,dword ptr [ebp+8]
add eax,8		;Operation name address
mov esi,dword ptr [eax]
mov edi,offset c_operation_name
sub eax,4
mov ecx,dword ptr [eax]
cld
rep movsb			;Transfer operation name from SPL to the c_operation_name

	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER	;tab_2
	mov MASM_TEMP_REGISTER,offset c_operation_name
add_edit_text MASM_TEMP_REGISTER	;c_operation_name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name to edit window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show First Contents
mov ebx,operation_fill_block_address
mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]

cmp eax,0
jne c_no_input_1_contents_invalid

.DATA
input_1_content		db 'Operation first input contents are invalid.',0
.CODE

	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line
	mov MASM_TEMP_REGISTER,offset input_1_content
add_edit_text MASM_TEMP_REGISTER	;input_1_content

c_no_input_1_contents_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show First Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER ;c_return_line
	mov MASM_TEMP_REGISTER,offset c_output_type
add_edit_text MASM_TEMP_REGISTER ;c_output_type
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER	;tab_2

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,0
jne no_c_output

	mov MASM_TEMP_REGISTER,offset c_output_none
add_edit_text MASM_TEMP_REGISTER	;c_output_none

no_c_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,2
jne no_c_all_output

	mov MASM_TEMP_REGISTER,offset c_all_output
add_edit_text MASM_TEMP_REGISTER	;c_all_output
no_c_all_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ebx,1
jne no_c_stdout
cmp ecx,1
je no_c_stdout
	mov MASM_TEMP_REGISTER,offset c_output_stdout
add_edit_text MASM_TEMP_REGISTER	;c_output_stdout
no_c_stdout:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ecx,1
jne no_c_stderr
cmp ebx,1
je no_c_stderr
	mov MASM_TEMP_REGISTER,offset c_output_stderr
add_edit_text MASM_TEMP_REGISTER	;c_output_stderr
no_c_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set output type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Program name
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line
	mov MASM_TEMP_REGISTER,offset c_program_name
add_edit_text MASM_TEMP_REGISTER	;c_program_name
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+24

mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Program name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Program name
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_command_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER	;tab_2

mov eax,dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+40

mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Program name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Program execution result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_program_execution
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov eax,dword ptr [ecx]+80	;Get system code

;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;push offset operation_fill_block		;ebp+8

push eax	;error code		;ebp+8
call Get_System_Error_Text
;;;;	extrn Get_System_Error_Text:PROC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - error text address
;;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Program execution result
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line;
	mov MASM_TEMP_REGISTER,offset c_result
add_edit_text MASM_TEMP_REGISTER	;c_result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp]+8 ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+56	;STDOUT buffer address

mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER	;c_return_line

xor eax,eax
mov ecx,100
mov edi,offset c_operation_name		;Reset operation name because 
rep stosd				;in other case [add_edit_text c_separator_line] can be add also 
					;operation name [reason cannot be found]

	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER	;c_separator_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
jmp end_report_operation_type
no_report_console_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,4			;Delete - 4 
jne no_report_delete_operation

.DATA
;;;c_separator_line	db '_________________________________________________________________',0
;;;c_all_output		db 'STDOUT/STDERR',0, 0, 0
;;;c_operation		db 'Operation name:',0
d_operation		db 'Operation name:		Delete',0
d_file			db 'Delete file name',0
d_operation_result	db 'Delete operation result',0

;c_operation_name	dd 100 dup (0)
;c_output_type		db 'Output type:',0, 0, 0, 0
;c_output_stdout		db 'STDOUT', 0, 0
;c_output_stderr		db 'STDERR', 0, 0 
;c_output_none		db 'None',0, 0, 0, 0
;c_program_name		db 'Program name:', 0, 0, 0
;c_program_execution	db 'Program execution:',0, 0, 0, 0, 0, 0
;c_command_line		db 'Command line:', 0, 0, 0 
;c_result		db 'Result:',0
;c_return_line		db 0dh, 0ah, 0,   0
;tab_1			db 09h, 0,   0,   0
;tab_2			db 09h, 09h, 0,   0
;tab_3			db 09h, 09h, 09h, 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset d_operation
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show First Contents
mov ebx,operation_fill_block_address
mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]

cmp eax,0
jne d_no_input_1_contents_invalid

;;.DATA
;;;input_1_content		db 'Operation first input contents are invalid.',0
;;;.CODE

;;;;add_edit_text c_return_line
	mov MASM_TEMP_REGISTER,offset input_1_content
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER

d_no_input_1_contents_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show First Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_output_type
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,0
jne no_d_output

	mov MASM_TEMP_REGISTER,offset c_output_none
add_edit_text MASM_TEMP_REGISTER

no_d_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,2
jne no_d_all_output

	mov MASM_TEMP_REGISTER,offset c_all_output
add_edit_text MASM_TEMP_REGISTER

no_d_all_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ebx,1
jne no_d_stdout
cmp ecx,1
je no_d_stdout

	mov MASM_TEMP_REGISTER,offset c_output_stdout
add_edit_text MASM_TEMP_REGISTER

no_d_stdout:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ecx,1
jne no_d_stderr
cmp ebx,1
je no_d_stderr
	mov MASM_TEMP_REGISTER,offset c_output_stderr
add_edit_text MASM_TEMP_REGISTER
no_d_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set output type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Delete File name 
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset d_file
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+24
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Delete File name 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Delete result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset d_operation_result
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov eax,dword ptr [ecx]+80	;Get system code

;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;push offset operation_fill_block		;ebp+8

push eax	;error code		;ebp+8
call Get_System_Error_Text
;;	extrn Get_System_Error_Text:PROC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - error text address
;;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Delete result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

jmp end_report_operation_type
no_report_delete_operation:

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,5			;Execute - 5 
jne no_report_execute_operation

.DATA
;;;c_separator_line	db '_________________________________________________________________',0
;;;c_all_output		db 'STDOUT/STDERR',0, 0, 0
;;;c_operation		db 'Operation name:',0
e_operation		db 'Operation name:			Execute',0
e_file			db 'Execute file name:',0
e_command_line		db 'Command line:', 0, 0, 0 
e_operation_result	db 'Execute operation result:',0

;c_operation_name	dd 100 dup (0)
;c_output_type		db 'Output type:',0, 0, 0, 0
;c_output_stdout		db 'STDOUT', 0, 0
;c_output_stderr		db 'STDERR', 0, 0 
;c_output_none		db 'None',0, 0, 0, 0
;c_program_name		db 'Program name:', 0, 0, 0
;c_program_execution	db 'Program execution:',0, 0, 0, 0, 0, 0
;c_result		db 'Result:',0
;c_return_line		db 0dh, 0ah, 0,   0
;tab_1			db 09h, 0,   0,   0
;tab_2			db 09h, 09h, 0,   0
;tab_3			db 09h, 09h, 09h, 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset e_operation
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show First Contents
mov ebx,operation_fill_block_address
mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]

cmp eax,0
jne e_no_input_1_contents_invalid

;;;.DATA
;;;input_1_content		db 'Operation first input contents are invalid.',0
;;;.CODE

;;;;add_edit_text c_return_line
	mov MASM_TEMP_REGISTER,offset input_1_content
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER

e_no_input_1_contents_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show First Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_output_type
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_3
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,0
jne no_e_output

	mov MASM_TEMP_REGISTER,offset c_output_none
add_edit_text MASM_TEMP_REGISTER

no_e_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,2
jne no_e_all_output
	mov MASM_TEMP_REGISTER,offset c_all_output
add_edit_text MASM_TEMP_REGISTER

no_e_all_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ebx,1
jne no_e_stdout
cmp ecx,1
je no_e_stdout
	mov MASM_TEMP_REGISTER,offset c_output_stdout
add_edit_text MASM_TEMP_REGISTER

no_e_stdout:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ecx,1
jne no_e_stderr
cmp ebx,1
je no_e_stderr
	mov MASM_TEMP_REGISTER,offset c_output_stderr
add_edit_text MASM_TEMP_REGISTER
no_e_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set output type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute File name 
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset e_file
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+24
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute File name 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute command name 
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset e_command_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_3
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+40
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute command name 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset e_operation_result
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov eax,dword ptr [ecx]+80	;Get system code

;;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;;push offset operation_fill_block		;ebp+8

push eax	;error code		;ebp+8
call Get_System_Error_Text
;;	extrn Get_System_Error_Text:PROC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - error text address
;;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

jmp end_report_operation_type
no_report_execute_operation:

mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,6			;ShellExecute - 6
jne no_report_sh_execute_operation

.DATA
;;;c_separator_line	db '_________________________________________________________________',0
;;;c_all_output		db 'STDOUT/STDERR',0, 0, 0
;;;c_operation		db 'Operation name:',0
she_operation		db 'Operation name:		ShellExecute',0
she_file		db 'File name:',0
she_command_line	db 'Command line:', 0, 0, 0 
she_operation_result	db 'Operation result:',0

;c_operation_name	dd 100 dup (0)
;c_output_type		db 'Output type:',0, 0, 0, 0
;c_output_stdout		db 'STDOUT', 0, 0
;c_output_stderr		db 'STDERR', 0, 0 
;c_output_none		db 'None',0, 0, 0, 0
;c_program_name		db 'Program name:', 0, 0, 0
;c_program_execution	db 'Program execution:',0, 0, 0, 0, 0, 0
;c_result		db 'Result:',0
;c_return_line		db 0dh, 0ah, 0,   0
;tab_1			db 09h, 0,   0,   0
;tab_2			db 09h, 09h, 0,   0
;tab_3			db 09h, 09h, 09h, 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset she_operation
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show First Contents
mov ebx,operation_fill_block_address
mov eax,dword ptr [ebx]+20		;Get Input_1_buffer content [ 0 - contents are invalid ]
;;;;mov ecx,dword ptr [ebx]+36		;Get Input_2_buffer content [ 0 - contents are invalid ]

cmp eax,0
jne she_no_input_1_contents_invalid

;;;.DATA
;;;input_1_content		db 'Operation first input contents are invalid.',0
;;;.CODE

;;;;add_edit_text c_return_line
	mov MASM_TEMP_REGISTER,offset input_1_content
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER

she_no_input_1_contents_invalid:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show First Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_output_type
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,0
jne no_she_output

	mov MASM_TEMP_REGISTER,offset c_output_none
add_edit_text MASM_TEMP_REGISTER

no_she_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,2
jne no_she_all_output
	mov MASM_TEMP_REGISTER,offset c_all_output
add_edit_text MASM_TEMP_REGISTER
no_she_all_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ebx,1
jne no_she_stdout
cmp ecx,1
je no_she_stdout
	mov MASM_TEMP_REGISTER,offset c_output_stdout
add_edit_text MASM_TEMP_REGISTER

no_she_stdout:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ecx,1
jne no_she_stderr
cmp ebx,1
je no_she_stderr
	mov MASM_TEMP_REGISTER,offset c_output_stderr
add_edit_text MASM_TEMP_REGISTER
no_she_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set output type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute File name 
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset she_file
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+24
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute File name 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute command name 
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset she_command_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+40
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute command name 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Execute result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset she_operation_result
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov ecx,dword ptr [ebp]+12	;operation_fill_block		;ebp+8
mov edx,dword ptr [ecx]+36	;Get ShellExecute code

mov eax,offset she_normal_execution
.DATA
she_normal_execution	db 'Operation completed succesfully.',0
.CODE

cmp edx,1024
je she_error_defined

;;;;push offset all_spl_program_descriptor_block	;ebp+12
;;;;push offset operation_fill_block		;ebp+8

mov ecx,dword ptr [ebp]+12	;operation_fill_block		;ebp+8
mov eax,dword ptr [ecx]+36	;Get ShellExecute code

push eax	;error code		;ebp+8
call Get_Shell_Execute_Error_Text 
;;	extrn Get_Shell_Execute_Error_Text:PROC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
she_error_defined:

mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Execute result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

no_report_sh_execute_operation:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Report Copy Results
mov ecx,dword ptr [ebp+8]
mov ebx,dword ptr [ecx]
cmp ebx,7			;Copy - 7
jne no_report_copy_operation

.DATA
;;;c_separator_line	db '_________________________________________________________________',0
;;;c_all_output		db 'STDOUT/STDERR',0, 0, 0
copy_operation_name	db 'Operation name:		Copy',0
copy_source		db 'Source:',0
copy_destination	db 'Destination:', 0, 0, 0 
copy_result		db 'Copy operation result:',0

;c_operation_name	dd 100 dup (0)
;c_output_type		db 'Output type:',0, 0, 0, 0
;c_output_stdout		db 'STDOUT', 0, 0
;c_output_stderr		db 'STDERR', 0, 0 
;c_output_none		db 'None',0, 0, 0, 0
;c_program_name		db 'Program name:', 0, 0, 0
;c_program_execution	db 'Program execution:',0, 0, 0, 0, 0, 0
;c_result		db 'Result:',0
;c_return_line		db 0dh, 0ah, 0,   0
;tab_1			db 09h, 0,   0,   0
;tab_2			db 09h, 09h, 0,   0
;tab_3			db 09h, 09h, 09h, 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset copy_operation_name
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_output_type
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,0
jne no_copy_output

	mov MASM_TEMP_REGISTER,offset c_output_none
add_edit_text MASM_TEMP_REGISTER

no_copy_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
add ebx,ecx
cmp ebx,2
jne no_copy_all_output
	mov MASM_TEMP_REGISTER,offset c_all_output
add_edit_text MASM_TEMP_REGISTER
no_copy_all_output:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ebx,1
jne no_copy_stdout
cmp ecx,1
je no_copy_stdout
	mov MASM_TEMP_REGISTER,offset c_output_stdout
add_edit_text MASM_TEMP_REGISTER
no_copy_stdout:

mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output
cmp ecx,1
jne no_copy_stderr
cmp ebx,1
je no_copy_stderr
	mov MASM_TEMP_REGISTER,offset c_output_stderr
add_edit_text MASM_TEMP_REGISTER
no_copy_stderr:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set output type
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Contents
mov ecx,dword ptr [ebp+8]	;offset operation_fill_block		;ebp+8
mov ebx,dword ptr [ecx]+20	;Input 1 content valid flag
cmp ebx,0
jne no_copy_input_1_contents
.DATA
input_1_e_c	db 'Source contents are invalid. Copy operation could not be performed.',0
.CODE
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset input_1_e_c
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

mov eax,1
jmp end_report_operation_type
no_copy_input_1_contents:

mov ecx,dword ptr [ebp+8]	;offset operation_fill_block		;ebp+8
mov ebx,dword ptr [ecx]+36	;Input 2 content valid flag
cmp ebx,0
jne no_copy_input_2_contents
.DATA
input_2_e_c	db 'Destination contents are invalid. Copy operation could not be performed.',0
.CODE
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset input_2_e_c
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

mov eax,1
jmp end_report_operation_type
no_copy_input_2_contents:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Contents
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Source
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset copy_source
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_3
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+24	;Input 1 buffer address
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Source
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Destination
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset copy_destination
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr dword ptr [ebp+8] ;push offset operation_fill_block		;ebp+8
mov esi,dword ptr [eax]+40	;Input 1 buffer address
mov MASM_TEMP_REGISTER,esi
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Destination
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Copy Result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset copy_result
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER

mov ecx,dword ptr [ebp]+8	;operation_fill_block		;ebp+8
mov eax,dword ptr [ecx]+80	;Get System Error code

push eax	;error code		;ebp+8
call Get_System_Error_Text 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
copy_error_defined:

mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Copy result
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER
no_report_copy_operation:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

;;mov ecx,dword ptr [ebp+8]
;;push 0
;;push dword ptr [ecx]+24
;;push dword ptr [ecx]+56
;;push 0
;;call MessageBoxA
;;	extrn MessageBoxA:PROC

end_report_operation_type:

mov esp,ebp
pop ebp
ret 12
SPL_Report_Operation_Results endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push hwnd					;ebp+16
;push offset all_spl_program_descriptor_block	;ebp+12
;push offset operation_fill_block		;ebp+8
;call SPL_Report_Errors
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Report_Errors proc
push ebp
mov ebp,esp

.DATA
;;;c_separator_line	db '_________________________________________________________________',0

SPL_error_code		db 'SPL error code:',0
SPL_error_description	db 'SPL error description:',0
SPL_error_line		db 'Error line:',0
SPL_error_column	db 'Error column:',0
SPL_current_operation	db 'Current operation number:',0

;c_return_line		db 0dh, 0ah, 0,   0
;tab_1			db 09h, 0,   0,   0
;tab_2			db 09h, 09h, 0,   0
;tab_3			db 09h, 09h, 09h, 0
SPL_Error_Code_Data	db '0000000000',0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set SPL error code
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset SPL_error_code
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER

CBTD_1:

mov eax,dword ptr [ebp+8]
mov ebx,dword ptr [eax]+84

mov eax,ebx
	;mov dword ptr string_bin_qword,eax
	;push offset SPL_Error_Code_Data      ;       ebp+20;
	;push offset string_pack210    ;       ebp+16
	;push offset output            ;       ebp+12 
	;push offset string_bin_qword  ;input  ebp+8
	;call ConvertBinToDec

push eax
push offset SPL_Error_Code_Data
call SC_Convert_Bin_To_Dec_10
cmp eax,(-1)
je CBTD_1


	mov MASM_TEMP_REGISTER,offset SPL_Error_Code_Data
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set SPL error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set SPL error text
	mov MASM_TEMP_REGISTER,offset SPL_error_description
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_1
add_edit_text MASM_TEMP_REGISTER

mov eax,dword ptr [ebp+8]
mov ebx,dword ptr [eax]+84

push ebx	;error code		;ebp+8
call Get_SPL_Error_Text
;;;	extrn Get_SPL_Error_Text:PROC

mov MASM_TEMP_REGISTER,eax
add_edit_text MASM_TEMP_REGISTER
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set SPL error text
mov eax,dword ptr [ebp+12] 
mov ecx,dword ptr [eax]+48	;SPL_start address

mov eax,dword ptr [ebp+8]
mov ebx,dword ptr [eax]+88		;Error address 
sub ebx,ecx

mov edx,dword ptr [ebp+12]	;all_spl_program_descriptor_block	;ebp+12
mov edx,dword ptr [edx]+48

push ebx	;edit_increment		;ebp+16
push dword ptr [ebp+20]	;scan_text_length		;ebp+12;
push edx		;offset scan_text		;ebp+8
call Get_Edit_Coordinats_By_Increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - no line found
;[eax] - 1 - line found
;[ebx] - line number
;[ecx] - column number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0			;;[eax] - 0 - no line found
je end_set_line_and_column
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set line and column
push ecx
push ebx

mov SC_TEMP_ECX_BUFFER,ecx
mov SC_TEMP_EBX_BUFFER,ebx

CBTD_2:

.DATA
SC_TEMP_ECX_BUFFER	dd 0
SC_TEMP_EBX_BUFFER	dd 0
.CODE

mov eax,SC_TEMP_EBX_BUFFER		;ebx
	;mov dword ptr string_bin_qword,eax
	;push offset SPL_Error_Code_Data      ;       ebp+20;
	;push offset string_pack210    ;       ebp+16
	;push offset output            ;       ebp+12 
	;push offset string_bin_qword  ;input  ebp+8
	;call ConvertBinToDec				;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

push eax
push offset SPL_Error_Code_Data
call SC_Convert_Bin_To_Dec_10
cmp eax,(-1)
je CBTD_2


	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset SPL_error_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_3
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset SPL_Error_Code_Data
add_edit_text MASM_TEMP_REGISTER

pop ebx
pop ecx

mov SC_TEMP_ECX_BUFFER,ecx
mov SC_TEMP_EBX_BUFFER,ebx

CBTD_3:

mov eax,SC_TEMP_EBX_BUFFER		;ebx
	;mov dword ptr string_bin_qword,eax
	;push offset SPL_Error_Code_Data      ;       ebp+20;
	;push offset string_pack210    ;       ebp+16
	;push offset output            ;       ebp+12 
	;push offset string_bin_qword  ;input  ebp+8
	;call ConvertBinToDec

push eax
push offset SPL_Error_Code_Data
call SC_Convert_Bin_To_Dec_10
cmp eax,(-1)
je CBTD_3

	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset SPL_error_column
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset tab_2
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset SPL_Error_Code_Data
add_edit_text MASM_TEMP_REGISTER

;;;SPL_error_line		db 'Error line:',0
;;;SPL_error_column	db 'Error column:',0
;;;tab_1			db 09h, 0,   0,   0
;;;tab_2			db 09h, 09h, 0,   0
;;;tab_3			db 09h, 09h, 09h, 0

	mov MASM_TEMP_REGISTER,offset c_return_line
add_edit_text MASM_TEMP_REGISTER
	mov MASM_TEMP_REGISTER,offset c_separator_line
add_edit_text MASM_TEMP_REGISTER

end_set_line_and_column:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set line and column

;;mov eax,dword ptr [ebp+8]
;;mov ebx,dword ptr [eax]+88		;Error address 
;;;sub ebx,ecx

;;push 80;ebx		;output_scan_string_length
;;push ebx ;spl_buffer_address	;output_scan_string_address
;;push 380	
;;push 30
;;push hdc
;;call TextOutA

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - error text address
;[ebx] - error text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Operation name
;;add_edit_text c_separator_line
;;add_edit_text she_operation

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Operation name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set output type
;;add_edit_text c_return_line
;;add_edit_text c_output_type
;;add_edit_text tab_3

;;mov eax,dword ptr [ebp+8]	;offset operation_fill_block	;ebp+8
;;mov ebx,dword ptr [eax]+44	;STDOUT output ; 0 - no output 1- output
;;mov ecx,dword ptr [eax]+60	;STDERR output ; 0 - no output 1- output

mov esp,ebp
pop ebp
ret 16
SPL_Report_Errors endp

endm

add_edit_text macro edit_text

;EM_REPLACESEL  0ch
;wParam = 0;                     // not used; must be zero 
;lParam = (LPARAM)(LPCTSTR)lpsz; // address of window-text string 
push edit_text	;lparam 
push 0	;wparam 
push 0C2h		;EM_REPLACESEL
push dword ptr [ebp+16]	;hwnd
call SendMessageA

endm

