;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Delimiters_Object macro
;;;;;;;;;;;;;;Using example
;push string_len			;ebp+16
;push scan_string			;ebp+12
;call Get_Object_In_Double_Delimiters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Object_In_Double_Delimiters proc

;;;;Get_Object_In_Double_Delimiters macro scan_string, string_len		;"........"
;;			"....................."
;;			|<---String length--->|
;;Start address-------->|

;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax			;ebp+12		;ebp+4
;;;push dword ptr string_len	;ebp+8		;ebp+16
;;;push dword ptr scan_string	;ebp+4		;ebp+12
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov dword ptr [ebp]+4,0		;mov dword ptr [ebp+12],0	;mov address_increment,0

;.DATA
;scan_string_address	dd 0	;ebp+4		;ebp+12
;string_length		dd 0	;ebp+8		;ebp+16
;address_increment	dd 0	;ebp+12		;ebp+4
;.CODE

mov eax,dword ptr [ebp]+12		;mov eax,dword ptr [ebp+4]

xor ecx,ecx
cmp byte ptr [eax],34
sete cl

xor edx,edx
mov edi,dword ptr [ebp]+16		;mov edi,dword ptr [ebp+8]	;mov edi,string_length
cmp edi,1
seta dl

push edx
push ecx

;SV_find_byte macro scan_string, find_byte, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes [For string limited by [Byte to Found]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx
mov cl,34		;;" --> 34
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,dword ptr [ebp]+16	;mov ebx,dword ptr [ebp+8]	;mov ebx,string_length
	cmp ebx,1
	seta al
	ror eax,1
	cdq
	mov esi,1
	and esi,edx
	sub ebx,esi	;dec ebx ;Decrement only if [string_length]>1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+8]	;mov eax,string_length
	cmp eax,1
	seta al
	ror eax,1
	cdq
	mov esi,1
	and esi,edx

add dword ptr [ebp]+4,esi		;add dword ptr [ebp+12],esi	;add address_increment,esi

	mov eax,dword ptr [ebp]+12	;mov eax,dword ptr [ebp+4]	;mov eax,scan_string_address
	add eax,esi	;inc eax	;Add 1 only if [string_length]>1
	and ebx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_find_byte eax, cl, ebx
push ebx	;string_length	;ebp+20
push ecx	;find_byte		;ebp+16
push eax	;scan_string	;ebp+12
call Find_Byte

pop edi
pop edx

and eax,edi
and eax,edx

mov edi,esi
inc edi

add dword ptr [ebp]+4,ecx	;add dword ptr [ebp+12],ecx	;add address_increment,ecx
mov edx,dword ptr [ebp]+4	;mov edx,dword ptr [ebp+12]	;mov edx,address_increment

;scan_string_address	dd 0	;ebp+4		;ebp+12
;string_length		dd 0	;ebp+8		;ebp+16
;address_increment	dd 0	;ebp+12		;ebp+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 8
Get_Object_In_Double_Delimiters endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push string_len			;ebp+16
;push scan_string			;ebp+12
;call Get_Object_In_Single_Delimiters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Object_In_Single_Delimiters proc
;;;;;;Get_Object_In_Single_Delimiters macro scan_string, string_len		;'........'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;			'.....................'
;;			|<---String length--->|
;;Start address-------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;' --> [code --> 39]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax				;ebp+12		;ebp+4
;;;push dword ptr string_len	;eax	;ebp+8
;;;push dword ptr scan_string	;eax	;ebp+4
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov dword ptr [ebp]+4,0		;mov dword ptr [ebp+12],0	;mov address_increment,0

;.DATA
;scan_string_address	dd 0	;ebp+4		;ebp+12
;string_length		dd 0	;ebp+8		;ebp+16
;address_increment	dd 0	;ebp+12		;ebp+4
;.CODE

mov eax,dword ptr [ebp]+12		;mov eax,dword ptr [ebp+4]

xor ecx,ecx
cmp byte ptr [eax],39
sete cl

xor edx,edx
mov edi,dword ptr [ebp]+16		;mov edi,dword ptr [ebp+8]	;mov edi,string_length
cmp edi,1
seta dl

push edx
push ecx

;SV_find_byte macro scan_string, find_byte, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes [For string limited by [Byte to Found]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx
mov cl,39		;;" --> 34
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ebx,dword ptr [ebp]+16	;mov ebx,dword ptr [ebp+8]	;mov ebx,string_length
	cmp ebx,1
	seta al
	ror eax,1
	cdq
	mov esi,1
	and esi,edx
	sub ebx,esi	;dec ebx ;Decrement only if [string_length]>1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+8]	;mov eax,string_length
	cmp eax,1
	seta al
	ror eax,1
	cdq
	mov esi,1
	and esi,edx

add dword ptr [ebp]+4,esi		;add dword ptr [ebp+12],esi	;add address_increment,esi

	mov eax,dword ptr [ebp]+12	;mov eax,dword ptr [ebp+4]	;mov eax,scan_string_address
	add eax,esi	;inc eax	;Add 1 only if [string_length]>1
	and ebx,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_find_byte eax, cl, ebx

push ebx	;string_length	;ebp+20
push ecx	;find_byte	;ebp+16
push eax	;scan_string	;ebp+12
call Find_Byte

pop edi
pop edx

and eax,edi
and eax,edx

mov edi,esi
inc edi

add dword ptr [ebp]+4,ecx	;add dword ptr [ebp+12],ecx	;add address_increment,ecx
mov edx,dword ptr [ebp]+4	;mov edx,dword ptr [ebp+12]	;mov edx,address_increment

;scan_string_address	dd 0	;ebp+4		;ebp+12
;string_length		dd 0	;ebp+8		;ebp+16
;address_increment	dd 0	;ebp+12		;ebp+4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 8
Get_Object_In_Single_Delimiters endp

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Standard_Functions_1 macro

SPL_Get_Standard_Object proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset spl_object_string ;spl_object_address	;ebp + 24
;push 20  ;string_length					;ebp + 20
;call SPL_Get_Standard_Object
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SPL_Get_Standard_Object
;;			[ "................." ]  
;;			[ '.................' ]
;;			[           X         ]
;;			|<---String length--->|
;;Start address ------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax
push eax		;
push eax		;ebp+8

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;	+4				;EBP + 24  
;;	+4				;EBP + 20
;		Eflags	+4		;EBP + 16

;	+4				;EBP + 12
;	+4				;EBP + 8
;	+4				;EBP + 4

;		+ebp	+4		;EBP + 0

;.DATA
;spl_object_address		dd 0	;ebp + 24 ;Get as function parameter
;string_length			dd 0	;ebp + 20 ;Get as function parameter

;address_increment		dd 0	;ebp + 4
;Word_or_label_Start_Address	dd 0	;ebp + 8
;Word_or_label_length		dd 0	;ebp + 12

;.CODE			;spl_object_string	db '[   "SPL_Object"   ]   ',0

mov eax,dword ptr [ebp+24]	;mov eax,offset spl_object_string
mov dword ptr [ebp+4],0		;mov address_increment,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+24]	;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4]	;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
cmp dword ptr [ebp+20],1	;cmp string_length,1
jbe end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4]  ;add esi,address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,2		;'[' - Expected [Error code]
mov ebx,dword ptr [ebp+24] ;mov ebx,offset spl_object_string
add ebx,dword ptr [ebp+4] ;add ebx,address_increment

cmp byte ptr [ebx],'['
jne end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
cmp dword ptr [ebp+20],2 ;cmp string_length,2
jb end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
inc dword ptr [ebp+4] ;inc address_increment
mov edx,dword ptr [ebp+24] ;mov edx,offset spl_object_string
add edx,dword ptr [ebp+4] ;add edx,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
dec ebx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_Escape_Separators  SPL_000, edx, ebx
push ebx	;string_length		;ebp+28
push edx		;offset load_file		;ebp+24
call Escape_Separators

mov esi,eax
mov edi,ebx
xchg eax,ebx

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
cmp ebx,1
jne end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,esi
mov ebx,edi

add dword ptr [ebp+4],ebx ;add address_increment,ebx

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
mov edx,dword ptr [ebp+4] ;mov edx,address_increment
cmp edx,dword ptr [ebp+20] ;cmp edx,string_length
jae end_get

mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4] ;add eax,address_increment

xor ecx,ecx
cmp byte ptr [eax],'"'	;direct word 
jne no_double

inc eax
mov dword ptr [ebp+8],eax ;mov Word_or_label_Start_Address,eax
dec eax

;Word_or_label_length		dd 0

;Get_Object_In_Double_Delimiters macro scan_string, string_len		;"........"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4] ;add eax,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4] ;sub ebx,address_increment

;;Get_Object_In_Double_Delimiters eax, ebx		;"........"

push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Double_Delimiters


mov dword ptr [ebp+12],ecx ;mov Word_or_label_length,ecx

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov ecx,eax
mov eax,8	;Error in delimiters, Or cannot find second delimiter [Error code]
cmp ecx,0
je end_get

mov eax,5	;Unexpected end [Error code]
mov ebx,dword ptr [ebp+4] ;mov ebx,address_increment
add ebx,edx
cmp ebx,dword ptr [ebp+20] ;cmp ebx,string_length
jae end_get

add dword ptr [ebp+4],edx ;add address_increment,edx

;;;[eax] = 1  Object in double delimiters is get

inc dword ptr [ebp+4] ;inc address_increment	;Go to second delimiter

mov edx,dword ptr [ebp+24] ;mov edx,offset spl_object_string
add edx,dword ptr [ebp+4] ;add edx,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4] ;sub ebx,address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_Escape_Separators  SPL_001, edx, ebx
push ebx	;string_length		;ebp+28
push edx		;offset load_file		;ebp+24
call Escape_Separators

mov esi,eax
mov edi,ebx
xchg eax,ebx
	mov esi,ecx
mov eax,5		;Unexpected end [Error code]
cmp ebx,1
jne end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,esi
mov ebx,edi

add dword ptr [ebp+4],ebx ;add address_increment,ebx

mov edi,dword ptr [ebp+24] ;mov edi,offset spl_object_string
add edi,dword ptr [ebp+4] ;add edi,address_increment		;[EDI] - Object end address  [  second ']'  ] 
mov eax,6		;]  Expected  [Error code]
cmp byte ptr [edi],']'
jne end_get

mov eax,5

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov edi,dword ptr [ebp+4] ;mov edi,address_increment
cmp edi,dword ptr [ebp+20] ;cmp edi,string_length
jae end_get

mov eax,1
mov ebx,0	;	;[EBX] - 0 - Find word	;[EBX] - 1 - Find label
mov esi,dword ptr [ebp+8] ;mov esi,Word_or_label_Start_Address
mov ecx,dword ptr [ebp+12] ;mov ecx,Word_or_label_length

mov edi,dword ptr [ebp+24] ;mov edi,offset spl_object_string
add edi,dword ptr [ebp+4] ;add edi,address_increment		;[EDI] - Object end address  [  second ']'  ] 

jmp end_get_object
no_double:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Single delimiters start
mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4]  ;add eax,address_increment

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

xor ecx,ecx
cmp byte ptr [eax],"'"	;direct word 
jne no_single

inc eax
mov dword ptr [ebp+8],eax ;mov Word_or_label_Start_Address,eax
dec eax

;Get_Object_In_Single_Delimiters macro scan_string, string_len		;'........'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No single delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4] ;add eax,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4] ;sub ebx,address_increment

;;Get_Object_In_Single_Delimiters eax, ebx		;"........"

push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Single_Delimiters

mov dword ptr [ebp+12],ecx ;mov Word_or_label_length,ecx

mov edi,eax

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,8	;Error in delimiters [Error code]
cmp edi,0
je end_get

mov eax,5	;Unexpected end [Error code]
mov ebx,dword ptr [ebp+4] ;mov ebx,address_increment
add ebx,edx
cmp ebx,dword ptr [ebp+20] ;cmp ebx,string_length
jae end_get

add dword ptr [ebp+4],edx ;add address_increment,edx

;;;[eax] = 1  Object in double delimiters is get

inc dword ptr [ebp+4] ;inc address_increment	;Go to second delimiter

mov edx,dword ptr [ebp+24] ;mov edx,offset spl_object_string
add edx,dword ptr [ebp+4]  ;add edx,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4]  ;sub ebx,address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;SV_Escape_Separators  SPL_002, edx, ebx
push ebx	;string_length		;ebp+28
push edx		;offset load_file		;ebp+24
call Escape_Separators

mov esi,eax
mov edi,ebx
xchg eax,ebx
	mov esi,ecx
mov eax,5		;Unexpected end [Error code]
cmp ebx,1
jne end_get
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,esi
mov ebx,edi

add dword ptr [ebp+4],ebx ;add address_increment,ebx

	mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
	add esi,dword ptr [ebp+4] ;add esi,address_increment

mov edi,dword ptr [ebp+24] ;mov edi,offset spl_object_string
add edi,dword ptr [ebp+4]  ;add edi,address_increment		;[EDI] - Object end address  [  second ']'  ] 
mov eax,6		;]  Expected  [Error code]
cmp byte ptr [edi],']'
jne end_get

mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
add esi,dword ptr [ebp+4]  ;add esi,address_increment

mov eax,5
mov edi,dword ptr [ebp+4] ;mov edi,address_increment
cmp edi,dword ptr [ebp+20] ;cmp edi,string_length
jae end_get

mov eax,1
mov ebx,0	;	;[EBX] - 0 - Find word	;[EBX] - 1 - Find label
mov esi,dword ptr [ebp+8] ;mov esi,Word_or_label_Start_Address
mov ecx,dword ptr [ebp+12] ;mov ecx,Word_or_label_length

mov edi,dword ptr [ebp+24] ;mov edi,offset spl_object_string
add edi,dword ptr [ebp+4]  ;add edi,address_increment		;[EDI] - Object end address  [  second ']'  ] 

jmp end_get_object
no_single:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;In other cases
;;Indirect label

mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,5		;Unexpected end [Error code]
mov ebx,dword ptr dword ptr [ebp+20] ;mov ebx,string_length
cmp ebx,dword ptr [ebp+4] ;cmp ebx,address_increment
jbe end_get

mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4] ;add eax,address_increment

xor ebx,ebx
mov bl,byte ptr [eax]

Check_Location_Within_Boundaries 33, ebx, 58 	;[EAX] - 1 True	[EAX] - 0 False
push eax
xor ebx,ebx

mov eax,dword ptr [ebp+24] ;mov eax,spl_object_address
add eax,dword ptr [ebp+4] ;add eax,address_increment

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries 60, ebx, 128  ;[EAX] - 1 True	[EAX] - 0 False

pop edx
add eax,edx

xchg ecx,eax

mov esi,dword ptr [ebp+24] ;mov esi,spl_object_address	;[ESI] - Word or label Start Address [Or error address when error occurs]
add esi,dword ptr [ebp+4]  ;add esi,address_increment

mov eax,7		;Cannot determine object type [Error code]
cmp ecx,1
jne no_word

mov eax,5		;Unexpected end [Error code]
mov edi,dword ptr [ebp+4] ;mov edi,address_increment
cmp edi,dword ptr [ebp+20] ;cmp edi,string_length
jae end_get

mov esi,dword ptr [ebp+24] ;mov esi,spl_object_address
add esi,dword ptr [ebp+4]  ;add esi,address_increment

mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4] ;sub ebx,address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;SV_Get_Word macro word_index, scan_string, scan_string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached 
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;SV_Get_Word SPL_003, esi, ebx
push ebx	;;scan_string_length	;ebp+20
push esi	;scan_string		;ebp+16
call Get_Word

xchg eax,ebx
mov eax,5	;Unexpected end [Error code]
cmp ebx,0
je end_get

mov dword ptr [ebp+8],esi ;mov Word_or_label_Start_Address,esi
mov dword ptr [ebp+12],ecx ;mov Word_or_label_length,ecx

add dword ptr [ebp+4],ecx ;add address_increment,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

add esi,ecx
mov ebx,dword ptr [ebp+20] ;mov ebx,string_length
sub ebx,dword ptr [ebp+4] ;sub ebx,address_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SV_Escape_Separators  SPL_003, esi, ebx
push ebx	;string_length		;ebp+28
push esi		;offset load_file		;ebp+24
call Escape_Separators

xchg eax,edx

mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+4] ;mov edi,address_increment
add edi,ebx
cmp edi,dword ptr [ebp+20] ;cmp edi,string_length
jae end_get

xchg eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp+4],ebx ;add address_increment,ebx

mov eax,5			;Unexpected end [Error code]
mov edi,dword ptr [ebp+4] ;mov edi,address_increment
cmp edi,dword ptr [ebp+20] ;cmp edi,string_length
jae end_get

mov eax,6			;] Expected [Error code]
mov ecx,dword ptr [ebp+24] ;mov ecx,spl_object_address
add ecx,dword ptr [ebp+4]  ;add ecx,address_increment
cmp byte ptr [ecx],']'
jne end_get

mov eax,1
mov ebx,1	;	;[EBX] - 0 - Find word	;[EBX] - 1 - Find label
mov esi,dword ptr [ebp+8] ;mov esi,Word_or_label_Start_Address
mov ecx,dword ptr [ebp+12] ;mov ecx,Word_or_label_length

mov edi,dword ptr [ebp+24] ;mov edi,offset spl_object_string
add edi,dword ptr [ebp+4] ;add edi,address_increment		;[EDI] - Object end address  [  second ']'  ] 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;In other cases
jmp end_get_object
no_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp+24] ;mov esi,offset spl_object_string	;[ESI] - Word or label Start Address [Or error address when error occurs]
add esi,dword ptr [ebp+4] ;add esi,address_increment

mov eax,7	;Cannot determine object type [Error code]
end_get_object:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;SPL_Get_Standard_Object
;;			[ "................." ]  
;;			[ '.................' ]
;;			[           X         ]
;;			|<---String length--->|
;;Start address ------->|

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 - success [TRUE]
;[EAX] - Any other value [Error code]
	;[EBX] - 0 - Find direct word in delimiters
	;[EBX] - 1 - Find label 
	;[ESI] - Word or label Start Address [Or error address when error occurs]
	;[ECX] - Word or label length
	;[EDI] - Object end address  [  second ']'  ] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_get:

;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
pop edx
pop edx

ret 8
;;;;;;;;;;;;;;;;;;;;;;;;
SPL_Get_Standard_Object endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push scan_string_len			;ebp+12
;push scan_string_address		;ebp+8
;call Get_Object_In_Delimiters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Object_In_Delimiters proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Get_Object_In_Delimiters macro SPL_index, scan_string_address, scan_string_len
;;;;;;;;;;;;;;;;;;;;;;;;;;
;push dword ptr scan_string_len
;push dword ptr scan_string_address
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;

;.DATA
;object_in_delimiters_address	dd 0	;ebp+4	;ebp+8
;scan_string_length		dd 2	;ebp+8	;ebp+12
;.CODE

mov eax,dword ptr [ebp]+8	;mov eax,dword ptr [ebp+4]	;mov eax,offset object_in_delimiters
cmp byte ptr [eax],'"'
jne GDO_no_double_delimiter

;Get_Object_In_Double_Delimiters macro scan_string, string_len		;"........"
;;			"....................."
;;			|<---String length--->|
;;Start address-------->|
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+8	;mov eax,dword ptr [ebp+4]	;mov eax,offset object_in_delimiters
mov ebx,dword ptr [ebp]+12	;mov ebx,dword ptr [ebp+8]	;mov ebx,scan_string_length

push eax

;;;Get_Object_In_Double_Delimiters eax, ebx
push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Double_Delimiters

xchg ebx,edx

xor edx,edx

cmp eax,1
sete dl

xchg eax,edi

pop eax
add eax,edx
mov esi,eax

xchg eax,edi
xchg ebx,edx

jmp GDO_object_find_end
GDO_no_double_delimiter:

mov eax,dword ptr [ebp]+8	;mov eax,dword ptr [ebp+4]	;mov eax,offset object_in_delimiters
cmp byte ptr [eax],"'"
jne GDO_no_single_delimiter

;Get_Object_In_Single_Delimiters macro scan_string, string_len		;'........'
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 0  No double delimiters found
;;;[eax] = 1  Object in double delimiters is get
;;;[eax] any other value is error code
	;;;[esi] = address of second double delimiter
	;;;[edi] = address of byte which is located after second delimiter
	;;;[ecx] = length of string limited by delimiters
	;;;[ebx] = Remaining bytes
	;;;[edx] = address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+8	;mov eax,dword ptr [ebp+4]	;mov eax,offset object_in_delimiters
mov ebx,dword ptr [ebp]+12	;mov ebx,dword ptr [ebp+8]	;mov ebx,scan_string_length

push eax

;;;;Get_Object_In_Single_Delimiters eax, ebx
push ebx	;string_len			;ebp+16
push eax	;scan_string			;ebp+12
call Get_Object_In_Single_Delimiters

xchg ebx,edx

xor edx,edx

cmp eax,1
sete dl

xchg eax,edi

pop eax
add eax,edx
mov esi,eax

xchg eax,edi
xchg ebx,edx

jmp GDO_object_find_end
GDO_no_single_delimiter:

mov eax,10
xor esi,esi
xor ecx,ecx
xor edx,edx
xor ebx,ebx
xor edi,edi

GDO_object_find_end:
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 10	First symbol is not a delimiter
;;;[eax] = 1	Object in double delimiters is get
;;;[eax] = 0	String end reached, cannot retrieve delimiter object 
	;;;[esi] = start address of object in delimiters
	;;;[ecx] = length of string limited by delimiters
	;;;[edx] = address increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 8
Get_Object_In_Delimiters endp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm










