;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;Accelerator controls
accel_controls  macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;;push offset message		;ebp+12
;;push vk_up			;ebp+8
;;call GetSingleKeyAccel

GetSingleKeyAccel proc
.586
push ebp
mov ebp,esp

xor eax,eax
mov ecx,dword ptr [ebp+12]
add ecx,4 
;cmp dword ptr [ecx],100h ;WM_KEYDOWN
;jne no_virtual_key_pressed

.DATA
sc_g_s_k_a_busy_flag	dd 0
single_key_code		dd 0
.CODE

mov single_key_code,0

push dword ptr [ebp+8] ;;1bh		;;VK_ESCAPE 1Bh
call GetAsyncKeyState
;	extrn GetAsyncKeyState:PROC
mov dword ptr single_key_code,eax        ;;15 - th bit  (0-15) signaled about key state (1-pressed, 0-not pressed)

xor eax,eax
bt single_key_code,15
jnc no_virtual_key_pressed

bt single_key_code,0
jnc no_virtual_key_pressed

push 11h ;VK_CONTROL  11h
call GetAsyncKeyState
bt eax,15
jc no_virtual_key_pressed

mov eax,1
no_virtual_key_pressed:

mov esp,ebp
pop ebp
ret 8
GetSingleKeyAccel endp   ;;eax = 0 not pressed ;;eax = 1  pressed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;;push offset message		;ebp+16
;;push vk_2			;ebp+12
;;push vk_1			;ebp+8
;;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2

;;;;Condition must be
;;vk_1  --->  bit   0(0)   15(1) 
;;vk_2  --->  bits  0(1)   15(1)    ;for  vk_1+vk_2

GetDoubleKeyAccel proc
.586
push ebp
mov ebp,esp
.DATA
double_key_code_1		dd 0
double_key_code_2		dd 0
.CODE

push dword ptr [ebp+8] ;;VK_1
call GetAsyncKeyState
;	extrn GetAsyncKeyState:PROC  
mov dword ptr double_key_code_1,eax        ;;15 - th bit  (0-15) signaled about key state (1-pressed, 0-not pressed)
push dword ptr [ebp+12] ;;VK_1
call GetAsyncKeyState  
mov dword ptr double_key_code_2,eax        ;;15 - th bit  (0-15) signaled about key state (1-pressed, 0-not pressed)

xor eax,eax
bt double_key_code_1,15              ; 15(1) 
jnc no_double_virtual_key_pressed

bt double_key_code_1,0
jc no_double_virtual_key_pressed   ;0(0)

bt double_key_code_2,0
jnc no_double_virtual_key_pressed   ;0(1)

bt double_key_code_2,15              ;; 15(1) 
jnc no_double_virtual_key_pressed

mov eax,1
no_double_virtual_key_pressed:

mov esp,ebp
pop ebp
ret 12
GetDoubleKeyAccel endp  ;;eax = 0 not pressed ;;eax = 1  pressed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm









 