string_functions_1  macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;Using example
;push string_length		;ebp+28
;push offset string		;ebp+24
;call Escape_Separators

Escape_Separators proc
;;;;;;SV_Escape_Separators macro es_index, string_address, string_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0				;ebp+16
push 0a0dh			;ebp+12
push 0				;ebp+8
push 0				;ebp+4

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;		
;push 0					;ebp+24 --> ebp+16
;push 0a0dh				;ebp+20 --> ebp+12
;push 0					;ebp+16 --> ebp+8
;push 0					;ebp+12 --> ebp+4
;push dword ptr string_length		;ebp+8	--> ebp+28
;push dword ptr string_address		;ebp+4	--> ebp+24
;push ebp
;mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;

;.DATA
;string_start_address	dd 0		;ebp+4
;escape_string_length	dd 0		;ebp+8
;address_increment	dd 0		;ebp+12
;increment_count		dd 0		;ebp+16
;eol			dw 0a0dh, 0	;ebp+20
;escape_result		db 0, 0, 0, 0	;ebp+24
;.CODE

start_escape_SPL_F:

mov dword ptr [ebp+8],0		;mov increment_count,0
mov dword ptr [ebp+16],0	;mov escape_result,0
mov edx,dword ptr [ebp+24]	;mov edx,string_start_address
add edx,dword ptr [ebp+4]	;add edx,address_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp byte ptr [edx],09h	;Tab
sete al
mov dword ptr [ebp+8],eax	;mov increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp byte ptr [edx],20h	;Space
sete al
add dword ptr [ebp+8],eax	;add increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor eax,eax
cmp word ptr [edx],0a0dh ;EOL
sete al
mov ebx,2
mul ebx		;after this edx --> 0
add dword ptr [ebp+8],eax	;add increment_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov ecx,1
	mov eax,dword ptr [ebp+8]	;mov eax,increment_count
	add eax,dword ptr [ebp+4]	;add eax,address_increment
	cmp eax,dword ptr [ebp+28]	;cmp eax,escape_string_length
	setna al
	mov byte ptr [ebp+16],al	;mov escape_result,al
	ror eax,1
	cdq
	and dword ptr [ebp+8],edx	;and increment_count,edx
	not edx
	and ecx,edx

mov eax,dword ptr [ebp+8]	;mov eax,increment_count
add dword ptr [ebp+4],eax	;add address_increment,eax	;string start address is changed parrallel with escape[increment] 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Escape Comments Start
mov edx,dword ptr [ebp+24]	;mov edx,string_start_address
add edx,dword ptr [ebp+4]	;add edx,address_increment
cmp byte ptr [edx],59	;Comment
jne no_find_comment_SPL_F

;;SV_find_string  macro label_index, scan_string_address, all_string_size, find_string_address, find_str_size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;[eax] = 1 string find
;;;;[eax] = 0 string not find
	;;;[ebx] address_increment while find string = [esi] -  scan_string_offset
	;;;[esi] address of first byte of found string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov edi,dword ptr [ebp+24]	;mov edi,string_start_address
add edi,dword ptr [ebp+4]	;add edi,address_increment

mov ebx,dword ptr [ebp+28]	;mov ebx,escape_string_length
sub ebx,dword ptr [ebp+4]	;sub ebx,address_increment
mov ecx,ebp	;mov ecx,offset eol ;0a0dh	;ebp+12
add ecx,12

;SV_find_string  SPL_F, edx, ebx, ecx, 2

push 2		;find_str_size			;ebp+24
push ecx	;find_string_address		;ebp+20
push ebx	;all_string_size			;ebp+16
push edx	;scan_string_address		;ebp+12
call Find_String 


mov dword ptr [ebp+8],ebx	;mov increment_count,ebx

	mov ecx,1
	mov eax,dword ptr [ebp+8]	;mov eax,increment_count
	add eax,dword ptr [ebp+4]	;add eax,address_increment
	cmp eax,dword ptr [ebp+28]	;cmp eax,escape_string_length
	setna al
add byte ptr [ebp+16],al	;add escape_result,al
	ror eax,1
	cdq
	and dword ptr [ebp+8],edx	;and increment_count,edx
	not edx
	and ecx,edx

mov eax,dword ptr [ebp+8]	;mov eax,increment_count
add dword ptr [ebp+4],eax	;add address_increment,eax	;string start address is changed parrallel with escape[increment] 

no_find_comment_SPL_F:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Escape Comments End
cmp dword ptr [ebp+8],0	;cmp increment_count,0
jne start_escape_SPL_F

mov ecx,dword ptr [ebp+24]	;mov ecx,string_start_address
add ecx,dword ptr [ebp+4]	;add ecx,address_increment

mov ebx,dword ptr [ebp+4]	;mov ebx,address_increment
mov eax,dword ptr [ebp+16]	;mov eax,dword ptr escape_result
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;[eax] - 1 - True [Normal escape and exit]
;;[eax] - any other value - False[String end reached]
	;;[ecx] - string scan new address = string_start_address + address_increment
	;;[ebx] - address_increment while escape separators
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp

pop edx
pop edx
pop edx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 8
Escape_Separators endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push find_str_size			;ebp+24
;push find_string_address		;ebp+20
;push all_string_size			;ebp+16
;push scan_string_address		;ebp+12
;call Find_String 

Find_String proc

;;SV_find_string  macro label_index, scan_string_address, all_string_size, find_string_address, find_str_size
;;;;;;;;;;;;;;;;;;;;;;;;;;
push edx		;address_increment		;ebp+4

;push dword ptr find_str_size ;edx	;find_string_size
;push dword ptr find_string_address ;edx		;find_string_offset
;push dword ptr all_string_size ;edx		;scan_string_size
;push dword ptr scan_string_address ;edx		;scan_string_offset

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;

;mov scan_string_offset,scan_string_address
;mov scan_string_size,all_string_size
;mov find_string_offset,find_string_address
;mov find_string_size,find_str_size
;.DATA
;scan_string_offset		dd 0	;ebp+4			;ebp+12
;scan_string_size		dd 0	;ebp+8			;ebp+16
;find_string_offset		dd 0	;ebp+12			;ebp+20
;find_string_size		dd 0	;ebp+16			;ebp+24
;address_increment		dd 0	;ebp+20			;ebp+4
;.CODE

mov dword ptr [ebp+4],0		;mov dword ptr [ebp+20],0	;mov address_increment,0

FS_start_find_string:

mov eax,dword ptr [ebp+12]	;mov eax,dword ptr [ebp+4] 	;scan_string_offset
add eax,dword ptr [ebp+4]	;add eax,dword ptr [ebp+20]	;add eax,address_increment

xor ecx,ecx
mov ebx,dword ptr [ebp+20]	;mov ebx,dword ptr [ebp+12]	;find_string_offset
mov cl,byte ptr [ebx]  		;at first find [find_string] first byte 
mov edx,dword ptr [ebp+16]	;mov edx,dword ptr [ebp+8] ;scan_string_size

		;;SV_find_byte macro scan_string, find_byte, string_length
		;;string_length = length of string[ecx] + Remaining bytes[ebx]

;SV_find_byte eax, cl, edx   ;scan_string, find_byte, string_length

push edx		;string_length	;ebp+20
push ecx		;find_byte		;ebp+16
push eax		;scan_string	;ebp+12
call Find_Byte

;string_length = length of string[ecx] + Remaining bytes[ebx]
;;;[eax] = 1  find byte
;;;[eax] = 0  not find byte
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes

cmp eax,0
je FS_no_find_string

xor eax,eax
add dword ptr [ebp+4],ecx	;add dword ptr [ebp+20],ecx	;add address_increment,ecx

mov ecx,dword ptr [ebp+4]	;mov ecx,dword ptr [ebp+20]	;address_increment

add ecx,dword ptr [ebp+24]	;add ecx,dword ptr [ebp+16] ;find_string_size
cmp ecx,dword ptr [ebp+16]	;cmp ecx,dword ptr [ebp+8] ;scan_string_size
ja FS_no_find_string

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,dword ptr [ebp+20]		;mov ebx,dword ptr [ebp+12] ;find_string_offset
mov ecx,dword ptr [ebp+24]		;mov ecx,dword ptr [ebp+16] ;find_string_size

;SV_compare_string   esi, ebx, ecx

push ecx	;compare_length		;ebp+24
push ebx	;Second_string		;ebp+20
push esi	;First_string		;ebp+16
call Compare_String
;;	;SV_compare_string macro First_string, Second_string, compare_length
;;	;[eax] = 1 Strings are similar
;;	;[eax] = 0 Strings are not similar

push eax

xor ebx,ebx
cmp eax,0		;If strings are similar[eax] = 1 then no address increment
sete bl
mov eax,ebx

ror eax,1
cdq 
mov ebx,1
and ebx,edx	;in edx --> 0ffffffffh
add dword ptr [ebp+4],ebx	;add dword ptr [ebp+20],ebx	;;add address_increment,ebx		;inc address_increment  ;Increment only if [eax] = 0

pop eax

cmp eax,0
je FS_start_find_string

FS_no_find_string:
mov ebx,dword ptr [ebp+4]		;mov ebx,dword ptr [ebp+20] ;address_increment

mov esi,dword ptr [ebp]+12	;mov esi,dword ptr [ebp+4]	;scan_string_offset
add esi,dword ptr [ebp]+4	;;add esi,dword ptr [ebp+20] 	;address_increment


;scan_string_offset		dd 0	;ebp+4
;scan_string_size		dd 0	;ebp+8
;find_string_offset		dd 0	;ebp+12
;find_string_size		dd 0	;ebp+16
;address_increment		dd 0	;ebp+20
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1 string find
;;;[eax] = 0 string not find
	;;;[ebx] address_increment while find string = [esi] -  scan_string_offset
	;;;[esi] address of first byte of found string
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
ret 16
Find_String endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;Using example
;push compare_length		;ebp+24
;push Second_string		;ebp+20
;push First_string		;ebp+16
;call Compare_String

Compare_String proc
;;;;;SV_compare_string macro First_string, Second_string, compare_length
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax			;ebp+8
push eax			;ebp+4
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esi,dword ptr [ebp+16]		;mov esi,First_string
mov edi,dword ptr [ebp+20]		;mov edi,Second_string

;;.DATA
;;i_c_s_string_length&c_s_index		dd 0	;ebp+4
;;i_c_s_direction_limit&c_s_index	dd 0	;ebp+8
;;.CODE

mov eax,dword ptr [ebp+24]		;mov eax,compare_length

mov dword ptr [ebp+4],eax
inc eax

mov dword ptr [ebp+8],eax

xor ebx,ebx
mov ecx,dword ptr [ebp+4]

inc ecx        ;mov ecx,direction_limit  ;100
cld
repe cmpsb  

xor eax,eax
inc ecx
mov eax,dword ptr [ebp+8]

sub eax,ecx
cmp eax,dword ptr [ebp+4]
sete bl
mov eax,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;

ret 12
Compare_String endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push string_length	;ebp+20
;push find_byte		;ebp+16
;push scan_string	;ebp+12
;call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Find_Byte proc

;;SV_find_byte macro scan_string, find_byte, string_length
;string_length = length of string[ecx] + Remaining bytes[ebx]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  ;;String address in edi
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;push eax		;ebp+16
;;;;push eax		;ebp+12
;;;;push eax		;ebp+8
push eax		;ebp+4

push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;mov dword ptr [ebp]+8,string_length		;mov find_direction_limit,direction_limit

inc dword ptr [ebp]+20				;inc dword ptr [ebp]+8

;;;mov  byte ptr [ebp]+12,find_byte		;mov byte ptr [byte_to_find],find_byte
;;;mov dword ptr [ebp]+4,scan_string		;mov scan_string_address,scan_string

;;.DATA
;;scan_string_address		dd 0		;ebp + 4			;ebp+12
;;find_direction_limit		dd 0		;ebp + 8			;ebp+20
;;byte_to_find			dd 0		;ebp + 12			;ebp+16
;;str_first_symbol_address	dd 0		;ebp + 16  internal use		;ebp+4
;;.CODE

mov edi,dword ptr [ebp]+12		;mov edi,dword ptr [ebp+4]	;scan_string_address

cld
mov ecx,dword ptr [ebp]+20		;mov ecx,dword ptr [ebp+8]	;find_direction_limit;
xor eax,eax
mov al,byte ptr [ebp+16]		;mov al,byte ptr [ebp+12]	;byte ptr [byte_to_find] ;find_byte
repnz scasb          
dec edi
mov dword ptr [ebp]+4,edi		;mov dword ptr [ebp+16],edi	;str_first_symbol_address,edi

mov eax,dword ptr [ebp]+20		;mov eax,dword ptr [ebp+8]	;find_direction_limit ;direction_limit
sub eax,ecx
dec eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx
mov ebx,dword ptr [ebp]+20		;mov ebx,dword ptr [ebp+8]	;find_direction_limit ;direction_limit
dec ebx
cmp eax,ebx
setne cl

mov esi,eax
mov eax,ecx
mul esi;

mov edi,dword ptr [ebp]+4	;mov edi,dword ptr [ebp+16]	;str_first_symbol_address
mov esi,edi
sub esi,dword ptr [ebp]+12	;sub esi,dword ptr [ebp+4]	;scan_string_address
mov ebx,dword ptr [ebp]+20	;mov ebx,dword ptr [ebp+8]	;find_direction_limit
sub ebx,esi

mov dword ptr [ebp]+20,ebx	;mov dword ptr [ebp+8],ebx	;find_direction_limit,ebx
mov esi,edi

xchg eax,ecx
dec ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp

pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 12
Find_Byte endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push scan_string_length	;ebp+20
;push scan_string		;ebp+16
;call Get_Word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Get_Word proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;SV_Get_Word macro word_index, scan_string, scan_string_length
;words are			[33 - 58][60 - 128]
;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax					;ebp+16		;ebp+8
push eax					;ebp+12		;ebp+4
;;;;push dword ptr scan_string_length ;eax	;ebp+8		;ebp+20
;;;;push dword ptr scan_string ;eax		;ebp+4		;ebp+16
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;mov eax,offset e_file_names
;mov string_start_address,eax

;.DATA
;string_start_address	dd 0	;ebp+4		;ebp+16
;string_length		dd 5	;ebp+8		;ebp+20

;address_increment	dd 0	;ebp+12		;ebp+4
;string_end_flag	dd 0	;ebp+16	;1-normal word found	;0-word found but string end reached
;.CODE

mov dword ptr [ebp]+4,0		;mov dword ptr [ebp+12],0	;mov address_increment,0

GV_start_get_word:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]
xor eax,eax
cmp bl,33
sete al
push eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]

Check_Location_Within_Boundaries 35, ebx, 38  ;[EAX] - 1 True	[EAX] - 0 False
pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries 40, ebx, 57  ;[EAX] - 1 True	[EAX] - 0 False

pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]
xor eax,eax
cmp bl,60
sete al

pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries 62, ebx, 90  ;[EAX] - 1 True	[EAX] - 0 False

pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment
mov bl,byte ptr [eax]
xor eax,eax
cmp bl,92
sete al

pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor ebx,ebx
mov eax,dword ptr [ebp]+16	;mov eax,dword ptr [ebp+4]	;mov eax,string_start_address  
add eax,dword ptr [ebp]+4	;add eax,dword ptr [ebp+12]	;add eax,address_increment

mov bl,byte ptr [eax]
Check_Location_Within_Boundaries 94, ebx, 128  ;[EAX] - 1 True	[EAX] - 0 False

pop edx
add eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;Ranges  [33][35 - 38][40 - 58][60][62 - 90][92][94 - 128]
;		      [40 - 57][60][62 - 90][92][94 - 128]
;Except 91 93 39 34

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 0 - IF byte is not in range 
;[EAX] - 0 - IF byte is in range
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push eax

xor edx,edx
mov ebx,eax
add ebx,dword ptr [ebp]+4	;add ebx,dword ptr [ebp+12]	;add ebx,address_increment

cmp ebx,dword ptr [ebp]+20	;cmp ebx,dword ptr [ebp+8]	;cmp ebx,string_length	;If [ebx]>[string_length] [ebx] = 0  Else [ebx] cannot be changed
setb dl
mov eax,edx
mov dword ptr [ebp]+8,edx	;mov dword ptr [ebp+16],edx	;mov string_end_flag,eax

ror eax,1
cdq

pop eax

mov esi,0
mov edi,eax
and edi,edx
not edx
and esi,edx
add esi,edi
mov eax,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
add dword ptr [ebp]+4,eax	;add dword ptr [ebp+12],eax	;add address_increment,eax

cmp eax,0
jne GV_start_get_word
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+8	;mov eax,dword ptr [ebp+16]	;mov eax,string_end_flag
mov ecx,dword ptr [ebp]+4	;mov ecx,dword ptr [ebp+12]	;mov ecx,address_increment
mov esi,dword ptr [ebp]+16	;mov esi,dword ptr [ebp+4]	;string_start_address

;;;;;;;;;;;IF [EAX] = 0 then increment ecx
xor ebx,ebx
cmp eax,0
sete bl
add ecx,ebx
;;;;;;;;;;;IF [EAX] = 0 then increment ecx
;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
	xchg eax,ebx
xor eax,eax
cmp ecx,0
setne al
ror eax,1
cdq 
	xchg eax,ebx
and eax,edx
;;;;;;;;;;;IF [ECX] = 0 then set [EAX] = 0 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[EAX] - 1 Word found  
;[EAX] - 0 Word found, but string end reached
	;[ESI] - Word start address
	;[ECX] - Word length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
pop edx
pop edx

ret 8
Get_Word endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push string_length	;ebp+20
;push find_byte		;ebp+16
;push scan_string	;ebp+12
;call Find_Byte_Back
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Find_Byte_Back proc
;;;;SV_find_byte_back macro scan_string, find_byte, string_length
;string_length = length of string[ecx] + Remaining bytes[ebx]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  ;;Strind address in edi
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;push eax		;ebp+16
;;;push eax		;ebp+12
;;;push eax		;ebp+8		
push eax		;ebp+4		;ebp+4
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;mov dword ptr [ebp+8],string_length	;mov find_direction_limit,direction_limit
inc dword ptr [ebp]+20		;inc dword ptr [ebp+8]
;;;;mov byte ptr [ebp+12],find_byte		;mov byte_to_find,find_byte
;;;mov dword ptr [ebp+4],scan_string	;mov scan_string_address,scan_string

;.DATA
;scan_string_address		dd 0		;ebp + 4		;ebp+12
;find_direction_limit		dd 0		;ebp + 8		;ebp+20
;byte_to_find			db 0, 0, 0, 0	;ebp + 12		;ebp+16
;str_first_symbol_address	dd 0		;ebp + 16 ;internal use	;ebp+4
;.CODE

mov edi,dword ptr [ebp]+12		;mov edi,dword ptr [ebp+4]	;mov edi,scan_string_address

std
mov ecx,dword ptr [ebp]+20		;mov ecx,dword ptr [ebp+8]	;find_direction_limit
xor eax,eax
mov al,byte ptr [ebp]+16		;mov al,byte ptr [ebp+12]	;byte_to_find ;find_byte
repnz scasb
CLD

inc edi
mov dword ptr [ebp]+4,edi		;mov dword ptr [ebp+16],edi	;mov str_first_symbol_address,edi

mov eax,dword ptr [ebp]+20		;mov eax,dword ptr [ebp+8]	;find_direction_limit ;direction_limit
sub eax,ecx
dec eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx
mov ebx,dword ptr [ebp]+20	;mov ebx,dword ptr [ebp+8]	;find_direction_limit ;direction_limit
dec ebx
cmp eax,ebx
setne cl			;not find if limits are equal to [ECX]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12	;mov eax,dword ptr [ebp+4] 	;scan_string_address
sub eax,dword ptr [ebp]+4	;sub eax,dword ptr [ebp+16]	;str_first_symbol_address

mov ebx,dword ptr [ebp]+20	;mov ebx,dword ptr [ebp+8]	;find_direction_limit
sub ebx,eax

mov esi,dword ptr [ebp]+4	;mov esi,dword ptr [ebp+16]	;str_first_symbol_address

xchg eax,ecx
dec ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found	
	;;;[ecx] = length of string	
	;;;[esi] address of found byte ;[esi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
pop edx
;;;;;;;;;;;;;;;;;;;;;;;;;;
ret 12
Find_Byte_Back endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



endm
