asm_ide_external_key_control macro
Perform_External_Key_Accelerator_Control proc

mov dispatch_allow_flag,0

call GetForegroundWindow
cmp eax,hwnd
jne end_perform_key_control

;;escape_close_masm hwnd

;push 40
;push 1200
;call Beep
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show/Hide file list
push offset message		;ebp+12
push 07Ah			;VK_F11			;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_show_hide_file_list
.DATA
dispatch_allow_flag	dd 0	;0 - Dispatch allowed ;1 - Dispatch not allowed
file_list_hide_status	dd 0	;0 - Hide 1 - show
.CODE

btc file_list_hide_status,0

push file_list_hide_status
push child_file_list_handle 
call ShowWindow

push file_list_hide_status				;ebp+16
push project_list_hide_status				;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Control_File_And_Project_List_Location

;push file_list_hide_status				;ebp+16
;push project_list_hide_status				;ebp+12
;push 0 ;operation_type					;ebp+8
;call SCL_Control_File_And_Project_List_Location

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_show_hide_file_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show/Hide file list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Show/Hide project list
push offset message		;ebp+12
push 07Bh			;VK_F12			;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_show_hide_project_list
.DATA
project_list_hide_status	dd 0	;0 - Hide 1 - show
.CODE

;push file_list_hide_status				;ebp+16
;push project_list_hide_status				;ebp+12
;push 0 ;operation_type					;ebp+8
;call SCL_Control_File_And_Project_List_Location

btc project_list_hide_status,0

push project_list_hide_status
push child_project_list_handle 
call ShowWindow

push file_list_hide_status				;ebp+16
push project_list_hide_status				;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Control_File_And_Project_List_Location

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_show_hide_project_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Show/Hide project list
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start add existing file to project
;  Ctrl + 0 --> Add existing file to project

push offset message		;ebp+16
push 4Fh			;VK_O			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_add_existing_file_to_project

;VK_CONTROL                           equ 11h
;VK_O						 equ 4Fh

push 0 ;add_type					;ebp+16
push 0 ;offset file_name				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Add_Existing_File_To_Project

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_add_existing_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End add existing file to project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start add new file to project
;  Ctrl + N --> Add new file to project
;VK_N 4Eh

push offset message		;ebp+16
push 4Eh			;VK_N			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_add_new_file_to_project

push 0 ;operation_type				;ebp+8
call SCL_Add_New_File_To_Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_add_new_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End add new file to project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start decrement [ UP ] file list 
;  Ctrl + UP --> Add existing file to project
;VK_UP 26h

push offset message		;ebp+16
push 26h			;VK_UP			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_up_file_list

push 2   ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control
mov dispatch_allow_flag,1
jmp end_perform_key_control
no_up_file_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End decrement [ UP ] file list 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start increment [ DOWN ] file list 
;  Ctrl + DOWN --> Add existing file to project
;VK_DOWN 28h

push offset message		;ebp+16
push 28h			;VK_DOWN		;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_down_file_list

push 3   ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_down_file_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End increment [ DOWN ] file list 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start switch header buttons
;  Ctrl + Tab 
;VK_TAB 9h

push offset message		;ebp+16
push 9h			;VK_DOWN		;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_switch_headers

push 4   ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_switch_headers:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End switch header buttons
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start compile project
;VK_F9                                equ 78h
push offset message		;ebp+12
push 78h			;VK_F9			;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_compile_project

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0			;operation_type
call SCL_Compile_Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_compile_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End compile project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start save current file
;VK_S 53h			;Ctrl + S

push offset message		;ebp+16
push 53h			;VD_S			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_save_current_file

mov eax,List_Item_Selection_Number
push 0  ;save_type		;ebp+16
push eax			;specified_file_list_item	;ebp+12
push 0	;operation_type		;ebp+8
call SCL_Save_Specified_File_List_Item
;;;save_type			;0 - Only save	 ;1 - Save and Close

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_save_current_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End save current file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start save and also close current file
;VK_W   57h			;Ctrl + W

push offset message		;ebp+16
push 57h			;VK_W			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_close_current_file

mov eax,List_Item_Selection_Number
push 1  ;save_type		;ebp+16
push eax			;specified_file_list_item	;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_Specified_File_List_Item
;;;save_type			;0 - Only save	 ;1 - Save and Close

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

;save_type   ;0 - Only save file without confirmation ;1 - Save and close file with confirmation

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_close_current_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End save and also close current file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start save entire contents of current active richedit window
;VK_I 49h			;Ctrl + I

push offset message		;ebp+16
push 49h			;VK_I			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_save_file_as

;popup_text_1_4_0	db '&Save file as...	Ctrl+I',0		;140 

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je no_save_file_as
cmp ebx,0
je no_save_file_as

push 0 ;save_type						;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Save_Selection_As
;;save_type ;0 -  Save all ;1 - Save selection

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_save_file_as:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End save entire contents of current active richedit window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Save All Project
;VK_T 54h			;Ctrl + T

push offset message		;ebp+16
push 54h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_save_all_project

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_save_all_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Save All Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open Project
;VK_E  45h 			;Ctrl + E

push offset message		;ebp+16
push 45h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_open_project
;popup_text_5_2_0	db '&Open project	Ctrl+E',0			;520 

push 0 ;open_type			;ebp+16
push 0 ;offset  project_name	;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Open_Project_APF_File
;;open_type ;0 - Use GetOpenFileNameA ;1 - Use specified file

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_open_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Close Project
;VK_R 52h			;Ctrl + R

push offset message		;ebp+16
push 52h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_close_all_project

push 1	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_close_all_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Close Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start save workspace as project
;VK_Q	 51h			;Ctrl + Q

push offset message		;ebp+16
push 51h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_save_workspace_as_project

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_save_workspace_as_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End save workspace as project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start call FRDv10 "Find"
;VK_F	 46h			;Ctrl + F

push offset message		;ebp+16
push 46h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_call_find_dialog
;;popup_text_2_6_0	db 'Find...	Ctrl+F',0			;260 

push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 1 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address 

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_key_call_find_dialog:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End call FRDv10 "Find"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start call FRDv10 "Replace"
;VK_H	 48h			;Ctrl + H

push offset message		;ebp+16
push 48h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_call_replace_dialog
;popup_text_2_7_0	db 'Replace...	Ctrl+H',0			;270

push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 1 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address 

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_key_call_replace_dialog:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End call FRDv10 "Replace"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start call FRDv10 "Goto"
;VK_H	 47h			;Ctrl + G
push offset message		;ebp+16
push 47h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_call_goto_dialog
;popup_text_2_8_0	db 'Goto...	Ctrl+G',0			;280 

push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 3 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address 

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_key_call_goto_dialog:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End call FRDv10 "Goto"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start key set Autosave
;VK_D	 44h			;Ctrl + D
push offset message		;ebp+16
push 44h			;VK_T			;ebp+12
push 11h			;VK_CONTROL		;ebp+8
call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_set_auto_save
;;popup_text_2_1_1	db 'Autosave...	Ctrl+D',0			;211

mov eax,autosave_enable_flag
btc eax,0
mov autosave_enable_flag,eax

;MF_UNCHECKED                         equ 0h
;MF_CHECKED                           equ 8h 

cmp autosave_enable_flag,0
sete al
ror eax,1
cdq
mov esi,0
mov edi,08h
and esi,edx
not edx
and edi,edx
add esi,edi

push esi		;8h
push 211
push popup_menu_handle_2
call CheckMenuItem

mov dispatch_allow_flag,1
jmp end_perform_key_control
no_key_set_auto_save:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End key set Autosave
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Key Show File Window
;VK_F5   74h
 
push offset message		;ebp+12
push 074h			;VK_F5   ;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_set_file_window
mov dispatch_allow_flag,1

cmp header_selection_number,1
je no_key_set_file_window

mov new_header_button_selection,1

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "FILE" window


jmp end_perform_key_control
no_key_set_file_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Key Show File Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Key Show SPL Window
;VK_F6   75h
 
push offset message		;ebp+12
push 075h			;VK_F6		;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_set_SPL_window
mov dispatch_allow_flag,1
cmp header_selection_number,2
je no_key_set_SPL_window

mov new_header_button_selection,2

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "FILE" window

jmp end_perform_key_control
no_key_set_SPL_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Key Show SPL Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Key Show Output Window
;VK_F7   76h
 
push offset message		;ebp+12
push 076h			;VK_F7		;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_set_OUTPUT_window

mov dispatch_allow_flag,1

cmp header_selection_number,3
je no_key_set_OUTPUT_window

mov new_header_button_selection,3

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "FILE" window

jmp end_perform_key_control
no_key_set_OUTPUT_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Key Show SPL Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Key Show Output Window
;VK_F8   77h
 
push offset message		;ebp+12
push 077h			;VK_F8		;ebp+8
call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed
cmp eax,0
je no_key_set_Reports_window

mov dispatch_allow_flag,1
cmp header_selection_number,4
je no_key_set_Reports_window

mov new_header_button_selection,4

push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "FILE" window

jmp end_perform_key_control
no_key_set_Reports_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Key Show SPL Window



;;push offset message		;ebp+16
;;push vk_2			;ebp+12
;;push vk_1			;ebp+8
;;call GetDoubleKeyAccel  ;;combination must be vk_1+vk_2
;;eax = 0 not pressed ;;eax = 1  pressed

;;push offset message		;ebp+12
;;push vk_up			;ebp+8
;;call GetSingleKeyAccel
;;eax = 0 not pressed ;;eax = 1  pressed

xor eax,eax
end_perform_key_control:

;push 40
;push 1800
;call Beep

mov eax,dispatch_allow_flag
ret
Perform_External_Key_Accelerator_Control endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;Using example
;push dword ptr [ebp]+20			;ebp+24		;lparam - second message parameter
;push dword ptr [ebp]+16			;ebp+20		;wparam - first message parameter
;push dword ptr [ebp]+12			;ebp+16		;mes    - message identifier
;push dword ptr [ebp]+8				;ebp+12
;push operation_type				;ebp+8
;call SCL_Process_Asm_Ide_Menu_Messages
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Process_Asm_Ide_Menu_Messages proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_PMM, EP_PMM 

mov eax,dword ptr [ebp]+8
mov operation_type_PMM,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_PMM, LF_PMM, operation_type_PMM, LP_PMM, EP_PMM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;push	dword ptr [ebp+14h];lparam - second message parameter
;push	dword ptr [ebp+10h];wparam - first message parameter
;push	dword ptr [ebp+0ch];mes    - message identifier
;push	dword ptr [ebp+08h];hwnd   - handle to window

;Value of the low-order word of wParam. 
;Specifies the identifier of the menu item, control, or accelerator. 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Add existing file to project
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,540
jne no_menu_add_existing_file_to_project

push 0	;add_type					;ebp+16
push 0	;offset file_name				;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Add_Existing_File_To_Project
jmp end_process_menu_commands
no_menu_add_existing_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Add existing file to project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process add new file to project
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,550
jne no_menu_add_new_file_to_project

push 0 ;operation_type				;ebp+8
call SCL_Add_New_File_To_Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_add_new_file_to_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process add new file to project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Change SPL file
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,560
jne no_menu_change_spl

push 0100b ;open_type				;ebp+16
push 0 ;offset file_name			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Open_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_process_menu_commands
no_menu_change_spl:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Change SPL file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu compile project
;popup_text_5_7_0	db 'Compile project	F9',0				;570
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,570
jne no_menu_compile_project

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0			;operation_type
call SCL_Compile_Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_compile_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu compile project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save current file
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,120
jne no_menu_save_current_file

mov eax,List_Item_Selection_Number
push 0  ;save_type		;ebp+16
push eax			;specified_file_list_item	;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_Specified_File_List_Item
;;;save_type			;0 - Only save	 ;1 - Save and Close

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_save_current_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save current file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start close current file
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,110
jne no_menu_close_current_file

mov eax,List_Item_Selection_Number
push 1  ;save_type		;ebp+16
push eax			;specified_file_list_item	;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_Specified_File_List_Item
;;;save_type			;0 - Only save	 ;1 - Save and Close

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_close_current_file:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End close current file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start close current file
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,370
jne no_menu_generate_files_report

push 0		;operation_type
call SCL_Generate_Loaded_Files_Report

jmp end_process_menu_commands
no_menu_generate_files_report:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End close current file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert selection into uppercase
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,710
jne no_menu_convert_selection_into_upper

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je end_process_menu_commands

push ebx		;window_handle
call SC_Convert_Richedit_Selection_To_Uppercase

jmp end_process_menu_commands
no_menu_convert_selection_into_upper:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert selection into uppercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert selection into lowercase
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,720
jne no_menu_convert_selection_into_lower

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je end_process_menu_commands

push ebx		;window_handle
call SC_Convert_Richedit_Selection_To_Lowercase

jmp end_process_menu_commands
no_menu_convert_selection_into_lower:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert selection into lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start comment selection
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,730
jne no_menu_comment_selection

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je end_process_menu_commands

push ebx		;richedit_window_handle		;ebp+8
call SC_Comment_Richedit_Selection

jmp end_process_menu_commands
no_menu_comment_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End comment selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start uncomment selection
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,740
jne no_menu_uncomment_selection

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je end_process_menu_commands

push ebx		;richedit_window_handle		;ebp+8
call SC_Uncomment_Richedit_Selection

jmp end_process_menu_commands
no_menu_uncomment_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End uncomment selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save selection
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,750
jne no_menu_save_selection_as
;popup_text_7_5_0	db 'Save selection as...',0			;750

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je no_menu_save_selection_as
cmp ebx,0
je no_menu_save_selection_as

push 1 ;save_type						;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Save_Selection_As
;;save_type ;0 -  Save all ;1 - Save selection

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_save_selection_as:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save file as
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,140
jne no_menu_save_as
;popup_text_1_4_0	db '&Save file as...	Ctrl+I',0		;140 

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
cmp eax,(-1)
je no_menu_save_as
cmp ebx,0
je no_menu_save_as

push 0 ;save_type						;ebp+12
push 0 ;operation_type					;ebp+8
call SCL_Save_Selection_As
;;save_type ;0 -  Save all ;1 - Save selection

jmp end_process_menu_commands
no_menu_save_as:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save file as
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save project
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,130
jne no_menu_save_project
;popup_text_1_3_0	db '&Save project	Ctrl+T',0		;130

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_save_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save file as
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,520
jne no_menu_open_project
;popup_text_5_2_0	db '&Open project	Ctrl+E',0			;520 

push 0 ;open_type			;ebp+16
push 0 ;offset  project_name	;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Open_Project_APF_File
;;open_type ;0 - Use GetOpenFileNameA ;1 - Use specified file

jmp end_process_menu_commands
no_menu_open_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save file as
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save file as
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,530
jne no_menu_close_project
;popup_text_5_3_0	db 'Close current project	Ctrl+R',0		;530

push 1	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_close_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save file as
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu add file name to results
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,810
jne no_menu_add_result_file_name
;popup_text_8_1_0	db 'Add file name to results',0			;810

push 0 ;add_type				;ebp+16
push 0 ;offset popup_text_8_3_0			;file_name			;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Add_File_Result_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;add_type	;0 - Use GetOpenFileName to retrieve file name ;1 -  Use specified file name

push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_add_result_file_name:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu add file name to results
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu validate result window 
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,830
jne no_menu_validate_result_window
;popup_text_8_3_0	db 'Validate results',0				;830

push 0					;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_validate_result_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu validate result window 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu remove Result window item
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,820
jne no_menu_remove_result_window_item
;popup_text_8_2_0	db 'Remove file name from results',0		;820

push P_List_Item_Selection_Number	;item_number			;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Remove_Result_Window_Item

push 0					;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_remove_result_window_item:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu remove Result window item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu save workspace as project
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,150
jne no_menu_save_workspace_as_project
;popup_text_1_5_0	db '&Save as project...	Ctrl+Q',0		;150

push 0	;project_save_type		;ebp+12
push 0  ;operation_type		;ebp+8
call SCL_Save_Project_To_APF_File
;;;;;;;;project_save_type	;0 - Only save Project	;1 - Close Project


push 0 ;operation_type			;ebp+8
call SCL_Validate_Result_Window

jmp end_process_menu_commands
no_menu_save_workspace_as_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu save workspace as project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu Exit
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,160
jne no_menu_exit
;;popup_text_1_6_0	db '&Exit	Alt+F4',0			;160 

push 0
push 0
push WM_CLOSE
push hwnd
call SendMessageA

jmp end_process_menu_commands
no_menu_exit:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu Exit
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu Generate Results Report
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,840
jne no_menu_generate_results
;;popup_text_8_4_0	db 'Generate results report',0			;840

push 0 ;operation_type
call SCL_Generate_Results_Report

jmp end_process_menu_commands
no_menu_generate_results:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu Generate Results Report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu Add New SPL to Project
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,580
jne no_menu_add_new_SPL
;popup_text_5_8_0	db 'Add new SPL file to project',0			;580

;push 0	;operation_type				;ebp+8
;call SCL_Add_New_SPL_File_To_Project

push 101 ;open_type				;ebp+16
push 0 ;offset file_name			;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Open_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;open_type
;;Bits
;0	;0 - Open Existing SPL file			;1 - Open New SPL file	;[Used in CreateFile Function]
;1	;0 - Use GetOpenFileNameA for filename		;1 - Use Specified file name
;2	;0 - Do not show confirmation if SPL is present	;1 - Show confirmation if SPL is present
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_process_menu_commands
no_menu_add_new_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu Add New SPL to Project
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu Generate Standard SPL
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,590
jne no_menu_Generate_Standard_SPL
;;popup_text_5_9_0	db 'Generate Standard SPL',0				;590

push 0		;operation_type				;ebp+8
call SCL_Generate_Standard_SPL

jmp end_process_menu_commands
no_menu_Generate_Standard_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu Generate Standard SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu Close SPL
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,511
jne no_menu_close_SPL
;popup_text_5_1_1	db 'Close SPL',0					;511

push 011b			;save_type			;ebp+12
push 0 ;operation_type		;ebp+8
call SCL_Save_SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;save_type
;;Bits
;0	;0 - Do not display save confirmation	;1 - Display save confirmation
;1	;0 - Do not close SPL			;1 - Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_process_menu_commands
no_menu_close_SPL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu Close SPL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Find"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,260
jne no_menu_call_find
;popup_text_2_6_0	db 'Find...	Ctrl+F',0			;260


push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 1 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address

jmp end_process_menu_commands
no_menu_call_find:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Find"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Replace"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,270
jne no_menu_call_replace
;popup_text_2_7_0	db 'Replace...	Ctrl+H',0			;270

push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 1 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address

jmp end_process_menu_commands
no_menu_call_replace:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Replace"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Replace"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,280
jne no_menu_call_goto
;popup_text_2_8_0	db 'Goto...	Ctrl+G',0			;280 

push spl_window_handle	;richedit_window_handle		;ebp+12
push 0				;operation_type			;ebp+8
call frd_v_10_show_dialog_address

push 3 ;header_number			;ebp+12
push 0 ;operation_type			;ebp+8
call frd_v_10_set_headers_address

jmp end_process_menu_commands
no_menu_call_goto:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Replace"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "AutoSave"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,211
jne no_menu_call_auto_save_project
;;popup_text_2_1_1	db 'Autosave...	Ctrl+D',0			;211

mov eax,autosave_enable_flag
btc eax,0
mov autosave_enable_flag,eax

;MF_UNCHECKED                         equ 0h
;MF_CHECKED                           equ 8h 

cmp autosave_enable_flag,0
sete al
ror eax,1
cdq
mov esi,0
mov edi,08h
and esi,edx
not edx
and edi,edx
add esi,edi

push esi		;8h
push 211
push popup_menu_handle_2
call CheckMenuItem

jmp end_process_menu_commands
no_menu_call_auto_save_project:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "AutoSave"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "About"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1220
jne no_menu_call_about
;;popup_text_12_2_0	db 'About',0					;1220 

push 0
push offset Asm_Ide_About_Dialog
push hwnd  ;handle to the owner window
push offset about_dialog_name
push hInst
call DialogBoxParamA


jmp end_process_menu_commands
no_menu_call_about:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "About"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Load New Instance"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,610
jne no_menu_load_new_instance
;;;popup_text_6_1_0	db 'Load New Instance',0				;510

push 0	;operation_type
call SCL_Load_Asm_Ide_New_Instance

jmp end_process_menu_commands
no_menu_load_new_instance:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Load New Instance"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Mouse coordinates"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,620
jne no_menu_load_MC_tool
;;;popup_text_6_2_0	db 'Mouse coordinates',0				;520 

push 0	;operation_type
call SCL_Load_Mouse_Coordinates_Tool

jmp end_process_menu_commands
no_menu_load_MC_tool:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Mouse coordinates"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start menu call "Menu Help"
mov eax,dword ptr [ebp]+20		;wparam
cmp ax,1210
jne no_menu_load_about_htm
;;;popup_text_6_2_0	db 'Mouse coordinates',0				;520 

push 0	;operation_type
call SCL_Load_ASM_IDE_About_Html

jmp end_process_menu_commands
no_menu_load_about_htm:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End menu call "Menu Help"


;frd_v_10_deactivate_address

end_process_menu_commands:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PMM, LP_PMM, EP_PMM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 20
SCL_Process_Asm_Ide_Menu_Messages endp		;FPC_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;Using example
;push function_number				;ebp+12
;push operation_type				;ebp+8
;call SCL_Concentrated_Switch_Control
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Concentrated_Switch_Control proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CSC_01, EP_CSC_01

mov eax,dword ptr [ebp]+8
mov operation_type_CSC_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CSC_01, LF_CSC_01, operation_type_CSC_01, LP_CSC_01, EP_CSC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 0
cmp dword ptr [ebp]+12,0			;Mouse control of list
jne no_function_0

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Check_Mouse_Cursor_On_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 -  mouse cursor located on item
;[eax] - 1 -  mouse cursor is not located on item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov mouse_status,ebx
btc dword ptr List_Item_3+28,0

push memory_dc				;ebp+36
push list_font_handle			;ebp+32
push child_file_list_handle		;ebp+28
push mouse_status ;new_selection_number		;ebp+24
push 1	;selection_type			;ebp+20
push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection		;FPC_8

cmp mouse_status,0
je no_set_file_list_item_visibility

push offset vertical_current_pos	;ebp+24
push mouse_status			;List_Item number		;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

cmp header_selection_number,1
jne no_set_file_list_item_visibility

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window

mov eax,old_active_richedit_window
cmp eax,ebx
je no_set_file_list_item_visibility
push ebx

cmp old_active_richedit_window,0
je no_hide_L_001
push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_001:

pop ebx

cmp ebx,0
je no_show_L_002

push ebx
push 1
push ebx
call ShowWindow
pop ebx
push ebx
call SetFocus

no_show_L_002:

no_set_file_list_item_visibility:

jmp end_of_function_process
no_function_0:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 1
cmp dword ptr [ebp]+12,1			;Mouse Control of Header Buttons
jne no_function_1

.DATA
mouse_header_old_selection	dd 0
old_active_richedit_window	dd 0
.CODE

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

mov eax,header_selection_number
mov mouse_header_old_selection,eax

start_process_headers:
push 0	;operation_type			;ebp+16
push child_header_handle		;ebp+12
push offset HEADER_DRAW_CONTENT	;ebp+8
call SCL_Process_Header_Mouse_Cursor
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Selection not changed
;[eax] - 1 - Selection changed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_process_headers

cmp eax,0
je header_selection_not_changed

;spl_window_handle
;output_window_handle
;report_window_handle

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window

mov eax,old_active_richedit_window
cmp eax,ebx
je header_selection_not_changed

push ebx

cmp old_active_richedit_window,0
je no_hide_L_002
push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_002:

pop ebx

cmp ebx,0
je no_show_003
push ebx
push	1		;SW_RESTORE
push	ebx  ;hwnd 
call	ShowWindow
pop ebx
push ebx
call SetFocus
no_show_003:

header_selection_not_changed:

jmp end_of_function_process
no_function_1:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 2
cmp dword ptr [ebp]+12,2		;Key Control of List [ UP ]
jne no_function_2

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

cmp List_Items_Count,0
je no_set_file_list_item_visibility_FUP

cmp List_Item_Selection_Number,0
je no_set_file_list_item_visibility_FUP

mov ebx,List_Item_Selection_Number
mov mouse_status,ebx

dec mouse_status

push memory_dc				;ebp+36
push list_font_handle			;ebp+32
push child_file_list_handle		;ebp+28
push mouse_status ;new_selection_number		;ebp+24
push 1	;selection_type			;ebp+20
push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection		;FPC_8

cmp mouse_status,0
je no_set_file_list_item_visibility_FUP

push offset vertical_current_pos	;ebp+24
push mouse_status			;List_Item number		;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

cmp header_selection_number,1
jne no_set_file_list_item_visibility_FUP

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window

mov eax,old_active_richedit_window
cmp eax,ebx
je no_set_file_list_item_visibility_FUP
push ebx

cmp old_active_richedit_window,0
je no_hide_L_004

push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_004:

pop ebx

cmp ebx,0
je no_show_L_005
push ebx
push 1
push ebx
call ShowWindow
pop ebx
push ebx
call SetFocus

no_show_L_005:

no_set_file_list_item_visibility_FUP:

jmp end_of_function_process
no_function_2:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 3
cmp dword ptr [ebp]+12,3		;Key Control of List [ DOWN ]
jne no_function_3

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

cmp List_Items_Count,0
je no_set_file_list_item_visibility_FDOWN

mov ebx,List_Items_Count
cmp List_Item_Selection_Number,ebx
je no_set_file_list_item_visibility_FDOWN

mov ebx,List_Item_Selection_Number
mov mouse_status,ebx

inc mouse_status

push memory_dc				;ebp+36
push list_font_handle			;ebp+32
push child_file_list_handle		;ebp+28
push mouse_status ;new_selection_number		;ebp+24
push 1	;selection_type			;ebp+20
push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection		;FPC_8

cmp mouse_status,0
je no_set_file_list_item_visibility_FDOWN

push offset vertical_current_pos	;ebp+24
push mouse_status			;List_Item number		;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

cmp header_selection_number,1
jne no_set_file_list_item_visibility_FDOWN

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window

mov eax,old_active_richedit_window
cmp eax,ebx
je no_set_file_list_item_visibility_FDOWN
push ebx

cmp old_active_richedit_window,0
je no_hide_L_006

push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_006:

pop ebx

cmp ebx,0
je no_show_L_007
push ebx
push 1
push ebx
call ShowWindow
pop ebx
push ebx
call SetFocus
no_show_L_007:

no_set_file_list_item_visibility_FDOWN:

jmp end_of_function_process
no_function_3:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 4
cmp dword ptr [ebp]+12,4		;Key control of Headers [ Ctrl + Tab ]
jne no_function_4

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

inc header_selection_number
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [header_selection_number] = 0 Then Set [header_selection_number] = 1
cmp header_selection_number,0
sete al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [header_selection_number] > 4 Then Set [header_selection_number] = 1
cmp header_selection_number,4
seta al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0						;lparam ;not used
push 0						;wparam 
push WM_PAINT
push child_header_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,header_selection_number
mov mouse_header_old_selection,eax

;spl_window_handle
;output_window_handle
;report_window_handle

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov eax,old_active_richedit_window
;cmp eax,ebx
;je KAC_header_selection_not_changed

push ebx

cmp old_active_richedit_window,0
je no_hide_L_008
push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_008:

pop ebx

cmp ebx,0
je no_show_009
push ebx
push	1		;SW_RESTORE
push	ebx  ;hwnd 
call	ShowWindow
pop ebx
push ebx
call SetFocus
no_show_009:

KAC_header_selection_not_changed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


jmp end_of_function_process
no_function_4:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 5
cmp dword ptr [ebp]+12,5		;Particular set of Header Buttons
jne no_function_5
.DATA
new_header_button_selection	dd 0
.CODE

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

mov eax,new_header_button_selection
mov header_selection_number,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [header_selection_number] = 0 Then Set [header_selection_number] = 1
cmp header_selection_number,0
sete al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [header_selection_number] > 4 Then Set [header_selection_number] = 1
cmp header_selection_number,4
seta al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0						;lparam ;not used
push 0						;wparam 
push WM_PAINT
push child_header_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,header_selection_number
mov mouse_header_old_selection,eax

;spl_window_handle
;output_window_handle
;report_window_handle

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov eax,old_active_richedit_window
cmp eax,ebx
je SPS_header_selection_not_changed

push ebx

cmp old_active_richedit_window,0
je no_hide_L_0010
push	0				;SW_RESTORE
push	old_active_richedit_window	;hwnd 
call	ShowWindow
no_hide_L_0010:

pop ebx

cmp ebx,0
je no_show_0011
push ebx
push	1		;SW_RESTORE
push	ebx  ;hwnd 
call	ShowWindow
pop ebx
push ebx
call SetFocus
no_show_0011:

SPS_header_selection_not_changed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

jmp end_of_function_process
no_function_5:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 6
cmp dword ptr [ebp]+12,6		;Particular set of Header Buttons and File List Item Selection Visibility
jne no_function_6
.DATA
;new_header_button_selection	dd 0
list_sew_selection		dd 0
.CODE

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov old_active_richedit_window,ebx

mov eax,new_header_button_selection
mov header_selection_number,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;IF [header_selection_number] = 0 Then Set [header_selection_number] = 1
cmp header_selection_number,0
sete al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;IF [header_selection_number] > 4 Then Set [header_selection_number] = 1
cmp header_selection_number,4
seta al
ror eax,1
cdq 
mov esi,1
mov edi,header_selection_number
and esi,edx
not edx
and edi,edx
add esi,edi
mov header_selection_number,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


push 0						;lparam ;not used
push 0						;wparam 
push WM_PAINT
push child_header_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,header_selection_number
mov mouse_header_old_selection,eax

;;spl_window_handle
;;output_window_handle
;;report_window_handle

push 0   ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov eax,old_active_richedit_window
cmp eax,ebx
je SP_HS_FS_header_selection_not_changed

push ebx

cmp old_active_richedit_window,0
je no_hide_L_0012
	push	0				;SW_RESTORE
	push	old_active_richedit_window	;hwnd 
	call	ShowWindow
no_hide_L_0012:

pop ebx

cmp ebx,0
je no_show_0013
		push ebx
	push	1		;SW_RESTORE
	push	ebx  ;hwnd 
	call	ShowWindow
		pop ebx
	push ebx
	call SetFocus
no_show_0013:

SP_HS_FS_header_selection_not_changed:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set File List Selection
cmp header_selection_number,1
jne no_set_file_list_selection

cmp List_Items_Count,0
je no_set_file_list_selection

xor ebx,ebx
xor eax,eax
cmp List_Items_Count,0
setne bl
cmp List_Item_Selection_Number,0
sete al
and eax,ebx
cmp eax,1
sete al
ror eax,1
cdq
mov esi,1
mov edi,List_Item_Selection_Number
and esi,edx
not edx
and edi,edx
add esi,edi
mov list_sew_selection,esi

push memory_dc				;ebp+36
push list_font_handle			;ebp+32
push child_file_list_handle		;ebp+28
push list_sew_selection			;new_selection_number		;ebp+24
push 1	;selection_type			;ebp+20
push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset LIST_CONTENTS		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection		;FPC_8

push offset vertical_current_pos	;ebp+24
push list_sew_selection			;List_Item number		;ebp+20
push offset LIST_CONTENTS		;ebp+16
push child_file_list_handle		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_Item_Visibility

mov eax,List_Item_Selection_Number
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle
	push ecx
push 1
push ecx				;richedit_window_handle
call ShowWindow				;Show Remaining richedit window
	pop ecx
push ecx				;richedit_window_handle
call SetFocus				;Show Remaining richedit window

no_set_file_list_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set File List Selection
jmp end_of_function_process
no_function_6:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 7
cmp dword ptr [ebp]+12,7
jne no_function_7

push 0		;operation_type
call SCL_Activate_Edit_Popup_Menu

jmp end_of_function_process
no_function_7:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 8
cmp dword ptr [ebp]+12,8
jne no_function_8

push 0		;operation_type
call SCL_Activate_Files_Popup_Menu

jmp end_of_function_process
no_function_8:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 9
cmp dword ptr [ebp]+12,9
jne no_function_9

push 0		;operation_type
call SCL_Activate_Results_Popup_Menu

jmp end_of_function_process
no_function_9:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 9
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Function 10
cmp dword ptr [ebp]+12,10
jne no_function_10

push 0					;operation_type				;ebp+8
call SCL_Set_Workspace_Lists_View

jmp end_of_function_process
no_function_10:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Function 10





end_of_function_process:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CSC_01, LP_CSC_01, EP_CSC_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Concentrated_Switch_Control  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Using example
;push operation_type				;ebp+8
;call SCL_Get_Active_Richedit_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Get_Active_Richedit_Window proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GARW_01, EP_GARW_01

mov eax,dword ptr [ebp]+8
mov operation_type_GARW_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_GARW_01, LF_GARW_01, operation_type_GARW_01, LP_GARW_01, EP_GARW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
current_active_richedit_window	dd 0
.CODE
mov current_active_richedit_window,0

cmp List_Items_Count,0
je no_file_select
cmp List_Item_Selection_Number,0
je no_file_select

mov eax,List_Item_Selection_Number
dec eax
mov ecx,32 				;List one item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status

shr ebx,24				;FNL Item number
dec ebx
mov eax,476				;FNL item number
mul ebx
add eax,offset FILE_NAME_LIST
mov ecx,dword ptr [eax]+448		;FNL_richedit_window_handle

mov current_active_richedit_window,ecx
no_file_select:

;1 - File
;2 - SPL
;3 - Output
;4 - Report

cmp header_selection_number,2
sete al
ror eax,1
cdq
mov esi,spl_window_handle
mov edi,current_active_richedit_window
and esi,edx
not edx
and edi,edx
add esi,edi
mov current_active_richedit_window,esi

cmp header_selection_number,3
sete al
ror eax,1
cdq
mov esi,output_window_handle
mov edi,current_active_richedit_window
and esi,edx
not edx
and edi,edx
add esi,edi
mov current_active_richedit_window,esi

cmp header_selection_number,4
sete al
ror eax,1
cdq
mov esi,report_window_handle
mov edi,current_active_richedit_window
and esi,edx
not edx
and edi,edx
add esi,edi
mov current_active_richedit_window,esi


end_determine_current_active_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GARW_01, LP_GARW_01, EP_GARW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov ebx,current_active_richedit_window
mov esp,ebp
pop ebp
ret 4
SCL_Get_Active_Richedit_Window  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







endm 