create_child_header	macro

Create_Child_Headers proc
push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
CH_cbSize_2                dd    48
CH_style_2                 dd    3				;CS_HREDRAW+CS_VREDRAW
CH_lpfnWndProc_2           dd    offset Child_Header_Window_Proc
CH_cbClsExtra_2            dd    0
CH_cbWndExtra_2            dd    0
CH_hInstance_2             dd    0
CH_hIcon_2                 dd    0				;Values get from LoadIcon
CH_hCursor_2               dd    0				;Values get from LoadCursorA
CH_hbrBackground_2         dd    0
CH_lpszMenuName_2          dd    0
CH_lpszClassName_2         dd    offset  header_class_name 	;Window name 
CH_hIconSm_2               dd    0

header_class_name	db 'ASM_IDE_NEW_HEADER_CLASS',0
child_header_handle	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov CH_hInstance_2,eax

	push	32512	;32649
	push	0
	call	LoadCursorA
	mov dword ptr CH_hCursor_2,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 5
	call GetStockObject
	mov   dword ptr CH_hbrBackground_2,eax

mov   CH_lpszClassName_2,offset header_class_name	

	push offset CH_cbSize_2
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	16			;Vertical size of window
	push	323			;Horizontal size of window 
	push	0			;Y coordinate relative to parent window
	push	151			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h;+0C00000h
	push	0			;Child window has not caption and has not title
	push	offset header_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_header_handle,eax

	push	1
	push	child_header_handle
	call	ShowWindow		;Do not need to show window because it is already visible
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create Child Class and Window
mov esp,ebp
pop ebp
ret
Create_Child_Headers endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Child_Header_Window_Proc proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	ch_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	ch_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	ch_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	ch_wm_mouse_right_button_up
jmp ch_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
ch_wm_mouse_right_button_up:

push 0	;operation_type
call SCL_Force_Close_Popup_Menu

mov eax,0
jmp ch_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process header mouse left
ch_wm_mouse_left_button_down:

push 0	;operation_type
call SCL_Force_Close_Popup_Menu

push 1  ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control

jmp ch_wmpaint
header_selection_not_changed:

mov eax,0
jmp ch_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process header mouse left
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
ch_wm_mouse_move:

mov eax,0
jmp ch_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
ch_wmpaint:

push child_header_handle		;ebp+16
push offset HEADER_DRAW_CONTENT	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Draw_Header_Buttons

push dword ptr [ebp]+8			;hwnd
call GetDC
mov header_device_context,eax
.DATA
header_device_context		dd 0
fill_area_1			dd 0, 16, 0, 0, 17, 0, 1, 16

fill_area_2			dd 79,  0,  93, 0,  86, 7
fill_area_3			dd 155, 0, 169, 0, 162, 7
fill_area_4			dd 231, 0, 245, 0, 238, 7
fill_area_5			dd 307, 0, 322, 0, 322, 15
.CODE

push background_color_pen_handle
push header_device_context
call SelectObject

push hbrBackground1
push header_device_context
call SelectObject

push 3				;point count
push offset fill_area_5
push header_device_context
call Polygon

push 3				;point count
push offset fill_area_4
push header_device_context
call Polygon

push 3				;point count
push offset fill_area_3
push header_device_context
call Polygon

push 4				;point count
push offset fill_area_1
push header_device_context
call Polygon

push 3				;point count
push offset fill_area_2
push header_device_context
call Polygon
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Headers Text
.DATA
file_text	db 'File'
spl_text	db 'SPL',0
output_text	db 'Output',0, 0
report_text	db 'Report',0, 0
.CODE

push list_font_handle
push header_device_context
call SelectObject

push 0
push header_device_context
call SetBkMode 

cmp header_selection_number,1
sete al
ror eax,1
cdq
mov esi,0
mov edi,00FFFFFFh
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
push header_device_context
call SetTextColor 

push 4
push offset file_text
push 2
push 35
push header_device_context
call TextOutA

cmp header_selection_number,2
sete al
ror eax,1
cdq
mov esi,0
mov edi,00FFFFFFh
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
push header_device_context
call SetTextColor 

push 3
push offset spl_text
push 2
push 115
push header_device_context
call TextOutA

cmp header_selection_number,3
sete al
ror eax,1
cdq
mov esi,0
mov edi,00FFFFFFh
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
push header_device_context
call SetTextColor 

push 6
push offset output_text
push 2
push 185
push header_device_context
call TextOutA

cmp header_selection_number,4
sete al
ror eax,1
cdq
mov esi,0
mov edi,00FFFFFFh
and esi,edx
not edx
and edi,edx
add esi,edi

push esi
push header_device_context
call SetTextColor 

push 6
push offset report_text
push 2
push 260
push header_device_context
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Headers Text
push header_device_context
push dword ptr [ebp]+8
call ReleaseDC


jmp ch_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
ch_default:
      win_default

pop edi
pop esi
pop ebx
pop ebp
ret 16
Child_Header_Window_Proc	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Create_Optional_Richedit_Windows proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
;file
spl_window_handle		dd 0
spl_window_old_proc		dd 0
spl_window_new_proc		dd offset Richedit_Window_Filter_ProcARW_1
spl_insert_overwrite_status	dd 0

output_window_handle		dd 0
output_window_old_proc		dd 0
output_window_new_proc		dd offset Richedit_Window_Filter_ProcARW_2
output_insert_overwrite_status	dd 0

report_window_handle		dd 0
report_window_old_proc		dd 0
report_window_new_proc		dd offset Richedit_Window_Filter_ProcARW_3
report_insert_overwrite_status	dd 0

global_keyboard_state_array	db 256 dup (0)

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;create_optional_window macro window_handle, window_old_proc, window_new_proc

create_optional_window spl_window_handle, spl_window_old_proc, spl_window_new_proc
create_optional_window output_window_handle, output_window_old_proc, output_window_new_proc
create_optional_window report_window_handle, report_window_old_proc, report_window_new_proc

;push 1
;push spl_window_handle
;call ShowWindow

ret
Create_Optional_Richedit_Windows endp

;;;;;;optional_filter_proc macro  optional_index, window_handle, ins_over_status, window_old_proc
optional_filter_proc ARW_1, spl_window_handle, spl_insert_overwrite_status, spl_window_old_proc
optional_filter_proc ARW_2, output_window_handle, output_insert_overwrite_status, output_window_old_proc
optional_filter_proc ARW_3, report_window_handle, report_insert_overwrite_status, report_window_old_proc



endm


create_optional_window macro window_handle, window_old_proc, window_new_proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push 0
push hInst
push 0
push hwnd					;dword ptr [ebp+08h]
push Richedit_Window_Height		;vertical size
push Richedit_Window_Width		;horizontal size
push Richedit_Window_Start_Y		;16
push Richedit_Window_Start_X		;160     
push 40000000h+4+40h+80h+1000h+100h+200000h+100000h
push 0				;offset cpedt	
push offset richedit_class_name
push 0
call CreateWindowExA ;;Create edit line
mov window_handle,eax

push 16384  					;lparam 
push 0						;wparam
push 400h+53					;EM_EXLIMITTEXT	400h+53
push window_handle				;richedit_window_handle
call SendMessageA

push 00C0C0C0h;15395562;006C6C6Ch;001F1F1Fh;
push 0 ;wParam   
push 400h+67					;EM_SETBKGNDCOLOR    
push window_handle				;richedit_window_handle
call SendMessageA

push 0		;lparam		;Not used
push 12		;wParam		;Maximum number of actions for undo
push 400h+82   ;EM_SETUNDOLIMIT  ;400h+82 
push window_handle				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Text size
;push 256000  					;lparam 
;push 0						;wparam
;push 400h+53					;EM_EXLIMITTEXT	400h+53
;push window_handle				;richedit_window_handle
;call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Text size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Font
push 1						;lparam  ;If this parameter is TRUE, the control redraws itself. 
push Window_font_handle				;wparam ;Handle to the font 
push 30h					;WM_SETFONT
push window_handle				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Font
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Text Mode
push 0						;lparam ;not used
push 1+8+16					;wparam 
push 400h+89					;EM_SETTEXTMODE WM_USER + 89
push window_handle				;richedit_window_handle
call SendMessageA				;

;TM_PLAINTEXT		1
;TM_SINGLECODEPAGE	16
;TM_MULTILEVELUNDO	8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Text Mode
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New Left Margin
push 10						;lparam	 ;New margin width
push 1						;wparam	 ;EC_LEFTMARGIN		1
push 0D3h					;;EM_SETMARGINS		0D3h
push window_handle				;richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New Left Margin
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set New Richedit Window Proc Address
push window_new_proc				;new_window_address
push (-4)					;GWL_WNDPROC
push window_handle				;richedit_window_handle
call SetWindowLong
mov window_old_proc,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set New Richedit Window Proc Address
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
optional_filter_proc macro  optional_index, window_handle, ins_over_status, window_old_proc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Richedit_Window_Filter_Proc&optional_index  proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start invert Insert/Overwrite status
cmp dword ptr [ebp+0ch],WM_KEYDOWN	;100h
jne no_char&optional_index

push offset global_keyboard_state_array
call GetKeyboardState

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Call Menu
mov eax,dword ptr [global_keyboard_state_array]+5Dh	;;VK_APPS  5Dh
bt eax,7			;7 - th bit is ;0 - Key not pressed ;1 - Key pressed
jnc no_vk_application_key&optional_index


push 0		;operation_type
call SCL_Activate_Edit_Popup_Menu

no_vk_application_key&optional_index:

;VK_APPS 		equ 5Dh
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Call Menu
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Filtering
mov eax,dword ptr [global_keyboard_state_array]+9	;VK_TAB
mov ebx,dword ptr [global_keyboard_state_array]+11h	;VK_CONTROL
and eax,ebx
bt eax,7			;7 - th bit is ;0 - Key not pressed ;1 - Key pressed
jc end_of_richedit_proc&optional_index

;VK_UP                                equ 26h
;VK_DOWN                              equ 28h

mov eax,dword ptr [global_keyboard_state_array]+26h	;VK_UP
mov ebx,dword ptr [global_keyboard_state_array]+11h	;VK_CONTROL
and eax,ebx
bt eax,7			;7 - th bit is ;0 - Key not pressed ;1 - Key pressed
jc end_of_richedit_proc&optional_index

mov eax,dword ptr [global_keyboard_state_array]+28h	;VK_DOWN
mov ebx,dword ptr [global_keyboard_state_array]+11h	;VK_CONTROL
and eax,ebx
bt eax,7			;7 - th bit is ;0 - Key not pressed ;1 - Key pressed
jc end_of_richedit_proc&optional_index

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Filtering
xor eax,eax
no_char&optional_index:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End invert Insert/Overwrite status




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start invert Insert/Overwrite status
cmp dword ptr [ebp+0ch],100h		;WM_KEYDOWN  	100h
jne no_optional_insert&optional_index

;WM_KEYDOWN  	100h
;nVirtKey = (int) wParam		;virtual-key code 
;lKeyData = lParam			;key data 

;cmp dword ptr [ebp]+16,2Dh	;VK_INSERT 2Dh
;jne no_optional_insert&optional_index

;mov ebx,ins_over_status		;Insert/Overwrite status
;btc ebx,0
;mov ins_over_status,ebx		;Insert/Overwrite status

;push 40
;push 440
;call Beep

;push 0  ;operation_type
;call SCL_Draw_Status_Bar

xor eax,eax
no_optional_insert&optional_index:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End invert Insert/Overwrite status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process mouse right button
cmp dword ptr [ebp+0ch],WM_LBUTTONDOWN		;WM_RBUTTONUP  205h
jne	richedit_optional_left_button_down&optional_index

;push 40
;push 880
;call Beep

;push 0  ;operation_type
;call SCL_Draw_Status_Bar


xor eax,eax
richedit_optional_left_button_down&optional_index:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process mouse right button

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process mouse right button
cmp dword ptr [ebp+0ch],205h		;WM_RBUTTONUP  205h
jne	richedit_optional_left_button_up&optional_index

;mov eax,offset FNL_Item

push 7 ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;SCL_Activate_Edit_Popup_Menu 

xor eax,eax
richedit_optional_left_button_up&optional_index:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process mouse right button

;push 40
;push 440
;call Beep

;mov eax,1

push dword ptr [ebp]+20		;lparam
push dword ptr [ebp]+16		;wparam
push dword ptr [ebp]+12		;message
push dword ptr [ebp]+8		;richedit_window_handle
push window_old_proc		;richedit_previous_proc_address
call CallWindowProcA

end_of_richedit_proc&optional_index:

pop edi
pop esi
pop ebx
mov esp,ebp
pop ebp
ret 16
Richedit_Window_Filter_Proc&optional_index endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm

