create_child_popup_list macro

Create_Child_Popup_Menu proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
APM_cbSize		dd    48
APM_style		dd    3				;CS_HREDRAW+CS_VREDRAW
APM_lpfnWndProc		dd    offset Child_Popup_Window_Proc_1
APM_cbClsExtra		dd    0
APM_cbWndExtra		dd    0
APM_hInstance		dd    0
APM_hIcon		dd    0				;Values get from LoadIcon
APM_hCursor		dd    0				;Values get from LoadCursorA
APM_hbrBackground	dd    0
APM_lpszMenuName	dd    0
APM_lpszClassName	dd    offset  APM_new_class_name 	;Window name 
APM_hIconSm		dd    0

APM_new_class_name	db 'ASM_IDE_POPUP_STANDARD_CLASS',0
APM_child_window_handle	dd 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov APM_hInstance,eax

	push	32512	;32649
	push	0
	call	LoadCursorA
	mov dword ptr APM_hCursor,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	APM_hIcon,eax		;There is no need to create Icon because child window has no caption

	push 4
	call GetStockObject
	mov  dword ptr APM_hbrBackground,eax

mov   APM_lpszClassName,offset APM_new_class_name	

	push offset APM_cbSize
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg  

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	320			;Vertical size of window
	push	150			;Horizontal size of window 
	push	160			;Y coordinate relative to parent window
	push	200			;X coordinate relative to parent window   
	push	80000000h	;40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset APM_new_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	APM_child_window_handle,eax

push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset PML_LIST_CONTENTS		;ebp+12
push 0;operation_type			;ebp+8
call SCL_Set_List_Parameters

;	push	1
;	push	child_file_list_handle
;	call	ShowWindow		;Do not need to show window because it is already visible
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create Child Class and Window
mov esp,ebp
pop ebp
ret
Create_Child_Popup_Menu endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Child_Popup_Window_Proc_1 proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	apm_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	apm_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	apm_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	apm_wm_mouse_right_button_up

jmp apm_default

apm_wm_mouse_left_button_down:

push 0
push APM_child_window_handle
call ShowWindow


jmp apm_wmpaint

mov eax,0
jmp apm_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
apm_wm_mouse_right_button_up:

mov eax,0
jmp apm_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
apm_wm_mouse_move:

;push 1;draw_operation			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push child_file_list_handle		;ebp+12
;push 0;operation_type			;ebp+8
;call SCL_Perform_List_Effect		;FPC_5

;push offset COLOR_HANDLES_ARRAY	;ebp+32
;push memory_dc				;ebp+28
;push List_Item_Number			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call SCL_Repaint_List_Item		;FPC_7

mov eax,0
jmp apm_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
apm_wmpaint:

push offset COLOR_HANDLES_ARRAY		;ebp+28
push memory_dc				;ebp+24
push list_font_handle			;ebp+20
push offset PML_LIST_CONTENTS		;ebp+16
push dword ptr [ebp]+8			;child_file_list_handle				;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6


;push offset COLOR_HANDLES_ARRAY	;ebp+16
;push offset LIST_CONTENTS		;ebp+12
;push operation_type			;ebp+8
;call SCL_Set_List_Selection_Color




;jmp apm_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
apm_default:
      win_default

pop edi
pop esi
pop ebx
pop ebp
ret 16
Child_Popup_Window_Proc_1	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.DATA


.CODE



















endm


