create_child_project_list macro

Create_Child_Project_List proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
cbSize_3                dd    48
style_3                 dd    3				;CS_HREDRAW+CS_VREDRAW
lpfnWndProc_3           dd    offset Child_List_Window_Proc_2
cbClsExtra_3            dd    0
cbWndExtra_3            dd    0
hInstance_3             dd    0
hIcon_3                 dd    0					;Values get from LoadIcon
hCursor_3               dd    0					;Values get from LoadCursorA
hbrBackground_3         dd    0
lpszMenuName_3          dd    0
lpszClassName_3         dd    offset  project_class_name 	;Window name 
hIconSm_3               dd    0

project_class_name		db 'PROJECT_LIST_CLASS',0
child_project_list_handle	dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov hInstance_3,eax

	push	32649
	push	0
	call	LoadCursorA
	mov dword ptr hCursor_3,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_3,eax		;There is no need to create Icon because child window has no caption

	push 5
	call GetStockObject
	mov   dword ptr hbrBackground_3,eax

mov   lpszClassName_3,offset project_class_name

	push offset cbSize_3
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg  ;

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	520			;Vertical size of window
	push	150			;Horizontal size of window 
	push	16			;Y coordinate relative to parent window
	push	640			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h;+0C00000h
	push	0			;Child window has not caption and has not title
	push	offset project_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_project_list_handle,eax

push offset COLOR_HANDLES_ARRAY		;ebp+16
push offset PROJECT_LIST_CONTENTS		;ebp+12
push 0;operation_type				;ebp+8
call SCL_Set_List_Parameters

push 0				;bRedraw
push 0				;nMaxPos
push 0				;nMinPos
push 0 				;nBar
push child_project_list_handle
call SetScrollRange			;Set New Scroll Range

push 1				;bRedraw
push 0				;nMaxPos
push 0				;nMinPos
push 1				;nBar
push child_project_list_handle
call SetScrollRange			;Set New Scroll Range

;	push	1
;	push	child_file_list_handle
;	call	ShowWindow		;Do not need to show window because it is already visible
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create Child Class and Window
mov esp,ebp
pop ebp
ret
Create_Child_Project_List endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Child_List_Window_Proc_2 proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	wmpaint_3
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	wm_mouse_move_3
cmp dword ptr ss:[ebp+0ch],WM_SIZE	;5h
je	wm_size_3
cmp dword ptr ss:[ebp+0ch],115h	;WM_VSCROLL 115h
je	wm_vscroll_3
cmp dword ptr ss:[ebp+0ch],114h	;WM_HSCROLL 115h
je	wm_hscroll_3
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	wm_mouse_left_button_down_3
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	wm_mouse_right_button_up_3

jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
wm_mouse_right_button_up_3:

push 8 ;function_number				;ebp+12
push 0 ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;SCL_Activate_Files_Popup_Menu 

mov eax,0
jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process left mouse down
wm_mouse_left_button_down_3:

push 0	;operation_type
call SCL_Force_Close_Popup_Menu

push offset PROJECT_LIST_CONTENTS	;ebp+16
push child_project_list_handle		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Check_Mouse_Cursor_On_Item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 -  mouse cursor located on item
;[eax] - 1 -  mouse cursor is not located on item
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov mouse_status,ebx
;btc dword ptr List_Item_3+28,0

push memory_dc				;ebp+36
push list_font_handle			;ebp+32
push child_project_list_handle		;ebp+28
push mouse_status ;new_selection_number		;ebp+24
push 1	;selection_type			;ebp+20
push offset COLOR_HANDLES_ARRAY	;ebp+16
push offset PROJECT_LIST_CONTENTS	;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Set_List_Selection		;FPC_8

jmp wmpaint_3

mov eax,0
jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process left mouse down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process vertical scroll
wm_vscroll_3:
P_scroll_vertical_scroll_bar
jmp wmpaint_3
;jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process vertical scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process horizontal scroll
wm_hscroll_3:
P_scroll_horizontal_scroll_bar

jmp wmpaint_3
;jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process horizontal scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redefine list size changes
wm_size_3:

push list_font_handle			;ebp+20
push offset PROJECT_LIST_CONTENTS		;ebp+16
push dword ptr [ebp]+8	;child_file_list_handle			;ebp+12
push 0  ;operation_type			;ebp+8
call SCL_Redefine_Project_List_Scroll_Bars

;jmp wmpaint_3
xor eax,eax
jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Redefine list size changes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
wm_mouse_move_3:

;push 1;draw_operation			;ebp+24
;push list_font_handle			;ebp+20
;push offset PROJECT_LIST_CONTENTS	;ebp+16
;push child_project_list_handle		;ebp+12
;push 0;operation_type			;ebp+8
;call SCL_Perform_Project_List_Effect		;FPC_5



;push offset P_vertical_current_pos	;ebp+24
;push 2  ;List_Item number		;ebp+20
;push offset PROJECT_LIST_CONTENTS		;ebp+16
;push child_project_list_handle		;ebp+12
;push 0	;operation_type			;ebp+8
;call SCL_Set_Item_Visibility

mov eax,0
jmp default_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
wmpaint_3:

push offset COLOR_HANDLES_ARRAY		;ebp+28
push memory_dc				;ebp+24
push list_font_handle			;ebp+20
push offset PROJECT_LIST_CONTENTS	;ebp+16
push dword ptr [ebp]+8			;child_file_list_handle				;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Draw_List_On_Window		;FPC_6

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
default_3:
      win_default

pop edi
pop esi
pop ebx
pop ebp
ret 16
Child_List_Window_Proc_2	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
Project_Save_Dialog	proc 
push ebp
mov ebp,esp
push ebx
push esi
push edi

mov project_save_dialog_result,0
cmp dword ptr ss:[ebp+0ch],WM_CLOSE
je	dialog_close
cmp dword ptr ss:[ebp+0ch],WM_COMMAND
je	wm_dialog_command
cmp dword ptr ss:[ebp+0ch],WM_PAINT
je	wm_dialog_paint

jmp dialog_default


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Dialog Contents
wm_dialog_paint:

xor ecx,ecx
push 400				;string_length	;ebp+20
push ecx				;find_byte		;ebp+16
push dialog_file_name_show_address		;scan_string	;ebp+12
call Find_Byte
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
cmp eax,0
je dialog_default

mov dialog_file_name_show_length,ecx

push dword ptr [ebp]+8		;hwnd
call GetDC
mov all_save_dialog_hdc,eax

push 20000
push all_save_dialog_hdc
call SetTextColor

push 0
push all_save_dialog_hdc
call SetBkMode

push list_font_handle
push all_save_dialog_hdc
call SelectObject

push dialog_file_name_show_length
push dialog_file_name_show_address
push 18					;Y
push 120				;X
push all_save_dialog_hdc
call TextOutA

push all_save_dialog_hdc
push dword ptr [ebp]+8		;hwnd
call ReleaseDC

jmp dialog_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Dialog Contents

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Dialog buttons
wm_dialog_command:
.DATA
dialog_file_name_show_address	dd 0
dialog_file_name_show_length	dd 0
all_save_dialog_hdc		dd 0

dialog_name			db 'PROJECT_SAVE_CONFIRMATION',0
project_save_dialog_result	dd 0
.CODE

mov project_save_dialog_result,1000
mov eax,dword ptr [ebp+16]		;wparam
cmp ax,1000
je dialog_close

mov project_save_dialog_result,1001
mov eax,dword ptr [ebp+16]		;wparam
cmp ax,1001
je dialog_close

mov project_save_dialog_result,1002
mov eax,dword ptr [ebp+16]		;wparam
cmp ax,1002
je dialog_close

mov project_save_dialog_result,1003
mov eax,dword ptr [ebp+16]		;wparam
cmp ax,1003
je dialog_close

mov project_save_dialog_result,1004
mov eax,dword ptr [ebp+16]		;wparam
cmp ax,1004
je dialog_close

jmp dialog_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Dialog buttons
;; Buttons ID
;Yes		-->	1000
;Yes to all	-->	1001
;No		-->	1002
;No to all	-->	1003
;Cancel		-->	1004

dialog_close:

push project_save_dialog_result
push dword ptr [ebp+8]  ;;hwnd
call EndDialog

jmp dialog_default

dialog_default:
mov eax,0
pop edi
pop esi
pop ebx
pop ebp
ret 16
Project_Save_Dialog	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Generate_Loaded_Files_Report proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GLFR_01, EP_GLFR_01

mov eax,dword ptr [ebp]+8
mov operation_type_GLFR_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_GLFR_01, LF_GLFR_01, operation_type_GLFR_01, LP_GLFR_01, EP_GLFR_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
file_list_create_report_internal_counter	dd 0
active_richedit_window_for_report		dd 0
current_report_file_name_address		dd 0
comment_line					db ';;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;',0dh, 0ah, 0
comment_symbol					db ';',0
files_count_text				db ';		Loaded files report',0dh, 0ah
						db ';Loaded files count		',0
files_count					db '0000000000',0dh, 0ah 
.CODE

push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window
mov active_richedit_window_for_report,ebx
cmp ebx,0
je end_create_file_list_report				;Jump if no active richedit window for report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset comment_line	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA

push offset files_count_text	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA

push List_Items_Count
push offset files_count
call SC_Convert_Bin_To_Dec_10 

push offset files_count	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Report Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Report Start
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate report
cmp List_Items_Count,0
je end_create_file_list_report
mov file_list_create_report_internal_counter,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_create_file_list_report:
inc file_list_create_report_internal_counter

mov eax,file_list_create_report_internal_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov ecx,eax				;FNL_file_full_name
add ecx,8 
mov current_report_file_name_address,ecx

mov eax,List_Items_Count
cmp file_list_create_report_internal_counter,eax
ja end_create_file_list_report

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start insert file name
push offset comment_symbol	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA

push current_report_file_name_address	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA

push offset eol_code		;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End insert file name

mov eax,List_Items_Count
cmp file_list_create_report_internal_counter,eax
jbe start_create_file_list_report


end_create_file_list_report:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate report
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push offset comment_line	;lparam 
push 1				;wparam 
push 0C2h			;EM_REPLACESEL
push active_richedit_window_for_report
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_GLFR_01, LP_GLFR_01, EP_GLFR_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Generate_Loaded_Files_Report endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push 0	;operation_type
;call SCL_Complete_All_FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Complete_All_FNL proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CAFNL_01, EP_CAFNL_01

mov eax,dword ptr [ebp]+8
mov operation_type_CAFNL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CAFNL_01, LF_CAFNL_01, operation_type_CAFNL_01, LP_CAFNL_01, EP_CAFNL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
all_FNL_complete_internal_counter	dd 0
.CODE

cmp List_Item_Selection_Number,0
je end_complete_all_FNL
mov all_FNL_complete_internal_counter,0
start_complete_all_FNL:

;push all_FNL_complete_internal_counter		;file_list_item_number		;ebp+12
;push 0 ;operation_type				;ebp+8
;call SCL_Complete_Corresponding_FNL 

inc all_FNL_complete_internal_counter
mov eax,List_Item_Selection_Number
cmp all_FNL_complete_internal_counter,eax
jb start_complete_all_FNL

end_complete_all_FNL:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CAFNL_01, LP_CAFNL_01, EP_CAFNL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Complete_All_FNL endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push 0	;operation_type
;call SCL_Destroy_File_List
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Destroy_File_List proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_DFL_01, EP_DFL_01

mov eax,dword ptr [ebp]+8
mov operation_type_DFL_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_DFL_01, LF_DFL_01, operation_type_DFL_01, LP_DFL_01, EP_DFL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
file_list_destroy_counter	dd 0
.CODE
mov file_list_destroy_counter,0

cmp List_Items_Count,0
je end_destroy_file_list

start_destroy_file_list:
inc file_list_destroy_counter

mov eax,file_list_destroy_counter
dec eax
mov ecx,32				;One item size in bytes
mul ecx
add eax,20				;Add LIST_CONTENTS header size
add eax,offset LIST_CONTENTS
mov ebx,dword ptr [eax]+28		;Arrow show status
shr ebx,24				;FNL item  number
dec ebx
mov eax,476				;FNL one item size
mul ebx
add eax,offset FILE_NAME_LIST
mov ecx,eax				;FNL_file_full_name
mov ebx,dword ptr [eax]+448

push ebx
call DestroyWindow

mov eax,List_Items_Count
cmp file_list_destroy_counter,eax
jb start_destroy_file_list

end_destroy_file_list:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset List
mov List_Items_Count,0
mov List_Item_Selection_Number,0

mov edi,offset LIST_CONTENTS
add edi,20			;LIST_CONTENTS header size
xor eax,eax
mov ecx,288			;LIST_CONTENTS all size [ in dwords ] except header size
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset List
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_DFL_01, LP_DFL_01, EP_DFL_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Destroy_File_List endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push file_handle			;ebp+12
;push operation_type			;ebp+8
;call SCL_Project_File_Into_Workspace

SCL_Project_File_Into_Workspace proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PFIW_01, EP_PFIW_01

mov eax,dword ptr [ebp]+8
mov operation_type_PFIW_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_PFIW_01, LF_PFIW_01, operation_type_PFIW_01, LP_PFIW_01, EP_PFIW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Current_Workspace_Data
mov edi,offset FILE_NAME_LIST
xor eax,eax
mov ecx,4284			;17136 / 4 = 4284
cld
rep stosd

mov edi,offset project_spl_file_name
xor eax,eax
mov ecx,100			;400 / 4 = 100
cld
rep stosd

mov edi,offset LIST_CONTENTS
xor eax,eax
mov ecx,293			;1172 / 4 = 293
cld
rep stosd

mov edi,offset PROJECT_LIST_CONTENTS
xor eax,eax
mov ecx,293			;1172 / 4 = 293
cld
rep stosd

mov edi,offset RESULT_FILE_NAME_LIST
xor eax,eax
mov ecx,4284			;17136 / 4 = 4284
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Current_Workspace_Data
.DATA
APF_project_FIW_error_code		dd 0
.CODE

start_check_APF_for_read:
push dword ptr [ebp]+12			;file_handle			;ebp+12
push 0;operation_type			;ebp+8
call SCL_Check_APF_Valid_State
cmp eax,(-1)
je start_check_APF_for_read
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Return
;[ebx] - 0 - APF  valid
;[ebx] - 1 - APF invalid
;	[ecx] - 1 - APF size incorrect [Error code]
;	[ecx] - 2 - APF header read error [Error code]
;	[ecx] - 3 - APF header absent [Error code]
;	[ecx] - 4 - APF List_Items_Count is above than 36 [Error code]
;	[ecx] - 5 - APF List Selection is above than 36 [Error code]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov APF_project_FIW_error_code,ebx
cmp ebx,1				;0 - APF  valid		;1 - APF invalid
je end_project_file_into_workspace

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Size  ;;;;;;;  Offset
;APF_header_text			db 'Assembler Project File version 1.6  '	;36		0
;APF_spl_file_present_flag		dd 0						;4		36
;APF_reserved				db 360 dup (0)					;360		40

;APF_spl_file_name			db 400   dup (0)				;400		400
;APF_File_List				db 1172  dup (0)				;1172		800
;APF_FNL				db 17136 dup (0)				;17136		1972
;APF_Results_List			db 1172  dup (0)				;1172		19108
;APF_RFNL				db 17136 dup (0)				;17136		20280
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   All size  37416
push 0					;METHOD ;FILE_BEGIN 0
push 0					;High 32 bits of move
push 36
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call SetFilePointer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read SPL File name
push 0						;must be offset in  other case
push offset APF_file_read_bytes_count
push 4
push offset SPL_load_flag	;0 - Spl file not loaded ;1 - SPl file loaded ;APF_spl_file_present_flag
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read SPL File name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start read from .APF file 
push 0					;METHOD ;FILE_BEGIN 0
push 0					;High 32 bits of move
push 400
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call SetFilePointer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read SPL File name
push 0						;must be offset in  other case
push offset APF_file_read_bytes_count
push 400
push offset project_spl_file_name
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read SPL File name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read File LIST_CONTENTS
push 0				;must be offset in  other case
push offset APF_file_read_bytes_count
push 1172
push offset LIST_CONTENTS
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read File LIST_CONTENTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read FNL
push 0				;must be offset in  other case
push offset APF_file_read_bytes_count
push 17136
push offset FILE_NAME_LIST
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read FNL
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read File LIST_CONTENTS
push 0				;must be offset in  other case
push offset APF_file_read_bytes_count
push 1172
push offset PROJECT_LIST_CONTENTS
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read File LIST_CONTENTS
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read FNL
push 0				;must be offset in  other case
push offset APF_file_read_bytes_count
push 17136
push offset RESULT_FILE_NAME_LIST
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read FNL
mov APF_load_flag,1			;0 - APF absent ;1 - APF present

mov eax,List_Active_Color_Handle
mov List_Empty_Region_Fill_Color_Handle,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End read from .APF file 

mov APF_project_FIW_error_code,0

end_project_file_into_workspace:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PFIW_01, LP_PFIW_01, EP_PFIW_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,APF_project_FIW_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy
;[ebx] - 1 - APF projection not occured. APF invalid. [Error description in "Reports" window]
;[ebx] - 0 - APF projection occured successfully. 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 8
SCL_Project_File_Into_Workspace endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push file_handle			;ebp+12
;push operation_type			;ebp+8
;call SCL_Project_Workspace_Into_File

SCL_Project_Workspace_Into_File proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_PWIF_01, EP_PWIF_01

mov eax,dword ptr [ebp]+8
mov operation_type_PWIF_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_PWIF_01, LF_PWIF_01, operation_type_PWIF_01, LP_PWIF_01, EP_PWIF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
APF_file_write_bytes_count		dd 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Size  ;;;;;;;  Offset
APF_header_text				db 'Assembler Project File version 1.6  '	;36		0
APF_spl_file_present_flag		dd 0						;4		36
APF_reserved				db 360 dup (0)					;360		40

;APF_spl_file_name			db 400   dup (0)				;400		400
;APF_File_List				db 1172  dup (0)				;1172		800
;APF_FNL				db 17136 dup (0)				;17136		1972
;APF_Results_List			db 1172  dup (0)				;1172		19108
;APF_RFNL				db 17136 dup (0)				;17136		20280
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   All size  37416
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer to APF file 
push 0				;must be offset in  other case
push offset APF_file_write_bytes_count
push 36
push offset APF_header_text	;"Assembler Project File version 1.6 "
push dword ptr [ebp]+12		;APF_file_create_internal_handle
call WriteFile

push 0				;must be offset in  other case
push offset APF_file_write_bytes_count
push 4
push offset SPL_load_flag	;0 - Spl file not loaded ;1 - SPl file loaded ;APF_spl_file_present_flag
push dword ptr [ebp]+12		;APF_file_create_internal_handle
call WriteFile

push 0				;must be offset in  other case
push offset APF_file_write_bytes_count
push 360
push offset APF_reserved
push dword ptr [ebp]+12		;APF_file_create_internal_handle
call WriteFile

push 0					;must be offset in  other case
push offset APF_file_write_bytes_count
push 400
push offset project_spl_file_name
push dword ptr [ebp]+12			;APF_file_create_internal_handle
call WriteFile

push 0					;must be offset in  other case
push offset APF_file_write_bytes_count
push 1172
push offset LIST_CONTENTS
push dword ptr [ebp]+12			;APF_file_create_internal_handle
call WriteFile

push 0					;must be offset in  other case
push offset APF_file_write_bytes_count
push 17136
push offset FILE_NAME_LIST
push dword ptr [ebp]+12			;APF_file_create_internal_handle
call WriteFile

push 0					;must be offset in  other case
push offset APF_file_write_bytes_count
push 1172
push offset PROJECT_LIST_CONTENTS
push dword ptr [ebp]+12			;APF_file_create_internal_handle
call WriteFile

push 0					;must be offset in  other case
push offset APF_file_write_bytes_count
push 17136
push offset RESULT_FILE_NAME_LIST
push dword ptr [ebp]+12			;APF_file_create_internal_handle
call WriteFile

push dword ptr [ebp]+12			;APF_file_create_internal_handle
call SetEndOfFile			;Truncate file
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer to APF file 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_PWIF_01, LP_PWIF_01, EP_PWIF_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Project_Workspace_Into_File endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push file_handle			;ebp+12
;push operation_type			;ebp+8
;call SCL_Check_APF_Valid_State

SCL_Check_APF_Valid_State proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_CAPFVS_01, EP_CAPFVS_01

mov eax,dword ptr [ebp]+8
mov operation_type_CAPFVS_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_CAPFVS_01, LF_CAPFVS_01, operation_type_CAPFVS_01, LP_CAPFVS_01, EP_CAPFVS_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov APF_valid_flag,0
mov APF_valid_error_code,0


.DATA
APF_valid_flag		dd 0		;0 - APF  valid		;1 - APF invalid
APF_valid_error_code	dd 0
APF_header_check_buffer	db 36 dup (0)	;db 'Assembler Project File version 1.6  ',0
APF_read_temp_buffer	db 40 dup (0)

apf_size_incorrect	db 0dh, 0ah, 'Specified .APF file has incorect size. [Valid size is 37416 bytes]', 0dh, 0ah, 0
apf_header_absent	db 0dh, 0ah, 'Specified .APF file header is incorrect. [Valid header "Assembler Project File version 1.6" ]', 0dh , 0ah, 0
apf_read_error		db 0dh, 0ah, 'Could not read from .APF',0dh, 0ah, 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check APF size
push 0				;High order word is not required
push dword ptr [ebp]+12		;file_handle
call GetFileSize
cmp eax,37416			;APF_size 37416 bytes
je no_apf_size_error		;Jump if file size is not equal to 37416 bytes

mov APF_valid_error_code,1	;APF size incorrect [Error code]
mov APF_valid_flag,1		;APF invalid

mov new_header_button_selection,4
push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

mov eax,offset apf_size_incorrect
add_report_line					;Report about APF size error

jmp end_check_apf
no_apf_size_error:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check APF size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check APF header text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start read from .APF file 
push 0					;METHOD ;FILE_BEGIN 0
push 0					;High 32 bits of move
push 0
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call SetFilePointer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read SPL File name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read FNL
push 0					;must be offset in  other case
push offset APF_file_read_bytes_count
push 36
push offset APF_header_check_buffer
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read FNL
;If the function fails, the return value is zero. To get extended error information, call GetLastError.
cmp eax,0
jne no_header_read_error

call GetLastError

push eax				;system_error code		;ebp+8
call Get_System_Error_Text 
;;;;;;mov eax,offset apf_read_error
add_report_line				;Report about APF read error

mov eax,offset apf_read_error
add_report_line				;Report about APF read error

mov new_header_button_selection,4
push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

mov APF_valid_error_code,2	;APF header read error [Error code]
mov APF_valid_flag,1		;APF invalid

jmp  end_check_apf
no_header_read_error:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Compare Read Header
push 30					;compare_length			;ebp+24
push offset APF_header_text		;Second_string			;ebp+20
push offset APF_header_check_buffer	;ebp+16
call Compare_String
;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = 1 Strings are similar
;[eax] = 0 Strings are not similar
;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Compare Read Header
cmp eax,1
je no_header_text_error

mov APF_valid_error_code,3	;APF header absent [Error code]
mov APF_valid_flag,1		;APF invalid

mov new_header_button_selection,4
push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

mov eax,offset apf_header_absent
add_report_line					;Report about APF header absent

jmp end_check_apf
no_header_text_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check APF header text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check APF optional fileds
mov edi,offset APF_read_temp_buffer		;40 byte
xor eax,eax
mov ecx,10
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start read from .APF file 
push 0					;METHOD ;FILE_BEGIN 0
push 0					;High 32 bits of move
push 800
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call SetFilePointer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read SPL File name
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Read FNL
push 0					;must be offset in  other case
push offset APF_file_read_bytes_count
push 8
push offset APF_read_temp_buffer
push dword ptr [ebp]+12			;APF_file_open_internal_handle
call ReadFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Read FNL
;If the function fails, the return value is zero. To get extended error information, call GetLastError.
cmp eax,0
je APF_file_optional_read_error
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov APF_valid_flag,0			;0 - APF  valid		;1 - APF invalid
mov APF_valid_error_code,0
jmp  end_check_apf
APF_file_optional_read_error:

call GetLastError

push eax				;system_error code		;ebp+8
call Get_System_Error_Text 
;;;;;;mov eax,offset apf_read_error
add_report_line				;Report about APF read error

mov eax,offset apf_read_error
add_report_line				;Report about APF read error

mov new_header_button_selection,4
push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

mov APF_valid_error_code,2	;APF header read error [Error code]
mov APF_valid_flag,1		;APF invalid

jmp  end_check_apf
no_APF_optional_read_error:


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check List Items Count
cmp dword ptr APF_read_temp_buffer,36
jbe no_list_count_APF_error
.DATA
APF_List_Items_Count_error	db 0dh, 0ah, '.APF [List_Items_Count] of file list is above than 36.',0dh, 0ah, 0
APF_List_selection_error	db 0dh, 0ah, '.APF [List_Item_Selection_Number] of file list is above than 36.',0dh, 0ah, 0
.CODE
mov APF_valid_error_code,4	;APF List_Items_Count is above than 36 [Error code]
mov APF_valid_flag,1		;APF invalid


no_list_count_APF_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check List Items Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check List Selection
cmp dword ptr APF_read_temp_buffer+4,36
jbe no_list_selection_APF_error

mov APF_valid_error_code,5	;APF List Selection is above than 36 [Error code]
mov APF_valid_flag,1		;APF invalid

mov new_header_button_selection,4
push 5  ;function_number			;ebp+12
push 0  ;operation_type				;ebp+8
call SCL_Concentrated_Switch_Control		;Show "Report" window

mov eax,offset APF_List_selection_error
add_report_line					;Report about APF header absent

jmp end_check_apf
no_list_selection_APF_error:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check List Selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check APF optional fileds


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;  Size  ;;;;;;;  Offset
;APF_header_text				db 'Assembler Project File version 1.6  '	;36		0
;APF_spl_file_present_flag		dd 0						;4		36
;APF_reserved				db 360 dup (0)					;360		40
;APF_spl_file_name			db 400   dup (0)				;400		400
;APF_File_List				db 1172  dup (0)				;1172		800
;APF_FNL				db 17136 dup (0)				;17136		1972
;APF_Results_List			db 1172  dup (0)				;1172		19108
;APF_RFNL				db 17136 dup (0)				;17136		20280
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;   All size  37416


mov APF_valid_flag,0			;0 - APF  valid		;1 - APF invalid
end_check_apf:


mov ebx,APF_valid_flag			;0 - APF  valid		;1 - APF invalid
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_CAPFVS_01, LP_CAPFVS_01, EP_CAPFVS_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,APF_valid_flag
mov ecx,APF_valid_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Return
;[ebx] - 0 - APF  valid
;[ebx] - 1 - APF invalid
;	[ecx] - 1 - APF size incorrect [Error code]
;	[ecx] - 2 - APF header read error [Error code]
;	[ecx] - 3 - APF header absent [Error code]
;	[ecx] - 4 - APF List_Items_Count is above than 36 [Error code]
;	[ecx] - 5 - APF List Selection is above than 36 [Error code]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SCL_Check_APF_Valid_State endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




endm


