create_child_statusbar macro

Create_Child_Status_Bar proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Create Child Class and Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
SB_cbSize			dd    48
SB_style			dd    3				;CS_HREDRAW+CS_VREDRAW
SB_lpfnWndProc			dd    offset Child_Status_Bar_Window_Proc
SB_cbClsExtra			dd    0
SB_cbWndExtra			dd    0
SB_hInstance			dd    0
SB_hIcon			dd    0				;Values get from LoadIcon
SB_hCursor			dd    0				;Values get from LoadCursorA
SB_hbrBackground		dd    0
SB_lpszMenuName			dd    0
SB_lpszClassName		dd    offset  new_class_name 	;Window name 
SB_hIconSm			dd    0
SB_class_name			db 'ASM_IDE_STANDARD_STATUS_BAR',0
child_status_bar_handle		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax,dword ptr hInst
	mov SB_hInstance,eax

	push	32512	;32649
	push	0
	call	LoadCursorA
	mov dword ptr SB_hCursor,eax 

;	push	1 ; offset icon_name	;offset icon_name ;32515 
;	push	hInst
;	call	LoadIconA
;	mov	hIcon_2,eax		;There is no need to create Icon because child window has no caption

	push 5
	call GetStockObject
	mov  dword ptr SB_hbrBackground,eax

mov   SB_lpszClassName,offset SB_class_name	

	push offset SB_cbSize
	call  RegisterClassExA
;	test  ax,ax    
;	jz    end_cycl_msg

	push	0			;lpParam  ; pointer to window-creation data;
	push	hInst			;hInstance  ;handle to application instance
	push	0			;handle to menu or child-window identifier
	push	hwnd			;handle to parent window
	push	16			;Vertical size of window
	push	1025			;Horizontal size of window 
	push	685			;Y coordinate relative to parent window
	push	0			;X coordinate relative to parent window   
	push	40000000h+80000h+10000000h+2000000h+4000000h;+40000h+200000h+100000h ;2000000h+4000000h
	push	0			;Child window has not caption and has not title
	push	offset SB_class_name	;
	push	0;1+8h			;extended window style
	call	CreateWindowExA
	mov	child_status_bar_handle,eax

;	push	1
;	push	child_status_bar_handle
;	call	ShowWindow		;Do not need to show window because it is already visible
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Create Child Class and Window
mov esp,ebp
pop ebp
ret
Create_Child_Status_Bar endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Child_Status_Bar_Window_Proc proc
push ebp
mov ebp,esp
push ebx
push esi
push edi

cmp dword ptr ss:[ebp+0ch],WM_PAINT  
je	SB_wmpaint
cmp dword ptr ss:[ebp+0ch],WM_MOUSEMOVE	;200h
je	SB_wm_mouse_move
cmp dword ptr ss:[ebp+0ch],WM_LBUTTONDOWN ;	201h
je	SB_wm_mouse_left_button_down
cmp dword ptr ss:[ebp+0ch],WM_RBUTTONUP ;	201h
je	SB_wm_mouse_right_button_up

jmp SB_default

SB_wm_mouse_left_button_down:

;jmp SB_wmpaint
mov eax,0
jmp SB_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start process right mouse up
SB_wm_mouse_right_button_up:

mov eax,0
jmp SB_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End process right mouse up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Mouse move check 
SB_wm_mouse_move:


mov eax,0
jmp SB_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Mouse move check 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint child window contents 
SB_wmpaint:

push 0  ;operation_type
call SCL_Draw_Status_Bar

;jmp SB_default
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint child window contents 
SB_default:
      win_default

pop edi
pop esi
pop ebx
pop ebp
ret 16
Child_Status_Bar_Window_Proc	endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Draw_Status_Bar proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_DSB_01, EP_DSB_01

mov eax,dword ptr [ebp]+8
mov operation_type_DSB_01,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_DSB_01, LF_DSB_01, operation_type_DSB_01, LP_DSB_01, EP_DSB_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
status_bar_hdc				dd 0
SB_active_window_handle			dd 0
SB_current_selection			dd 0, 0
status_bar_bound_rect			dd 0, 0, 800, 16
status_bar_fill_rect			dd 642,  0, 1800, 16
status_bar_bottom_fill_rect		dd 0,   14, 1800, 18

active_text_line_count			dd 0
active_text_selection_start_line	dd 0
active_text_selection_end_line		dd 0
active_selection_size			dd 0
active_text_size			dd 0
active_text_column			dd 0
SB_line_text				db ' Line  '
SB_column_text				db 'Column  '
SB_text_text				db 'Text    '
SB_byte_text				db 'Bytes   '
SB_selected_text			db 'Selected    '
SB_selected_lines_text			db 'Selected Lines  '
SB_delimiter				db ' -  '
SB_line_count				db 'Line Count      '
SB_result				db '0000000000                         '
.CODE

mov active_text_line_count,0
mov active_text_selection_start_line,0
mov active_text_selection_end_line,0
mov active_selection_size,0
mov active_text_size,0
mov active_text_column,0

push child_status_bar_handle
call GetDC
mov status_bar_hdc,eax

;;;	show_decimal 160, 30, mouse_status

start_get_active_window_for_status_bar:
push 0 ;operation_type				;ebp+8
call SCL_Get_Active_Richedit_Window 
cmp eax,(-1)
je start_get_active_window_for_status_bar
mov SB_active_window_handle,ebx
cmp ebx,0
je no_active_window_for_SB
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Current Selection
push offset SB_current_selection	;lParam   
push 0					;wParam		Modification new value   
push 400h+52				;EM_EXGETSEL  WM_USER + 52 
push SB_active_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Current Selection

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values SB_current_selection, SB_current_selection+4	;[EAX] - Max ;[EBX] - Min

mov SB_current_selection+4,eax
mov SB_current_selection,ebx 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection start line
mov eax,SB_current_selection
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;EM_EXLINEFROMCHAR	400h+54
push SB_active_window_handle
call SendMessageA
mov active_text_selection_start_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection start line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection end line
mov eax,SB_current_selection+4
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;EM_EXLINEFROMCHAR	400h+54
push SB_active_window_handle
call SendMessageA
mov active_text_selection_end_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection end line
;IF [comment_selection_end_line] < [comment_selection_start_line] 
;Then SET [comment_selection_end_line] = [comment_selection_start_line]

;mov ebx,active_text_selection_start_line
;cmp active_text_selection_end_line,ebx
;setb al
;ror eax,1
;cdq
;mov esi,active_text_selection_start_line
;mov edi,active_text_selection_end_line
;and esi,edx
;not edx
;and edi,edx
;add esi,edi
;mov active_text_selection_end_line,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Line Count
push 0					;lParam   
push 0					;wParam		Modification new value   
push 0BAh				;EM_GETLINECOUNT  0BAh
push SB_active_window_handle
call SendMessageA
mov active_text_line_count,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Line Count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Selection Size
mov eax,SB_current_selection+4
mov ebx,SB_current_selection
sub eax,ebx
mov active_selection_size,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Selection Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Text Size
push 0					;lParam   
push 0					;wParam		Modification new value   
push 0Eh				;WM_GETTEXTLENGTH  0Eh 
push SB_active_window_handle
call SendMessageA
mov active_text_size,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Text Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Text Column
push 0					;lParam   
push (-1)				;wParam LINE INDEX 
push 0BBh				;EM_LINEINDEX  0BBh
push SB_active_window_handle
call SendMessageA
mov ebx,SB_current_selection		;selection start
sub ebx,eax
mov active_text_column,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Text Column

no_active_window_for_SB:

push list_font_handle
push memory_dc
call SelectObject

push 0
push memory_dc
call SetBkColor

push 0000FF00h		;00FFFFFFh
push memory_dc
call SetTextColor

;active_text_line_count
;active_text_selection_start_line
;active_text_selection_end_line
;active_selection_size
;active_text_size

;SB_column_text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Line Text And Value
push 0000FF00h ;text_color			;ebp+32
push offset SB_line_text		;ebp+28
push 6 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 0;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text		;FPC_7

push active_text_selection_start_line		;comment_selection_start_line	;comment_selection_start_position;
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 0000FF00h ;text_color		;ebp+32
push offset SB_result+4			;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 26;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Line Text And Value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Column Text And Value
push 0000FF00h ;text_color			;ebp+32
push offset SB_column_text		;ebp+28
push 8 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 70;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push active_text_column			;comment_selection_start_line	;comment_selection_start_position;
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 0000FF00h ;text_color		;ebp+32
push offset SB_result+4			;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 110;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Column Text And Value
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Text Size
push 00FFFFFFh ;text_color			;ebp+32
push offset SB_text_text		;ebp+28
push 6 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 155 ;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push active_text_size			;comment_selection_start_line	;comment_selection_start_position;
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 00FFFFFFh ;text_color		;ebp+32
push offset SB_result+4			;ebp+28
push 12 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 180;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push 00FFFFFFh ;text_color			;ebp+32
push offset SB_byte_text		;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 220 ;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Text Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Selection Size
push 0000FF00h;00FFFFFFh ;text_color			;ebp+32
push offset SB_selected_text		;ebp+28
push 10 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 255 ;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push active_selection_size			;comment_selection_start_line	;comment_selection_start_position;
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 0000FF00h;00FFFFFFh ;text_color		;ebp+32
push offset SB_result+4			;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 300;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push 0000FF00h;00FFFFFFh ;text_color			;ebp+32
push offset SB_byte_text		;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 340 ;text_x				;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Selection Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Selected Lines
push 00FFFFFFh ;text_color		;ebp+32
push offset SB_selected_lines_text	;ebp+28
push 18 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 375 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

mov eax,active_text_selection_start_line
push eax
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 00FFFFFFh ;text_color		;ebp+32
push offset SB_result+4		;ebp+28
push 6 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 450 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

push 00FFFFFFh ;text_color		;ebp+32
push offset SB_delimiter		;ebp+28
push 3 ;text_length			;ebp+24
push 1 ;text_y				;ebp+20
push 486 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

;SB_current_selection+4	;

mov eax,active_text_selection_end_line
push eax
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 00FFFFFFh ;text_color		;ebp+32
push offset SB_result+4		;ebp+28
push 9 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 495 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Selected Lines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Line Count
push 0000FF00h;00FFFFFFh ;text_color		;ebp+32
push offset SB_line_count	;ebp+28
push 14 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 540 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7

mov eax,active_text_line_count
push eax
push offset SB_result
call SC_Convert_Bin_To_Dec_10

push 0000FF00h;00FFFFFFh ;text_color		;ebp+32
push offset SB_result+4		;ebp+28
push 8 ;text_length			;ebp+24
push 1;text_y				;ebp+20
push 600 ;text_x			;ebp+16
push status_bar_hdc			;ebp+12
push memory_dc				;ebp+8
call SC_Draw_Double_Buffered_Text	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Line Count




;mov active_text_line_count,0
;mov active_text_selection_start_line,0
;mov active_text_selection_end_line,0
;mov active_selection_size,0
;mov active_text_size,0
;mov active_text_column,0


push List_Color_2_Handle
push offset status_bar_fill_rect
push status_bar_hdc
call FillRect

push List_Color_2_Handle
push offset status_bar_bottom_fill_rect
push status_bar_hdc
call FillRect


;mov status_bar_rect,0				;X
;mov status_bar_rect+4,eax			;Y
;mov status_bar_rect+8,ebx			;Width
;mov status_bar_rect+12,16			;Height


.DATA
status_bar_line_1	dd 0, 0, 816, 1
status_bar_line_2	dd 0, 0, 152, 18
status_bar_line_3	dd 0, 0, 252, 18
status_bar_line_4	dd 0, 0, 372, 18
status_bar_line_5	dd 0, 0, 536, 18
status_bar_line_6	dd 0, 0, 640, 18
.CODE

mov eax,status_bar_rect+8
mov status_bar_bound_rect+8,eax

push List_Color_2_Handle			;List_Color_1_Handle
push offset status_bar_line_1
push status_bar_hdc
call FrameRect


;push List_Color_1_Handle
;push offset status_bar_bound_rect
;push status_bar_hdc
;call FrameRect

;push List_Color_1_Handle
;push offset status_bar_line_6
;push status_bar_hdc
;call FrameRect

;push List_Color_1_Handle
;push offset status_bar_line_5
;push status_bar_hdc
;call FrameRect

;push List_Color_1_Handle
;push offset status_bar_line_4
;push status_bar_hdc
;call FrameRect

;push List_Color_1_Handle
;push offset status_bar_line_3
;push status_bar_hdc
;call FrameRect

;push List_Color_1_Handle
;push offset status_bar_line_2
;push status_bar_hdc
;call FrameRect

push status_bar_hdc
push child_status_bar_handle
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_DSB_01, LP_DSB_01, EP_DSB_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 4
SCL_Draw_Status_Bar endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm




