;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Keep_Within_Boundaries macro min, value, max

mov esi,min
mov edi,value
mov edx,max

push esi
push edi
push edx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Keep_Up_To_Min
cmp edi,esi
setb al		;Set if [EDI] < [ESI]
ror eax,1
cdq
mov eax,edx
not eax
and esi,edx
and edi,eax
add edi,esi
mov eax,edi		;result in [EAX]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pop edx	;max
pop edi	;value
pop esi	;min

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Keep_Up_To_Max
mov edi,eax	;value
mov esi,edx	;max

cmp edi,esi
seta al		;Set if [EDI] > [ESI]
ror eax,1
cdq
mov eax,edx
not eax
and esi,edx
and edi,eax
add edi,esi
mov eax,edi		;result in [EAX]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm		;result in [EAX]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Keep_Up_To_Min macro  value, min    ;If Value =< min then Value = Min  ;If Value > Min do nothing

mov esi,min
mov edi,value
cmp edi,esi
setb al		;Set if [EDI] < [ESI]
ror eax,1
cdq
mov eax,edx
not eax
and esi,edx
and edi,eax
add edi,esi
mov eax,edi		;result in [EAX]

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Keep_Up_To_Max macro  value, max    ;If Value >= max then Value = Max  ;If Value < Max do nothing

mov esi,max
mov edi,value
cmp edi,esi
seta al		;Set if [EDI] > [ESI]
ror eax,1
cdq
mov eax,edx
not eax
and esi,edx
and edi,eax
add edi,esi
mov eax,edi		;result in [EAX]

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_Location_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False
xor eax,eax
mov esi,Min
mov edi,Max
mov ecx,Value
cmp ecx,esi   ;Value Min
setae al
rol eax,8
cmp ecx,edi   ;Value Max
setbe al
and al,ah
xor ah,ah

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_Location_Within_Rectangle macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2 
;;;;;[EAX] - 1 True ;;[EAX] - 0 False

mov eax,Min_2
push eax
mov eax,Max_2
push eax
mov eax,Value_2
push eax

Check_Location_Within_Boundaries  Min_1, Value_1, Max_1 

pop ebx
pop edi
pop ecx

push eax
Check_Location_Within_Boundaries  ecx, ebx, edi 
pop edx

and eax,edx 
endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min

mov eax,Value_1
mov ebx,Value_2
push eax
push ebx

Keep_Up_To_Min  eax, ebx    ;value_1, min  ;;Also Get Max

pop ebx
pop ecx

push eax

Keep_Up_To_Max ecx, ebx  ;;;Also get min

mov ebx,eax
pop eax

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SV_Get_String_Length macro string_address, string_max_limit

;SV_find_byte macro scan_string, find_byte, string_length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;[eax] = 1  byte found
;;;[eax] = 0  byte not found
	;;;[ecx] = length of string [from start to different byte]	
	;;;[esi] address of found byte ;[edi] points to [byte_to_find]
	;;;[ebx] = Remaining bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
xor ecx,ecx

SV_find_byte string_address, cl, string_max_limit

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push iMaxLength 	    ;number of bytes or characters to copy
;push offset lpString2 ;address of source string
;push offset lpString1 ;address of target buffer 
;call lstrcpynA	;The lstrcpyn function copies a specified number of characters from a source string into a buffer.

;push offset lpString2 ;address of string to copy 
;push offset lpString1 ;address of buffer 
;call lstrcpyA	;The lstrcpy function copies a string to a buffer. 


;push offset lpString2 ;address of string to add to string1 
;push offset lpString1 ;address of buffer for concatenated strings 
;call lstrcatA	;The lstrcat function appends one string to another.  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_Location_Within_Rect macro Min_1, Value_1, Max_1, Min_2, Value_2, Max_2 
;;;;;[EAX] - 1 True ;;[EAX] - 0 False

mov eax,Min_2
push eax
mov eax,Max_2
push eax
mov eax,Value_2
push eax

Check_Loc_Within_Boundaries  Min_1, Value_1, Max_1 

pop ebx
pop edi
pop ecx

push eax
Check_Loc_Within_Boundaries  ecx, ebx, edi 
pop edx

and eax,edx 
endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Check_Loc_Within_Boundaries macro Min, Value, Max ;[EAX] - 1 True	[EAX] - 0 False
xor eax,eax
mov esi,Min
mov edi,Max
mov ecx,Value
cmp ecx,esi   ;Value Min
seta al
rol eax,8
cmp ecx,edi   ;Value Max
setb al
and al,ah
xor ah,ah

endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;














;Convert_Bin_To_Dec
;Convert_Dec_To_Bin
;Convert_Bin_To_Hex
;Convert_Hex_To_Bin


