list_standard_operations macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push arrow_x		;ebp+16
;push arrow_y		;ebp+12
;push hdc		;ebp+8
;call SCDrawArrow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCDrawArrow  proc 	;FP_3
.586
push ebp
mov ebp,esp
cmp sc_d_a_busy_flag,1
mov eax,(-1)
je d_a_end

.DATA
sc_d_a_busy_flag	dd 0
arrow_vertex_array	dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
.CODE

mov eax,dword ptr [ebp+12]
mov arrow_vertex_array,eax
mov ebx,dword ptr [ebp+16]
mov arrow_vertex_array+4,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Draw arrow in window
;poly_vertex_array  
; X    Y
;100, 100  ;Start point
;110, 100 
;110, 96  
;116, 102 
;110, 108 
;110, 104 
;100, 104
mov esi,offset arrow_vertex_array ;dword ptr [ebp+8]

;;;;;;;;;;;;poly_vertex_array 
mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add eax,10
mov dword ptr [esi]+8 ,eax  ;poly_vertex_array+8,eax ;110
mov dword ptr [esi]+12,ebx  ;;poly_vertex_array+12,ebx ;100

mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add eax,10
sub ebx,4
mov dword ptr [esi]+16,eax   ;poly_vertex_array+16,eax ;110
mov dword ptr [esi]+20,ebx   ;poly_vertex_array+20,ebx ;96

mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add eax,16
add ebx,2
mov dword ptr [esi]+24,eax ;116
mov dword ptr [esi]+28,ebx ;102

mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add eax,10
add ebx,8
mov dword ptr [esi]+32,eax ;110
mov dword ptr [esi]+36,ebx; 108

mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add eax,10
add ebx,4
mov dword ptr [esi]+40,eax ;110
mov dword ptr [esi]+44,ebx ;104;

mov eax,dword ptr [esi]    ;poly_vertex_array
mov ebx,dword ptr [esi+4] ;poly_vertex_array+4
add ebx,4
mov dword ptr [esi]+48,eax ;100
mov dword ptr [esi]+52,ebx ;104

push 7  ;poly_vertex_count
push offset arrow_vertex_array
push dword ptr [ebp+8]	;hdc
call Polygon
 ; extrn Polygon:PROC

mov sc_d_a_busy_flag,0
mov eax,0
d_a_end:

mov esp,ebp
pop ebp
ret 12
SCDrawArrow endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Draw arrow in window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Create_Used_Handles proc	;FP_0
push ebp
mov ebp,esp

push offset List_Font_Parameters ;pointer to logical font structure  
call CreateFontIndirectA
;    extrn CreateFontIndirectA:PROC
mov list_font_handle,eax

.DATA
List_Font_Parameters		db  8, 0, 0, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 'Ms Sans Serif',0, 0, 0 
list_font_handle		dd 0

arrow_background_color_handle	dd 0
arrow_fill_green_color		dd 0023FE2Eh
arrow_fill_green_color_handle	dd 0
arrow_pen_black_color		dd 0
arrow_pen_black_color_handle	dd 0

black_color_handle		dd 0

;text_backgroud_color		dd 00E6E6E6h
;;;text_backgroud_color_handle	dd 0 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COLOR_HANDLES_ARRAY label dword			;0 - Based

List_Passive_Color			dd 00E9E9E9h			;0		;Inc Files
List_Passive_Color_Handle		dd 0	;Background		;4

List_Active_Color			dd 007F7F7Fh			;8
List_Active_Color_Handle		dd 0	;Background		;12

List_Color_1				dd 00C0C0C0h			;16
List_Color_1_Handle			dd 0	;Background		;20	;Selected Item ;[IF asm file]

List_Color_2				dd 0				;24	;Black color. Used as 
List_Color_2_Handle			dd 0	;Background		;28

List_Color_3				dd 0				;32	;arrow_pen_black_color
List_Color_3_Handle			dd 0	;Background		;36	;arrow_pen_black_color_handle

List_Color_4				dd 0023FE2Eh			;40	;arrow_fill_green_color
List_Color_4_Handle			dd 0	;Background		;44	;arrow_fill_green_color_handle

List_Color_5				dd 0016764879			;48
List_Color_5_Handle			dd 0	;Background		;52

List_Color_6				dd 00FFFFFFh			;48	;Files without extension [ White ]
List_Color_6_Handle			dd 0	;Background		;52

List_Color_7				dd 0				;48
List_Color_7_Handle			dd 0	;Background		;52

List_Color_8				dd 0				;48
List_Color_8_Handle			dd 0	;Background		;52




;LIGHT GREY	--> 00E8E8E8h
;BLUE 		--> 00FF0000h
;GREEN		--> 0000FF00h
;LIGHT GREEN	--> 00EBFFE1h
;DARK GREEN	--> 00009700h
;DARK BLUE	--> 00BDB402h
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
LIST_CONTENTS	label dword

List_Items_Count			dd   0						;0
List_Item_Selection_Number		dd   0  ;1 - Based ;Current list selection	;4
List_Internal_X_offset			dd   0						;8
List_Internal_Y_offset			dd   0					;12
List_Empty_Region_Fill_Color_Handle	dd   0						;16

List_Item_1				dd   85						;0
					dd   offset text_to_show			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   0	;Text Y coordinate			;24
					dd   000000100000001100000000b	;Arrow show status			;28

List_Item_2				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   14	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status	;28

List_Item_3				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   28	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28


List_Item_4				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   42	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28

List_Item_5				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   56	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28

List_Item_6				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   70	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28


List_Item_7				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   84	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28

List_Item_8				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   98	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28

List_Item_9				dd   12						;0
					dd   offset another_text			;4
					dd   0			;Text color		;8
					dd   00E9E9E9h		;Text background color	;12
					dd   0	;Background color handle		;16
					dd   28	;Text X coordinate			;20
					dd   0	;Text Y coordinate			;24
					dd   000001100000000b	;Arrow show status			;28

					dd 216 dup (0)


;;Offsets must be substracted from all X and Y coordinates
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
text_to_show			db 'Very long Text which must be Show in New list, also must provide partial show of text',0
another_text			db 'Another Text',0
current_fill_end_x		dd 0
show_counter			dd 0
text_1				db 'TEXT 1 ......123456789 0  123 456 789  0 ',0
text_2				db 'TEXT 2 ......123456789 0  123 456 789  0 ',0
text_3				db 'TEXT 3 ......123456789 0  123 456 789  0 ',0
text_4				db 'TEXT 4 ......123456789 0  123 456 789  0 ',0
text_5				db 'TEXT 5 ......123456789 0  123 456 789  0 ',0
text_6				db 'TEXT 6 ......123456789 0  123 456 789  0 ',0

.CODE

push List_Color_1
call CreateSolidBrush 
mov List_Color_1_Handle,eax

push List_Color_2						;Active Selection color
call CreateSolidBrush 
mov List_Color_2_Handle,eax

push List_Active_Color 				;Active Selection color
call CreateSolidBrush 
mov List_Active_Color_Handle,eax

push List_Passive_Color ;14408667 		;Passive Background color
call CreateSolidBrush 
mov List_Passive_Color_Handle,eax

push List_Color_5
call CreateSolidBrush 
mov List_Color_5_Handle,eax

push List_Color_4			;arrow_fill_green_color
call CreateSolidBrush 
mov List_Color_4_Handle,eax		;arrow_fill_green_color_handle,eax

push List_Color_3			;arrow_pen_black_color
push 0
push 0
call CreatePen
mov List_Color_3_Handle,eax		;arrow_pen_black_color_handle,eax 

mov esp,ebp
pop ebp
ret 
Create_Used_Handles endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Delete_Used_Handles proc
push ebp
mov ebp,esp

push list_font_handle
call DeleteObject

push List_Color_4_Handle		;arrow_fill_green_color_handle
call DeleteObject

push List_Color_3_Handle		;arrow_pen_black_color_handle
call DeleteObject

push black_color_handle
call DeleteObject

push List_Passive_Color_Handle
call DeleteObject

push List_Active_Color_Handle
call DeleteObject

push List_Color_1_Handle
call DeleteObject

push List_Color_2_Handle
call DeleteObject

push List_Color_5_Handle
call DeleteObject

mov esp,ebp
pop ebp
ret 
Delete_Used_Handles endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example 
;push offset COLOR_HANDLES_ARRAY	;ebp+28
;push memory_dc				;ebp+24
;push offset List_Item_1		;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Fill_Show_Zone_By_Arrow	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Fill_Show_Zone_By_Arrow	proc	;FP_6
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_013, EP_013

mov eax,dword ptr [ebp]+8
mov operation_type_013,eax

;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_013, LF_013, operation_type_013, LP_013, EP_013

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;LIST_CONTENTS	label dword
;List_Items_Count			dd   2						;0
;List_Item_Selection_Number		dd   1  ;1 - Based ;Current list selection	;4
;List_Internal_X_offset			dd   0						;8
;List_Internal_Y_offset			dd   0						;12
;List_Empty_Region_Fill_Color_Handle	dd   0						;16
;
;List_Item_1				dd   85					;20
;					dd   offset text_to_show		;24
;					dd   0	;Text color			;28
;					dd   0	;Text background color		;32
;					dd   0	;Background color handle	;36
;					dd   30	;Text X coordinate		;40
;					dd   0	;Text Y coordinate		;44
;					dd   1	;Arrow show status		;48
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Lines on Arrow Background
mov esi,dword ptr [ebp]+28
mov ebx,dword ptr [esi]+36

push ebx		;arrow_pen_black_color_handle
push dword ptr [ebp]+12			;memory_dc
call SelectObject
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Left [From Arrow] Vertical line
	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS;
	mov edi,dword ptr [ebp]+20	;offset List_Item_1
mov eax,0
sub eax,dword ptr [esi]+8		;sub eax,List_Internal_X_offset

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset

push 0
push ebx		;y
push eax		;x    			;vertical line coordinate
push dword ptr [ebp]+12			;dword ptr [ebp]+12		;memory_dc
call MoveToEx

	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1
mov eax,0
sub eax,dword ptr [esi]+8		;sub eax,List_Internal_X_offset

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset
add ebx,15;

push ebx		;y
push eax		;x       		;vertical line coordinate
push dword ptr [ebp]+12			;memory_dc
call LineTo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Left [From Arrow] Vertical line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Reset Arrow Background
	mov esi,dword ptr [ebp]+20	;offset List_Item_1
mov eax,dword ptr [esi]+16
push eax			
push dword ptr [ebp]+12			;memory_dc
call SelectObject

	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS;
	mov edi,dword ptr [ebp]+20	;offset List_Item_1
mov eax,1
sub eax,dword ptr [esi]+8		;sub eax,List_Internal_X_offset

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset

;;[ebx] - Y
;;[eax] - X

push 0F00021h
push 15		;vertical size
push 4;28		;horizontal size
push ebx	;y
push eax	;x
push dword ptr [ebp]+12			;memory_dc;
call PatBlt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Reset Arrow Background

;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point 
standard_sync_lock_footer BF_013, LP_013, EP_013 

mov esp,ebp
pop ebp
ret 24
SCL_Fill_Show_Zone_By_Arrow	endp	;FP_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push memory_dc				;ebp+28
;push list_font_handle			;ebp+24
;push offset List_Item_1		;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Fill_Show_Zone_By_Text	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Fill_Show_Zone_By_Text	proc	;FP_6
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_014, EP_014

mov eax,dword ptr [ebp]+8
mov operation_type_014,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_014, LF_014, operation_type_014, LP_014, EP_014
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push dword ptr [ebp]+24		;push list_font_handle
;push dword ptr [ebp]+12
;call SelectObject		;Select List font

;mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
;push dword ptr [eax]+12
;push dword ptr [ebp]+12		;memory_dc
;call SetBkColor

push dword ptr [ebp]+24		;push list_font_handle
push dword ptr [ebp]+28		;memory_dc
call SelectObject		;Select List font

mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
push dword ptr [eax]+12
push dword ptr [ebp]+28		;memory_dc
call SetBkColor

mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
mov ebx,dword ptr [eax]	
mov ecx,dword ptr [eax]+4	;Text address

mov edx,dword ptr [ebp]+16	;mov edx,offset LIST_CONTENTS
mov esi,dword ptr [eax]+20	;Text X coordinate
sub esi,dword ptr [edx]+8	;List_Internal_X_offset

mov edi,dword ptr [eax]+24	;Text Y coordinate
sub edi,dword ptr [edx]+12	;List_Internal_Y_offset
inc edi

mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
push dword ptr [eax]+8 	;text_color	;ebp+32
push ecx	;offset text_to_show	;ebp+28
push ebx	;text_length		;ebp+24
push edi	;text_y			;ebp+20
push esi	;text_x			;ebp+16
push dword ptr [ebp]+12			;ebp+12
push dword ptr [ebp]+28			;memory_dc	;ebp+8
call SC_Draw_Double_Buffered_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_014, LP_014, EP_014

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 24
SCL_Fill_Show_Zone_By_Text	endp	;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push offset COLOR_HANDLES_ARRAY	;ebp+32
;push list_font_handle			;ebp+24
;push offset List_Item_1		;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Fill_Empty_Zone		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Fill_Empty_Zone	proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_015, EP_015

mov eax,dword ptr [ebp]+8
mov operation_type_015,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_015, LF_015, operation_type_015, LP_015, EP_015 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Text length
push dword ptr [ebp]+24		;push list_font_handle
push dword ptr [ebp]+12		;hdc
call SelectObject		;Select List font

mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1 
mov ebx,dword ptr [eax]		;Text length
mov ecx,dword ptr [eax]+4	;Text address

;mov edx,dword ptr [ebp]+16	;mov edx,offset LIST_CONTENTS
;mov esi,dword ptr [eax]+20	;Text X coordinate
;sub esi,dword ptr [edx]+8	;List_Internal_X_offset

;mov edi,dword ptr [eax]+24	;Text Y coordinate
;sub edi,dword ptr [edx]+12	;List_Internal_Y_offset
;inc edi

.DATA
text_size_parameters	dd 0, 0, 0, 0
.CODE

push offset text_size_parameters
push ebx	;Text length
push ecx	;Text address
push dword ptr [ebp]+12		;hdc
call GetTextExtentPoint32A
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Text length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint empty zone
mov eax,dword ptr [text_size_parameters]
;in [eax] - text width

mov esi,dword ptr [ebp]+16		;offset LIST_CONTENTS
add eax,28				;Add [Arrow with background] width
sub eax,dword ptr [esi]+8		;sub eax,List_Internal_X_offset
mov ebx,15
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset

	mov esi,dword ptr [ebp]+20	;offset List_Item_1
mov eax,dword ptr [esi]+16		;Background color handle
push eax			
push dword ptr [ebp]+12		;hdc
call SelectObject

	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1

mov eax,dword ptr [text_size_parameters]
;in [eax] - text width
add eax,4;28				;Add [Arrow with background] width
sub eax,dword ptr [esi]+8		;sub eax,List_Internal_X_offset

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset
inc ebx

push 0F00021h
push 13		;vertical size
push 1024		;horizontal size
push ebx	;y
push eax	;x
push dword ptr [ebp]+12		;hdc
call PatBlt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint empty zone
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint horizontal lines
;push offset COLOR_HANDLES_ARRAY	;ebp+32

mov esi,dword ptr [ebp]+32
mov ebx,dword ptr [esi]+36

push ebx		;arrow_pen_black_color_handle
push dword ptr [ebp]+12		;hdc
call SelectObject
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint top line
	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1
mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset

push 0
push ebx		;y
push 0			;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call MoveToEx

	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset

push ebx		;y
push 1024		;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call LineTo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint top line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start paint bottom line
	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1
mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset
add ebx,14

push 0
push ebx		;y
push 0			;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call MoveToEx

	mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
	mov edi,dword ptr [ebp]+20	;offset List_Item_1

mov ebx,dword ptr [edi]+24		;Text Y coordinate
sub ebx,dword ptr [esi]+12		;sub ebx,List_Internal_Y_offset
add ebx,14

push ebx		;y
push 1024		;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call LineTo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint bottom line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End paint horizontal lines
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_015, LP_015, EP_015

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 24
SCL_Fill_Empty_Zone	endp		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset LIST_CONTENTS		;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call SCL_Check_Mouse_Cursor_On_Item	;FPC_3

SCL_Check_Mouse_Cursor_On_Item proc	;FPC_3
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_011, EP_011

mov eax,dword ptr [ebp]+8
mov operation_type_011,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_011, LF_011, operation_type_011, LP_011, EP_011 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;List_Item_1				dd   85					;0
;					dd   offset text_to_show		;4
;					dd   0			;Text color	;8
;					dd   00E9E9E9h		;		;12
;					dd   0	;Background color handle	;16
;					dd   28	;Text X coordinate		;20
;					dd   0	;Text Y coordinate		;24
;					dd   1	;Arrow show status		;28
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
child_1_mouse_cursor_status		dd 0
child_1_mouse_cursor_coordinates	dd 0, 0
min_1					dd 0
max_1					dd 0
mouse_cursor_check_show_counter		dd 0
list_item_number			dd 0

.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov list_item_number,0

push offset child_1_mouse_cursor_coordinates
call GetCursorPos;

push offset child_1_mouse_cursor_coordinates
push dword ptr [ebp]+12
call ScreenToClient

mov eax,dword ptr [ebp]+16			;offset LIST_CONTENTS
mov ebx,dword ptr [eax]				;List_Items_Count
mov mouse_cursor_check_show_counter,ebx

cmp mouse_cursor_check_show_counter,0
je no_check_mouse_cursor_on_list		;Jump if List_Items_Count is null

start_check_mouse_cursor_on_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check Mouse cursor location on List
mov ebx,mouse_cursor_check_show_counter
mov eax,32				;One list Item size
dec ebx
mul ebx

add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+16		;mov eax,offset LIST_CONTENTS

mov ebx,dword ptr [eax]+24		;Text Y coordinate
mov min_1,ebx
mov esi,ebx
add esi,13
mov max_1,esi

	mov eax,dword ptr [ebp]+16		;offset LIST_CONTENTS		;ebp+16
mov eax,dword ptr [eax]+12			;mov eax,List_Internal_Y_offset
sub min_1,eax
sub max_1,eax

;push offset LIST_CONTENTS		;ebp16
;LIST_CONTENTS	label dword

;List_Items_Count			dd   8						;0
;List_Item_Selection_Number		dd   5  ;1 - Based ;Current list selection	;4
;List_Internal_X_offset			dd   0						;8
;List_Internal_Y_offset			dd   0					;12

;mov eax,List_Internal_Y_offset
;sub child_1_mouse_cursor_coordinates+4,eax	;Y coordinate

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check conditions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check first condition
;  IF     Mouse_Y < max_1  and  min_1  < 0 

mov ebx,child_1_mouse_cursor_coordinates+4	;Mouse Y coordinate
xor eax,eax
cmp ebx,max_1
setb al

xor ecx,ecx
cmp min_1,0
setle cl		;Set if signed < 0

and ecx,eax		;Result in ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check first condition
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Check second condition
;  IF     Mouse_Y > min_1  and  Mouse_Y < max_1

mov ebx,child_1_mouse_cursor_coordinates+4	;Mouse Y coordinate
xor eax,eax
cmp ebx,min_1
seta al

mov ebx,child_1_mouse_cursor_coordinates+4	;Mouse Y coordinate

xor edx,edx
cmp ebx,max_1
setbe dl			;Set if signed < 0

and edx,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check second condition
or edx,ecx
mov eax,edx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check conditions
;Result in [eax]
;[eax] - 0 - False
;[eax] - 1 - True


mov ebx,mouse_cursor_check_show_counter
mov list_item_number,ebx
cmp eax,1
je no_check_mouse_cursor_on_list

dec mouse_cursor_check_show_counter
cmp mouse_cursor_check_show_counter,0
jne start_check_mouse_cursor_on_list

mov list_item_number,0

no_check_mouse_cursor_on_list:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Check Mouse cursor location on List

LP_011:
xor eax,eax
mov BF_011,0
EP_011: 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - function processed
	;[ebx] -  item number on which mouse cursor is located
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov ebx,list_item_number

mov esp,ebp
pop ebp
ret 12
SCL_Check_Mouse_Cursor_On_Item endp	;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+28
;push memory_dc				;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call SCL_Draw_List_On_Window		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Draw_List_On_Window	proc
push ebp
mov ebp,esp

;;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_012, EP_012 

mov eax,dword ptr [ebp]+8
mov operation_type_012,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_012, LF_012, operation_type_012, LP_012, EP_012

push dword ptr [ebp]+12		;push child_file_list_handle
call GetDC
mov internal_draw_child_hdc,eax

.DATA
internal_draw_child_hdc		dd 0
internal_show_counter		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov esi,dword ptr [ebp]+16		;offset LIST_CONTENTS
mov eax,dword ptr [esi]				;mov eax,List_Items_Count
cmp eax,0
je no_show_list_on_child_window			;Jump if List_Items_Count is null

mov internal_show_counter,eax

start_draw_list_on_child_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by arrow
mov eax,internal_show_counter	;Internal show counter is 1 - based
dec eax
mov ebx,32			;One item size in bytes
mul ebx
add eax,20			;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16	;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+28			;offset COLOR_HANDLES_ARRAY		;ebp+28
push dword ptr [ebp]+24			;memory_dc
push ebx				;offset List_Item_1			;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push internal_draw_child_hdc		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Fill_Show_Zone_By_Arrow	;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by arrow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by Text
mov eax,internal_show_counter	;Internal show counter is 1 - based
dec eax
mov ebx,32			;One item size in bytes
mul ebx
add eax,20			;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16	;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+24			;memory_dc
push dword ptr [ebp]+20			;push list_font_handle			;ebp+24
push ebx				;offset List_Item_1			;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push internal_draw_child_hdc		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Fill_Show_Zone_By_Text		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by empty area
mov eax,internal_show_counter	;Internal show counter is 1 - based
dec eax
mov ebx,32			;One item size in bytes
mul ebx
add eax,20			;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16	;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+28			;offset COLOR_HANDLES_ARRAY		;ebp+32
push dword ptr [ebp]+20			;push list_font_handle			;ebp+24
push ebx				;offset List_Item_1			;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push internal_draw_child_hdc		;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Fill_Empty_Zone		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by empty area

dec internal_show_counter
cmp internal_show_counter,0
jne start_draw_list_on_child_window

no_show_list_on_child_window:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill remaining empty zone
push dword ptr [ebp]+28			;offset COLOR_HANDLES_ARRAY		;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push internal_draw_child_hdc		;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Fill_Remaining_Empty_Zone	;FPC_4	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill remaining empty zone

push internal_draw_child_hdc
push dword ptr [ebp]+12		;push child_file_list_handle
call ReleaseDC

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_012, LP_012, EP_012

mov esp,ebp
pop ebp
ret 24
SCL_Draw_List_On_Window endp		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Get_List_Content_Dimensions	;FPC_4

SCL_Get_List_Content_Dimensions proc	;FPC_4
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_016, EP_016

mov eax,dword ptr [ebp]+8
mov operation_type_016,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_016, LF_016, operation_type_016, LP_016, EP_016


.DATA
get_dimension_internal_counter	dd 0
maximum_list_width		dd 0
maximum_list_height		dd 0
.CODE

mov maximum_list_width,0
mov maximum_list_height,0

mov ebx,dword ptr [ebp]+16		;offset LIST_CONTENTS
mov eax,dword ptr [ebx]			;List_Items_Count
mov get_dimension_internal_counter,eax
xor ebx,ebx
xor ecx,ecx
cmp eax,0
je end_get_content_dimension		;Jump if list does not contain any items

start_get_list_content_dimension:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Text Maximum width
push dword ptr [ebp]+20		;push list_font_handle
push dword ptr [ebp]+12		;hdc
call SelectObject		;Select List font

mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
mov eax,32			;One item size
mov ebx,get_dimension_internal_counter
dec ebx
mul ebx
add eax,esi			;add eax,offset offset LIST_CONTENTS
add eax,20			;Add LIST_CONTENTS header size

mov ebx,dword ptr [eax]		;Text length 
mov ecx,dword ptr [eax]+4	;Text address

.DATA
text_size_parameters_001	dd 0, 0, 0, 0
.CODE

push offset text_size_parameters_001
push ebx	;Text length
push ecx	;Text address
push dword ptr [ebp]+12		;hdc
call GetTextExtentPoint32A

mov eax,text_size_parameters_001		;Text width
cmp eax,maximum_list_width
jbe no_reset_text_max_width
add eax,28					;Add text start X coordinate

mov maximum_list_width,eax

no_reset_text_max_width:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Text Maximum width
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Text Maximum height

mov esi,dword ptr [ebp]+16	;offset LIST_CONTENTS
mov eax,32			;One item size
mov ebx,get_dimension_internal_counter
dec ebx
mul ebx
add eax,esi			;add eax,offset offset LIST_CONTENTS
add eax,20			;Add LIST_CONTENTS header size

mov ebx,dword ptr [eax]+24	;Text Y coordinate
add ebx,14			;Add One item height. [ 14 pixels ]

cmp ebx,maximum_list_height
jbe no_reset_text_max_height

mov maximum_list_height,ebx
no_reset_text_max_height:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Text Maximum height

dec get_dimension_internal_counter
cmp get_dimension_internal_counter,0
jne start_get_list_content_dimension

mov ecx,maximum_list_width
mov ebx,maximum_list_height

mov eax,1
end_get_content_dimension:

LP_016:
mov BF_016,0
EP_016:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 1 - function successful processed
	;[ecx] - List contents width
	;[ebx] - List contents height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
SCL_Get_List_Content_Dimensions endp	;FPC_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Redefine_List_Scroll_Bars

SCL_Redefine_List_Scroll_Bars proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_027, EP_027

mov eax,dword ptr [ebp]+8
mov operation_type_027,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point 
standard_lock_header IND_027, LF_027, operation_type_027, LP_027, EP_027

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 


push dword ptr [ebp]+12	;child_file_list_handle
call GetDC
mov scroll_bars_redefine_internal_hdc,eax
.DATA
scroll_bars_redefine_internal_hdc		dd 0
client_list_rectangle				dd 0, 0, 0, 0
list_content_width				dd 0
list_content_height				dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get List content dimensions
start_get_list_content_dimensions:
push dword ptr [ebp]+20			;list_font_handle			;ebp+20
push dword ptr [ebp]+16			;offset LIST_CONTENTS		;ebp+16
push scroll_bars_redefine_internal_hdc	;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Get_List_Content_Dimensions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 1 - function successful processed
	;[ecx] - List contents width
	;[ebx] - List contents height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_get_list_content_dimensions
mov list_content_width,ecx
mov list_content_height,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get List content dimensions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get List dimensions
push offset client_list_rectangle
push dword ptr [ebp]+12	;child_file_list_handle
call GetClientRect

;client_list_rectangle + 8	;Width  of client area
;client_list_rectangle + 12 	;Height of client area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get List dimensions
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set horizontal scroll bar parameters
mov eax,client_list_rectangle + 8	;Width  of client area
cmp eax,list_content_width
ja no_list_content_W_above

mov ebx,list_content_width
sub ebx,eax
add ebx,15				;Add optional 15 pixels

mov horizontal_scroll_bar_range,ebx

push    1				;bRedraw
push	ebx				;nMaxPos
push    0				;nMinPos
push    0				;nBar
push dword ptr [ebp]+12		;child_file_list_handle
call   SetScrollRange			;Set New Scroll Range	;Set horizontal scroll bar range

no_list_content_W_above:

mov eax,client_list_rectangle + 8	;Width  of client area
cmp eax,list_content_width
jbe no_list_content_W_below

push    1				;bRedraw
push	0				;nMaxPos
push    0				;nMinPos
push    0				;nBar
push dword ptr [ebp]+12		;child_file_list_handle
call   SetScrollRange			;Set New Scroll Range	;Set horizontal scroll bar range

mov List_Internal_X_offset,0

no_list_content_W_below:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set horizontal scroll bar parameters

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set vertical scroll bar parameters
mov eax,client_list_rectangle + 12	;Height  of client area
cmp eax,list_content_height
ja no_list_content_H_above

mov ebx,list_content_height
sub ebx,eax
add ebx,15				;Add optional 15 pixels

mov vertical_scroll_bar_range,ebx

push    0				;bRedraw
push	ebx				;nMaxPos
push    0				;nMinPos
push    1				;nBar
push dword ptr [ebp]+12		;child_file_list_handle
call   SetScrollRange			;Set New Scroll Range	;Set vertical Scroll bar Range

no_list_content_H_above:

mov eax,client_list_rectangle + 12	;Height  of client area
cmp eax,list_content_height
jbe no_list_content_H_below

push    1				;bRedraw
push	0				;nMaxPos
push    0				;nMinPos
push    1				;nBar
push dword ptr [ebp]+12		;child_file_list_handle
call   SetScrollRange			;Set New Scroll Range	;Set vertical scroll bar range

mov List_Internal_Y_offset,0

no_list_content_H_below:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set vertical scroll bar parameters
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
push scroll_bars_redefine_internal_hdc
push dword ptr [ebp]+12	;child_file_list_handle
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_027, LP_027, EP_027


mov esp,ebp
pop ebp
ret 16
SCL_Redefine_List_Scroll_Bars endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+32
;push memory_dc				;ebp+28
;push List_Item_Number			;ebp+24
;push list_font_handle			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call SCL_Repaint_List_Item		;FPC_7

SCL_Repaint_List_Item proc		;FPC_7
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_021, EP_021

mov eax,dword ptr [ebp]+12
mov operation_type_021,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_021, LF_021, operation_type_021, LP_021, EP_021
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp dword ptr [ebp]+24,0	
je no_repaint_null_item

push dword ptr [ebp]+12		;push child_file_list_handle
call GetDC
mov repaint_internal_draw_child_hdc,eax

.DATA
repaint_internal_draw_child_hdc		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Repaint Item
cmp dword ptr [ebp]+24,0
je no_repaint_list_item			;Jump if Repaint item number is null
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by arrow
mov eax,dword ptr [ebp]+24		;List_Item_Number
dec eax
mov ebx,32				;One item size in bytes
mul ebx
add eax,20				;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16		;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+32			;offset COLOR_HANDLES_ARRAY
push dword ptr [ebp]+28			;memory_dc
push ebx				;offset List_Item_1			;ebp+24
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+20
push repaint_internal_draw_child_hdc	;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Fill_Show_Zone_By_Arrow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by arrow
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by Text
mov eax,dword ptr [ebp]+24		;Internal show counter is 1 - based
dec eax
mov ebx,32				;One item size in bytes
mul ebx
add eax,20				;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16		;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+28			;memory_dc
push dword ptr [ebp]+20			;push list_font_handle			;ebp+24
push ebx				;offset List_Item_1			;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push repaint_internal_draw_child_hdc	;ebp+12
push 0	;operation_type			;ebp+8
call SCL_Fill_Show_Zone_By_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill show zone by empty area
mov eax,dword ptr [ebp]+24		;Internal show counter is 1 - based
dec eax
mov ebx,32				;One item size in bytes
mul ebx
add eax,20				;Add LIST_CONTENTS header size
mov ebx,dword ptr [ebp]+16		;mov ebx,offset LIST_CONTENTS
add ebx,eax

push dword ptr [ebp]+32			;offset COLOR_HANDLES_ARRAY		;ebp+32
push dword ptr [ebp]+20			;push list_font_handle			;ebp+24
push ebx				;offset List_Item_1			;ebp+20
push dword ptr [ebp]+16			;push offset LIST_CONTENTS		;ebp+16
push repaint_internal_draw_child_hdc	;ebp+12
push 0 ;operation_type			;ebp+8
call SCL_Fill_Empty_Zone		;FPC_6
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill show zone by empty area

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Fill remaining empty zone
;push dword ptr [ebp]+32		;offset COLOR_HANDLES_ARRAY		;ebp+32
;push dword ptr [ebp]+16		;push offset LIST_CONTENTS		;ebp+16
;push repaint_internal_draw_child_hdc	;ebp+12
;push 0	;operation_type			;ebp+8
;call SCL_Fill_Remaining_Empty_Zone	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Fill remaining empty zone
no_repaint_list_item:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Repaint Item
push repaint_internal_draw_child_hdc
push dword ptr [ebp]+12			;push child_file_list_handle
call ReleaseDC

no_repaint_null_item:

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_021, LP_021, EP_021

mov esp,ebp
pop ebp
ret 28
SCL_Repaint_List_Item endp		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm



scroll_horizontal_scroll_bar macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Horizontal Scroll
;mov eax,child_file_list_handle
;cmp dword ptr [ebp+14h],eax	;lparam 
;jne no_horizontal_scroll			;Jump if 

.DATA
horizontal_current_pos		dd 0
horizontal_scroll_bar_range	dd 0
.CODE

cmp horizontal_scroll_bar_range,0
je no_horizontal_scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;WM_VSCROLL 
;nScrollCode = (int)LOWORD(wParam); 
;nPos = (short int)HIWORD(wParam); 
;hwndScrollBar = (HWND) lParam;

;SB_LINEUP		0
;SB_LINEDOWN		1
;SB_PAGEUP		2
;SB_PAGEDOWN		3
;SB_THUMBPOSITION	4
;SB_THUMBTRACK		5
;SB_TOP 		6
;SB_BOTTOM		7
;SB_ENDSCROLL		8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Page Up
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,2			;SB_PAGEUP		2
jne no_page_up

cmp horizontal_current_pos,0 
jbe no_page_up
dec horizontal_current_pos

push    0		; bRedraw
push    horizontal_current_pos	; nPos
push    0		; nBar
push    child_file_list_handle
call    SetScrollPos

no_page_up:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Page Up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Page Down
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,3			;SB_PAGEDOWN		3
jne no_page_Down

mov eax,horizontal_scroll_bar_range
cmp horizontal_current_pos,eax 		;RANGE
jae no_page_Down

inc horizontal_current_pos

push    0		; bRedraw
push    horizontal_current_pos	; nPos
push    0		; nBar
push    child_file_list_handle
call    SetScrollPos

no_page_Down:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Page Down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process scroll end
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,5			;SB_THUMBTRACK		5
jne no_thumbtrack

mov eax,dword ptr [ebp+16]
xor ax,ax
ror eax,16
mov horizontal_current_pos,eax

no_thumbtrack:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process scroll end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process scroll end
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,8			;SB_ENDSCROLL		8
jne no_end_scroll

mov eax,horizontal_current_pos

push    0		; bRedraw
push    eax		; nPos
push    0		; nBar
push    child_file_list_handle
call    SetScrollPos

no_end_scroll:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process scroll end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Line down
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,1			;SB_LINEDOWN		1
jne no_line_down

mov eax,horizontal_scroll_bar_range
cmp horizontal_current_pos,eax 		;RANGE
jae no_line_down

inc horizontal_current_pos

push    0			;bRedraw
push    horizontal_current_pos	;nPos
push    0			;nBar
push    child_file_list_handle
call    SetScrollPos

no_line_down:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Line down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Line up
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,0		;SB_LINEUP		0
jne no_line_up

cmp horizontal_current_pos,0 			;RANGE
jbe no_line_up

dec horizontal_current_pos

push    0			;bRedraw
push    horizontal_current_pos	;nPos
push    0			;nBar
push    child_file_list_handle
call    SetScrollPos

no_line_up:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Line up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redraw file list
mov eax,horizontal_current_pos
mov List_Internal_X_offset,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redraw file list

push    1			;bRedraw
push    eax;horizontal_current_pos	;nPos
push    0			;nBar
push    child_file_list_handle
call    SetScrollPos


no_horizontal_scroll:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Horizontal Scroll
endm


scroll_vertical_scroll_bar macro

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Vertical Scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;mov eax,vertical_scroll_bar_handle
;cmp dword ptr [ebp+14h],eax	;lparam 
;jne no_vertical_scroll			;Jump if 

cmp vertical_scroll_bar_range,0
je no_vertical_scroll
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;WM_VSCROLL 
;nScrollCode = (int)LOWORD(wParam); 
;nPos = (short int)HIWORD(wParam); 
;hwndScrollBar = (HWND) lParam;

;SB_LINEUP		0
;SB_LINEDOWN		1
;SB_PAGEUP		2
;SB_PAGEDOWN		3
;SB_THUMBPOSITION	4
;SB_THUMBTRACK		5
;SB_TOP 		6
;SB_BOTTOM		7
;SB_ENDSCROLL		8
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
vertical_current_pos		dd 0
vertical_scroll_bar_range	dd 0
.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Page Up
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,2			;SB_PAGEUP		2
jne no_v_page_up

cmp vertical_current_pos,0 
jbe no_v_page_up
dec vertical_current_pos

push    0		; bRedraw
push    vertical_current_pos	; nPos
push    2		; nBar
push    child_file_list_handle
call    SetScrollPos

no_v_page_up:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Page Up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Page Down
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,3			;SB_PAGEDOWN		3
jne no_v_page_Down

mov eax,vertical_scroll_bar_range
cmp vertical_current_pos,eax 		;RANGE
jae no_v_page_Down

inc vertical_current_pos

push    0		; bRedraw
push    vertical_current_pos	; nPos
push    1		; nBar
push    child_file_list_handle
call    SetScrollPos

no_v_page_Down:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Page Down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process scroll end
mov eax,dword ptr [ebp+16]

xor ebx,ebx
mov bx,ax
cmp ebx,5			;SB_THUMBTRACK		5
jne no_v_thumbtrack

mov eax,dword ptr [ebp+16]
xor ax,ax
ror eax,16
mov vertical_current_pos,eax

no_v_thumbtrack:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process scroll end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process scroll end
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,8			;SB_ENDSCROLL		8
jne no_v_end_scroll

mov eax,vertical_current_pos

push    0		;bRedraw
push    eax		;nPos
push    1		;nBar
push    child_file_list_handle
call    SetScrollPos

no_v_end_scroll:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process scroll end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Line down
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,1			;SB_LINEDOWN		1
jne no_v_line_down

mov eax,vertical_scroll_bar_range
cmp vertical_current_pos,eax 		;RANGE
jae no_v_line_down

inc vertical_current_pos

push    0                ; bRedraw
push    vertical_current_pos              ; nPos
push    1               ; nBar
push    child_file_list_handle
call    SetScrollPos

no_v_line_down:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Line down
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Process Line up
mov eax,dword ptr [ebp+16]
xor ebx,ebx
mov bx,ax
cmp ebx,0		;SB_LINEUP		0
jne no_v_line_up

cmp vertical_current_pos,0 			;RANGE
jbe no_v_line_up

dec vertical_current_pos

push    0                ; bRedraw
push    vertical_current_pos               ; nPos
push    1               ; nBar
push    child_file_list_handle
call    SetScrollPos

no_v_line_up:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Line up
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redraw file list
mov eax,vertical_current_pos
mov List_Internal_Y_offset,eax

push    1                ; bRedraw
push    vertical_current_pos               ; nPos
push    1               ; nBar
push    child_file_list_handle
call    SetScrollPos

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Redraw file list
no_vertical_scroll:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Process Vertical Scroll
endm



double_buffered_text macro
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Bitmap operation
;;Using example
;push 0;fill_color		;ebp+24
;push hwnd			;ebp+20
;push template_width		;ebp+16
;push template_height		;ebp+12
;push offset memory_dc		;ebp+8
;call Create_Copy_Template	;FPC_5

Create_Copy_Template  proc
.586
push ebp
mov ebp,esp

mov eax,dword ptr [ebp]+16 ;;item_H
mov t_memory_dc_rectangle+8,eax

mov eax,dword ptr [ebp]+12	 ;svs
mov t_memory_dc_rectangle+12,eax

push dword ptr [ebp+20] ;hwnd
call GetDC
mov t_temp_hdc,eax

push t_temp_hdc ;hdc
call CreateCompatibleDC  ;The CreateCompatibleDC function creates a memory device context (DC) ;compatible with the specified device
;	extrn CreateCompatibleDC:PROC
mov edi,dword ptr [ebp]+8
mov dword ptr [edi],eax		;mov  memory_dc,eax

push	dword ptr [ebp]+12 	;height of bitmap, in pixels ;in Y axis
push	dword ptr [ebp]+16 	;width of bitmap, in pixels  ;in X axis
push	t_temp_hdc ;hdc 
call	CreateCompatibleBitmap  ;The CreateCompatibleBitmap function creates a bitmap compatible with the device that is associated with the specified device context. 
;	extrn CreateCompatibleBitmap:PROC
mov	t_handle_to_bitmap,eax

mov edi,dword ptr [ebp]+8

push	t_handle_to_bitmap
push	dword ptr [edi]     ;memory_dc
call	SelectObject
;	extrn SelectObject:PROC

push dword ptr [ebp+24] ;14408667              ;;13160660
call CreateSolidBrush
;	extrn CreateSolidBrush:PROC
mov t_pen_handle,eax  ;also used as brush handle for rectangle

mov edi,dword ptr [ebp]+8
push t_pen_handle 
push offset t_memory_dc_rectangle
push dword ptr [edi]   ;memory_dc
call FillRect
;	extrn FillRect:PROC
.DATA
t_memory_dc_rectangle	dd  0, 0, 0, 0 ;  Filled internally [by using parameters_array]
t_pen_handle		dd  0
t_handle_to_bitmap	dd  0
t_temp_hdc		dd  0
.CODE

push t_pen_handle
call DeleteObject
;	extrn DeleteObject:PROC
push t_temp_hdc ;hdc
push dword ptr [ebp+20] ;hwnd
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Bitmap operation
mov esp,ebp
pop ebp
ret 20
Create_Copy_Template  endp		;FPC_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push text_color			;ebp+32
;push offset text_address		;ebp+28
;push text_length			;ebp+24
;push text_y				;ebp+20
;push text_x				;ebp+16
;push hdc				;ebp+12
;push memory_dc				;ebp+8
;call SC_Draw_Double_Buffered_Text		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Draw_Double_Buffered_Text	proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_DDBT_01, EP_DDBT_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

start_draw_text:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
text_height			dd 0
text_show_length		dd 0
text_address_increment		dd 0
text_length_in_units		dd 0

text_size_in_pixels		dd 0
text_size_in_pixels_increment	dd 0

text_x_coordinate		dd 0
text_x_coordinate_increment	dd 0
text_y_coordinate		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+16
mov text_x_coordinate,eax
mov text_x_coordinate_increment,0
mov ebx,dword ptr [ebp]+20
mov text_y_coordinate,ebx

mov text_height,0
mov text_show_length,0
mov text_address_increment,0
mov text_length_in_units,0
mov text_size_in_pixels,0
mov text_size_in_pixels_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start_show_text:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push text_length	;ebp+20
;push offset text	;ebp+16
;push hdc		;ebp+8
;call Get_Valid_Text_Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ecx] - show_text_length_in_units
;[ebx] - show_text_size_in_pixels
;[edx] - show_text_height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+28		;mov eax,offset text
add eax,text_address_increment
mov ebx,dword ptr [ebp]+24		;Full text length
sub ebx,text_address_increment

push ebx				;text_length	;ebp+20
push eax	;offset text		;ebp+16
push dword ptr [ebp]+8			;push hdc	;ebp+8
call Get_Valid_Text_Size
mov text_height,edx
mov text_show_length,ecx
mov text_size_in_pixels,ebx

push dword ptr [ebp]+32
push dword ptr [ebp]+8			;push memory_dc
call SetTextColor

push 2	
push dword ptr [ebp]+8			;push memory_dc
call SetBkMode

mov eax,dword ptr [ebp]+28		;mov eax,offset text
add eax,text_address_increment

push text_show_length
push eax		;offset text
push 0
push 0
push dword ptr [ebp]+8			;push memory_dc
Call TextOutA

mov eax,text_x_coordinate
add eax,text_x_coordinate_increment

	push	0CC0020h  	;SRCCOPY
	push 	13		;text_height	;T_cv	;height, in logical units, of the source rectangle. 
	push	text_size_in_pixels 		;256	;width, in logical units, of the source rectangle. 
	push	0		;y-coordinate of source upper-left corner
	push	0		;x-coordinate of source upper-left corner;
	push dword ptr [ebp]+8	;push memory_dc
	push	13;text_height	;height of destination rectangle
	push	text_size_in_pixels		;256		;width of destination rectangle
	push	text_y_coordinate		;y-coord of destination upper-left corner
	push	eax				;x-coord of destination upper-left corner
	push dword ptr [ebp]+12			;push	hdc
	call StretchBlt


mov ecx,text_show_length
mov ebx,text_size_in_pixels

add text_address_increment,ecx
add text_size_in_pixels_increment,ebx
add text_x_coordinate_increment,ebx

mov eax,dword ptr [ebp]+24		;Full  text length
cmp text_address_increment,eax
jb start_show_text

mov ebx,text_x_coordinate_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ebx] - Current end coordinate
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_DDBT_01, LP_DDBT_01, EP_DDBT_01
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 28
SC_Draw_Double_Buffered_Text	endp	;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push text_length	;ebp+16	
;push offset text	;ebp+12	
;push hdc		;ebp+8
;call Get_Valid_Text_Size		;Calculates Valid template size for standard 256 pixel width template
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Get_Valid_Text_Size proc	;FPC_3
push ebp
mov ebp,esp

.DATA
;;;;;;;;;;;;;;;;;;;X   Y
valid_text_size_parameters	dd 0, 0
show_text_size_in_pixels	dd 0
show_text_length_in_units	dd 0
show_text_height		dd 0
.CODE

mov show_text_size_in_pixels,0
mov show_text_length_in_units,0

mov ecx,dword ptr [ebp]+16		;Text length
mov show_text_length_in_units,ecx

start_get_valid_text_size:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Corresponding Text Size
mov eax,dword ptr [ebp]+12	;Text address
mov ecx,show_text_length_in_units

push offset valid_text_size_parameters
push ecx	;Text length
push eax	;offset text_to_show
push dword ptr [ebp]+8		;memory_dc
call GetTextExtentPoint32A

mov eax,valid_text_size_parameters+4
mov show_text_height,eax

mov eax,valid_text_size_parameters
mov show_text_size_in_pixels,eax

cmp eax,256		;	;cmp eax,template_size;
jbe end_get_valid_text_size

mov ecx,show_text_length_in_units		;dword ptr [ebp+20]		;Text length
sar ecx,1	;div 2
mov show_text_length_in_units,ecx 

jmp start_get_valid_text_size

end_get_valid_text_size:

mov ecx,show_text_length_in_units
mov ebx,show_text_size_in_pixels
mov edx,show_text_height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Corresponding Text Size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ecx] - show_text_length_in_units
;[ebx] - show_text_size_in_pixels
;[edx] - show_text_height
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
Get_Valid_Text_Size endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset COLOR_HANDLES_ARRAY	;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push internal_draw_child_hdc		;ebp+12
;push 0	;operation_type			;ebp+8
;call SCL_Fill_Remaining_Empty_Zone	;FPC_4	

SCL_Fill_Remaining_Empty_Zone proc
push ebp
mov ebp,esp

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unloc
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; 
;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_017, EP_017

mov eax,dword ptr [ebp]+8
mov operation_type_017,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_017, LF_017, operation_type_017, LP_017, EP_017

.DATA
empty_areas_start_y_coordinate		dd 0
empty_areas_draw_counter		dd 0
start_y_coordinate_increment		dd 0
.CODE
mov start_y_coordinate_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Get Empty areas draw start coordinate
mov empty_areas_start_y_coordinate,0

mov ecx,dword ptr [ebp]+16		;offset LIST_CONTENTS
cmp dword ptr [ecx],0
je no_specify_start_y_coordinate

mov ebx,dword ptr [ecx]			;List_Items_Count
dec ebx
mov eax,32				;One item size in bytes
mul ebx

add eax,20				;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+16		;Add  offset LIST_CONTENTS

mov esi,dword ptr [eax]+24		;Text Y coordinate
add esi,14				;Add List item vertical size in pixels
mov empty_areas_start_y_coordinate,esi

no_specify_start_y_coordinate:

mov esi,dword ptr [ebp]+16		;offset LIST_CONTENTS
mov eax,dword ptr [esi]+12		;mov eax,List_Internal_Y_offset
sub empty_areas_start_y_coordinate,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Get Empty areas draw start coordinate

mov empty_areas_draw_counter,50
start_draw_empty_areas:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Lines in Empty Area
mov esi,dword ptr [ebp]+20
mov ebx,dword ptr [esi]+36	;arrow_pen_black_color_handle

push ebx
push dword ptr [ebp]+12		;memory_dc
call SelectObject

mov eax,empty_areas_start_y_coordinate
add eax,start_y_coordinate_increment

push 0
push eax		;y
push 0			;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call MoveToEx

mov eax,empty_areas_start_y_coordinate
add eax,start_y_coordinate_increment

push eax		;y
push 1024		;x	;vertical line coordinate
push dword ptr [ebp]+12		;memory_dc
call LineTo
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Lines in Empty Area
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Empty Area
mov esi,dword ptr [ebp]+20
mov ebx,dword ptr [esi]+4	;List_Passive_Color_Handle

push ebx		;List_Passive_Color_Handle
push dword ptr [ebp]+12		;hdc
call SelectObject

mov eax,empty_areas_start_y_coordinate
add eax,start_y_coordinate_increment
inc eax

push 0F00021h
push 14		;vertical size
push 1600		;horizontal size
push eax	;y
push 0		;x
push dword ptr [ebp]+12		;hdc
call PatBlt
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Empty Area
add start_y_coordinate_increment,15

dec empty_areas_draw_counter
cmp empty_areas_draw_counter,0
jne start_draw_empty_areas

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_017, LP_017, EP_017

mov esp,ebp
pop ebp
ret 16
SCL_Fill_Remaining_Empty_Zone endp	;FPC_4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example
;push show_text_type			;ebp+32
;push text_color			;ebp+28
;push list_font_handle			;ebp+24
;push item_number			;ebp+20
;push offset LIST_CONTENTS		;ebp+16
;push hdc				;ebp+12
;push operation_type			;ebp+8
;call SCL_Fill_Show_Zone_Only_By_Text	;FPC_7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Fill_Show_Zone_Only_By_Text	proc
push ebp
mov ebp,esp

;;show_text_type - [ 0 ] - show original color.  [ 1 ] - show specified color
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_018, EP_018

mov eax,dword ptr [ebp]+8
mov operation_type_018,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_018, LF_018, operation_type_018, LP_018, EP_018
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check invalid cases
mov eax,dword ptr [ebp]+16	;offset LIST_CONTENTS
cmp dword ptr [eax],0		;List_Items_Count
je no_show_only_text		;Jump if List not contains any values

mov eax,dword ptr [ebp]+16	;offset LIST_CONTENTS
mov ebx,dword ptr [ebp]+20	;Item_number to show 
cmp dword ptr [eax]+4,ebx	;List_Item_Selection_Number
je no_show_only_text		;Jump if Specified item number is selected
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check invalid cases


push dword ptr [ebp]+24		;push list_font_handle
push dword ptr [ebp]+12
call SelectObject		;Select List font

mov eax,32
mov ebx,dword ptr [ebp]+20	
dec ebx
mul ebx
add eax,20			;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+16	;offset LIST_CONTENTS

;mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1

push dword ptr [eax]+12
push dword ptr [ebp]+12		;memory_dc
call SetBkColor

push 0				;Set background mode as "TRANSPARENT"
push dword ptr [ebp]+12		;hdc
call SetBkMode

push dword ptr [ebp]+28
push dword ptr [ebp]+12		;hdc
call SetTextColor		;Set specified text color

cmp dword ptr [ebp]+32,1	;show_text_type
je not_show_in_orginal_color

mov eax,32
mov ebx,dword ptr [ebp]+20	
dec ebx
mul ebx
add eax,20			;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+16	;offset LIST_CONTENTS

;mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
push dword ptr [eax]+8	 	;text_color
push dword ptr [ebp]+12		;hdc
call SetTextColor		;Set Original text color

not_show_in_orginal_color:

mov eax,32
mov ebx,dword ptr [ebp]+20	
dec ebx
mul ebx
add eax,20			;Add LIST_CONTENTS header size
add eax,dword ptr [ebp]+16	;offset LIST_CONTENTS

;mov eax,dword ptr [ebp]+20	;mov eax,offset List_Item_1
mov ebx,dword ptr [eax]	
mov ecx,dword ptr [eax]+4	;Text address

mov edx,dword ptr [ebp]+16	;mov edx,offset LIST_CONTENTS
mov esi,dword ptr [eax]+20	;Text X coordinate
sub esi,dword ptr [edx]+8	;List_Internal_X_offset

mov edi,dword ptr [eax]+24	;Text Y coordinate
sub edi,dword ptr [edx]+12	;List_Internal_Y_offset
inc edi

push ebx
push ecx			;offset text
push edi			;Y
push esi			;X
push dword ptr [ebp]+12		;hdc
call TextOutA

;push dword ptr [eax]+8 	;text_color	;ebp+32
;push ecx	;offset text_to_show	;ebp+28
;push ebx	;text_length		;ebp+24
;push edi	;text_y			;ebp+20
;push esi	;text_x			;ebp+16
;push dword ptr [ebp]+12		;ebp+12
;push memory_dc				;ebp+8
;call SC_Draw_Double_Buffered_Text
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

no_show_only_text:

;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
standard_sync_lock_footer BF_018, LP_018, EP_018
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 28
SCL_Fill_Show_Zone_Only_By_Text	endp		;FPC_7
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm











