header_buttons_draw macro

Create_Header_Used_Handles proc
push ebp
mov ebp,esp

.DATA

black_pen_handle		dd 0
;active_text_background_color	dd 0
;passive_text_background_color	dd 0
background_color_pen_handle	dd 0
.CODE

push 14408667
call CreateSolidBrush
mov header_active_bk_color_handle,eax 

push 9474192
call CreateSolidBrush
mov header_passive_bk_color_handle,eax 

push 0 ;arrow_pen_color
push 0
push 0
call CreatePen
mov header_bounding_pen_handle,eax

push 00949494h		;10724259;arrow_pen_color
push 0
push 0
call CreatePen
mov background_color_pen_handle,eax



mov esp,ebp
pop ebp
ret 
Create_Header_Used_Handles endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Delete_Header_Used_Handles proc
push ebp
mov ebp,esp

;push memory_dc
;call DeleteDC 
;	extrn DeleteDC:PROC

push list_font_handle
call DeleteObject

push header_active_bk_color_handle
call DeleteObject

push header_passive_bk_color_handle
call DeleteObject

push header_bounding_pen_handle
call DeleteObject

push background_color_pen_handle
call DeleteObject

mov esp,ebp
pop ebp
ret 
Delete_Header_Used_Handles endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;Using example 
;push hwnd				;ebp+16
;push offset HEADER_DRAW_CONTENT	;ebp+12
;push operation_type			;ebp+8
;call SCL_Draw_Header_Buttons

SCL_Draw_Header_Buttons proc
push ebp
mov ebp,esp

.DATA
header_internal_hdc	dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
HEADER_DRAW_CONTENT	 label dword 

	headers_count			dd 4			;0		;
	headers_y			dd 8			;4
	header_active_bk_color_handle	dd 0			;8
	header_passive_bk_color_handle	dd 0			;12
	header_bounding_pen_handle	dd 0			;16
	header_active_text_color	dd 0			;20
	header_passive_text_color	dd 0			;24
	header_selection_number		dd 1			;28	1-based

	Header_Item_1		dd 0					;28
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;32
				dd 10						;Header start X

	Header_Item_2		dd 0					;80
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;84
				dd 86

	Header_Item_3		dd 0					;132
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;136
				dd 162

	Header_Item_4		dd 0					;184
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;188
				dd 238

	Header_Item_5		dd 0					;236
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;240
				dd 314

	Header_Item_6		dd 0					;288
				dd 00FFFFFFh
				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;292
				dd 390
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

;HEADER_TYPE		0 - FULL_ACTIVE		call Check_Cursor_For_Active_Element
;			1 - LEFT_TRUNCATED	call Check_C_For_Passive_Element_Left
;			2 - RIGHT_TRUNCATED	call Check_C_For_Passive_Element_Right

;HEADER_TYPE		0 - FULL_ACTIVE		[header_active_text_color][header_active_bk_color_handle]
;			1 - LEFT_TRUNCATED	[header_passive_text_color][header_passive_bk_color_handle]
;			2 - RIGHT_TRUNCATED	[header_passive_text_color][header_passive_bk_color_handle]

;HEADER_TYPE		0 - FULL_ACTIVE		call Set_Header_As_Active
;			1 - LEFT_TRUNCATED	call Set_Header_As_Left_Truncated
;			2 - RIGHT_TRUNCATED	call Set_Header_As_Right_Truncated

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA

.CODE

;;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_007, EP_007

mov eax,dword ptr [ebp]+8
mov DHB_operation_type,eax

;;;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_007, LF_007, DHB_operation_type, LP_007, EP_007


push dword ptr [ebp]+16		;push hwnd
call GetDC
mov header_internal_hdc,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	mov edi,dword ptr [ebp]+12
cmp dword ptr [edi],0		;cmp headers_count,0
je end_show_headers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
H_show_counter	dd 0
.CODE

push dword ptr [ebp]+12		;push offset HEADER_DRAW_CONTENT		;ebp+8
call Set_All_Headers_Visibility_State

	mov edi,dword ptr [ebp]+12
mov eax,dword ptr [edi]		;mov eax,headers_count
mov H_show_counter,eax

start_show_headers:


	mov edi,dword ptr [ebp]+12
mov eax,dword ptr [edi]+28		;mov eax,header_selection_number
cmp H_show_counter,eax
sete al
ror eax,1
cdq

	mov eax,dword ptr [ebp]+12
mov esi,dword ptr [eax]+8		;mov esi,header_active_bk_color_handle
mov edi,dword ptr [eax]+12		;mov edi,header_passive_bk_color_handle

and esi,edx
not edx
and edi,edx
add esi,edi

push esi	;header_passive_bk_color_handle
push header_internal_hdc
call SelectObject

mov esi,dword ptr [ebp]+12		;mov esi,offset HEADER_DRAW_CONTENT
add esi,32
mov eax,H_show_counter
dec eax
mov ebx,60
mul ebx
add eax,esi

add eax,8

push 6		;point count
push eax	;push offset Header_Item_1+8
push header_internal_hdc
call Polygon
;	extrn Polygon:PROC

dec H_show_counter
cmp H_show_counter,0
jne start_show_headers

end_show_headers:

push header_internal_hdc
push dword ptr [ebp]+16		;push hwnd
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point

standard_sync_lock_footer BF_007, LP_007, EP_007



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Draw_Header_Buttons endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push offset Header_Item_1	;ebp+16
;push X				;ebp+12
;push Y				;ebp+8
;call Set_Header_As_Active
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Set_Header_As_Active proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12	;X
mov ebx,dword ptr [ebp]+8	;Y
mov edi,dword ptr [ebp]+16	;offset Header_Item_1

sub EAX,8
add ebx,8

mov dword ptr [edi],eax		;Set start X 1
mov dword ptr [edi]+4,ebx	;Set start Y 1

add eax,16		;add X,16
sub ebx,16		;sub Y,16

mov dword ptr [edi]+8,eax		;X 2
mov dword ptr [edi]+12,ebx	;Y 2

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;0,   16,  
;16,   0,  	;ADD 16		SUB 16
;86,   0, 	;ADD 60		
;102,  16, 	;ADD 16		ADD 16
;82,   16,	;SUB 20	
;102,  16, 	;ADD 90		

add eax,60		;add X,16

mov dword ptr [edi]+16,eax		;X 2
mov dword ptr [edi]+20,ebx	;Y 2

add eax,16		;add X,16
add ebx,16		;sub Y,16

mov dword ptr [edi]+24,eax		;X 2
mov dword ptr [edi]+28,ebx	;Y 2

sub eax,20		;add X,16

mov dword ptr [edi]+32,eax		;X 2
mov dword ptr [edi]+36,ebx	;Y 2

add eax,20		;add X,16

mov dword ptr [edi]+40,eax		;X 2
mov dword ptr [edi]+44,ebx	;Y 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 12
Set_Header_As_Active endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push offset Header_Item_3	;ebp+16
;push X				;ebp+12
;push Y				;ebp+8
;call Set_Header_As_Left_Truncated
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Set_Header_As_Left_Truncated proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp]+12	;X
mov ebx,dword ptr [ebp]+8	;Y
mov edi,dword ptr [ebp]+16	;offset Header_Item_3

add ebx,8
add eax,8

mov dword ptr [edi],eax		;X 2
mov dword ptr [edi]+4,ebx	;Y 2

sub eax,8
sub ebx,8

mov dword ptr [edi]+8,eax		;X 2
mov dword ptr [edi]+12,ebx	;Y 2

add eax,8
sub ebx,8

mov dword ptr [edi]+16,eax		;X 2
mov dword ptr [edi]+20,ebx	;Y 2

add eax,60

mov dword ptr [edi]+24,eax		;X 2
mov dword ptr [edi]+28,ebx	;Y 2

add eax,16
add ebx,16

mov dword ptr [edi]+32,eax		;X 2
mov dword ptr [edi]+36,ebx	;Y 2

mov dword ptr [edi]+40,eax		;X 2
mov dword ptr [edi]+44,ebx	;Y 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;16,  16    
;8,    8	;SUB 8		SUB 8
;16,   0	;ADD 8		SUB 8
;86,   0	;ADD 60		
;102,  16	;ADD 16		ADD 16

;102,  16	

mov esp,ebp
pop ebp
ret 12
Set_Header_As_Left_Truncated endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;Using example
;push offset Header_Item_3	;ebp+16
;push X				;ebp+12
;push Y				;ebp+8
;call Set_Header_As_Right_Truncated
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Set_Header_As_Right_Truncated proc
push ebp
mov ebp,esp

mov eax,dword ptr [ebp]+12	;X
mov ebx,dword ptr [ebp]+8	;Y
mov edi,dword ptr [ebp]+16	;offset Header_Item_3

sub eax,8
add ebx,8

mov dword ptr [edi],eax		;X 2
mov dword ptr [edi]+4,ebx	;Y 2

add eax,16
sub ebx,16

mov dword ptr [edi]+8,eax		;X 2
mov dword ptr [edi]+12,ebx	;Y 2

add eax,60

mov dword ptr [edi]+16,eax		;X 2
mov dword ptr [edi]+20,ebx	;Y 2

add eax,8
add ebx,8

mov dword ptr [edi]+24,eax		;X 2
mov dword ptr [edi]+28,ebx	;Y 2

sub eax,8
add ebx,8

mov dword ptr [edi]+32,eax		;X 2
mov dword ptr [edi]+36,ebx	;Y 2

mov dword ptr [edi]+40,eax		;X 2
mov dword ptr [edi]+44,ebx	;Y 2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;4,   16
;20,   0	;ADD 16		SUB 16
;90,   0	;ADD 60
;98,   8	;ADD 8		ADD 8
;90,  16	;SUB 8		ADD 8
;90,  16 	;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
Set_Header_As_Right_Truncated endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;Using example
;push offset HEADER_DRAW_CONTENT		;ebp++8
;call Set_All_Headers_Visibility_State
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Set_All_Headers_Visibility_State proc
push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HEADER_DRAW_CONTENT:
;	headers_count			dd 3			;0
;	header_active_bk_color_handle	dd 0			;4
;	header_passive_bk_color_handle	dd 0			;8
;	header_bounding_pen_handle	dd 0			;12
;	header_active_text_color	dd 0			;16
;	header_passive_text_color	dd 0			;20
;	header_selection_number		dd 1			;24	1-based
;
;	Header_Item_1		dd 0					;Header type
;				dd 0					;Text color
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;Header coordinates
;				dd 0					;Header start X

;	Header_Item_2		dd 0					;84
;				dd 0					;88
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;92
;	Header_Item_3		dd 0					;140
;				dd 0					;144
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;148
;	Header_Item_4		dd 0					;196
;				dd 0					;200
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;204
;	Header_Item_5		dd 0					;
;				dd 0					;
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;
;	Header_Item_6		dd 0					;
;				dd 0					;
;				dd 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0	;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;One header item size is equal to 56 bytes

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
current_process_number	dd 0
.CODE


	mov edi,dword ptr [ebp]+8
mov eax,dword ptr [edi]		;mov eax,headers_count
mov current_process_number,eax

cmp dword ptr [edi],0
je end_set_visibility_state			;Jump if Headers count is null

start_process_headers:

xor edx,edx
xor ebx,ebx
xor ecx,ecx

	mov edi,dword ptr [ebp]+8
mov eax,current_process_number
cmp dword ptr [edi]+28,eax		;cmp header_selection_number,eax
sete dl		;Set if "FULL ACTIVE"
seta bl		;Set if "RIGHT TRUNCATED"
setb cl		;Set if "LEFT TRUNCATED"

rol ebx,1
rol ecx,2
add ecx,ebx
add ecx,edx

mov esi,dword ptr [ebp]+8		;mov esi,offset HEADER_DRAW_CONTENT
add esi,32
mov eax,current_process_number
dec eax
mov ebx,60
mul ebx
add eax,esi

mov dword ptr [eax],ecx		;mov Header_Item_1,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp ecx,1			;FULL_ACTIVE
jne no_full_active_set

	mov edi,dword ptr [ebp]+8
	add eax,8
push eax		;offset Header_Item_2+8
push dword ptr [eax]+48		;push 96;X
push dword ptr [edi]+4		;push headers_y;Y
call Set_Header_As_Active

jmp end_set_headers_visibility
no_full_active_set:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp ecx,4			;LEFT_TRUNCATED
jne no_left_truncated_set

	mov edi,dword ptr [ebp]+8
	add eax,8
push eax		;push offset Header_Item_1
push dword ptr [eax]+48		;push 96;X
push dword ptr [edi]+4		;push headers_y;Y
call Set_Header_As_Left_Truncated

jmp end_set_headers_visibility
no_left_truncated_set:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp ecx,2			;RIGHT_TRUNCATED
jne no_right_truncated_set

	mov edi,dword ptr [ebp]+8
	add eax,8
push eax		;offset Header_Item_1+8
push dword ptr [eax]+48		;push 96;X
push dword ptr [edi]+4		;push headers_y;Y
call Set_Header_As_Right_Truncated

jmp end_set_headers_visibility
no_right_truncated_set:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; 000000000001	;FULl ACTIVE		;1
; 000000000010	;RIGHT_TRUNCATED	;2
; 000000000100	;LEFT_TRUNCATED		;4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_set_headers_visibility:

dec current_process_number
cmp current_process_number,0
jne start_process_headers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;header_selection_number	1 - based
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [header_selection_number] > [current_process_number] than SET as "RIGHT_TRUNCATED"
;IF [header_selection_number] = [current_process_number] than SET as "FULL_ACTIVE"
;IF [header_selection_number] < [current_process_number] than SET as "LEFT_TRUNCATED"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_set_visibility_state:


mov esp,ebp
pop ebp
ret 4
Set_All_Headers_Visibility_State endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;Using example
;push offset mouse_cursor_coordinates		;ebp+12
;push offset HEADER_DRAW_CONTENT		;ebp+8
;call Test_Mouse_Location_On_Headers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Test_Mouse_Location_On_Headers proc
push ebp
mov ebp,esp

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;HEADER_TYPE		1 - FULL_ACTIVE		call Check_Cursor_For_Active_Element
;			2 - RIGHT_TRUNCATED	call Check_C_For_Passive_Element_Right
;			4 - LEFT_TRUNCATED	call Check_C_For_Passive_Element_Left
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
tml_current_process_number	dd 0
header_number			dd 0
current_header_item_offset	dd 0
.CODE

mov header_number,0

	mov edi,dword ptr [ebp]+8
mov header_number,0
mov eax,dword ptr [edi]		;mov eax,headers_count
mov tml_current_process_number,eax

cmp dword ptr [edi],0		;cmp headers_count,0
je end_check_cursor_on_header	;Jump if Headers count is null

tml_start_process_headers:

xor edx,edx
xor ebx,ebx
xor ecx,ecx

mov eax,tml_current_process_number

mov esi,dword ptr [ebp]+8		;mov esi,offset HEADER_DRAW_CONTENT
add esi,32
mov eax,tml_current_process_number
dec eax
mov ebx,60
mul ebx
add eax,esi

mov current_header_item_offset,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,current_header_item_offset
cmp dword ptr [eax],1		;FULL_ACTIVE
jne no_cursor_on_full_active

mov eax,current_header_item_offset
add eax,8

push eax		;offset Header_Item_2+8	;ebp+12
push dword ptr [ebp]+12		;push offset mouse_cursor_coordinates	;ebp+8
call Check_Cursor_For_Active_Element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the element
;[eax] - 1 - cursor is on the element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je no_cursor_on_full_active

mov ebx,tml_current_process_number
mov header_number,ebx

jmp end_check_cursor_on_header
no_cursor_on_full_active:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,current_header_item_offset
cmp dword ptr [eax],2			;RIGHT_TRUNCATED
jne no_cursor_on_right_truncated

mov eax,current_header_item_offset
add eax,8

push eax		;offset Header_Item_2+8	;ebp+12
push dword ptr [ebp]+12		;push offset mouse_cursor_coordinates	;ebp+8
call Check_C_For_Passive_Element_Right
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the element
;[eax] - 1 - cursor is on the element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je no_cursor_on_right_truncated;

mov ebx,tml_current_process_number
mov header_number,ebx

jmp end_check_cursor_on_header
no_cursor_on_right_truncated:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,current_header_item_offset
cmp dword ptr [eax],4			;LEFT_TRUNCATED
jne no_cursor_on_left_truncated

mov eax,current_header_item_offset
add eax,8

push eax		;offset Header_Item_2+8	;ebp+12
push dword ptr [ebp]+12		;push offset mouse_cursor_coordinates	;ebp+8
call Check_C_For_Passive_Element_Left
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - cursor is not on the element
;[eax] - 1 - cursor is on the element
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je no_cursor_on_left_truncated;

mov ebx,tml_current_process_number
mov header_number,ebx

jmp end_check_cursor_on_header
no_cursor_on_left_truncated:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
dec tml_current_process_number
cmp tml_current_process_number,0
jne tml_start_process_headers

end_check_cursor_on_header:

mov eax,header_number


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Cursor not on the headers
;[eax] - Any other value is a header item number in which cursor is located
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
Test_Mouse_Location_On_Headers endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;Using example
;push operation_type			;ebp+16
;push hwnd				;ebp+12
;push offset HEADER_DRAW_CONTENT	;ebp+8
;call SCL_Process_Header_Mouse_Cursor
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Process_Header_Mouse_Cursor proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_006, EP_006

mov eax,dword ptr [ebp]+16
mov PHMC_operation_type,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_006, LF_006, PHMC_operation_type, LP_006, EP_006

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
mouse_cursor_coordinates	dd 0, 0
selection_change_status		dd 0	;0 - Selection not changed 	;1 - Selection changed
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov selection_change_status,0

push offset mouse_cursor_coordinates
call GetCursorPos;
;	extrn GetCursorPos:PROC

push offset mouse_cursor_coordinates
push dword ptr [ebp]+12		;push hwnd
call ScreenToClient
;	extrn ScreenToClient:PROC 

push offset mouse_cursor_coordinates		;ebp+12
push dword ptr [ebp]+8				;push offset HEADER_DRAW_CONTENT	;ebp+8
call Test_Mouse_Location_On_Headers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Cursor not on the headers
;[eax] - Any other value is a header item number in which cursor is located
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je no_reset_header_selection

cmp header_selection_number,eax
je no_reset_header_selection

mov header_selection_number,eax

mov selection_change_status,1


no_reset_header_selection:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;standard_sync_lock_footer macro busy_flag, lock_point, end_point
LP_006:
mov eax,selection_change_status
mov BF_006,0
EP_006:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Selection not changed
;[eax] - 1 - Selection changed
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
SCL_Process_Header_Mouse_Cursor endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;Using example
;push offset HEADER_DRAW_CONTENT	;ebp+16
;push hwnd				;ebp+12
;push operation_type			;ebp+8
;call Draw_Header_Buttons_Text

Draw_Header_Buttons_Text proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
text_draw_internal_hdc		dd 0
.CODE

push dword ptr [ebp]+12		;push hwnd
call GetDC
mov text_draw_internal_hdc,eax


push 0
push text_draw_internal_hdc
call SetBkMode
;	extrn SetBkMode:PROC 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;.DATA
;text_1		db 'Text 1'
;.CODE

start_draw_only_text:

push list_font_handle
push text_draw_internal_hdc
call SelectObject

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Item 1
mov eax,0
cmp header_selection_number,1
je no_set_color_1_as_mouse_move

mov eax,dword ptr Header_Item_1+4

no_set_color_1_as_mouse_move:

push eax
push text_draw_internal_hdc
call SetTextColor

push 6
push offset text_1
push 34
push 40
push text_draw_internal_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Item 1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Draw Item 1
mov eax,0
cmp header_selection_number,2
je no_set_color_2_as_mouse_move

mov eax,dword ptr Header_Item_2+4

no_set_color_2_as_mouse_move:

push eax
push text_draw_internal_hdc
call SetTextColor

push 6
push offset text_1
push 34
push 120
push text_draw_internal_hdc
call TextOutA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Draw Item 1



push text_draw_internal_hdc
push dword ptr [ebp]+12		;push hwnd
call ReleaseDC
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
Draw_Header_Buttons_Text endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset HEADER_DRAW_CONTENT	;ebp+16
;push hwnd				;ebp+12
;push 0	;operation_type			;ebp+8
;call Process_Text_Color_In_Mouse_Move
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
Process_Text_Color_In_Mouse_Move proc
push ebp
mov ebp,esp

.DATA
only_text_draw_internal_hdc		dd 0
mouse_current_position			dd 0
current_mouse_coordinates		dd 0, 0
.CODE

mov Header_Item_1+4,00FFFFFFh		;Set Item 1 Text color
mov Header_Item_2+4,00FFFFFFh		;Set Item 1 Text color
mov Header_Item_3+4,00FFFFFFh		;Set Item 1 Text color
mov Header_Item_4+4,00FFFFFFh		;Set Item 1 Text color
mov Header_Item_5+4,00FFFFFFh		;Set Item 1 Text color
mov Header_Item_6+4,00FFFFFFh		;Set Item 1 Text color

push offset current_mouse_coordinates
call GetCursorPos;
;	extrn GetCursorPos:PROC

push offset current_mouse_coordinates
push dword ptr [ebp]+12		;push hwnd
call ScreenToClient
;	extrn ScreenToClient:PROC 

push offset current_mouse_coordinates		;ebp+12
push dword ptr [ebp]+16				;push offset HEADER_DRAW_CONTENT	;ebp+8
call Test_Mouse_Location_On_Headers
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Cursor not on the headers
;[eax] - Any other value is a header item number in which cursor is located
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,0
je no_change_text_color
mov mouse_current_position,eax

cmp mouse_current_position,1
jne no_change_item_1_color
mov Header_Item_1+4,0000FF80h ;00F0FFF0h
no_change_item_1_color:

cmp mouse_current_position,2
jne no_change_item_2_color
mov Header_Item_2+4,0000FF80h ;00F0FFF0h
no_change_item_2_color:

cmp mouse_current_position,3
jne no_change_item_3_color
mov Header_Item_3+4,0000FF80h ;00F0FFF0h
no_change_item_3_color:

cmp mouse_current_position,4
jne no_change_item_4_color
mov Header_Item_4+4,0000FF80h ;00F0FFF0h
no_change_item_4_color:

cmp mouse_current_position,5
jne no_change_item_5_color
mov Header_Item_5+4,0000FF80h ;00F0FFF0h
no_change_item_5_color:

no_change_text_color:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 12
Process_Text_Color_In_Mouse_Move endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

endm 





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
show_decimal macro s_x_c, s_y_c, show_value
pushad
mov eax,show_value  ;show;start_address
mov dword ptr string_bin_qword,eax
push offset result_data       ;       ebp+20;
push offset string_pack210    ;       ebp+16
push offset output            ;       ebp+12 
push offset string_bin_qword  ;input  ebp+8
call ConvertBinToDec
push 10
push offset result_data
push s_x_c ;100
push s_y_c ;100
push header_internal_hdc
call TextOutA
popad
endm
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



