richedit_file_standard_operations macro
;;;;;;Using example 
;push STREAMIN_type					;ebp+24
;push 128000		;file_size_limit in bytes	;ebp+20
;push richedit_window_handle				;ebp+16
;push offset file_name					;ebp+12
;push operation_type					;ebp+8
;call SCL_Transfer_File_Contents_Into_Richedit_Window
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SCL_Transfer_File_Contents_Into_Richedit_Window proc
push ebp
mov ebp,esp
;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_028, EP_028

mov eax,dword ptr [ebp]+8
mov operation_type_028,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_028, LF_028, operation_type_028, LP_028, EP_028
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov STREAMIN_error_code_owner,0			;Set owner to "NONE"
mov STREAMIN_system_error_code,0
mov STREAMIN_type,0001h

;SFF_SELECTION	--> 8000h

cmp dword ptr [ebp]+24,1		;STREAMIN_type
sete al
ror eax,1
cdq
mov edi,0001h
mov esi,0001h+8000h
and esi,edx
not edx
and edi,edx
add esi,edi
mov STREAMIN_type,esi			;;SFF_SELECTION	--> 8000h

.DATA
STREAMIN_type					dd 0	;SF_TEXT + [SFF_SELECTION]
STREAMIN_error_code_owner			dd 0
STREAMIN_system_error_code			dd 0
file_size_high_dword				dd 0
file_load_internal_handle			dd 0
file_open_for_input_transfer_error_code		dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
edit_input_stream LABEL DWORD
    dd 0			;application defained value
    dd 0			;DWORD dwError;
    dd offset Stream_Input	;EDITSTREAMCALLBACK pfnCallback;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

mov file_read_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
push 0         
push 80h			;FILE_ATTRIBUTE_NORMAL)
push 3				;OPEN_EXISTING  3 
push 0         
push 0  
push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
push dword ptr  [ebp+12]	;offset file_name
call CreateFileA
mov file_load_internal_handle,eax
cmp eax,(-1)
jne no_error_in_file_for_stream_input		;INVALID_HANDLE_VALUE -1

call GetLastError
mov STREAMIN_error_code_owner,1			;[Error code]
mov STREAMIN_system_error_code,eax

jmp file_input_transfer_end
no_error_in_file_for_stream_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start check file size

push offset file_size_high_dword
push file_load_internal_handle
call GetFileSize
mov ebx,eax

cmp eax,dword ptr [ebp]+20
setae al
ror eax,1
cdq
mov esi,3
mov edi,0
and esi,edx
not edx
and edi,edx
add esi,edi

mov STREAMIN_error_code_owner,esi		;File size is out of allowed limit [Error code]
mov STREAMIN_system_error_code,0		

cmp ebx,dword ptr [ebp]+20
jae file_handle_close_STREAMIN_point
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End check file size
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer file contents 
mov file_read_error_code,0		;Set error code to null

mov ebx,file_load_internal_handle
mov dword ptr edit_input_stream,ebx

push offset  edit_input_stream	;lParam   
push STREAMIN_type		;SF_TEXT ;wParam   +SFF_SELECTION
push 400h+73			;EM_STREAMIN =WM_USER + 73 ;message    
push dword ptr [ebp]+16		;richedit_window_handle
call SendMessageA

cmp file_read_error_code,0
je file_handle_close_STREAMIN_point

mov eax,file_read_error_code
mov STREAMIN_error_code_owner,2			;[Error code]
mov STREAMIN_system_error_code,eax

file_handle_close_STREAMIN_point:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 
push file_load_internal_handle		; current_file_handle;  ;(offset)   ;Returned by CreateFileA
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
file_input_transfer_end:

mov eax,STREAMIN_error_code_owner
mov ebx,STREAMIN_system_error_code

LP_028:
mov BF_028,0
EP_028:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - Error owner
	;[eax] - (-1) - function busy
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - ReadFile generates error
	;[eax] - 3 - File size is out of allowed limit
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 20
SCL_Transfer_File_Contents_Into_Richedit_Window endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push pcb		;ebp+20	;count of valid bytes in buffer.(must be filled)
;push cb		;ebp+16	;Buffer size in bytes
;push offset pbBuff	;ebp+12	;offset of RICHEDIT internal buffer 
;push dwCookie		;ebp+8 	;Value of the dwCookie member of the EDITSTREAM structure.[which passed to streamIn proc]
;call Stream_Input	;FPC_4

Stream_Input  proc
push ebp
mov ebp,esp
push esi
push edi
push ebx

.DATA
read_file_status_code			dd 0
internal_status				dd 0
number_of_read_bytes_for_stream_input	dd 0
file_read_error_code			dd 0
.CODE

push 0				;must be offset in  other case
push dword ptr [ebp]+20		;offset number_of_read_bytes_for_stream_input
push dword ptr [ebp]+16		;Buffer size in bytes
push dword ptr [ebp]+12		;offset of RICHEDIT internal buffer
push file_load_internal_handle		;dword ptr [ebp]+8 		;file_load_internal_handle
call ReadFile
mov read_file_status_code,eax
;;If the function fails, the return value is zero. 
;;To get extended error information, call GetLastError.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get ReadFile system error code
cmp eax,0
jne no_read_error_for_stream_input
call GetLastError
mov file_read_error_code,eax
mov number_of_read_bytes_for_stream_input,0

no_read_error_for_stream_input:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get ReadFile system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate Stream_Input end code
mov eax,read_file_status_code
cmp eax,0
sete al
ror eax,1
cdq
mov esi,0		;For success
mov edi,2		;For Read Error
and edi,edx
not edx
and esi,edx
add esi,edi
mov eax,esi

mov internal_status,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate Stream_Input end code
mov eax,internal_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Operation result is depend on the [eax] - value
;; IF [eax] - 2 - than current operation discarded 
;; IF [eax] - 0 - than current operation continue 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret 16
Stream_Input  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push STREAMOUT_type					;ebp+20
;push richedit_window_handle				;ebp+16
;push offset file_name					;ebp+12
;push operation_type					;ebp+8
;call SCL_Transfer_Richedit_Window_Contents_Into_File

SCL_Transfer_Richedit_Window_Contents_Into_File proc
push ebp
mov ebp,esp

;STREAMOUT_type	 ;0 - Save All Richedit window ;1 - Save only selection

;;;;;;Operation type
;0 - call unlocked free function
;1 - call locked function
;2 - unlock function
;3 - lock function
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] = (-1)	Function busy
;[eax] = (-2)	Function locked
;[eax] = (-3)	Function unlocked
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_029, EP_029

mov eax,dword ptr [ebp]+8
mov operation_type_029,eax

;;standard_lock_header macro IND, lock_flag, operation_type, lock_point, end_point
standard_lock_header IND_029, LF_029, operation_type_029, LP_029, EP_029
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov STREAMOUT_error_code_owner,0
mov STREAMOUT_system_error_code,0
mov STREAMOUT_type,0001h		;;SFF_SELECTION	--> 8000h

add STREAMOUT_type,8000h		;IF process only selection
;;add STREAMOUT_type,0010h		;IF process as UNICODE

cmp dword ptr [ebp]+20,1
sete al
ror eax,1
cdq
mov edi,0001h
mov esi,0001h+8000h
and esi,edx
not edx
and edi,edx
add esi,edi
mov STREAMOUT_type,esi			;;SFF_SELECTION	--> 8000h

;SF_TEXT	--> 0001h
;SF_UNICODE	--> 0010h
;SFF_SELECTION	--> 8000h

.DATA
STREAMOUT_type					dd 0	;SF_TEXT + [SFF_SELECTION]
STREAMOUT_error_code_owner			dd 0
STREAMOUT_system_error_code			dd 0

file_save_internal_handle			dd 0
file_save_for_output_transfer_error_code	dd 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
edit_output_stream LABEL DWORD
    dd 0			;application defained value
    dd 0			;DWORD dwError;
    dd offset Stream_Output	;EDITSTREAMCALLBACK pfnCallback;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.CODE

;mov file_read_error_code,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Open file
push 0         
push 80h			;FILE_ATTRIBUTE_NORMAL)
push 4				;OPEN_ALWAYS  4
push 0         
push 0  
push 80000000h+40000000h	;(GENERIC READ/WRITE)  ;;;      mov eax,dword ptr [ebp+28]     
push dword ptr  [ebp+12]	;offset file_name
call CreateFileA
mov file_save_internal_handle,eax
cmp eax,(-1)
jne no_error_in_file_for_stream_output		;INVALID_HANDLE_VALUE -1

call GetLastError
mov STREAMOUT_error_code_owner,1		;CreateFile generates error	[Error code]
mov STREAMOUT_system_error_code,eax

jmp file_output_transfer_end
no_error_in_file_for_stream_output:

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer file contents 
mov file_save_error_code,0		;Set error code to null

mov ebx,file_save_internal_handle
mov dword ptr edit_output_stream,ebx

push offset  edit_output_stream	;lParam   
push STREAMOUT_type		;SF_TEXT ;wParam   
push 400h+74			;EM_STREAMOUT    
push dword ptr [ebp]+16		;richedit_window_handle
call SendMessageA
cmp file_save_error_code,0
je no_error_on_file_save

mov eax,file_save_error_code
mov STREAMOUT_error_code_owner,2		;CreateFile generates error	[Error code]
mov STREAMOUT_system_error_code,eax

no_error_on_file_save:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer file contents 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start truncate file after file write
push file_save_internal_handle
call SetEndOfFile
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start truncate file after file write
push file_save_internal_handle
call CloseHandle
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Open file
file_output_transfer_end:

mov eax,STREAMOUT_error_code_owner
mov ebx,STREAMOUT_system_error_code

LP_029:
mov BF_029,0
EP_029:

mov eax,STREAMOUT_error_code_owner
mov ebx,STREAMOUT_system_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - Error owner
	;[eax] - 0 - function normal processed
	;[eax] - 1 - CreateFile generates error
	;[eax] - 2 - WriteFile generates error
		;[ebx]  - system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 16
SCL_Transfer_Richedit_Window_Contents_Into_File endp		;FPC_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push pcb		;ebp+20	;count of valid bytes in buffer.(must be filled)
;push cb		;ebp+16	;Buffer size in bytes
;push offset pbBuff	;ebp+12	;offset of RICHEDIT internal buffer 
;push dwCookie		;ebp+8 	;Value of the dwCookie member of the EDITSTREAM structure.[which passed to streamIn proc]
;call Stream_Output	;
;
Stream_Output  proc
push ebp
mov ebp,esp
push esi
push edi
push ebx

.DATA
write_file_status_code			dd 0
internal_write_status			dd 0
number_of_save_bytes_for_stream_output	dd 0
file_save_error_code			dd 0
.CODE

mov write_file_status_code,0
push 0				;must be offset in  other case
push dword ptr [ebp]+20		;offset number_of_save_bytes_for_stream_output
push dword ptr [ebp]+16		;Buffer size in bytes
push dword ptr [ebp]+12		;offset of RICHEDIT internal buffer
push file_save_internal_handle		;dword ptr [ebp]+8 		;file_load_internal_handle
call WriteFile
mov write_file_status_code,eax
;;If the function fails, the return value is zero. 
;;To get extended error information, call GetLastError.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get ReadFile system error code
cmp eax,0
jne no_save_error_for_stream_output
call GetLastError
mov file_save_error_code,eax
mov number_of_save_bytes_for_stream_output,0

no_save_error_for_stream_output:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get ReadFile system error code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start generate Stream_Input end code
mov eax,write_file_status_code
cmp eax,0
sete al
ror eax,1
cdq
mov esi,0		;For success
mov edi,2		;For Write Error
and edi,edx
not edx
and esi,edx
add esi,edi
mov eax,esi

mov internal_write_status,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End generate Stream_Input end code
mov eax,internal_write_status
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Operation result is depend on the [eax] - value
;; IF [eax] - 2 - than current operation discarded 
;; IF [eax] - 0 - than current operation continue 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pop ebx
pop edi
pop esi
mov esp,ebp
pop ebp
ret 16
Stream_Output  endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;New_richedit_window_proc proc
;push ebp
;mov ebp,esp
;push ebx
;push esi
;push edi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cmp dword ptr [ebp+0ch],100h		;WM_KEYDOWN  	100h
;jne no_insert

;WM_KEYDOWN  	100h
;nVirtKey = (int) wParam;    // virtual-key code 
;lKeyData = lParam;          // key data 

;cmp dword ptr [ebp]+16,2Dh	;VK_INSERT 2Dh
;jne no_insert

;push 40
;push 880
;call Beep

;xor eax,eax
;no_insert:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;cmp dword ptr [ebp+0ch],205h		;WM_RBUTTONUP  205h
;jne	richedit_left_button_up

;push 40
;push 880*2
;call Beep

;push 0
;push offset text
;push offset text
;push hwnd
;call MessageBoxA

;xor eax,eax
;richedit_left_button_up:

;push dword ptr [ebp]+20		;lparam
;push dword ptr [ebp]+16		;wparam
;push dword ptr [ebp]+12		;message
;push dword ptr [ebp]+8		;richedit_window_handle
;push richedit_previous_proc_address
;call CallWindowProcA

;win_default

;push 40
;push 440
;call Beep

;mov eax,1

;pop edi
;pop esi
;pop ebx
;mov esp,ebp
;pop ebp
;ret 16
;New_richedit_window_proc endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push offset RANGE				;ebp+12
;push richedit_window_handle			;ebp+8
;call SC_Determine_Range_Commented_State 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Determine_Range_Commented_State proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point 
standard_sync_header BF_DRCS_0001, EP_DRCS_0001 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
commented_range_start		dd 0
commented_range_end		dd 0
line_start_position		dd 0
line_end_position		dd 0
text_commented_state		dd 0	;0 - Not commented ;1 - Commented
.CODE
mov text_commented_state,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,dword ptr [ebp]+12		;offset RANGE
mov ebx,dword ptr [eax]
mov ecx,dword ptr [eax]+4

mov commented_range_start,ebx
mov commented_range_end,ecx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values commented_range_start, commented_range_end	;[EAX] - Max ;[EBX] - Min

mov commented_range_start,ebx
mov commented_range_end,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;..........|<----------COMMENTED RANGE------------>|...........

;Use only  [commented_range_start]

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE INDEX which contains RANGE_START
push commented_range_start		;lparam	;characted_position
push 0					;wparam
push 400h+54 				;;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;Returns the zero-based index of the line. [ or line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE INDEX which contains RANGE_START
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
push 0				;lparam
push eax			;wparam line index
push 0BBh 			;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;in [eax] - line start position
mov line_start_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE length 
push 0				;lparam
push commented_range_start	;wparam line index
push 0C1h 			;EM_LINELENGTH  0C1h
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;The return value is the length, in characters, of the line

add eax,line_start_position
mov line_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find comment symbol in specified line
mov ebx,line_start_position
mov eax,line_end_position
mov comment_search_start_position,ebx
mov comment_search_end_position,eax

.DATA
CF_FIND_TEXT_EX LABEL DWORD
		comment_search_start_position		dd 0
		comment_search_end_position		dd 0
		comment_find_text_address		dd offset DCS_COMMENT_SYMBOL
		comment_found_text_start_position	dd 0
		comment_found_text_end_position		dd 0
DCS_COMMENT_SYMBOL						db ";",0
.CODE

push offset CF_FIND_TEXT_EX	;lparam
push 1				;wparam
push 400h+79			;EM_FINDTEXTEX	400h + 79
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find comment symbol in specified line
;IF [eax] - (-1) then Set range_commented_state as "NOT COMMENTED"
cmp eax,(-1)
je end_determine_commented_state

;IF [eax] - any other value then 
	;Check ;IF [comment_found_text_start_position] > commented_range_start Then set range_commented_state as "NOT COMMENTED"
	;Check ;IF [comment_found_text_start_position] = < commented_range_start Then set range_commented_state as "COMMENTED"
;text_commented_state		dd 0	;0 - Not commented ;1 - Commented

mov ebx,comment_found_text_start_position
cmp ebx,commented_range_start
seta al
ror eax,1
cdq
mov esi,0
mov edi,1
and esi,edx
not edx
and edi,edx
add esi,edi
mov text_commented_state,esi
end_determine_commented_state:

mov eax,text_commented_state
mov BF_DRCS_0001,0
EP_DRCS_0001:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - function busy
;[eax] - 0 - Range not commented. [ checked only range start ]
;[eax] - 1 - Range commented
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov esp,ebp
pop ebp
ret 8
SC_Determine_Range_Commented_State endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push window_handle
;call SC_Convert_Richedit_Selection_To_Uppercase

SC_Convert_Richedit_Selection_To_Uppercase proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GRL_2, EP_GRL_2
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine SELECTION start
push offset convert_into_uppercase_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

mov convert_into_uppercase_error_code,1

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values convert_into_uppercase_start_position, convert_into_uppercase_end_position	;[EAX] - Max ;[EBX] - Min

mov convert_into_uppercase_end_position,eax
mov convert_into_uppercase_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine SELECTION start
.DATA
convert_into_uppercase_error_code	dd 0
convert_into_uppercase_start_position	dd 0
convert_into_uppercase_end_position	dd 0
uppercase_selection_length		dd 0
uppercase_convert_buffer		db 400 dup (0)
					dd 0
uppercase_transfer_size			dd 0
uppercase_transfer_increment		dd 0
count_of_converted_uppercase_bytes	dd 0
.CODE

;mov convert_into_uppercase_error_code,1
mov eax,convert_into_uppercase_start_position
cmp eax,convert_into_uppercase_end_position
je end_convert_into_uppercase				;Jump if no selection. [Selection empty]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,convert_into_uppercase_end_position
sub eax,convert_into_uppercase_start_position
mov uppercase_selection_length,eax
mov uppercase_transfer_increment,0
mov count_of_converted_uppercase_bytes,0


start_convert_selection_into_uppercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset buffer
xor eax,eax
mov edi,offset uppercase_convert_buffer
mov ecx,100
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset buffer
;IF [selection_length] > 400 then transfer info buffer 400 byte
;IF [selection_length] < = 400 byte then transfer into buffer [selection_length]

cmp uppercase_selection_length,400
seta al
ror eax,1
cdq
mov esi,400
mov edi,uppercase_selection_length
and esi,edx
not edx
and edi,edx
add esi,edi
mov uppercase_transfer_size,esi

mov eax,convert_into_uppercase_start_position
add eax,uppercase_transfer_increment

mov uppercase_text_get_start_position,eax
add eax,uppercase_transfer_size

mov uppercase_text_get_end_position,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer selection or selection part into buffer
;;;EM_GETTEXTRANGE	400h+75
push offset get_character_range_for_uppercase_convert
push 0				;wparam 
push 400h+75 			;EM_GETTEXTRANGE	400h+75
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA

.DATA
get_character_range_for_uppercase_convert LABEL DWORD
	uppercase_text_get_start_position	dd 0
	uppercase_text_get_end_position		dd 0
	uppercase_text_get_buffer_address	dd offset uppercase_convert_buffer

	uppercase_selection_character_range_start	dd 0
	uppercase_selection_character_range_end		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer selection or selection part into buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into uppercase
start_convert_into_uppercase:
push uppercase_transfer_size			;ebp+12
push offset uppercase_convert_buffer		;ebp+8
call SC_Convert_Into_Uppercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_convert_into_uppercase
add count_of_converted_uppercase_bytes,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into uppercase

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer converted bytes back
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection for transfer
mov eax,convert_into_uppercase_start_position
add eax,uppercase_transfer_increment
mov uppercase_selection_character_range_start,eax

add eax,uppercase_transfer_size
mov uppercase_selection_character_range_end,eax

push offset uppercase_selection_character_range_start
push 0				;wparam 
push 400h+55 			;EM_EXSETSEL 400h + 55
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set selection for transfer

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection
push offset uppercase_convert_buffer
push 1				;wparam 
push 0C2h 			;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer converted bytes back

mov eax,uppercase_transfer_size
add uppercase_transfer_increment,eax
sub uppercase_selection_length,eax		;uppercase_transfer_size

cmp uppercase_selection_length,0
jne start_convert_selection_into_uppercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection  after convert operation
push offset convert_into_uppercase_start_position
push 0				;wparam 
push 400h+55 			;EM_EXSETSEL 400h + 55
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection  after convert operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov convert_into_uppercase_error_code,0

; IF [selection_length] > 400 byte THEN  [Transfer 400 byte ][Perform convert][Transfer from buffer][calculate substraction]
; IF [substraction] > 400 byte THEN  [Transfer 400 byte ][Perform convert][Transfer from buffer][calculate substraction]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_convert_into_uppercase:
mov eax,convert_into_uppercase_error_code
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Uppercase change process performed successfully
;[eax] - 1 - selection is empty. Cannot perform [change  to UPPERCASE ] operation.
;[ebx] - count of converted bytes in selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,convert_into_uppercase_error_code
mov ebx,count_of_converted_uppercase_bytes
mov BF_GRL_2,0
EP_GRL_2:

mov esp,ebp
pop ebp
ret 4
SC_Convert_Richedit_Selection_To_Uppercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Convert_Richedit_Selection_To_Lowercase proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GRL_3, EP_GRL_3
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine SELECTION start
push offset convert_into_lowercase_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

mov convert_into_lowercase_error_code,1

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values convert_into_lowercase_start_position, convert_into_lowercase_end_position	;[EAX] - Max ;[EBX] - Min

mov convert_into_lowercase_end_position,eax
mov convert_into_lowercase_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine SELECTION start
.DATA
convert_into_lowercase_error_code	dd 0
convert_into_lowercase_start_position	dd 0
convert_into_lowercase_end_position	dd 0
lowercase_selection_length		dd 0
lowercase_convert_buffer		db 400 dup (0)
					dd 0
lowercase_transfer_size			dd 0
lowercase_transfer_increment		dd 0
count_of_converted_lowercase_bytes	dd 0
.CODE

;mov convert_into_lowercase_error_code,1
mov eax,convert_into_lowercase_start_position
cmp eax,convert_into_lowercase_end_position
je end_convert_into_lowercase				;Jump if no selection. [Selection empty]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,convert_into_lowercase_end_position
sub eax,convert_into_lowercase_start_position
mov lowercase_selection_length,eax
mov lowercase_transfer_increment,0
mov count_of_converted_lowercase_bytes,0

start_convert_selection_into_lowercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start reset buffer
xor eax,eax
mov edi,offset lowercase_convert_buffer
mov ecx,100
cld
rep stosd
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End reset buffer
;IF [selection_length] > 400 then transfer info buffer 400 byte
;IF [selection_length] < = 400 byte then transfer into buffer [selection_length]

cmp lowercase_selection_length,400
seta al
ror eax,1
cdq
mov esi,400
mov edi,lowercase_selection_length
and esi,edx
not edx
and edi,edx
add esi,edi
mov lowercase_transfer_size,esi

mov eax,convert_into_lowercase_start_position
add eax,lowercase_transfer_increment

mov lowercase_text_get_start_position,eax
add eax,lowercase_transfer_size

mov lowercase_text_get_end_position,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer selection or selection part into buffer
;;;EM_GETTEXTRANGE	400h+75
push offset get_character_range_for_lowercase_convert
push 0				;wparam 
push 400h+75 			;EM_GETTEXTRANGE	400h+75
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA

.DATA
get_character_range_for_lowercase_convert LABEL DWORD
	lowercase_text_get_start_position	dd 0
	lowercase_text_get_end_position		dd 0
	lowercase_text_get_buffer_address	dd offset lowercase_convert_buffer

	lowercase_selection_character_range_start	dd 0
	lowercase_selection_character_range_end		dd 0
.CODE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer selection or selection part into buffer
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start convert into lowercase
start_convert_into_lowercase:
push lowercase_transfer_size			;ebp+12
push offset lowercase_convert_buffer		;ebp+8
call SC_Convert_Into_Lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - (-1) - Function busy 
;[eax] -  0  - Function normal processed
	;[ebx] - count of converted bytes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
cmp eax,(-1)
je start_convert_into_lowercase
add count_of_converted_lowercase_bytes,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End convert into lowercase

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start transfer converted bytes back
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection for transfer
mov eax,convert_into_lowercase_start_position
add eax,lowercase_transfer_increment
mov lowercase_selection_character_range_start,eax

add eax,lowercase_transfer_size
mov lowercase_selection_character_range_end,eax

push offset lowercase_selection_character_range_start
push 0				;wparam 
push 400h+55 			;EM_EXSETSEL 400h + 55
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End set selection for transfer

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection
push offset lowercase_convert_buffer
push 1				;wparam 
push 0C2h 			;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End transfer converted bytes back

;push 0
;push offset lowercase_convert_buffer
;push offset lowercase_convert_buffer
;push 0
;call MessageBoxA

mov eax,lowercase_transfer_size
add lowercase_transfer_increment,eax
sub lowercase_selection_length,eax		;lowercase_transfer_size

cmp lowercase_selection_length,0
jne start_convert_selection_into_lowercase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection  after convert operation
push offset convert_into_lowercase_start_position
push 0				;wparam 
push 400h+55 			;EM_EXSETSEL 400h + 55
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start set selection  after convert operation
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov convert_into_lowercase_error_code,0

; IF [selection_length] > 400 byte THEN  [Transfer 400 byte ][Perform convert][Transfer from buffer][calculate substraction]
; IF [substraction] > 400 byte THEN  [Transfer 400 byte ][Perform convert][Transfer from buffer][calculate substraction]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
end_convert_into_lowercase:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[eax] - 0 - Lowercase change process performed successfully
;[eax] - 1 - selection is empty. Cannot perform [change  to LOWERCASE ] operation.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,convert_into_lowercase_error_code
mov ebx,count_of_converted_lowercase_bytes
mov BF_GRL_3,0
EP_GRL_3:

mov esp,ebp
pop ebp
ret 4
SC_Convert_Richedit_Selection_To_Lowercase endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;push richedit_window_handle		;ebp+8
;call SC_Comment_Richedit_Selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Comment_Richedit_Selection proc
push ebp
mov ebp,esp

;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GRL_4, EP_GRL_4
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
commented_lines_count			dd 0

comment_selection_start_position	dd 0
comment_selection_end_position		dd 0
comment_selection_start_line		dd 0
comment_selection_end_line		dd 0
comment_line_start_position		dd 0
comment_set_start_position		dd 0
comment_set_end_position		dd 0
comment_get_sel_end_line_pos		dd 0
comment_sel_range_char_count		dd 0
.CODE
mov commented_lines_count,0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine selection for comment
push offset comment_selection_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values comment_selection_start_position, comment_selection_end_position	;[EAX] - Max ;[EBX] - Min

mov comment_selection_end_position,eax
mov comment_selection_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine selection for comment
sub eax,ebx
mov comment_sel_range_char_count,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection start line
mov eax,comment_selection_start_position
inc eax
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
mov comment_selection_start_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection start line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection end line
mov eax,comment_selection_end_position
dec eax
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
mov comment_selection_end_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection end line

;IF [comment_selection_end_line] < [comment_selection_start_line] 
;Then SET [comment_selection_end_line] = [comment_selection_start_line]

mov ebx,comment_selection_start_line
cmp comment_selection_end_line,ebx
setb al
ror eax,1
cdq
mov esi,comment_selection_start_line
mov edi,comment_selection_end_line
and esi,edx
not edx
and edi,edx
add esi,edi
mov comment_selection_end_line,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
push 0					;lparam
push comment_selection_start_line	;wparam line index
push 0BBh 				;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;in [eax] - line start position
mov comment_line_start_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine comment set position
;IF [comment_line_start_position] < [comment_selection_start_position] then [comment_set_start_position] = [comment_selection_start_position]

mov ebx,comment_line_start_position
cmp ebx,comment_selection_start_position
setb al
ror eax,1
cdq 
mov esi,comment_selection_start_position
mov edi,comment_line_start_position
and esi,edx
not edx
and edi,edx
add esi,edi

mov comment_set_start_position,esi
mov comment_set_end_position,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine comment set position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset comment_set_start_position	;lparam	;Selection end
push 0					;wparam	;Selection start  
push 400h+55 				;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection with comment symbol
push offset DCS_COMMENT_SYMBOL
push 1					;wparam 
push 0C2h 				;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection with comment symbol
.DATA
;;;DCS_COMMENT_SYMBOL		db ';',0		;Already defined
.CODE

mov commented_lines_count,0
start_comment_line:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Comment remaining lines
inc commented_lines_count
mov eax,comment_selection_start_line
add eax,commented_lines_count
cmp eax,comment_selection_end_line
ja  end_comment_richedit_selection
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
mov eax,comment_selection_start_line
add eax,commented_lines_count

push 0					;lparam
push eax				;wparam line index
push 0BBh 				;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;in [eax] - line start position
mov comment_set_start_position,eax
mov comment_set_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset comment_set_start_position	;lparam	;Selection end
push 0					;wparam	;Selection start  
push 400h+55 				;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection with comment symbol
push offset DCS_COMMENT_SYMBOL
push 1					;wparam 
push 0C2h 				;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection with comment symbol
jmp start_comment_line

;comment_selection_start_line
;comment_selection_end_line

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Comment remaining lines
end_comment_richedit_selection:


mov ebx,commented_lines_count
add comment_selection_end_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset comment_selection_start_position	;lparam	;Selection end
push 0					;wparam	;Selection start  
push 400h+55 				;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment
; Insert comment symbol into this position

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov BF_GRL_4,0
EP_GRL_4:

mov esp,ebp
pop ebp
ret 4
SC_Comment_Richedit_Selection endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SC_Uncomment_Richedit_Selection proc
push ebp
mov ebp,esp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;standard_sync_header macro  busy_flag, end_point
standard_sync_header BF_GRL_5, EP_GRL_5
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.DATA
uncommented_lines_count			dd 0
uncomment_selection_start_position	dd 0
uncomment_selection_end_position	dd 0
uncomment_selection_start_line		dd 0
uncomment_selection_end_line		dd 0
uncomment_line_start_position		dd 0
uncomment_set_start_position		dd 0
uncomment_set_end_position		dd 0
uncomment_line_length			dd 0
uncomment_line_increment		dd 0
.CODE
mov uncommented_lines_count,0
mov uncomment_line_increment,0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start determine selection for comment
push offset uncomment_selection_start_position	;lparam
push 0				;wparam
push 400h+52			;EM_EXGETSEL
push dword ptr [ebp]+8		;richedit_window_handle
call SendMessageA

;;Sort_Values macro Value_1, Value_2	;[EAX] - Max ;[EBX] - Min
Sort_Values uncomment_selection_start_position, uncomment_selection_end_position	;[EAX] - Max ;[EBX] - Min

mov uncomment_selection_end_position,eax
mov uncomment_selection_start_position,ebx
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End determine selection for comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection start line
mov eax,uncomment_selection_start_position
inc eax
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
mov uncomment_selection_start_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection start line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start get selection end line
mov eax,uncomment_selection_end_position
dec eax
push eax				;lparam	;character_position
push 0					;wparam
push 400h+54 				;EM_EXLINEFROMCHAR	400h+54
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
mov uncomment_selection_end_line,eax	;Returns the zero-based index of the line. [ line number ]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End get selection end line

;IF [uncomment_selection_end_line] < [uncomment_selection_start_line] 
;Then SET [uncomment_selection_end_line] = [uncomment_selection_start_line]

mov ebx,uncomment_selection_start_line
cmp uncomment_selection_end_line,ebx
setb al
ror eax,1
cdq
mov esi,uncomment_selection_start_line
mov edi,uncomment_selection_end_line
and esi,edx
not edx
and edi,edx
add esi,edi
mov uncomment_selection_end_line,esi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
mov eax,uncomment_selection_start_line
add eax,uncomment_line_increment

push 0					;lparam
push eax				;uncomment_selection_start_line	;wparam line index ;Line index
push 0BBh 				;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;in [eax] - line start position [char index]
mov uncomment_line_start_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
mov eax,uncomment_selection_start_line
add eax,uncomment_line_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE length 
push 0					;lparam
push eax				;uncomment_line_start_position	;wparam line index
push 0C1h 				;EM_LINELENGTH  0C1h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;The return value is the length, in characters, of the line
mov uncomment_line_length,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE length 
mov esi,uncomment_selection_start_position
mov uncomment_search_start_position,esi

;IF [uncomment_selection_start_position] > [uncomment_line_start_position]
;		Then [uncomment_search_start_position] = [uncomment_selection_start_position]
;		Else [uncomment_search_start_position] = [uncomment_line_start_position]

mov ebx,uncomment_selection_start_position
cmp ebx,uncomment_line_start_position
seta al
ror eax,1
cdq
mov esi,uncomment_selection_start_position
mov edi,uncomment_line_start_position
and esi,edx
not edx
and edi,edx
add esi,edi
mov uncomment_search_start_position,esi 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;IF [uncomment_selection_start_position] > [uncomment_line_start_position]
;Then [uncomment_line_length] = [ [uncomment_line_start_position] + [uncomment_line_length] ]-[uncomment_selection_start_position]

mov ebx,uncomment_line_start_position
cmp uncomment_selection_start_position,ebx
seta al
ror eax,1
cdq
mov esi,uncomment_line_start_position
	add esi,uncomment_line_length
	sub esi,uncomment_selection_start_position
mov edi,uncomment_line_length
and esi,edx
not edx
and edi,edx
add esi,edi
mov uncomment_line_length,esi

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,uncomment_selection_start_position		;Char index
add eax,uncomment_line_length				;uncomment_line_length
mov uncomment_search_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find comment symbol in specified line
.DATA
UCF_FIND_TEXT_EX LABEL DWORD
		uncomment_search_start_position		dd 0
		uncomment_search_end_position		dd 0
		uncomment_find_text_address		dd offset DCS_COMMENT_SYMBOL
		uncomment_found_text_start_position	dd 0
		uncomment_found_text_end_position	dd 0
;;DCS_COMMENT_SYMBOL						db ";",0
.CODE

push offset UCF_FIND_TEXT_EX	;lparam
push 1				;wparam
push 400h+79			;EM_FINDTEXTEX	400h + 79
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find comment symbol in specified line
cmp eax,(-1)
je no_found_DCS_COMMENT_SYMBOL_in_specified_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset uncomment_found_text_start_position	;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8				;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection with comment symbol
push 0	;offset DCS_COMMENT_SYMBOL
push 1				;wparam 
push 0C2h 			;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection with comment symbol

inc uncommented_lines_count
no_found_DCS_COMMENT_SYMBOL_in_specified_line:

inc uncomment_line_increment

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Uncomment Remaining lines
start_uncomment_line:

mov eax,uncomment_selection_start_line
add eax,uncomment_line_increment
cmp eax,uncomment_selection_end_line
ja end_uncomment_richedit_selection

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE start position
mov eax,uncomment_selection_start_line
add eax,uncomment_line_increment

push 0					;lparam
push eax				;uncomment_selection_start_line	;wparam line index ;Line index
push 0BBh 				;EM_LINEINDEX 0BBh
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;in [eax] - line start position [char index]
mov uncomment_search_start_position,eax	;Current Uncomment line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End  find LINE start position
mov eax,uncomment_selection_start_line
add eax,uncomment_line_increment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find LINE length 
push 0					;lparam
push eax				;uncomment_line_start_position	;wparam line index
push 0C1h 				;EM_LINELENGTH  0C1h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA			;The return value is the length, in characters, of the line;
mov uncomment_line_length,eax		;Current uncomment line length
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find LINE length 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov eax,uncomment_search_start_position		;Char index
add eax,uncomment_line_length		;uncomment_line_length
mov uncomment_search_end_position,eax
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start find comment symbol in specified line
;.DATA
;UCF_FIND_TEXT_EX LABEL DWORD
;		uncomment_search_start_position		dd 0
;		uncomment_search_end_position		dd 0
;		uncomment_find_text_address		dd offset DCS_COMMENT_SYMBOL
;		uncomment_found_text_start_position	dd 0
;		uncomment_found_text_end_position	dd 0
;;DCS_COMMENT_SYMBOL						db ";",0

;get_text_range_for_check LABEL DWORD
;;	get_start_position_FC		dd 0
;;	get_end_position_FC		dd 0
;;	get_buffer_address_FC		dd offset check_get_text_buffer
;;check_get_text_buffer	dd 10 dup (0)
;.CODE

;;mov eax,uncomment_search_start_position
;;mov ebx,uncomment_search_end_position
;;mov get_start_position_FC,eax
;;mov get_end_position_FC,ebx
;;;;EM_GETTEXTRANGE	400h+75
;;push offset get_text_range_for_check
;;push 0				;wparam 
;;push 400h+75 			;EM_GETTEXTRANGE	400h+75
;;push dword ptr [ebp]+8		;push richedit_window_handle
;;call SendMessageA
;;push 0
;;push offset check_get_text_buffer
;;push offset check_get_text_buffer
;;push hwnd
;;call MessageBoxA

;push 40
;push 880
;call Beep

push offset UCF_FIND_TEXT_EX	;lparam
push 1				;wparam
push 400h+79			;EM_FINDTEXTEX	400h + 79
push dword ptr [ebp]+8		;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End find comment symbol in specified line
cmp eax,(-1)
je not_found_DCS_COMMENT_SYMBOL_in_specified_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset uncomment_found_text_start_position	;lparam	;Selection end
push 0						;wparam	;Selection start  
push 400h+55 					;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8				;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start replace selection with comment symbol
push 0	;offset DCS_COMMENT_SYMBOL
push 1				;wparam 
push 0C2h 			;EM_REPLACESEL 0C2h
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End replace selection with comment symbol
;push 40
;push 440
;call Beep

inc uncommented_lines_count
not_found_DCS_COMMENT_SYMBOL_in_specified_line:

inc uncomment_line_increment
jmp start_uncomment_line
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Uncomment Remaining lines

end_uncomment_richedit_selection:

;mov eax,uncomment_selection_end_position
;add eax,uncommented_lines_count
;mov uncomment_selection_end_position,eax
;sub eax,uncomment_line_increment
;mov uncomment_selection_start_position,eax

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;Start Set Selection for line comment
push offset uncomment_selection_start_position	;lparam	;Selection end
push 0					;wparam	;Selection start  
push 400h+55 				;EM_EXSETSEL  WM_USER + 55
push dword ptr [ebp]+8			;push richedit_window_handle
call SendMessageA
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;End Set Selection for line comment

mov ebx,uncommented_lines_count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
mov BF_GRL_5,0
EP_GRL_5:
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;[ebx] - uncommented lines count
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

mov esp,ebp
pop ebp
ret 4
SC_Uncomment_Richedit_Selection endp
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
endm 

